unit SpPorovnOdd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, iniFiles, Db, DBTables,
  ELesObec, E_LesOdd, mat1,
  U_Props,elements,E_Class, StdCtrls;

type
TCheckBoxPorovn = class;

TPorovnavanaProperta = class (TOwnerEntity)
 private
  fPorProperta:string;
  FPorovnavat:Boolean;
  procedure SetPorovnavat(S:Boolean);
 public
  FCheckBoxPorovn:TCheckBoxPorovn;
  constructor Create; override;
 published
  property  PorProperta:string  read FPorProperta write FPorProperta;
  property  Porovnavat:Boolean  read FPorovnavat  write SetPorovnavat;

 end;

TPorovnavanaPropertaMN = class(TLesniMnozina)
 public
 private
  fNazevProIni:string;
 public
  constructor Create; override;
 published
  property  NazevProIni:string  read FNazevProIni write FNazevProIni;
 end;


TCheckBoxPorovn = class(TCheckBox)
 protected
   procedure DoExit;  override;
 public
  FPorovnavanaProperta:TPorovnavanaProperta;
   procedure udelejDoExit;
 end;

  TFPorovnOdd = class(TForm)
    ButUloz: TButton;
    ButNacti: TButton;
    Button1: TButton;
    ButPorovn: TButton;
    ButZapVse: TButton;
    ButVypVse: TButton;
    procedure ButUlozClick(Sender: TObject);
    procedure ButNactiClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ButPorovnClick(Sender: TObject);
    procedure ButZapVseClick(Sender: TObject);
    procedure ButVypVseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    propLHC,
    propOddeleni,propDilec,propPorost,
    PropPorostniSkupina,PropEtaz,PropDrevina,PropPoskozeni,PropZalesneni,PropKategorie,
    PropZvlSt, PropJinyPozemek, PropBezlesi, PropOstatni:TPorovnavanaPropertaMN;
    FprovadetPorovnavani:boolean;
    procedure CheckboxyzPorovnavanychPropert;
    procedure VytvorCheckBox(Vtop,VLeft,hwidth:integer;jmeno:string;
                             VPorovnavanaProperta:TPorovnavanaProperta);
    procedure VytvorLABEL(Vtop,VLeft:integer;jmeno:string);
    procedure UlozVsechnyPorovnProp;
    procedure NactiVsechnyPorovnProp;
  end;

var
  FPorovnOdd: TFPorovnOdd;

function SeznamDleOwnerElementu(TOClass:TOrbisClass):TPorovnavanaPropertaMN;

Procedure VytvorSeznamPorovnavanychPropert(var provadetPorovnavani:boolean);
procedure srovnejoddeleni(VOdd1,VOdd2:TOddeleni;Vtable:TTable;AdrZdroj1,AdrZdroj2:String);
procedure nactiTextyZOddeleni(VOdd1,VOdd2:TOddeleni;AdrZdroj1,AdrZdroj2:String);
procedure porovnejDveEntity(Muj1,Muj2:TOwnerEntity; PropEnt:TPorovnavanaPropertaMN;Vtable:TTable);


implementation

{$R *.DFM}
function SeznamDleOwnerElementu(TOClass:TOrbisClass):TPorovnavanaPropertaMN;
var i,PocetPropert:Integer;
    JmenoProperty:string;
    VPP:TPorovnavanaProperta;
 begin
  result := TPorovnavanaPropertaMN.Create;
  PocetPropert:=TOClass.PropCount;
  for i:=1 to PocetPropert-1 do
   begin
    JmenoProperty := TOClass.PropertyName[i];
    if  TOClass.PropertyStored[i] then
     begin
      if    (JmenoProperty<>'Name')
         and(JmenoProperty<>'RId')
         and(JmenoProperty<>'Vazba')
         and(JmenoProperty<>'KontrolaP0110')
         and(JmenoProperty<>'PouzivatPlochuJakoVymeru')
         and(JmenoProperty<>'PlochaDleP0110')
         and(JmenoProperty<>'VymeraDleP0110')
         and(JmenoProperty<>'Plocha0')
         and(JmenoProperty<>'Vymera')
         and(JmenoProperty<>'Plocha')
      then
       begin
        VPP:=TPorovnavanaProperta.Create;
        VPP.name:=JmenoProperty;
        VPP.PorProperta:=JmenoProperty;
        Result.AddElement(VPP);
       end;
      // showmessage(JmenoProperty + ' Stored');
     end;
    {
    else
     begin
      showmessage(JmenoProperty + ' Neee');
     end;
     }
   end;
 end;
Procedure VytvorSeznamPorovnavanychPropert(var provadetPorovnavani:boolean);
Var
 TOClass:TOrbisClass;
 begin
  Application.CreateForm(TFPorovnOdd,FPorovnOdd);

  TOClass:=orbisClasses.GetOrbisClassByName('TLHCMoje');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TLHCMoje');
   end
  else
   begin
    FPorovnOdd.propLHC:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropLHC.NazevProIni:='LHC';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TOddeleniMoje');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TOddeleniMoje.');
   end
  else
   begin
    FPorovnOdd.propOddeleni:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropOddeleni.NazevProIni:='Oddeleni';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TDilecMoje');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TDilecMoje.');
   end
  else
   begin
    FPorovnOdd.propDilec:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropDilec.NazevProIni:='Dilec';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TPorostMoje');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TPorostMoje.');
   end
  else
   begin
    FPorovnOdd.propPorost:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropPorost.NazevProIni:='Porost';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TPorostniSkupinaMoje');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TPorostniSkupinaMoje.');
   end
  else
   begin
    FPorovnOdd.PropPorostniSkupina:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropPorostniSkupina.NazevProIni:='PorostniSkupina';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TEtaz');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TEtaz.');
   end
  else
   begin
    FPorovnOdd.PropEtaz:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropEtaz.NazevProIni:='Etaz';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TDrevina');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TDrevina.');
   end
  else
   begin
    FPorovnOdd.PropDrevina:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropDrevina.NazevProIni:='Drevina';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TPoskozeni');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TPoskozeni.');
   end
  else
   begin
    FPorovnOdd.PropPoskozeni:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropPoskozeni.NazevProIni:='Poskozeni';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TZalesneni');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ  TZalesneni.');
   end
  else
   begin
    FPorovnOdd.PropZalesneni:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropZalesneni.NazevProIni:='Zalesneni';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TKategorie1');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ  TKategorie1.');
   end
  else
   begin
    FPorovnOdd.PropKategorie:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropKategorie.NazevProIni:='Kategorie';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TZvlSt');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ  TZvlSt .');
   end
  else
   begin
    FPorovnOdd.PropZvlSt:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropZvlSt.NazevProIni:='ZvlSt';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TJinyPozemek');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TJinyPozemek .');
   end
  else
   begin
    FPorovnOdd.PropJinyPozemek:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropJinyPozemek.NazevProIni:='JinyPozemek';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TBezlesi');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TBezlesi .');
   end
  else
   begin
    FPorovnOdd.PropBezlesi:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropBezlesi.NazevProIni:='Bezlesi';
   end;

  TOClass:=orbisClasses.GetOrbisClassByName('TOstatni');
  if TOClass=nil then
   begin
    Showmessage('Nenalezen typ TOstatni .');
   end
  else
   begin
    FPorovnOdd.PropOstatni:=SeznamDleOwnerElementu(TOClass);
    FPorovnOdd.PropOstatni.NazevProIni:='Ostatni';
   end;
  FPorovnOdd.CheckboxyzPorovnavanychPropert;
  FPorovnOdd.showModal;
  provadetPorovnavani:=FPorovnOdd.FprovadetPorovnavani;
 end;



procedure TFPorovnOdd.CheckboxyzPorovnavanychPropert;
var
    i:integer;
    Vtop,VLeft:integer;
 begin
  Vtop:=5;  VLeft:=10;
  VytvorLABEL(Vtop,VLeft,'LHC');
  Vtop:=VTop+18;
  for i:=0 to PropLHC.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,125,'LHC '+TPorovnavanaProperta(PropLHC.Elements[i]).PorProperta,
                   TPorovnavanaProperta(PropLHC.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+130;
  VytvorLABEL(Vtop,VLeft,'Oddlen');
  Vtop:=VTop+18;
  for i:=0 to propOddeleni.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'ODD '+TPorovnavanaProperta(propOddeleni.Elements[i]).PorProperta,
                     TPorovnavanaProperta(propOddeleni.Elements[i]));
    Vtop:=VTop+16;
   end;
  Vtop:=Vtop+20; // VLeft:=10;
  VytvorLABEL(Vtop,VLeft,'Dlec');
  Vtop:=VTop+18;
  for i:=0 to propDilec.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'DIL '+TPorovnavanaProperta(propDilec.Elements[i]).PorProperta,
                               TPorovnavanaProperta(propDilec.Elements[i]));
    Vtop:=VTop+16;
   end;
  Vtop:=Vtop+20; // VLeft:=10;
  VytvorLABEL(Vtop,VLeft,'Porost');
  Vtop:=VTop+18;
  for i:=0 to propPorost.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'POR '+TPorovnavanaProperta(propPorost.Elements[i]).PorProperta,
                               TPorovnavanaProperta(propPorost.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=Vtop+20; // VLeft:=10;
  VytvorLABEL(Vtop,VLeft,'Kategorie');
  Vtop:=VTop+18;
  for i:=0 to PropKategorie.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'Ktg '+TPorovnavanaProperta(propKategorie.Elements[i]).PorProperta,
                            TPorovnavanaProperta(propKategorie.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=Vtop+20; // VLeft:=10;
  VytvorLABEL(Vtop,VLeft,'Zvl.stat.');
  Vtop:=VTop+18;
  for i:=0 to PropZvlSt.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'ZvlSt '+TPorovnavanaProperta(propZvlSt.Elements[i]).PorProperta,
                            TPorovnavanaProperta(propZvlSt.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+120;
  VytvorLABEL(Vtop,VLeft,'Por.skupina');
  Vtop:=VTop+18;
  for i:=0 to PropPorostniSkupina.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,125,'PSK '+TPorovnavanaProperta(PropPorostniSkupina.Elements[i]).PorProperta,
                              TPorovnavanaProperta(PropPorostniSkupina.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+110;
  VytvorLABEL(Vtop,VLeft,'Et');
  Vtop:=VTop+18;
  for i:=0 to PropEtaz.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,125,'ETAZ '+TPorovnavanaProperta(PropEtaz.Elements[i]).PorProperta,
                               TPorovnavanaProperta(PropEtaz.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+130;
  VytvorLABEL(Vtop,VLeft,'Devina');
  Vtop:=VTop+18;
  for i:=0 to PropDrevina.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,171,'DR '+TPorovnavanaProperta(PropDrevina.Elements[i]).PorProperta,
                               TPorovnavanaProperta(PropDrevina.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+180;
  VytvorLABEL(Vtop,VLeft,'Pokozen');
  Vtop:=VTop+18;
  for i:=0 to PropPoskozeni.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'POSK '+TPorovnavanaProperta(PropPoskozeni.Elements[i]).PorProperta,
                               TPorovnavanaProperta(PropPoskozeni.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=Vtop+20;  // VLeft:=690;
  VytvorLABEL(Vtop,VLeft,'Zalesnn');
  Vtop:=VTop+18;
  for i:=0 to PropZalesneni.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'ZAL '+TPorovnavanaProperta(PropZalesneni.Elements[i]).PorProperta,
                                 TPorovnavanaProperta(PropZalesneni.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=Vtop+20; // VLeft:=690;
  VytvorLABEL(Vtop,VLeft,'Bezles');
  Vtop:=VTop+18;
  for i:=0 to PropBezlesi.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,125,'BZL '+TPorovnavanaProperta(PropBezlesi.Elements[i]).PorProperta,
                                TPorovnavanaProperta(PropBezlesi.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=5;  VLeft:=VLeft+130;
  VytvorLABEL(Vtop,VLeft,'Jin pozemek');
  Vtop:=VTop+18;
  for i:=0 to PropJinyPozemek.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'JP '+TPorovnavanaProperta(PropJinyPozemek.Elements[i]).PorProperta,
                               TPorovnavanaProperta(PropJinyPozemek.Elements[i]));
    Vtop:=VTop+16;
   end;

  Vtop:=Vtop+10;  // VLeft:=690;
  VytvorLABEL(Vtop,VLeft,'Ostatn');
  Vtop:=VTop+16;
  for i:=0 to PropOstatni.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,151,'OST '+TPorovnavanaProperta(PropOstatni.Elements[i]).PorProperta,
                               TPorovnavanaProperta(PropOstatni.Elements[i]));
    Vtop:=VTop+16;
   end;

{  Vtop:=5;  VLeft:=VLeft+130;
  for i:=0 to PropLHC.count-1 do
   begin
    VytvorCheckBox(Vtop,VLeft,'LHC '+TPorovnavanaProperta(PropLHC.Elements[i]).PorProperta);
    Vtop:=VTop+16;
   end;    }

 end;
procedure TFPorovnOdd.VytvorCheckBox(Vtop,VLeft,hwidth:integer;jmeno:string;
                                     VPorovnavanaProperta:TPorovnavanaProperta);
var
    VCheckBox1: TCheckBoxPorovn;
begin
  VCheckBox1:= TCheckBoxPorovn.Create(Self);
  with VCheckBox1 do
   begin
    Parent         := self;
    top            := VTop;
    left           := VLeft;
    height         := 21;
    width          := hwidth;
    name           := ubm(jmeno);
    caption        := OdPrvnihoZnaku(jmeno,' ');
    visible        := true;
    Checked        := VPorovnavanaProperta.Porovnavat;
    FPorovnavanaProperta:=VPorovnavanaProperta;
    VPorovnavanaProperta.FCheckBoxPorovn:=VCheckBox1;
   end;
end;
procedure TFPorovnOdd.VytvorLABEL(Vtop,VLeft:integer;jmeno:string);
var
    VLabel: TLabel;
begin
  VLabel:= TLabel.Create(Self);
  with VLabel do
   begin
    Parent         := self;
    top            := VTop;
    left           := VLeft;
    height         := 28;
    width          := 151;
    name           := 'Lab'+vyberjenCislaAPismena(jmeno);
    caption        := jmeno;
    visible        := true;
    font.Style     := [fsBold];
    font.Size      := 10;
   end;
end;

procedure  NactiPorovnProp(Vinitext:Tinifile;PropMN:TPorovnavanaPropertaMN);
var
  i:integer;
  odp:String;
 begin
  for i:=0 to PropMN.count-1 do
   begin
    with TPorovnavanaProperta(propMN.Elements[i]) do
     begin
      Odp:=Vinitext.ReadString(propMN.NazevProIni,PorProperta,'ANO');
      if uppercase(Odp)='ANO' then Porovnavat:=true
                              else Porovnavat:=false;
     end;
   end;
 end;


procedure  ulozPorovnProp(Vinitext:Tinifile;PropMN:TPorovnavanaPropertaMN);
var
  i:integer;
 begin
  for i:=0 to PropMN.count-1 do
   begin
    with TPorovnavanaProperta(propMN.Elements[i]) do
     begin
      if Porovnavat then
       begin
        Vinitext.writeString(propMN.NazevProIni,PorProperta,'ANO');
       end
      else
       begin
        Vinitext.writeString(propMN.NazevProIni,PorProperta,'NE');
       end
     end;
   end;
 end;

procedure TFPorovnOdd.ButUlozClick(Sender: TObject);
 begin
  UlozVsechnyPorovnProp;
 end;
procedure TFPorovnOdd.UlozVsechnyPorovnProp;
var
 initext:Tinifile;
 hl_Cesta :String;
 begin
  hl_Cesta:=KPoslednimuZnaku(Application.ExeName,'\')+'\Porovnavat.ini';
  initext:=Tinifile.create(Hl_cesta);
  ulozPorovnProp(initext,propLHC);
  ulozPorovnProp(initext,propOddeleni);
  ulozPorovnProp(initext,propDilec);
  ulozPorovnProp(initext,propPorost);
  ulozPorovnProp(initext,PropPorostniSkupina);
  ulozPorovnProp(initext,PropEtaz);
  ulozPorovnProp(initext,PropDrevina);
  ulozPorovnProp(initext,PropPoskozeni);
  ulozPorovnProp(initext,PropZalesneni);
  ulozPorovnProp(initext,PropKategorie);
  ulozPorovnProp(initext,PropZvlSt);
  ulozPorovnProp(initext,PropJinyPozemek);
  ulozPorovnProp(initext,PropBezlesi);
  ulozPorovnProp(initext,PropOstatni);
  initext.free;
 end;

procedure TFPorovnOdd.NActiVsechnyPorovnProp;
var
 initext:Tinifile;
 hl_Cesta :String;
 begin
  hl_Cesta:=KPoslednimuZnaku(Application.ExeName,'\')+'\Porovnavat.ini';
  initext:=Tinifile.create(Hl_cesta);
  nactiPorovnProp(initext,propLHC);
  nactiPorovnProp(initext,propOddeleni);
  nactiPorovnProp(initext,propDilec);
  nactiPorovnProp(initext,propPorost);
  nactiPorovnProp(initext,PropPorostniSkupina);
  nactiPorovnProp(initext,PropEtaz);
  nactiPorovnProp(initext,PropDrevina);
  nactiPorovnProp(initext,PropPoskozeni);
  nactiPorovnProp(initext,PropZalesneni);
  nactiPorovnProp(initext,PropKategorie);
  nactiPorovnProp(initext,PropZvlSt);
  nactiPorovnProp(initext,PropJinyPozemek);
  nactiPorovnProp(initext,PropBezlesi);
  nactiPorovnProp(initext,PropOstatni);
  initext.free;
 end;
constructor TPorovnavanaPropertaMN.Create;
 begin
  inherited create;
  FClass:=TPorovnavanaProperta;
  FPredponaName:='pProp';
 end;

procedure TFPorovnOdd.ButNactiClick(Sender: TObject);
begin
 NActiVsechnyPorovnProp;
end;

procedure TCheckBoxPorovn.doexit;
 begin
  inherited DoExit;
  FPorovnavanaProperta.Porovnavat:=checked;
 end;

procedure TCheckBoxPorovn.udelejDoExit;
 begin
  DoExit;
 end;

procedure TFPorovnOdd.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if ActiveControl is TCheckBoxPorovn then
  begin
   TCheckBoxPorovn(Activecontrol).udelejDoExit;
  end;
 UlozVsechnyPorovnProp;
end;

procedure TPorovnavanaProperta.SetPorovnavat(S:Boolean);
 begin
  if FPorovnavat<>S then
   begin
    FPorovnavat:=S;
    if FCheckBoxPorovn<>nil then
     begin
      if FCheckBoxPorovn.checked<>S then
       begin
        FCheckBoxPorovn.checked:=S;
        FCheckBoxPorovn.refresh;
       end;
     end;
   end;
 end;

constructor TPorovnavanaProperta.Create;
 begin
  inherited create;
  FCheckBoxPorovn:=nil;
 end;

procedure TFPorovnOdd.FormShow(Sender: TObject);
begin
 NActiVsechnyPorovnProp;
 FProvadetPorovnavani:=false;
end;



procedure srovnejoddeleni(VOdd1,VOdd2:TOddeleni;Vtable:TTable;AdrZdroj1,AdrZdroj2:String);
var
  IDil,iPor,iPsk,iEt,iDr,iPosk,iZal,IBzl,iJp,iOst,IZvlSt,iKateg : Integer;
  vElement:TElement;
  VDil1,VDil2:tdilec;
  VPor1,Vpor2:Tporost;
  VPsk1,VPsk2:TPorostniSkupina;
  VEtaz1,Vetaz2:TEtaz;
  VDrev1,Vdrev2:Tdrevina;

 begin
  porovnejDveEntity(VOdd1,VOdd2,FPorovnOdd.propOddeleni,VTable);
  for iDil:=0 to VOdd2.DilecMN.count-1 do
   begin
    vElement:=VOdd1.DilecMN.FindElementName(VOdd2.IDilec[idil].name);
    if vElement=nil then
     begin
      Vtable.Append;
      Vtable.edit;
      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
      Vtable.FindField('Dil').AsString:=Vodd2.IDilec[idil].dil;
      Vtable.FindField('Poznamka').AsString:='Dlec '+VOdd2.IDilec[idil].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
      Vtable.post;
     end;
   end;

  for iDil:=0 to VOdd1.DilecMN.count-1 do
   begin
    vElement:=VOdd2.DilecMN.FindElementName(VOdd1.IDilec[idil].name);
    if vElement=nil then
     begin
      Vtable.Append;
      Vtable.edit;
      Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
      Vtable.FindField('Dil').AsString:=Vodd1.IDilec[idil].dil;
      Vtable.FindField('Poznamka').AsString:='Dlec '+VOdd1.IDilec[idil].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
      Vtable.post;
     end
    else
     begin

      VDil1:=Vodd1.IDilec[idil];
      VDil2:=TDilec(vElement);
      porovnejDveEntity(VDil1,VDil2,FPorovnOdd.propDilec,VTable);

      for iPor:=0 to Vdil2.porostMN.count-1 do
       begin
        vElement:=VDil1.porostMN.FindElementName(VDil2.IPorost[iPor].name);
        if vElement=nil then
         begin
          Vtable.Append;
          Vtable.edit;
          Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
          Vtable.FindField('Dil').AsString:=Vdil2.dil;
          Vtable.FindField('Por').AsString:=VDil2.Iporost[iPor].por;
          Vtable.FindField('Poznamka').AsString:=VDil2.Iporost[iPor].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
          Vtable.post;
         end;
       end;
      for iPor:=0 to Vdil1.porostMN.count-1 do
       begin
        vElement:=VDil2.porostMN.FindElementName(VDil1.IPorost[iPor].name);
        if vElement=nil then
         begin
          Vtable.Append;
          Vtable.edit;
          Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
          Vtable.FindField('Dil').AsString:=VDil1.dil;
          Vtable.FindField('Por').AsString:=VDil1.Iporost[iPor].por;
          Vtable.FindField('Poznamka').AsString:=VDil1.Iporost[iPor].CeleOznaceni+' kkk1 ve zdroji '+AdrZdroj2+' chyb.';
          Vtable.post;
         end
        else
         begin
          VPor1:=Vodd1.IDilec[idil].Iporost[iPor];
          VPor2:=TPorost(VElement);
          porovnejDveEntity(VPor1, VPor2,FPorovnOdd.propPorost ,VTable);

          // Muj1,Muj2:TOwnerEntity; PropEnt:TPorovnavanaPropertaMN;Vtable:TTable;

          for IKateg:=0 to VPor2.Kategorie1MN.count-1 do
           begin
            vElement:=VPor1.Kategorie1MN.FindElementName(Vpor2.IKategorie1[iKateg].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IKategorie1[iKateg].KATEGORIE;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IKategorie1[iKateg].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IKateg:=0 to VPor1.Kategorie1MN.count-1 do
           begin
            vElement:=VPor2.Kategorie1MN.FindElementName(Vpor1.IKategorie1[iKateg].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=Vpor1.IKategorie1[iKateg].KATEGORIE;
              Vtable.FindField('Poznamka').AsString:=Vpor1.IKategorie1[iKateg].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IKategorie1[iKateg],TOwnerEntity(vElement),FPorovnOdd.PropKategorie ,VTable);
             end;
           end;

          for IZvlSt:=0 to VPor2.ZvlStMn.count-1 do
           begin
            vElement:=VPor1.ZvlStMN.FindElementName(Vpor2.IZvlSt[iZvlSt].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IZvlSt[iZvlSt].ZVL_STATUT;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IZvlSt[iZvlSt].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IZvlSt:=0 to VPor1.ZvlStMn.count-1 do
           begin
            vElement:=VPor2.ZvlStMN.FindElementName(Vpor1.IZvlSt[iZvlSt].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=Vpor1.IZvlSt[iZvlSt].ZVL_STATUT;
              Vtable.FindField('Poznamka').AsString:=Vpor1.IZvlSt[iZvlSt].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IZvlSt[izvlSt],TOwnerEntity(vElement) ,FPorovnOdd.PropZvlSt ,VTable);
             end;
           end;

          for IBzl:=0 to VPor2.BezlesiMN.count-1 do
           begin
            vElement:=VPor1.BezlesiMN.FindElementName(Vpor2.IBezlesi[iBzl].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IBezlesi[iBzl].BZL);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IBezlesi[iBzl].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;
          for IBzl:=0 to VPor1.BezlesiMN.count-1 do
           begin
            vElement:=VPor2.BezlesiMN.FindElementName(Vpor1.IBezlesi[iBzl].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IBezlesi[iBzl].BZL);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IBezlesi[iBzl].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IBezlesi[iBzl],TOwnerEntity(vElement) ,FPorovnOdd.PropBezlesi ,VTable);
             end;
           end;
          for Ijp:=0 to VPor2.JinyPozemekMN.count-1 do
           begin
            vElement:=VPor1.JinyPozemekMN.FindElementName(Vpor2.IJinyPozemek[ijp].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IJinyPozemek[ijp].jp);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IJinyPozemek[ijp].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for Ijp:=0 to VPor1.JinyPozemekMN.count-1 do
           begin
            vElement:=VPor2.JinyPozemekMN.FindElementName(Vpor1.IJinyPozemek[ijp].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IJinyPozemek[ijp].jp);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IJinyPozemek[ijp].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IJinyPozemek[iJp],TOwnerEntity(vElement) ,FPorovnOdd.PropJinyPozemek ,VTable);
             end;
           end;

          for IOst:=0 to VPor2.OstatniMN.count-1 do
           begin
            vElement:=VPor1.OstatniMN.FindElementName(Vpor2.IOstatni[iOst].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IOstatni[iOst].Ost);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IOstatni[iOst].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IOst:=0 to VPor1.OstatniMN.count-1 do
           begin
            vElement:=VPor2.OstatniMN.FindElementName(Vpor1.IOstatni[iOst].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IOstatni[iOst].Ost);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IOstatni[iOst].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IOstatni[iOst],TOwnerEntity(vElement) ,FPorovnOdd.PropOstatni ,VTable);
             end;

           end;

          for IPsk:=0 to VPor2.porostniSkupinaMN.count-1 do
           begin
            vElement:=VPor1.porostniskupinaMN.FindElementName(Vpor2.IPorostniskupina[iPsk].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IPorostniskupina[iPsk].PSK;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IPorostniskupina[iPsk].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end; // for ipsk
          for IPsk:=0 to VPor1.porostniSkupinaMN.count-1 do
           begin
            vElement:=VPor2.porostniskupinaMN.FindElementName(Vpor1.IPorostniskupina[iPsk].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=Vodd1.IDilec[idil].dil;
              Vtable.FindField('Por').AsString:=Vodd1.IDilec[idil].Iporost[iPor].por;
              Vtable.FindField('Skup').AsString:=Vpor1.IPorostniskupina[iPsk].PSK;
              Vtable.FindField('Poznamka').AsString:=Vpor1.IPorostniskupina[iPsk].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin

              VPsk1:=Vpor1.IPorostniskupina[iPsk];
              VPsk2:=TPorostniskupina(VElement);
              porovnejDveEntity(VPsk1,VPsk2, FPorovnOdd.PropPorostniSkupina ,VTable);

              for IEt:=0 to VPsk2.etazMN.count-1 do
               begin
                vElement:=VPsk1.EtazMN.FindElementName(Vpsk2.IEtaz[iEt].name);
                if vElement=nil then
                 begin
                  Vtable.Append;
                  Vtable.edit;
                  Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                  Vtable.FindField('Dil').AsString:=VDil2.dil;
                  Vtable.FindField('Por').AsString:=VPor2.por;
                  Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                  Vtable.FindField('Etaz').AsString:=VPsk2.IEtaz[iEt].Etaz;
                  Vtable.FindField('Poznamka').AsString:=VPsk2.IEtaz[iEt].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                  Vtable.post;
                 end;
               end; // for iEt
              for IEt:=0 to VPsk1.etazMN.count-1 do
               begin
                vElement:=VPsk2.EtazMN.FindElementName(Vpsk1.IEtaz[iEt].name);
                if vElement=nil then
                 begin
                  Vtable.Append;
                  Vtable.edit;
                  Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                  Vtable.FindField('Dil').AsString:=VDil1.dil;
                  Vtable.FindField('Por').AsString:=VPor1.por;
                  Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                  Vtable.FindField('Etaz').AsString:=VPsk1.IEtaz[iEt].Etaz;
                  Vtable.FindField('Poznamka').AsString:=VPsk1.IEtaz[iEt].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                  Vtable.post;
                 end
                else
                 begin
                  VEtaz1:=Vpsk1.Ietaz[iEt];
                  VEtaz2:=TEtaz(VElement);
                  porovnejDveEntity(VEtaz1,VEtaz2, FPorovnOdd.PropEtaz ,VTable);
                  for IDr:=0 to VEtaz2.DrevinaMN.count-1 do
                   begin
                    vElement:=VEtaz1.DrevinaMN.FindElementName(VEtaz2.IDrevina[iDr].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                      Vtable.FindField('Dil').AsString:=VDil2.dil;
                      Vtable.FindField('Por').AsString:=VPor2.por;
                      Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                      Vtable.FindField('Drev').AsString:=VEtaz2.IDrevina[iDr].DR_ZKR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz2.IDrevina[iDr].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                      Vtable.post;
                     end;
                   end; // for iDr
                  for IDr:=0 to VEtaz1.DrevinaMN.count-1 do
                   begin
                    vElement:=VEtaz2.DrevinaMN.FindElementName(VEtaz1.IDrevina[iDr].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                      Vtable.FindField('Dil').AsString:=VDil1.dil;
                      Vtable.FindField('Por').AsString:=VPor1.por;
                      Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                      Vtable.FindField('Drev').AsString:=VEtaz1.IDrevina[iDr].DR_ZKR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz1.IDrevina[iDr].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                      Vtable.post;
                     end
                    else
                     begin
                      VDrev1:=VEtaz1.IDrevina[iDr];
                      VDrev2:=TDrevina(VElement);
                      porovnejDveEntity(VDrev1,VDrev2, FPorovnOdd.PropDrevina ,VTable);
                      for iPosk:=0 to VDrev2.PoskozeniMN.count-1 do
                       begin
                        vElement:=Vdrev1.PoskozeniMN.FindElementName(Vdrev2.IPoskozeni[iPosk].name);
                        if vElement=nil then
                         begin
                          Vtable.Append;
                          Vtable.edit;
                          Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                          Vtable.FindField('Dil').AsString:=VDil2.dil;
                          Vtable.FindField('Por').AsString:=VPor2.por;
                          Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                          Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                          Vtable.FindField('Drev').AsString:=Vdrev2.DR_ZKR;
                          Vtable.FindField('Posk').AsString:=inttostr(Vdrev2.IPoskozeni[iPosk].POSKOZ_D);
                          Vtable.FindField('Poznamka').AsString:=Vdrev2.IPoskozeni[iPosk].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                          Vtable.post;
                         end
                        else
                         begin
                          porovnejDveEntity(VDrev1,VDrev2, FPorovnOdd.PropDrevina ,VTable);
                         end;
                       end; // for iPosk
                      for iPosk:=0 to VDrev1.PoskozeniMN.count-1 do
                       begin
                        vElement:=Vdrev2.PoskozeniMN.FindElementName(Vdrev1.IPoskozeni[iPosk].name);
                        if vElement=nil then
                         begin
                          Vtable.Append;
                          Vtable.edit;
                          Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                          Vtable.FindField('Dil').AsString:=VDil1.dil;
                          Vtable.FindField('Por').AsString:=VPor1.por;
                          Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                          Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                          Vtable.FindField('Drev').AsString:=Vdrev1.DR_ZKR;
                          Vtable.FindField('Posk').AsString:=inttostr(Vdrev1.IPoskozeni[iPosk].POSKOZ_D);
                          Vtable.FindField('Poznamka').AsString:=Vdrev1.IPoskozeni[iPosk].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                          Vtable.post;
                         end
                        else
                         begin
                          // V1:=VDrev1.IPoskozeni[iPosk];
                          // V2:=TPoskozeni(VElement);
                          porovnejDveEntity(VDrev1.IPoskozeni[iPosk],TPoskozeni(VElement), FPorovnOdd.PropPoskozeni ,VTable);
                         end;
                       end; // for iPosk

                     end;
                   end; // for iDr
                  for IZal:=0 to VEtaz2.ZalesneniMN.count-1 do
                   begin
                    vElement:=VEtaz1.ZalesneniMN.FindElementName(VEtaz2.IZalesneni[iZal].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                      Vtable.FindField('Dil').AsString:=VDil2.dil;
                      Vtable.FindField('Por').AsString:=VPor2.por;
                      Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                      Vtable.FindField('Zales').AsString:=VEtaz2.IZalesneni[iZal].ZAL_DR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz2.IZalesneni[iZal].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                      Vtable.post;
                     end;
                   end; // for iZal

                  for IZal:=0 to VEtaz1.ZalesneniMN.count-1 do
                   begin
                    vElement:=VEtaz2.ZalesneniMN.FindElementName(VEtaz1.IZalesneni[iZal].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                      Vtable.FindField('Dil').AsString:=VDil1.dil;
                      Vtable.FindField('Por').AsString:=VPor1.por;
                      Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                      Vtable.FindField('Zales').AsString:=VEtaz1.IZalesneni[iZal].ZAL_DR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz1.IZalesneni[iZal].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                      Vtable.post;
                     end
                    else
                     begin
                          // V1:=VEtaz1.IZalesneni[iZal];
                          // V2:=TZalesneni(VElement);
                          porovnejDveEntity(VEtaz1.IZalesneni[iZal],TZalesneni(VElement), FPorovnOdd.PropZalesneni ,VTable);
                     end;
                   end; // for iZal

                 end;
               end; // for iEt



             end;
           end; // for ipsk

         end; // element iPor<>nil
       end; // for ipor
       // end;
     end; // element idil<>nil
   end; // for idil
 end;



procedure nactiTextyZOddeleni(VOdd1,VOdd2:TOddeleni;AdrZdroj1,AdrZdroj2:String);
var
  IDil,iPor,iPsk,iEt,iDr,iPosk,iZal,IBzl,iJp,iOst,IZvlSt,iKateg : Integer;
  vElement:TElement;
  VDil1,VDil2:tdilec;
  VPor1,Vpor2:Tporost;
  VPsk1,VPsk2:TPorostniSkupina;
  VEtaz1,Vetaz2:TEtaz;
  VDrev1,Vdrev2:Tdrevina;

 begin
 { porovnejDveEntity(VOdd1,VOdd2,FPorovnOdd.propOddeleni,VTable);
  for iDil:=0 to VOdd2.DilecMN.count-1 do
   begin
    vElement:=VOdd1.DilecMN.FindElementName(VOdd2.IDilec[idil].name);
    if vElement=nil then
     begin
      Vtable.Append;
      Vtable.edit;
      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
      Vtable.FindField('Dil').AsString:=Vodd2.IDilec[idil].dil;
      Vtable.FindField('Poznamka').AsString:='Dlec '+VOdd2.IDilec[idil].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
      Vtable.post;
     end;
   end;
  }
  for iDil:=0 to VOdd1.DilecMN.count-1 do
   begin
    vElement:=VOdd2.DilecMN.FindElementName(VOdd1.IDilec[idil].name);
    if vElement=nil then
     begin
     end
    else
     begin
      VDil1:=Vodd1.IDilec[idil];
      VDil2:=TDilec(vElement);
      for iPor:=0 to Vdil1.porostMN.count-1 do
       begin
        vElement:=VDil2.porostMN.FindElementName(VDil1.IPorost[iPor].name);
        if vElement=nil then
         begin
         end
        else
         begin
          VPor1:=Vodd1.IDilec[idil].Iporost[iPor];
          VPor2:=TPorost(VElement);
          VPor1.POR_TEXT_Vse:=VPor2.POR_TEXT_Vse;
           {
          porovnejDveEntity(VPor1, VPor2,FPorovnOdd.propPorost ,VTable);
          for IKateg:=0 to VPor2.Kategorie1MN.count-1 do
           begin
            vElement:=VPor1.Kategorie1MN.FindElementName(Vpor2.IKategorie1[iKateg].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IKategorie1[iKateg].KATEGORIE;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IKategorie1[iKateg].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IKateg:=0 to VPor1.Kategorie1MN.count-1 do
           begin
            vElement:=VPor2.Kategorie1MN.FindElementName(Vpor1.IKategorie1[iKateg].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=Vpor1.IKategorie1[iKateg].KATEGORIE;
              Vtable.FindField('Poznamka').AsString:=Vpor1.IKategorie1[iKateg].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IKategorie1[iKateg],TOwnerEntity(vElement),FPorovnOdd.PropKategorie ,VTable);
             end;
           end;

          for IZvlSt:=0 to VPor2.ZvlStMn.count-1 do
           begin
            vElement:=VPor1.ZvlStMN.FindElementName(Vpor2.IZvlSt[iZvlSt].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IZvlSt[iZvlSt].ZVL_STATUT;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IZvlSt[iZvlSt].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IZvlSt:=0 to VPor1.ZvlStMn.count-1 do
           begin
            vElement:=VPor2.ZvlStMN.FindElementName(Vpor1.IZvlSt[iZvlSt].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=Vpor1.IZvlSt[iZvlSt].ZVL_STATUT;
              Vtable.FindField('Poznamka').AsString:=Vpor1.IZvlSt[iZvlSt].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IZvlSt[izvlSt],TOwnerEntity(vElement) ,FPorovnOdd.PropZvlSt ,VTable);
             end;
           end;

          for IBzl:=0 to VPor2.BezlesiMN.count-1 do
           begin
            vElement:=VPor1.BezlesiMN.FindElementName(Vpor2.IBezlesi[iBzl].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IBezlesi[iBzl].BZL);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IBezlesi[iBzl].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;
          for IBzl:=0 to VPor1.BezlesiMN.count-1 do
           begin
            vElement:=VPor2.BezlesiMN.FindElementName(Vpor1.IBezlesi[iBzl].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IBezlesi[iBzl].BZL);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IBezlesi[iBzl].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IBezlesi[iBzl],TOwnerEntity(vElement) ,FPorovnOdd.PropBezlesi ,VTable);
             end;
           end;
          for Ijp:=0 to VPor2.JinyPozemekMN.count-1 do
           begin
            vElement:=VPor1.JinyPozemekMN.FindElementName(Vpor2.IJinyPozemek[ijp].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IJinyPozemek[ijp].jp);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IJinyPozemek[ijp].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for Ijp:=0 to VPor1.JinyPozemekMN.count-1 do
           begin
            vElement:=VPor2.JinyPozemekMN.FindElementName(Vpor1.IJinyPozemek[ijp].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IJinyPozemek[ijp].jp);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IJinyPozemek[ijp].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IJinyPozemek[iJp],TOwnerEntity(vElement) ,FPorovnOdd.PropJinyPozemek ,VTable);
             end;
           end;

          for IOst:=0 to VPor2.OstatniMN.count-1 do
           begin
            vElement:=VPor1.OstatniMN.FindElementName(Vpor2.IOstatni[iOst].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor2.IOstatni[iOst].Ost);
              Vtable.FindField('Poznamka').AsString:=Vpor2.IOstatni[iOst].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end;

          for IOst:=0 to VPor1.OstatniMN.count-1 do
           begin
            vElement:=VPor2.OstatniMN.FindElementName(Vpor1.IOstatni[iOst].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
              Vtable.FindField('Dil').AsString:=VDil1.dil;
              Vtable.FindField('Por').AsString:=VPor1.por;
              Vtable.FindField('Skup').AsString:=inttostr(Vpor1.IOstatni[iOst].Ost);
              Vtable.FindField('Poznamka').AsString:=Vpor1.IOstatni[iOst].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
              Vtable.post;
             end
            else
             begin
              porovnejDveEntity(Vpor1.IOstatni[iOst],TOwnerEntity(vElement) ,FPorovnOdd.PropOstatni ,VTable);
             end;

           end;

          for IPsk:=0 to VPor2.porostniSkupinaMN.count-1 do
           begin
            vElement:=VPor1.porostniskupinaMN.FindElementName(Vpor2.IPorostniskupina[iPsk].name);
            if vElement=nil then
             begin
              Vtable.Append;
              Vtable.edit;
              Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
              Vtable.FindField('Dil').AsString:=VDil2.dil;
              Vtable.FindField('Por').AsString:=VPor2.por;
              Vtable.FindField('Skup').AsString:=Vpor2.IPorostniskupina[iPsk].PSK;
              Vtable.FindField('Poznamka').AsString:=Vpor2.IPorostniskupina[iPsk].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
              Vtable.post;
             end;
           end; // for ipsk
           }
          for IPsk:=0 to VPor1.porostniSkupinaMN.count-1 do
           begin
            vElement:=VPor2.porostniskupinaMN.FindElementName(Vpor1.IPorostniskupina[iPsk].name);
            if vElement=nil then
             begin
             end
            else
             begin

              VPsk1:=Vpor1.IPorostniskupina[iPsk];
              VPsk2:=TPorostniskupina(VElement);
              // VPsk1.PSK_TEXT:= VPsk2.PSK_TEXT;   fungovalo by, kdyby se porovnvali texty
              {
              porovnejDveEntity(VPsk1,VPsk2, FPorovnOdd.PropPorostniSkupina ,VTable);

              for IEt:=0 to VPsk2.etazMN.count-1 do
               begin
                vElement:=VPsk1.EtazMN.FindElementName(Vpsk2.IEtaz[iEt].name);
                if vElement=nil then
                 begin
                  Vtable.Append;
                  Vtable.edit;
                  Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                  Vtable.FindField('Dil').AsString:=VDil2.dil;
                  Vtable.FindField('Por').AsString:=VPor2.por;
                  Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                  Vtable.FindField('Etaz').AsString:=VPsk2.IEtaz[iEt].Etaz;
                  Vtable.FindField('Poznamka').AsString:=VPsk2.IEtaz[iEt].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                  Vtable.post;
                 end;
               end; // for iEt
              for IEt:=0 to VPsk1.etazMN.count-1 do
               begin
                vElement:=VPsk2.EtazMN.FindElementName(Vpsk1.IEtaz[iEt].name);
                if vElement=nil then
                 begin
                  Vtable.Append;
                  Vtable.edit;
                  Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                  Vtable.FindField('Dil').AsString:=VDil1.dil;
                  Vtable.FindField('Por').AsString:=VPor1.por;
                  Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                  Vtable.FindField('Etaz').AsString:=VPsk1.IEtaz[iEt].Etaz;
                  Vtable.FindField('Poznamka').AsString:=VPsk1.IEtaz[iEt].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                  Vtable.post;
                 end
                else
                 begin
                  VEtaz1:=Vpsk1.Ietaz[iEt];
                  VEtaz2:=TEtaz(VElement);
                  porovnejDveEntity(VEtaz1,VEtaz2, FPorovnOdd.PropEtaz ,VTable);
                  for IDr:=0 to VEtaz2.DrevinaMN.count-1 do
                   begin
                    vElement:=VEtaz1.DrevinaMN.FindElementName(VEtaz2.IDrevina[iDr].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                      Vtable.FindField('Dil').AsString:=VDil2.dil;
                      Vtable.FindField('Por').AsString:=VPor2.por;
                      Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                      Vtable.FindField('Drev').AsString:=VEtaz2.IDrevina[iDr].DR_ZKR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz2.IDrevina[iDr].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                      Vtable.post;
                     end;
                   end; // for iDr
                  for IDr:=0 to VEtaz1.DrevinaMN.count-1 do
                   begin
                    vElement:=VEtaz2.DrevinaMN.FindElementName(VEtaz1.IDrevina[iDr].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                      Vtable.FindField('Dil').AsString:=VDil1.dil;
                      Vtable.FindField('Por').AsString:=VPor1.por;
                      Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                      Vtable.FindField('Drev').AsString:=VEtaz1.IDrevina[iDr].DR_ZKR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz1.IDrevina[iDr].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                      Vtable.post;
                     end
                    else
                     begin
                      VDrev1:=VEtaz1.IDrevina[iDr];
                      VDrev2:=TDrevina(VElement);
                      porovnejDveEntity(VDrev1,VDrev2, FPorovnOdd.PropDrevina ,VTable);
                      for iPosk:=0 to VDrev2.PoskozeniMN.count-1 do
                       begin
                        vElement:=Vdrev1.PoskozeniMN.FindElementName(Vdrev2.IPoskozeni[iPosk].name);
                        if vElement=nil then
                         begin
                          Vtable.Append;
                          Vtable.edit;
                          Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                          Vtable.FindField('Dil').AsString:=VDil2.dil;
                          Vtable.FindField('Por').AsString:=VPor2.por;
                          Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                          Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                          Vtable.FindField('Drev').AsString:=Vdrev2.DR_ZKR;
                          Vtable.FindField('Posk').AsString:=inttostr(Vdrev2.IPoskozeni[iPosk].POSKOZ_D);
                          Vtable.FindField('Poznamka').AsString:=Vdrev2.IPoskozeni[iPosk].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                          Vtable.post;
                         end
                        else
                         begin
                          porovnejDveEntity(VDrev1,VDrev2, FPorovnOdd.PropDrevina ,VTable);
                         end;
                       end; // for iPosk
                      for iPosk:=0 to VDrev1.PoskozeniMN.count-1 do
                       begin
                        vElement:=Vdrev2.PoskozeniMN.FindElementName(Vdrev1.IPoskozeni[iPosk].name);
                        if vElement=nil then
                         begin
                          Vtable.Append;
                          Vtable.edit;
                          Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                          Vtable.FindField('Dil').AsString:=VDil1.dil;
                          Vtable.FindField('Por').AsString:=VPor1.por;
                          Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                          Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                          Vtable.FindField('Drev').AsString:=Vdrev1.DR_ZKR;
                          Vtable.FindField('Posk').AsString:=inttostr(Vdrev1.IPoskozeni[iPosk].POSKOZ_D);
                          Vtable.FindField('Poznamka').AsString:=Vdrev1.IPoskozeni[iPosk].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                          Vtable.post;
                         end
                        else
                         begin
                          // V1:=VDrev1.IPoskozeni[iPosk];
                          // V2:=TPoskozeni(VElement);
                          porovnejDveEntity(VDrev1.IPoskozeni[iPosk],TPoskozeni(VElement), FPorovnOdd.PropPoskozeni ,VTable);
                         end;
                       end; // for iPosk

                     end;
                   end; // for iDr
                  for IZal:=0 to VEtaz2.ZalesneniMN.count-1 do
                   begin
                    vElement:=VEtaz1.ZalesneniMN.FindElementName(VEtaz2.IZalesneni[iZal].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd2.odd;
                      Vtable.FindField('Dil').AsString:=VDil2.dil;
                      Vtable.FindField('Por').AsString:=VPor2.por;
                      Vtable.FindField('Skup').AsString:=VPsk2.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz2.Etaz;
                      Vtable.FindField('Zales').AsString:=VEtaz2.IZalesneni[iZal].ZAL_DR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz2.IZalesneni[iZal].CeleOznaceni+' ve zdroji '+AdrZdroj1+' chyb.';
                      Vtable.post;
                     end;
                   end; // for iZal

                  for IZal:=0 to VEtaz1.ZalesneniMN.count-1 do
                   begin
                    vElement:=VEtaz2.ZalesneniMN.FindElementName(VEtaz1.IZalesneni[iZal].name);
                    if vElement=nil then
                     begin
                      Vtable.Append;
                      Vtable.edit;
                      Vtable.FindField('Odd').AsInteger:=VOdd1.odd;
                      Vtable.FindField('Dil').AsString:=VDil1.dil;
                      Vtable.FindField('Por').AsString:=VPor1.por;
                      Vtable.FindField('Skup').AsString:=VPsk1.PSK;
                      Vtable.FindField('Etaz').AsString:=Vetaz1.Etaz;
                      Vtable.FindField('Zales').AsString:=VEtaz1.IZalesneni[iZal].ZAL_DR;
                      Vtable.FindField('Poznamka').AsString:=Vetaz1.IZalesneni[iZal].CeleOznaceni+' ve zdroji '+AdrZdroj2+' chyb.';
                      Vtable.post;
                     end
                    else
                     begin
                          // V1:=VEtaz1.IZalesneni[iZal];
                          // V2:=TZalesneni(VElement);
                          porovnejDveEntity(VEtaz1.IZalesneni[iZal],TZalesneni(VElement), FPorovnOdd.PropZalesneni ,VTable);
                     end;
                   end; // for iZal

                 end;
               end; // for iEt                }



             end;
           end; // for ipsk

         end; // element iPor<>nil
       end; // for ipor
       // end;
     end; // element idil<>nil
   end; // for idil
 end;

procedure porovnejDveEntity(Muj1,Muj2:TOwnerEntity; PropEnt:TPorovnavanaPropertaMN;Vtable:TTable);
var
 i:integer;
 S1,S2 : string;
 begin
  for I:=0 to PropEnt.Count-1 do
   begin
    if not (TPorovnavanaProperta(PropEnt.Elements[i]).FPorovnavat) then continue;
    S1:=Muj1.GetPropertyStringByName(TPorovnavanaProperta(PropEnt.Elements[i]).fPorProperta);
    S2:=Muj2.GetPropertyStringByName(TPorovnavanaProperta(PropEnt.Elements[i]).fPorProperta);
    if S1<>S2 then
     begin
      Vtable.Append;
      Vtable.edit;
      if Muj1 is TOddeleni then
         begin
          Vtable.fieldbyName('Odd').AsInteger:=toddeleni(Muj1).ODD;
         end;
      if Muj1 is TDilec then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TDilec(Muj1).ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TDilec(Muj1).DIL;
         end;

      if Muj1 is TPorost then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TPorost(Muj1).ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TPorost(Muj1).ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TPorost(Muj1).POR;
         end;

      if Muj1 is TKategorie1 then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TKategorie1(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TKategorie1(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TKategorie1(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('Ktg').AsString:=TKategorie1(Muj1).KATEGORIE;
         end;

      if Muj1 is TZvlSt then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TZvlSt(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TZvlSt(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TZvlSt(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('ZvlSt').AsString:=TZvlSt(Muj1).ZVL_STATUT;
         end;

      if Muj1 is TPorostniSkupina then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TPorostniSkupina(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TPorostniSkupina(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TPorostniSkupina(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TPorostniSkupina(Muj1).PSK;
         end;

      if Muj1 is TEtaz then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TEtaz(Muj1).ownerPorostniSkupina.ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TEtaz(Muj1).ownerPorostniSkupina.ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TEtaz(Muj1).ownerPorostniSkupina.ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TEtaz(Muj1).ownerPorostniSkupina.PSK;
          Vtable.FieldbyName('Etaz').AsString:=TEtaz(Muj1).etaz;
         end;

      if Muj1 is TZalesneni then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TZalesneni(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TZalesneni(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TZalesneni(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TZalesneni(Muj1).ownerEtaz.ownerPorostniSkupina.PSK;
          Vtable.FieldbyName('Etaz').AsString:=TZalesneni(Muj1).ownerEtaz.etaz;
          Vtable.FieldbyName('Zales').AsString:=TZalesneni(Muj1).ZAL_DR;
         end;

      if Muj1 is TDrevina then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.PSK;
          Vtable.FieldbyName('Etaz').AsString:=TDrevina(Muj1).ownerEtaz.etaz;
          Vtable.FieldbyName('Drev').AsString:=TDrevina(Muj1).DR_ZKR;
         end;

      if Muj1 is TDrevina then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TDrevina(Muj1).ownerEtaz.ownerPorostniSkupina.PSK;
          Vtable.FieldbyName('Etaz').AsString:=TDrevina(Muj1).ownerEtaz.etaz;
          Vtable.FieldbyName('Drev').AsString:=TDrevina(Muj1).DR_ZKR;
         end;

      if Muj1 is TPoskozeni then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TPoskozeni(Muj1).ownerDrevina.ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TPoskozeni(Muj1).ownerDrevina.ownerEtaz.ownerPorostniSkupina.ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TPoskozeni(Muj1).ownerDrevina.ownerEtaz.ownerPorostniSkupina.ownerPorost.POR;
          Vtable.FieldbyName('Skup').AsString:=TPoskozeni(Muj1).ownerDrevina.ownerEtaz.ownerPorostniSkupina.PSK;
          Vtable.FieldbyName('Etaz').AsString:=TPoskozeni(Muj1).ownerDrevina.ownerEtaz.etaz;
          Vtable.FieldbyName('Drev').AsString:=TPoskozeni(Muj1).ownerDrevina.DR_ZKR;
          Vtable.FieldbyName('Posk').AsString:=inttostr(TPoskozeni(Muj1).POSKOZ_D);
         end;

      if Muj1 is TBezlesi then
         begin
          Vtable.FieldbyName('Odd').AsInteger:=TBezlesi(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString:=TBezlesi(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString:=TBezlesi(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('BZL').AsString:=inttostr(TBezlesi(Muj1).BZL);
         end;

      if Muj1 is TJinyPozemek then
         begin
          Vtable.FieldbyName('Odd').AsInteger :=TJinyPozemek(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString  :=TJinyPozemek(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString  :=TJinyPozemek(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('Jine').AsString :=inttostr(TJinyPozemek(Muj1).JP);
         end;

      if Muj1 is TOstatni then
         begin
          Vtable.FieldbyName('Odd').AsInteger :=TOstatni(Muj1).ownerPorost.ownerDilec.ownerOddeleni.ODD;
          Vtable.FieldbyName('Dil').AsString  :=TOstatni(Muj1).ownerPorost.ownerDilec.DIL;
          Vtable.FieldbyName('Por').AsString  :=TOstatni(Muj1).ownerPorost.POR;
          Vtable.FieldbyName('Ost').AsString :=inttostr(TOstatni(Muj1).OST);
         end;

        Vtable.FieldbyName('Vlastnost').AsString:= TPorovnavanaProperta(PropEnt.Elements[i]).fPorProperta;
        Vtable.FieldbyName('Hodnota1').AsString:= S1;
        Vtable.FieldbyName('Hodnota2').AsString:= S2;

      Vtable.post;
     end;
   end;
 end;

procedure TFPorovnOdd.Button1Click(Sender: TObject);
begin
 FprovadetPorovnavani:=False;
 close;
end;

procedure TFPorovnOdd.ButPorovnClick(Sender: TObject);
begin
 FprovadetPorovnavani:=true;
 close;
end;

procedure TFPorovnOdd.ButZapVseClick(Sender: TObject);
var i:integer;
begin
 for i:=0 to ComponentCount-1 do
  begin
   if (Components[i] is TCheckBoxPorovn) then
    begin
     with TCheckBoxPorovn(Components[i]) do
      begin
       Checked:=true;
       FPorovnavanaProperta.Porovnavat:=checked;
      end;
    end;
  end;
 refresh;
end;

procedure TFPorovnOdd.ButVypVseClick(Sender: TObject);
var i:integer;
begin
 for i:=0 to ComponentCount-1 do
  begin
   if (Components[i] is TCheckBoxPorovn) then
    begin
     with TCheckBoxPorovn(Components[i]) do
      begin
       Checked:=false;
       FPorovnavanaProperta.Porovnavat:=checked;
      end;
    end;
  end;
 refresh;
end;

end.
