unit ELHEvidence;

interface

uses sysUtils,Dialogs,dbtables,DB,
     ELesObec,LesCisOr,mat1,
     E_Class,U_props,T_oper,TypInfo,
     elements,creacond,U_Podmin,LesCisel;
type
 TtrideniEvidence = ( EvDlePSK, EvDleDatumu, EvDleCasuZadani );

 TSloupecRocniVykaz = class(TObecnyLesniPrvek)
  private
   fOdd:integer;
   fDIL:string;
   fPOR:string;
   fPSK:string;
   fEtaz:string;
   fZalesneniNelesnichPud:double;
   fVznikHoliny:double;
   fZalesneni:double;
   fZalesneniMZD:double;
   fProrezavky:double;
   fProbirky40:double;
   fPU:integer;
   fMU:integer;
   fPN:integer;
   fMN:integer;
   fKurovec:integer;
   function GetEtaz:string;
   function GetOddDilPorPskEtMinus:string;
   function GetOddDilPorPskEt:string;
   function GetTezbaCelkem:integer;
  published
   property Odd:integer read fOdd write fOdd;
   property DIL:string read fDIL write fDIL;
   property POR:string read fPOR write fPOR;
   property PSK:string read fPSK write fPSK;
   property Etaz:string read GetEtaz write fETAZ;
   property ZalesneniNelesnichPud:double read fZalesneniNelesnichPud write fZalesneniNelesnichPud;
   property VznikHoliny:double read fVznikHoliny write fVznikHoliny;
   property Zalesneni:double read fZalesneni write fZalesneni;
   property ZalesneniMZD:double read fZalesneniMZD write fZalesneniMZD;
   property Prorezavky:double read fProrezavky write fProrezavky;
   property Probirky40:double read fProbirky40 write fProbirky40;
   property PU:integer read fPU write fPU;
   property MU:integer read fMU write fMU;
   property PN:integer read fPN write fPN;
   property MN:integer read fMN write fMN;
   property Kurovec:integer read fKurovec write fKurovec;
   property TezbaCelkem:integer read GetTezbaCelkem;
   property OddDilPorPskEtMinus:string read GetOddDilPorPskEtMinus;
   property OddDilPorPskEt:string read GetOddDilPorPskEt;

  end;

 TSloupecRocniVykazMN = class(TLesniMnozina)
  private
  public
   VypoctenoZaRok :integer;
   constructor Create; override;
  published
  end;
 TMesicKurovce = class(TObecnyLesniPrvek)
  private
   fKonecnyStav:integer;
   fPrirustek:integer;
   fUbytek:integer;
  published
   property Ubytek:integer read fUbytek write fUbytek;
   property Prirustek:integer read fPrirustek write fPrirustek;
   property KonecnyStav:integer read fKonecnyStav write fKonecnyStav;
  end;

 TMesicKurovceMN = class(TLesniMnozina)
  private
  public
   VypoctenoZaRok :integer;
   function getMesicKurovce(mesic:Integer) :TMesicKurovce;
   constructor Create; override;
   destructor destroy; override;
  published


  end;
 TRadekLHEvidenceMN = class;
 TRadekLHEvidence = class(TObecnyLesniPrvek)
  private
   FODD:integer;
   FDIL:string;
   FPOR:string;
   FPSK:string;
   FETAZ:string;
   FMAJ_KOD   :string;
   FMAJ_DRUH  :integer;
   FDruhUkonu :string;
   FPoznamka  :string;
   FPlocha    :Double;
   FDrevina   :string;
   FMnozstvi  :Double;
   FVykon     :integer;
   FPodVykon  :integer;
   FRok       :integer;
   FMesic     :integer;
   FDen       :integer;
   FJeMZD       :string;
   FDruhPohybu:integer;
   FCisloDokladu:integer;
   FPrirustekHoliny:integer;  //(+1 prirustek,-1 ubytek, 0- nic)

   FRokZadani:integer;
   FMesicZadani:integer;
   FDenZadani:integer;
   FZadaniHodina:integer;
   FZadaniMinuta:integer;
   FZadaniVterina:integer;

   function GetOddDilPorPskEtMinus:string;
   function GetOddDilPorPskEt:string;
   function GetVykPodvykDat:string;
   function GetRokMesicVykon:string;
   function GetCasZadani:string;

   function GetKod:LongInt;
   function GetNazevCinnosti:String;
   function GetSrafa:String;
   function GetEtaz:String;
   function GetPSK:string;
  public
   function OwnerRadekLHEvidenceMN:TRadekLHEvidenceMN;
  published
   property ODD:integer read FODD write FODD;
   property DIL:string read FDIL write FDIL;
   property POR:string read FPOR write FPOR;
   property PSK:string read GetPSK write FPSK;
   property ETAZ:string read getETAZ write FETAZ;
   property MAJ_KOD:string read FMAJ_KOD write FMAJ_KOD;
   property MAJ_DRUH:integer read FMAJ_DRUH write FMAJ_DRUH;
   property CisloDokladu:integer read FCisloDokladu write FCisloDokladu;
   property DruhUkonu:string read FDruhUkonu write FDruhUkonu;
   property DruhPohybu:integer read FDruhPohybu write FDruhPohybu;
   property Vykon:integer read FVykon write FVykon;
   property PodVykon:integer read FPodVykon write FPodVykon;
   property Rok:integer read FRok write FRok;
   property Mesic:integer read FMesic write FMesic;
   property Den:integer read FDen write FDen;
   property Drevina:string read Fdrevina write Fdrevina;
   property JeMZD:string read FJeMZD write FJeMZD;

   property RokZadani:integer read FRokZadani write FRokZadani;
   property MesicZadani:integer read FMesicZadani write FMesicZadani;
   property DenZadani:integer read FDenZadani write FDenZadani;
   property ZadaniHodina:integer read FZadaniHodina write FZadaniHodina;
   property ZadaniMinuta:integer read FZadaniMinuta write FZadaniMinuta;
   property ZadaniVterina:integer read FZadaniVterina write FZadaniVterina;

   property Plocha:Double read FPlocha write FPlocha;
   property Mnozstvi:Double read FMnozstvi write FMnozstvi;
   property Poznamka:string read FPoznamka write FPoznamka;
   property PrirustekHoliny:integer read FPrirustekHoliny write FPrirustekHoliny;

   property OddDilPorPskEt:string  read GetOddDilPorPskEt stored false;
   property OddDilPorPskEtMinus:string read GetOddDilPorPskEtMinus stored false;
   property VykPodvykDat:string read GetVykPodvykDat stored false;
   property RokMesicVykon:string read GetRokMesicVykon stored false;
   property CasZadani:string read GetCasZadani stored false;
   property Kod:longint  read GetKod stored false;
   property NazevCinnosti:String  read GetNazevCinnosti stored false;
   property Srafa :string   read GetSrafa stored false;
  end;

 TRadekLHEvidenceMN = class(TLesniMnozina)
  private
   FMesicKurovceMN:TMesicKurovceMN;
   fdruhtrideni:TtrideniEvidence;
  public
   FSloupecRocniVykazMN:TSloupecRocniVykazMN;
   ciselVykonPodVykon:TTable;
   function GetSoucetKurovce(ZaRok:integer): TMesicKurovceMN;
   function GetRocniVykaz(ZaRok:integer;vMAJ_KOD:string): TSloupecRocniVykazMN;

   constructor Create; override;
   procedure nastavAktualDleOddDilPorPskEtMinus(VOddDilPorPskEtMinus:string);
   procedure aktualizujKurovce(Vrok:integer);
   procedure aktualizujRocniVykaz(Vrok:integer;vMAJ_KOD:string);
  published
   property Druhtrideni:TtrideniEvidence read FDruhtrideni write FDruhtrideni;

  end;

implementation
uses  E_LesOdd;

constructor TSloupecRocniVykazMN.Create;
 begin
  inherited create;
  FClass:=TSloupecRocniVykaz;
  FPredponaName:='RocniVyk';
 end;

constructor TMesicKurovceMN.Create;
var i:integer;
 begin
  inherited create;
  FClass:=TMesicKurovce;
  FPredponaName:='Kurovec';
  for i:=0 to 12 do
   begin
    addelement(TMesicKurovce.create);
   end;
 end;

destructor TMesicKurovceMN.destroy;
 begin
  inherited destroy;
 end;

constructor TRadekLHEvidenceMN.Create;
 begin
  inherited create;
  FClass:=TRadekLHEvidence;
  FPredponaName:='R_LHEVID';
  FMesicKurovceMN:=nil;
 end;
function TRadekLHEvidence.GetOddDilPorPskEt:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,' ')+DIL+POR+PSK+ETAZ;
 end;
function TRadekLHEvidence.GetOddDilPorPskEtMinus:string;
 begin
  try
   result:=DoplnZePreduZnakem1(inttostr(ODD),4,'-')+DIL+POR+PSK+ETAZ;
  except
   result:='';
  end;
 end;
function TRadekLHEvidence.GetVykPodvykDat:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(Vykon),4,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(PodVykon),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(rok),5,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(Mesic),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(Den),3,'0');
 end;

function TRadekLHEvidence.GetRokMesicVykon:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(rok),5,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(Mesic),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(Vykon),4,'0');
 end;
function TRadekLHEvidence.GetCasZadani:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(RokZadani),5,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(MesicZadani),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(DenZadani),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(ZadaniHodina),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(ZadaniMinuta),3,'0');
  result:=result+DoplnZePreduZnakem1(inttostr(Zadanivterina),3,'0');
 end;


function TSloupecRocniVykaz.GetOddDilPorPskEtMinus:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,'-')+DIL+POR+PSK+ETAZ;
 end;
function TSloupecRocniVykaz.GetOddDilPorPskEt:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,' ')+DIL+POR+PSK+ETAZ;
 end;

function TRadekLHEvidence.OwnerRadekLHEvidenceMN:TRadekLHEvidenceMN;
 begin
  result:=TRadekLHEvidenceMN(OwnerTypu(TRadekLHEvidenceMN));
 end;

function TRadekLHEvidence.GetKod:LongInt;
 begin
  result:=vykon*1000+podvykon;
 end;

function TRadekLHEvidence.GetNazevCinnosti:String;
 begin
  if OwnerRadekLHEvidenceMN=nil then
   begin
    result:='';
    exit;
   end;
  result:=DleCiselniku(OwnerRadekLHEvidenceMN.ciselVykonPodVykon,'Kod',
                       inttostr(Kod),'POPIS',false);
 end;

function TRadekLHEvidence.GetSrafa:string;
 begin
  if OwnerRadekLHEvidenceMN=nil then
   begin
    result:='';
    exit;
   end;
  if OwnerRadekLHEvidenceMN.ciselVykonPodVykon=nil then
   begin
    // showmessage('RadekLHEvidenceMN.ciselVykonPodVykon = nil');
    result:='*';
   end
  else
   begin
    result:=DleCiselniku(OwnerRadekLHEvidenceMN.ciselVykonPodVykon,'Kod',
                       inttostr(Kod),'SRAFA',false);
   end;
 end;

procedure TRadekLHEvidenceMN.nastavAktualDleOddDilPorPskEtMinus(VOddDilPorPskEtMinus:string);
var
 index1:integer;
 begin
  if aktualniPrvek<>nil then
   begin
    if TRadekLHEvidence(aktualniPrvek).OddDilPorPskEtMinus=VOddDilPorPskEtMinus then
     begin
      exit;
     end;
   end;
  index1:=GetIndexNejblizsihoPrvkuPodleSetridenePropertyString
                     ('OddDilPorPskEtMinus',VOddDilPorPskEtMinus);
  if index1=-1 then
   begin
    aktualniPrvek:=getPrazdny;
    exit;
   end;
  if TRadekLHEvidence(elements[index1]).OddDilPorPskEtMinus=VOddDilPorPskEtMinus then
   begin
    aktualniPrvek:=elements[index1];
   end
  else
   begin
    aktualniPrvek:=getPrazdny;
   end;
 end;

function TMesicKurovceMN.getMesicKurovce(mesic:Integer) :TMesicKurovce;
 begin
  result:=TMesicKurovce(elements[mesic]);
 end;

procedure TRadekLHEvidenceMN.aktualizujRocniVykaz(Vrok:integer;vMAJ_KOD:string);
var i,Evmesic:integer;
 procedure nastavNeboVytvor;
  begin
   with TRadekLHEvidence(elements[i]) do
    begin
     FSloupecRocniVykazMN.nastavNeboVytvorAktualDleProperty('OddDilPorPskEtMinus',OddDilPorPskEtMinus);
     if TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).OddDilPorPskEtMinus<>OddDilPorPskEtMinus then
      begin
       TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ODD:=ODD;
       TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).DIL:=DIL;
       TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).POR:=POR;
       TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).PSK:=PSK;
       TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ETAZ:=ETAZ;
      end;
    end;
  end;

 begin
  FSloupecRocniVykazMN.SmazVsechnyPrvkyVMnozine;
  FSloupecRocniVykazMN.VypoctenoZaRok:=VRok;
  for i:=0 to count-1 do
   begin
    with TRadekLHEvidence(elements[i]) do
     begin
      // showmessage('rok='+)
      if (rok = VRok)and((vMAJ_KOD=MAJ_KOD)or(VMAJ_KOD='')) then
       begin
        if (Vykon=11) and (PodVykon=51) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ZalesneniNelesnichPud:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ZalesneniNelesnichPud+Plocha;
         end;
        if (Vykon=10) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).VznikHoliny:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ZalesneniNelesnichPud+Plocha;
         end;
        if (Vykon=11) and (PodVykon<>51) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Zalesneni:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ZalesneniNelesnichPud+Plocha;
          if JeMZD='ANO' then
           begin
            TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Zalesneni:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).ZalesneniNelesnichPud+Plocha;
           end;
         end;
        if (Vykon=25) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Prorezavky:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Prorezavky+Plocha;
         end;
        if (Vykon=111) and (PodVykon=2) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Probirky40:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Probirky40+Plocha;
         end;
        if (Vykon=111) and ((PodVykon=1)or(PodVykon=2)or(PodVykon=3)) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).PU:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).PU+round(Mnozstvi);
         end;
        if (Vykon=111) and ((PodVykon=13)or(PodVykon=15)or(PodVykon=16)or(PodVykon=19)) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).MU:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).MU+round(Mnozstvi);
         end;
        if (Vykon=111) and ((PodVykon=5)or(PodVykon=6)or(PodVykon=8)or(PodVykon=10)or(PodVykon=11)) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).MN:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).MN+round(Mnozstvi);
         end;
        if (Vykon=111) and ((PodVykon=5)) then
         begin
          nastavNeboVytvor;
          TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Kurovec:=TSloupecRocniVykaz(FSloupecRocniVykazMN.AktualniPrvek).Kurovec+round(Mnozstvi);
         end;
       end;
     end;
   end;
  FSloupecRocniVykazMN.InsertElement(0,TSloupecRocniVykaz.create);
  for i:=1 to FSloupecRocniVykazMN.count-1 do
   begin
    with TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[0]) do
     begin
      ZalesneniNelesnichPud:=ZalesneniNelesnichPud+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).ZalesneniNelesnichPud;
      VznikHoliny:=VznikHoliny+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).VznikHoliny;
      Zalesneni:=Zalesneni+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).Zalesneni;
      ZalesneniMZD:=ZalesneniMZD+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).ZalesneniMZD;
      Prorezavky:=Prorezavky+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).Prorezavky;
      Probirky40:=Probirky40+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).Probirky40;
      PU:=PU+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).PU;
      MU:=MU+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).MU;
      PN:=PN+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).PN;
      MN:=MN+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).MN;
      Kurovec:=Kurovec+TSloupecRocniVykaz(FSloupecRocniVykazMN.elements[i]).Kurovec;
     end;
   end;
 end;

procedure TRadekLHEvidenceMN.aktualizujKurovce(Vrok:integer);
var i,Evmesic:integer;
 begin
  for i:=0 to FMesicKurovceMN.count-1 do
   begin
    with TMesicKurovce(FmesicKurovceMN.elements[i]) do
     begin
      fKonecnyStav:=0;
      fPrirustek:=0;
      fUbytek:=0;
     end;
   end;
  FMesicKurovceMN.VypoctenoZaRok:=VRok;
  for i:=0 to count-1 do
   begin
    with TRadekLHEvidence(elements[i]) do
     begin
      if (rok < VRok) then
       begin
        if (FVykon=111) and (FPodvykon=5) then
         begin
          TMesicKurovce(FmesicKurovceMN.elements[0]).fKonecnyStav
             :=TMesicKurovce(FmesicKurovceMN.elements[0]).fKonecnyStav-round(Mnozstvi);
         end;
        if (FVykon=700) then
         begin
          TMesicKurovce(FmesicKurovceMN.elements[0]).fKonecnyStav
             :=TMesicKurovce(FmesicKurovceMN.elements[0]).fKonecnyStav+round(Mnozstvi);
         end;
       end
      else
       begin
        if (rok=VRok) then
         begin
          EvMesic:=Mesic;
          if den>15 then
           begin
            Evmesic:=Evmesic+1;
            if EvMesic=13 then EvMesic:=12;
           end;
          if (FVykon=111) and (FPodvykon=5) then
           begin
            TMesicKurovce(FmesicKurovceMN.elements[Evmesic]).fUbytek
               :=TMesicKurovce(FmesicKurovceMN.elements[Evmesic]).fUbytek+round(Mnozstvi);
           end;
          if (FVykon=700) then
           begin
            TMesicKurovce(FmesicKurovceMN.elements[Evmesic]).fPrirustek
              :=TMesicKurovce(FmesicKurovceMN.elements[Evmesic]).fPrirustek+round(Mnozstvi);
           end;
         end;
       end;
     end;
   end;
  for evmesic:=1 to 12 do
   begin
    with TMesicKurovce(FmesicKurovceMN.elements[Evmesic]) do
     begin
      fKonecnyStav:=TMesicKurovce(FmesicKurovceMN.elements[Evmesic-1]).fKonecnyStav+fPrirustek-fUbytek;
     end;
   end;
 end;

function TRadekLHEvidenceMN.GetSoucetKurovce(ZaRok:integer): TMesicKurovceMN;
 begin
  if FMesicKurovceMN=nil then
   begin
    FMesicKurovceMN:=TMesicKurovceMN.create;
   end;
  if FMesicKurovceMN.VypoctenoZaRok<>ZaRok then
   begin
    aktualizujKurovce(ZaRok);
   end;
  result:=FMesicKurovceMN;
 end;

function TRadekLHEvidenceMN.GetRocniVykaz(ZaRok:integer;vMAJ_KOD:string): TSloupecRocniVykazMN;
 begin
  if FSloupecRocniVykazMN=nil then
   begin
    FSloupecRocniVykazMN:=TSloupecRocniVykazMN.create;
   end;
  if FSloupecRocniVykazMN.VypoctenoZaRok<>ZaRok then
   begin
    aktualizujRocniVykaz(ZaRok,vMAJ_KOD);
   end;
  result:=FSloupecRocniVykazMN;
 end;
function TSloupecRocniVykaz.GetTezbaCelkem:integer;
 begin
  result:=MU+PU+PN+MN;
 end;
function TRadekLHEvidence.GetEtaz:String;
 begin
  if Fetaz<>'' then
   begin
    result:=OpravenaEtaz(Fetaz);
   end
  else
   begin
    result:= OpravenaEtaz(KPrvnimuZnaku(FPSK,'/'));
   end;
 end;

function TRadekLHEvidence.GetPSK:String;
 begin
   result:=opravenaSkupina(FPsk);
 end;
function TSloupecRocniVykaz.GetEtaz:String;
 begin
  if Fetaz<>'' then
   begin
    result:=Fetaz;
   end
  else
   begin
    result:= KPrvnimuZnaku(FPSK,'/');
   end;
 end;

initialization

 registerOrbisClass(TRadekLHEvidence);
 registerOrbisClass(TRadekLHEvidenceMN);

end.
