unit ELesObec;

interface
uses
  Elements,E_Type,Classes,E_Class,Worlds,M_ORBIS,
  dialogs,forms,DBTables,Graphics,FileCtrl,
  lesCisel,LesRecur,mat1,Dotaz,
  T_Loader,T_Saver;

type
TTypZmeny=(nezmenilse,bylNoveZaveden,BudeSmazan1);
TJazyk=(cesky,nemecky1,anglicky1);
TVcetneBarev=(VcetneBarvy1,BezBarvy1);
TPoziceTisku=(naLevo,naPravo,uprostred);
TTypDatLHP=(LHP160,tax97,tax98,IsHul98,IsHul99a,OraIDC,tax99,NeniLHP,isHul2000,OraLCR);

TVlastnostiMN = class;
TVlastnostiSloupcuMN = class;
TLesniMnozina = class;

// TPrvekNaUlozeni
TXXxt = class (TOwnerEntity)
 private
  FUlIndex :longint;
 public
 published
  property UlIndex :longint read  FUlIndex write FUlIndex;
 end;

TVlastnostiSloupcu   = class (TOwnerEntity)
 private
  FNadpis:String;
  FNazevProperty:String;
  FIndexVGridu:integer;
  FIndexPropertyVElementu:integer;
  FSirka:Integer;
  FViditelny:Boolean;
  FPoziceTisku:TPoziceTisku;
  FPocetZnaku:integer;
  FDesMista:integer;
  FTypPolozky:char;
  function GetNadpis:String;
  function GetNazevProperty:String;
  function GetIndexVGridu:integer;
  function GetIndexPropertyVElementu:integer;
  function GetSirka:Integer;
  function Getviditelny:Boolean;

  procedure SetNadpis(A:String);
  procedure SetNazevProperty(A:String);
  procedure SetIndexVGridu(A:integer);
  procedure SetIndexPropertyVElementu(A:integer);
  procedure SetSirka(A:Integer);
  procedure SetViditelny(A:Boolean);

 public
  property Nadpis:String  read getNadpis write SetNadpis ;
  property NazevProperty:String  read getNazevProperty write SetNazevProperty ;
  property IndexVGridu:integer  read getIndexVGridu write SetIndexVGridu ;
  property IndexPropertyVElementu:integer  read getIndexPropertyVElementu write SetIndexPropertyVElementu;
  property Sirka:Integer  read getSirka write SetSirka;
  property viditelny:Boolean  read getviditelny write SetViditelny;
  property PoziceTisku:TPoziceTisku read FPoziceTisku write FPoziceTisku;
  property PocetZnaku:integer read FPocetZnaku write FPocetZnaku;
  property TypPolozky:char read FTypPolozky write FTypPolozky;
           //I-integer, F-extended, A:jen pismena bez hak
  property DesMista:integer read FDesMista write FDesMista;
 end;
TVlastnosti = class (TOwnerEntity)
 private
  function Get_barva_cis:integer;
 public
  barva:TColor;
  chyba:integer;
  Typ_Fontu:integer;
  constructor create;  override;
 published
  property barva_cis:integer read  Get_barva_cis  stored false;
  property UklBarva:tcolor read barva write barva;
 end;

TPrvekNaTrideni  = class (TOwnerEntity)
 private
  FPuvIndex :longint;
  FStrTrid:String;
  FPuvStr:String;
 public
 published
  property PuvIndex :longint read  FPuvIndex write FPuvIndex;
  property StrTrid:String    read  FStrTrid  write FStrTrid;
  property PuvStr:String     read  FPuvStr   write FPuvStr;
 end;


TObecnyLesniPrvek = class(TOwnerEntity)
 private
  FVlastnostiMN:TVlastnostiMN;
  FTypDatLHP:TTypDatLHP;
  FSelekt   :boolean;
  FBylEditovan:Boolean;
  FPuvodni_oznaceni:string;
  function  GetVlastnostiMN:TVlastnostiMN;
  function  GetBylEditovanNeboNoveVytvorenRekurz:Boolean;
  function  GetBylNoveVytvoren:Boolean;

 protected
  function  GetMaSmazany:Boolean;  Virtual;
  function  GetMaSmazanyRekurz:Boolean;  Virtual;
  function  GetBarva(VProperta:string):TColor;
  procedure SetBarva(VProperta:string;ABarva:TColor);
  function  GetChyba(VProperta:string):integer;
  procedure SetChyba(VProperta:string;ACHyba:integer);
  function  GetCiselnik:TCiselnik;  Virtual;
  function  GetciselOrbisOwnEnt:TOwnerEntity; Virtual;
  function  GetLHCOwnEnt:TOwnerEntity; Virtual;
  function  GetSeznamExportStandard:TLesniStringListElement; virtual;
  function  GetTypDatLHP:TTypDatLHP;       Virtual;
  function  GetLHC_KODOwnEnt: longInt;
 public
  FRId, FVazba: longint;
  historie:String;
  constructor create;  override;
  Destructor  destroy; override;
  procedure VlastnostiMNCreate; virtual;
  procedure VlastnostiMNCreateKdyzNejsou;
  procedure SmazEntityTridy(aClass:TElementClass);
  procedure SmazEntityTridyRekursivne(aClass:TElementClass);
  procedure VypoctiVsechnyTabulkoveZasoby;
  procedure nastavAktualniNaPrvni; //rekurentne
  procedure NastavNebylEditovanVytvorRekurz;
  function  OwnerTypu(AClass:TElementClass):TElement;
  function  SeznamHodnotTypu(SProperty:String):TIntegerListElement;
  function  SumaPodleProperty(SumProperta:string):longint;
  function  SumRetezecPodleProperty(SumProperta,VOddelovac:string):string;
  function  prvniPrvekTypu(AClass:TElementClass):TElement;
  function  KopieElementu:TObecnyLesniPrvek; virtual;
  function  OwnerLesniMnozina:TLesniMnozina;
  function  MaModrouBarvu:boolean;
  procedure SetBylEditovan(VBylEditovan:boolean);
  Procedure smazModrouBarvu;
  procedure VsechnoSmaz;
  procedure NactiProperty(aElement: TStringListElement);
  property  VlastnostiMN:TVlastnostiMN read GetVlastnostiMN write FVlastnostiMN;
  property  Barva[AProperta:String]:TColor read GetBarva write SetBarva;
  property  Chyba[AProperta:String]:integer read GetChyba write SetChyba;
  property  Selekt :boolean read FSelekt  write FSelekt;
  function  ExportovatDoStandardu(NazevProperty:String):Boolean;
  property  TypDatLHP:TTypDatLHP read GetTypDatLHP write FTypDatLHP;
  property  FFTypDatLHP:TTypDatLHP read FTypDatLHP write FTypDatLHP;

 published
  property  Puvodni_oznaceni:string read FPuvodni_oznaceni write FPuvodni_oznaceni  stored false;
  property  RId: longInt read FRId write FRId;
  property  Vazba: longInt read FVazba write FVazba;
  property  BylNoveVytvoren:Boolean read GetBylNoveVytvoren stored false;
  property  BylEditovan:Boolean read FBylEditovan write SetBylEditovan  stored false;
  property  BylEditovanNeboNoveVytvorenRekurz:Boolean read GetBylEditovanNeboNoveVytvorenRekurz  stored false;
  property  MaSmazany:Boolean read GetMaSmazany stored false;
  property  MaSmazanyRekurz:Boolean read GetMaSmazanyRekurz stored false;
  property  Ciselnik:TCiselnik read GetCiselnik stored false;
  property  ciselOrbisOwnEnt:TOwnerEntity read GetCiselOrbisOwnEnt  stored false;
  property  LHCOwnEnt:TOwnerEntity read GetLHCOwnEnt  stored false;
  property  LHC_KODOwnEnt: longInt read GetLHC_KODOwnEnt stored false;
  property  SeznamExportStandard:TLesniStringListElement
            read GetSeznamExportStandard  stored false;
end;

TLesniMnozina = class(TObecnyLesniPrvek)
private
 FAktualniPrvek:TElement;
 FAdresaOrbu:String;
 FKontrolovatSdileni:boolean;
 FPouzeCteni:Boolean;
 fPrazdny:TElement;
 Procedure SetPouzeCteni(VPouzeCteni:Boolean);
protected
 FPredponaName:String; {name prvku mnoziny zacina stringem FPredponaName}
 FJmenoStarehoPrvku:String;
 FNechavatJenJedenPrvek:Boolean;
 procedure SetNovyPrvek(AStr: string);                virtual;
 procedure SetNovyPrvekVzdy(AStr: string);                virtual;
 procedure SetJmenoAktualnihoPrvku(aStr: string);     virtual;
 procedure SetNovyNeboAktualniPrvek(aStr: string);    virtual;
 Function  GetJmenoAktualnihoPrvku:string;
 Function  GetAktualniPrvekVzdy:TElement;
 Function  GetAktualniPrvekVzdyN:TElement;
 Function  GetAktualniPrvekKdyzJe:TElement;
 function  GetPocetPrvku:Longint;
 procedure SetAktualniPrvek(VAktualniPrvek:TElement);
 function  GetPoradiAktualnihoPrvku:Integer;
public
 FClass:TElementClass;
 function  ExistujePredchazejiciIndexHledaneHodnoty
                   (SProperta,HlHodnota:string;index:integer):boolean;
 function  GetNejblizsiPoradiIPodleSetridenePropertyString(
                      SProperta,HlHodnota:string):Integer;

 procedure VsechnyPrvkyPodleSetridenePropertyString(
                      SProperta,HlHodnota:string;RR:TLesniMnozina);
 procedure VsechnyPrvkyPodlePropertyString(
                      SProperta,HlHodnota:string;RR:TLesniMnozina);

 function  GetNejblizsiPredchazejiciIndexHledaneHodnoty
                   (SProperta,HlHodnota:string;index:integer):integer;
 function  GetNejblizsiPrvekPodleSetridenePropertyString(SProperta,HlHodnota:string):TObecnyLesniprvek;
 function  GetNejblizsiPrvekPodleSetridenePropertyLongInt(SProperta:string;HlHodnota:LongInt):TObecnyLesniprvek;
 function  GetIndexNejblizsihoPrvkuPodleSetridenePropertyLongInt(SProperta:string;HlHodnota:LongInt):Integer;

 function  GetIndexNejblizsihoPrvkuPodleSetridenePropertyString(
                      SProperta:string;HlHodnota:string):Integer;

 Procedure PrvniIndexAPocetStejnychPrvkuPodleSetridenePropertyLongInt(
                       SProperta:string;HlHodnota:LongInt;var indexPrvniho,Pocet:integer);

 Procedure PrvniIndexAPocetStejnychPrvkuPodleSetridenePropertyString(
                      SProperta,HlHodnota:string;var indexPrvniho,Pocet:integer);
 procedure SetStringNasobnychPrvku(AStr,Oddelovac:String);
 procedure SetStringNasobnychHodnot(Properta,AStr,Oddelovac:String);
 procedure AddElement(Element:TElement); override;
 procedure VyplnHromadneHodnotu(Properta,AStr:String);
 procedure pripojLesniMnozinu(LesMN:TlesniMnozina);
 function  jakoPodleCiselniku(
               poleKtereZname,hodnotaPoleKtereZname,poleKtereHledameVCiselniku:string):string;
 function  HodnotaPropertyExistuje(
               poleKtereZname,hodnotaPoleKtereZname:string):boolean;
 function  PrvekPodleHodnotyProperty(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;
 function  PrvekPodleHodnotyPropertyKontrolneVypisuj(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;

 function  PrvekPodleHodnotyPropertyOdZadu(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;
 function  PocetPrvkuPodleHodnotyProperty(
               poleKtereZname,hodnotaPoleKtereZname:string):integer;
 function  NajdiSubstrVProperte(
               poleKtereZname,HledSubstr:string;AktPrvek:TElement):TElement;
 function  NajdiSubstrVPropertach(
               poleKtereZname1,HledSubstr1,poleKtereZname2,HledSubstr2:string;AktPrvek:TElement):TElement;

 function  MaxPrvek(Properta:string):TElement;

 procedure setridPodlePropertyLongInt(SProperty:String;vzestupne:Boolean);
 procedure setridPodlePropertyString(SProperty:String;vzestupne:Boolean);
 procedure setridPodlePropertyLongIntPuvodni(SProperty:String;vzestupne:Boolean);
 procedure setridPodlePropertyStringPuvodni(SProperty:String;vzestupne:Boolean);
 procedure IncAktualniPrvek;
 procedure DecAktualniPrvek;
 function  AktualniPrvekJeVMnozine:Boolean;
 function  PrvekJeVMnozine(VElement:TElement):Boolean;
 function ZaSebouStr(Properta,Oddelovac:string):string;
 function ZaSebouStrFlo(Properta,Oddelovac:string;delka,desMista:integer):string;
 function Suma(Properta:string):double;
 Procedure UlozDoOrbuPodleAdresy(pocetZaloznichKopii:integer);
 Procedure OdhlasSeZeZapisu;
 function  SelektPocet:integer;
 Procedure SmazVsechnyPrvkyVMnozine;
 function  GetPrazdny:TElement;
 procedure nastavNeboVytvorAktualDleProperty(VProperta,HodnotaProperty:string);
 function  prvekDleJmena(aStr: string):TElement;

 constructor Create; override;
 Destructor  destroy; override;

published
 property PoradiAktualnihoPrvku:Integer read GetPoradiAktualnihoPrvku stored false;
 property JmenoAktualnihoPrvku:string read GetJmenoAktualnihoPrvku write SetJmenoAktualnihoPrvku stored false;
 property JmenoStarehoPrvku:String read FJmenoStarehoPrvku write FJmenoStarehoPrvku;
 property AktualniPrvek:TElement read FAktualniPrvek write SetAktualniPrvek stored false;
 property AktualniPrvekVzdy:TElement read GetAktualniPrvekVzdy  stored false;
 property AktualniPrvekVzdyN:TElement read GetAktualniPrvekVzdyN  stored false;
 property AktualniPrvekKdyzJe:TElement read GetAktualniPrvekKdyzJe  stored false;
 property NovyPrvek:string write SetNovyPrvek  stored false;
 property NovyPrvekVzdy:string write SetNovyPrvekVzdy stored false;
 property NovyNeboAktualniPrvek:String write SetNovyNeboAktualniPrvek  stored false;
 property PocetPrvku:longInt read GetPocetPrvku stored false;
 property NechavatJenJedenPrvek:Boolean read FNechavatJenJedenPrvek write FNechavatJenJedenPrvek;
 property PredponaName:String read FPredponaName write FPredponaName;
 property AdresaOrbu:String read FAdresaOrbu write FAdresaOrbu;
 property KontrolovatSdileni:boolean read FKontrolovatSdileni write FKontrolovatSdileni;
 Property PouzeCteni:Boolean read FPouzeCteni write SetPouzeCteni stored false;
end;

TVlastnostiMN = class(TLesniMnozina)
public
  constructor Create; override;
  procedure dejVsechyBarvyBile;
end;

TVlastnostiSloupcuMN = class(TLesniMnozina)
public
  pocetViditelnychPolozek:integer;
  constructor Create; override;
  constructor CreatePodle(VClass:TElementClass);
  procedure  IndexujSe;
published

end;

procedure KdyzNeniTakPridej(strList:TStringList;vString:string);
procedure KdyzNeniTakPridejNAME1(strList:TStringList;vName,vValue:string);
procedure KdyzNeniTakPridejODD(strList:TStringList;vName,vValue:string);
procedure zvetsRekurzivneNAME(Enti:TEntity);
function  ZTypuZmenyString(VTypZmeny:TTypZmeny):String;
function  ZeStringuTypZmeny(strTypZmeny:String):TTypZmeny;
function  JazykZeStringu1(SJazyk:String):TJazyk;
function  ZeStrListuStrListElem(Seznam:TStringList):TStringListElement;
procedure UlozDoOrbu(UlozBlok:TOwnerEntity;kamSoubDir:string; pocetZaloznichKopii:integer);
function  NactiZOrbu(odkudSoubDir:string;hlasitKdyzNeni:boolean):TOwnerEntity;
function  NactiZOrbuLesniMnozinu(odkudSoubDir:string):TLesniMnozina;
function  zBarvyInteger(Vbarva:TColor):integer;
function  zIntegeruBarva(Vbarva:integer):TColor;
function  BarvaBraniMenit(Barva:TColor):boolean;
function  BarvaNutiMenit(Barva:TColor):boolean;

var LesniMnozinaSetPouzeCtenivyslo:Boolean;
implementation
uses E_lesOdd,SysUtils,U_props;

function TVlastnosti.Get_barva_cis:integer;
 begin
   result:=zBarvyInteger(Barva);
 end;

procedure TVlastnostiMN.dejVsechyBarvyBile;
var i:Integer;
 begin
  if self=nil then exit;
  for i:=0 to count-1 do
   begin
     TVlastnosti(Elements[i]).UklBarva:=clInfoBk;
   end;
 end;

function  NactiZOrbuLesniMnozinu(odkudSoubDir:string):TLesniMnozina;
var
  VUzivatel:string;
begin
 result:=TLesniMnozina(NactiZOrbu(odkudSoubDir,true));
 result.AdresaOrbu:=odkudSoubDir;
 VUzivatel:=NactiZIni(KPoslednimuZnaku(result.AdresaOrbu,'.')+'.UZI'
                   ,'Sdileni','Prave_uziva','nikdo');
 if VUzivatel=jmenoPocitace then
  begin
   result.PouzeCteni:=false
  end
 else
  begin
   result.PouzeCteni:=true;
  end;
end;
procedure KdyzNeniTakPridej(strList:TStringList;vString:string);
begin
 if strList.IndexOf(VString)=-1 then
  begin
   strList.add(VString);
  end;
end;

procedure KdyzNeniTakPridejNAME1(strList:TStringList;vName,vValue:string);
begin
 if strList.IndexOfName(VName)=-1 then
  begin
   strList.add(VName+'='+VValue);
  end;
end;

procedure KdyzNeniTakPridejODD(strList:TStringList;vName,vValue:string);
begin
 VName:=DoplnZePreduZnakem1(vName,3,' ');
 if strList.IndexOfName(VName)=-1 then
  begin
   strList.add(VName+'='+VValue);
  end;
end;

constructor TVlastnosti.Create;
 begin
  inherited create;
  barva:=clInfoBk;
  chyba:=0;
 end;
constructor TVlastnostiSloupcuMN.Create;
 begin
  inherited create;
  FClass:=TVlastnostiSloupcu;
  FPredponaName:='SLOUP';
 end;
constructor TVlastnostiSloupcuMN.CreatePodle(VClass:TElementClass);
 var VElement:TElement;
     s1:String;
     I,im:integer;
 begin
  create;
  VElement:=VClass.create;
  im:=0;
  for I:= GetPropIndex(VElement,'LastIndex')+1 to GetPropCount(VElement)-1 do
    begin
      s1:=GetPropName(VElement, I);
      NovyPrvekVzdy:=s1;
      with TVlastnostiSloupcu(aktualniPrvek) do
       begin
        nadpis:=S1;
        NazevProperty:=s1;
        IndexVGridu:=Im;
        IndexPropertyVElementu:=I;
        Sirka:=80;
        viditelny:=true;
        poziceTisku:=naLevo;
       end;
      inc(im);
    end;
  VElement.free;
 end;
constructor TVlastnostiMN.Create;
 begin
  inherited create;
  FClass:=TVlastnosti;
  FPredponaName:='VLAS';
 end;

function TObecnyLesniPrvek.ExportovatDoStandardu(NazevProperty:String):Boolean;
 begin
  SeznamExportStandard.AktualniPolozka:=NazevProperty;
  result:=SeznamExportStandard.AktualniJeVSeznamuAMaAno;
 end;
procedure TObecnyLesniPrvek.SmazEntityTridy(aClass:TElementClass);
var i,cc:Integer;
 begin
  if count>0 then
   begin
    cc:=count-1;
    for i:=cc downto 0 do
     begin
      if i<count then
       begin
        if Elements[i] is aClass then
         begin
          Elements[i].free;
         end;
       end;
     end;
   end;
 end;

 procedure TObecnyLesniPrvek.SmazEntityTridyRekursivne(aClass:TElementClass);
 var SmazTrid:TMazacTridy;
 begin
  SmazTrid:=TMazacTridy.create;
  SmazTrid.AClass:=AClass;
  SmazTrid.Input:= self;
  SmazTrid.DoIt;
  SmazTrid.free;
 end;

function TObecnyLesniPrvek.GetciselOrbisOwnEnt:TOwnerEntity;
var i0:integer;
 begin
  result:=nil;
  for i0:=0 to count-1 do
   begin
    if elements[i0].Name='CiselOrbis' then result:=TOwnerEntity(elements[i0]);
   end;
  if result=nil then
   begin
    for i0:=0 to Ownerscount-1 do
     begin
      if Owners[i0] is TObecnyLesniPrvek then
       begin
        if result=nil then
         begin
          result:=TObecnyLesniPrvek(Owners[i0]).CiselOrbisOwnEnt;
         end;
       end;
     end;
   end;
 end;

function TObecnyLesniPrvek.GetLHC_KODOwnEnt: longInt;
var
  HlLHCOwnEnt:TOwnerEntity;
 begin
  HlLHCOwnEnt:=LHCOwnEnt;
  if hlLHCOwnEnt=nil then
   begin
    result:=-1;
   end
  else
   begin
    result:=HlLHCOwnEnt.GetPropertyLongIntByName('LHC_KOD');
   end;
 end;

function TObecnyLesniPrvek.GetLHCOwnEnt:TOwnerEntity;
var i0:integer;
 begin
  result:=nil;
  for i0:=0 to count-1 do
   begin
    if elements[i0].Name='TLHC' then result:=TOwnerEntity(elements[i0]);
   end;
  if result=nil then
   begin
    for i0:=0 to Ownerscount-1 do
     begin
      if Owners[i0] is TObecnyLesniPrvek
                  then result:=TObecnyLesniPrvek(Owners[i0]).LHCOwnEnt;
     end;
   end;
 end;

function TObecnyLesniPrvek.GetBylEditovanNeboNoveVytvorenRekurz:Boolean;
var i0:integer;
 begin
  result:=false;
  if bylEditovan then
   begin
    result:=true;
    exit;
   end;
  if BylNoveVytvoren then
   begin
    result:=true;
    exit;
   end;
  for i0:=0 to count-1 do
   begin
    if elements[i0] is TObecnyLesniPrvek then
     begin
      if TObecnyLesniPrvek(elements[i0]).BylEditovanNeboNoveVytvorenRekurz then
       begin
        result:=true;
        // World.PostTextMsg(tm_AddToProtocol,Name+' Rekurz byl',nil);
        exit;
       end;
     end;
   end;
 end;

Procedure TObecnyLesniPrvek.NastavNebylEditovanVytvorRekurz;
var i0:integer;
 begin
  if bylEditovan then
   begin
    BylEditovan:=false;
   end;
 {
  if BylNoveVytvoren then
   begin
    BylNoveVytvoren:=false;
   end;
  }
  for i0:=0 to count-1 do
   begin
    if elements[i0] is TObecnyLesniPrvek then
     begin
      TObecnyLesniPrvek(elements[i0]).NastavNebylEditovanVytvorRekurz;
     end;
   end;
 end;


function TObecnyLesniPrvek.GetCiselnik:TCiselnik;
var i0:integer;
 begin
  result:=nil;
  for i0:=0 to count-1 do
   begin
    if elements[i0] is TCiselnik then result:=TCiselnik(elements[i0]);
   end;
  if result=nil then
   begin
    for i0:=0 to Ownerscount-1 do
     begin
      if Owners[i0] is TObecnyLesniPrvek
                  then
       begin
        if result=nil then result:=TObecnyLesniPrvek(Owners[i0]).Ciselnik;
       end;
     end;
   end;
  if result=nil then
   begin
    Result:=LesCisel.ciselnikP;
   // showmessage('Cau '+name+' cislenikP.');
   end;
 end;

function TObecnyLesniPrvek.GetSeznamExportStandard:TLesniStringListElement;
var i0:integer;
 begin
  result:=nil;
  result:=TLesniStringListElement(FindElementName('SeznamExportStandard'));
  if result=nil then
   begin
    for i0:=0 to Ownerscount-1 do
     begin
      if Owners[i0] is TObecnyLesniPrvek
                  then result:=TObecnyLesniPrvek(Owners[i0]).SeznamExportStandard;
     end;
   end;
 end;
function TObecnyLesniPrvek.OwnerTypu(AClass:TElementClass):TElement;
var i0:integer;
begin
 result:=nil;
 if self=nil then
  begin
   showmessage('cau');
   exit;
  end;
 for i0:=0 to Ownerscount-1 do
  begin
   if Owners[i0] is AClass then
    begin
     result:=Owners[i0];
     exit;
    end;
  end;
 for i0 :=0 to Ownerscount-1 do
  begin
   if Owners[i0] is TObecnyLesniPrvek
           then result:=TObecnyLesniPrvek(Owners[i0]).OwnerTypu(AClass);
   if result<>nil then exit;
  end;
end;
function TObecnyLesniPrvek.PrvniPrvekTypu(AClass:TElementClass):TElement;
var i0:integer;
begin
 result:=nil;
 for i0:=0 to count-1 do
  begin
   if elements[i0] is AClass then
    begin
     result:=elements[i0];
     exit;
    end;
  end;
 for i0 :=0 to count-1 do
  begin
   if elements[i0] is TObecnyLesniPrvek
           then result:=TObecnyLesniPrvek(elements[i0]).PrvniPrvekTypu(AClass);
   if result<>nil then exit;
  end;
end;
function TObecnyLesniPrvek.SumaPodleProperty(SumProperta:string):longint;
var SumaDlePro :TSumaPodleProperty;
 begin
  SumaDlePro:=TSumaPodleProperty.create;
  with SumaDlePro do
   begin
    PropertaStr:=SumProperta;
    Input := self;
    doIt;
    result:=Round(Suma);
   end;
  SumaDlePro.free;
 end;

function TObecnyLesniPrvek.SumRetezecPodleProperty(SumProperta,VOddelovac:string):string;
var SumRetezecDlePro :TSumRetezecPodleProperty;
 begin
  SumRetezecDlePro:=TSumRetezecPodleProperty.create;
  with SumRetezecDlePro do
   begin
    PropertaStr:=SumProperta;
    Oddelovac:=VOddelovac;
    Input := self;
    doIt;
    result:=Retezec;
   end;
  SumRetezecDlePro.free;
 end;


function  TObecnyLesniPrvek.SeznamHodnotTypu(SProperty:String):TIntegerListElement;
var VytvorSeznamPodleProperty:TVytvorSeznamPodleProperty;
 begin
  VytvorSeznamPodleProperty:=TVytvorSeznamPodleProperty.create;
  vytvorSeznamPodleProperty.propertaStr := SProperty;
  vytvorSeznamPodleProperty.input:=self;
  result:=TIntegerListElement.create;
  { result.sorted:=true; }
  vytvorSeznamPodleProperty.output:=result;
  vytvorSeznamPodleProperty.doit;
  addelement(result);
 end;
 procedure TObecnyLesniPrvek.VypoctiVsechnyTabulkoveZasoby;
 var i:integer;
   begin
    Zalodkornovat:=Odkornovat;odkornovat:=false;
    if self is TDrevina then
     begin
      with TDrevina(Self) do
       begin
        ZAS_TAB_HA:=VypoctenaTabulkovaZasoba;
       end;
     end;
    for i:=0 to count-1 do
     begin
      if elements[i] is TObecnyLesniPrvek then
       begin
        TObecnyLesniPrvek(elements[i]).VypoctiVsechnyTabulkoveZasoby;
       end;
     end;
    odkornovat:=ZalOdkornovat;
   end;
procedure TObecnyLesniPrvek.VsechnoSmaz;
var i:Integer;
 begin
  for i:=count-1 downto 0 do
   begin
    if elements[i] is TObecnyLesniPrvek then
          TObecnyLesniPrvek(elements[i]).VsechnoSmaz;
    elements[i].free;
   end;
 end;
procedure TLesniMnozina.AddElement(Element:TElement);
 begin
  If element is FClass then
   begin
    AktualniPrvek:=Element;
    if copy(Element.Name,1,Length(FPredponaName))<>FPredponaName then
          Element.Name:=FPredponaName+' '+Element.Name;
    if NechavatJenJedenPrvek then
     begin
      SmazEntityTridy(FClass);
     end;
    inherited AddElement(Element);
    AktualniPrvek:=Element;
   end
  else
   Showmessage('Prvek "'+Element.Name+'" neni typem pro mnozinu "'+name+'"');
 end;
function TLesniMnozina.ZaSebouStrFlo(Properta,Oddelovac:string;Delka,desMista:integer):string;
var i0:integer;
 begin
  result:='';
  for i0:=0 to count-1 do
   begin
    if Elements[i0].HasPropertyByName(Properta) then
     begin
      result:=result+floatTOStrf(
            strToFloat(Elements[i0].GetPropertyStringByName(Properta))
            ,ffFixed,delka,desMista) + Oddelovac;
     end;
   end;
  if length(result)>0 then result:=copy(result,1,length(result)-length(Oddelovac));
 end;
function  TLesniMnozina.MaxPrvek(Properta:string):TElement;
 var iMax,ff:double;
     i:integer;
     ss:String;
 begin
  Result:=nil;
  IMax:=-10E20;
  for i:=0 to count-1 do
   begin
    ss:=Elements[i].GetPropertyStringByName(Properta);
    ff:=strToFloat(Elements[i].GetPropertyStringByName(Properta));
    if ff>iMax then
      begin
       iMax:=ff;
       result:=Elements[i];
      end;
   end;
 end;

function TLesniMnozina.Suma(Properta:string):double;
var i0:integer;
 begin
  result:=0;
  for i0:=0 to count-1 do
   begin
    if Elements[i0].HasPropertyByName(Properta) then
     begin
      result:=result+strToFloat(Elements[i0].GetPropertyStringByName(Properta));
     end;
   end;
 end;
function TLesniMnozina.ZaSebouStr(Properta,Oddelovac:string):string;
var i0:integer;
 begin
  result:='';
  for i0:=0 to count-1 do
   begin
    if Elements[i0].HasPropertyByName(Properta) then
     begin
      if ubm(Elements[i0].GetPropertyStringByName(Properta))<>'' then
       begin
        result:=result+Elements[i0].GetPropertyStringByName(Properta)+oddelovac;
       end;
     end;
   end;
  if length(result)>0 then result:=copy(result,1,length(result)-length(Oddelovac));
 end;

function TLesniMnozina.GetPocetPrvku:Longint;
 begin
  result:=getClassCount(FClass);
 end;
procedure TLesniMnozina.SetJmenoAktualnihoPrvku(aStr: string);
begin
  AktualniPrvek := FindElementName(FPredponaName+' '+aStr)
end;
function TLesniMnozina.prvekDleJmena(aStr: string):TElement;
begin
  result := FindElementName(FPredponaName+' '+aStr);
end;

Function TLesniMnozina.GetJmenoAktualnihoPrvku:string;
begin
 if FAktualniPrvek=nil then result:='PrvekNeni'
 else
 begin
  if not AktualniPrvekJeVMnozine then
   begin
    result:='PrvekNeni';
    exit;
   end;
  try
  result:= copy(AktualniPrvek.name,length(FPredponaName)+2,length(AktualniPrvek.name)-(length(FPredponaName)+1));
  except
   result:='PrvekNeni';
  end;
 end;
end;


procedure TLesniMnozina.SetNovyPrvek(aStr: string);
var
  aPrvek: TElement;
begin
  aPrvek:= FindElementName(FPredponaName+' '+aStr);
  if aPrvek = nil then
  begin
    aPrvek:= FClass.Create;
    aPrvek.Name:=FPredponaName+' '+aStr;
    AddElement(aPrvek);
    AktualniPrvek:= aPrvek;
  end
 else AktualniPrvek:=nil;
end;

procedure TLesniMnozina.SetNovyPrvekVzdy(aStr: string);
begin
 AktualniPrvek:= FClass.Create;
 AktualniPrvek.Name:= aStr;
 AddElement(AktualniPrvek);
end;

procedure TLesniMnozina.SetNovyNeboAktualniPrvek(aStr: string);
 begin
  JmenoAktualnihoPrvku:=Astr;
  if AktualniPrvek=nil then
   begin
    NovyPrvek:=Astr;
   end;
 end;
procedure TLesniMnozina.VyplnHromadneHodnotu(Properta,AStr:String);
var i:Integer;
 begin
  for i:=0 to count-1 do
   begin
     Elements[i].SetPropertyStringByName(Properta,AStr);
   end;
 end;
procedure TLesniMnozina.SetStringNasobnychHodnot(Properta,AStr,Oddelovac:String);
var P,i:Integer;
    S:String;
 begin
  P:=Pos(Oddelovac,AStr);
  i:=0;
  while P<>0 do
   begin
     S:=copy(Astr,1,P-1);
     if UpperCase(Properta)='NAME' then S:=FPredponaName+' '+S;
     if i>count-1 then
      begin
       AddElement(FClass.create);
       { showmessage('Properta:"'+Properta+'" Nesoulad mezi nasobnou hodnotou a potem prvk');
         exit; }
      end;
     Elements[i].SetPropertyStringByName(Properta,s);
     i:=i+1;
     Astr:=copy(Astr,P+1,Length(Astr)-P);
     P:=Pos(Oddelovac,AStr);
   end;
  if AStr<>'' then
   begin
     if i>count-1 then
      begin
       AddElement(FClass.create);
       { showmessage('Properta:"'+Properta+'" Nesoulad mezi nasobnou hodnotou a potem prvk');
         exit; }
      end;
     if UpperCase(Properta)='NAME' then AStr:=FPredponaName+' '+AStr;
     Elements[i].SetPropertyStringByName(Properta,Astr);
     i:=i+1;
   end;
 end;

procedure TLesniMnozina.SetStringNasobnychPrvku(AStr,Oddelovac:String);
begin
 SetStringNasobnychHodnot('NAME',AStr,Oddelovac);
end;

Function  TLesniMnozina.GetAktualniPrvekVzdy:TElement;
 begin
  if AktualniPrvek=nil then
   begin
    NovyNeboAktualniPrvek:='Vzdy';
   end;
  result:=AktualniPrvek;
 end;

Function  TLesniMnozina.GetAktualniPrvekVzdyN:TElement;
 begin
  if AktualniPrvek=nil then
   begin
    if count>0 then FAktualniPrvek:=elements[0]
    else NovyNeboAktualniPrvek:='Vzdy';
   end;
  result:=AktualniPrvek;
 end;

Function  TLesniMnozina.GetAktualniPrvekKdyzJe:TElement;
 begin
  if count=0 then
   begin
    FAktualniPrvek:=nil;
    result:=nil;
    exit;
   end;
  if AktualniPrvek=nil then
   begin
    FAktualniPrvek:=elements[count-1];
   end;
  result:=AktualniPrvek;
 end;

procedure TObecnyLesniPrvek.VlastnostiMNCreateKdyzNejsou;
 begin
  if VlastnostiMN=NIl then
   begin
    VlastnostiMNCreate;
   end;
 end;
procedure TObecnyLesniPrvek.VlastnostiMNCreate;
var  i:integer;
    s1:string;
 begin
  if VlastnostiMN<>NIl then
   begin
    showmessage('Pozor, Vlastnosti u jsou vytvoen');
   end;
  FVlastnostiMN:=TVlastnostiMN.create;
  AddElement(FVlastnostiMN);
  for I:= GetPropIndex(self,'LastIndex')+1 to GetPropCount(self)-1 do
    begin
      s1:=GetPropName(Self, I);
      VlastnostiMN.NovyPrvek:=s1;
    end;
 end;

procedure  TVlastnostiSloupcuMN.IndexujSe;
 var i:Integer;
 begin
  pocetViditelnychPolozek:=0;
  for i:=0 to count-1 do
   begin
    with TVlastnostiSloupcu(elements[i]) do
     begin
      if viditelny then
       begin
        indexVGridu:=pocetViditelnychPolozek;
        pocetViditelnychPolozek:=pocetViditelnychPolozek+1;
       end
      else
       begin
        indexVGridu:=-1;
       end;
     end;
   end;
 end;
function  BarvaBraniMenit(Barva:TColor):boolean;
var odp:char;
 begin
  odp:=' ';
  case Barva  of
   clAqua:    odp:='A';
   cl3DLight: odp:='N';
   clInfoBk:  odp:='N';
   ClYellow:  odp:='N';
   clWhite:   odp:='N';
  end;
  case odp of
   'A':result:=true;
   'N':result:=false;
   ' ':begin
        result:=false;
        showmessage('To je ale divn barva polka.');
       end;
  end;
 end;
function  BarvaNutiMenit(Barva:TColor):boolean;
var odp:char;
 begin
  odp:=' ';
  case Barva  of
   cl3DLight: odp:='N';
   clAqua:    odp:='N';
   clInfoBk:  odp:='A';
   ClYellow:  odp:='A';
   clWhite:   odp:='A';
  end;
  case odp of
   'A':result:=true;
   'N':result:=false;
   ' ':begin
        result:=false;
        showmessage('To je ale divn barva polka.');
       end;
  end;
 end;
{
function rucneZadano(Vbarva:TColor):boolean;
 begin
  case VBarva of
    clInfoBk,clWhite,cl3DLight,ClYellow:result:=false;
    clAqua:result:=true;
   end;
 end;
}
function  TObecnyLesniPrvek.MaModrouBarvu:boolean;
var i:integer;
 begin
  if VlastnostiMN=nil then
   begin
    result:=false;
   end
  else
   begin
    result:=false;
    for i:=0 to  FVlastnostiMN.count-1 do
     begin
      if barvaBraniMenit(TVlastnosti(FVlastnostiMN.Elements[i]).Barva) then
       begin
        result:=true;
       end;
     end;
   end;
 end;

Procedure  TObecnyLesniPrvek.smazModrouBarvu;
var i:integer;
 begin
  if VlastnostiMN=nil then
   begin
    exit;
   end
  else
   begin
    for i:=0 to  FVlastnostiMN.count-1 do
     begin
      TVlastnosti(FVlastnostiMN.Elements[i]).Barva:=clInfoBk;
     end;
   end;
 end;

function  TObecnyLesniPrvek.GetBarva(VProperta:string):TColor;
var s:string;
  tc:TColor;
 begin
  if VlastnostiMN=nil then result:=cl3DLight
  else
   begin
    FVlastnostiMN.jmenoAktualnihoPrvku:=uppercase(VProperta);
    if FVlastnostiMN.AktualniPrvek=nil then
     begin
      result:=cl3DLight;
     end
    else
     begin
      result:=TVlastnosti(FVlastnostiMN.AktualniPrvek).Barva;
     end;

   end;
  tc:=result;
  result:=tc;
   
 end;
function  TObecnyLesniPrvek.GetChyba(VProperta:string):Integer;
 begin
  if VlastnostiMN=nil then result:=0
  else
   begin
    FVlastnostiMN.jmenoAktualnihoPrvku:=uppercase(VProperta);
    if FVlastnostiMN.AktualniPrvek=nil then result:=0
    else
     begin
      result:=TVlastnosti(FVlastnostiMN.AktualniPrvek).chyba;
     end;
   end;
 end;
procedure TObecnyLesniPrvek.SetBarva(VProperta:string;ABarva:TColor);
 begin
  if VlastnostiMN=nil then exit
  else
   begin
    FVlastnostiMN.jmenoAktualnihoPrvku:=VProperta;
    if FVlastnostiMN.AktualniPrvek=nil then exit
    else
     begin
      TVlastnosti(FVlastnostiMN.AktualniPrvek).Barva:=ABarva;
     end;
   end;
 end;

procedure TObecnyLesniPrvek.SetChyba(VProperta:string;AChyba:Integer);
 begin
  if VlastnostiMN=nil then exit
  else
   begin
    FVlastnostiMN.jmenoAktualnihoPrvku:=VProperta;
    if FVlastnostiMN.AktualniPrvek=nil then exit
    else
     begin
      TVlastnosti(FVlastnostiMN.AktualniPrvek).Chyba:=AChyba;
     end;
   end;
 end;

  function TVlastnostiSloupcu.GetNadpis:String;
   begin
    if self=nil then result:='neni'
    else result:=FNadpis;
   end;
  function TVlastnostiSloupcu.GetNazevProperty:String;
   begin
    if self=nil then result:='neni'
    else result:=FNazevProperty;
   end;
  function TVlastnostiSloupcu.GetIndexVGridu:integer;
   begin
    if self=nil then result:=-1
    else result:=FIndexVGridu;
   end;
  function TVlastnostiSloupcu.GetIndexPropertyVElementu:integer;
   begin
    if self=nil then result:=-1
    else result:=FIndexPropertyVElementu;
   end;
  function TVlastnostiSloupcu.GetSirka:Integer;
   begin
    if self=nil then result:=-1
    else result:=FSirka;
   end;
  function TVlastnostiSloupcu.GetViditelny:Boolean;
   begin
    if self=nil then result:=false
    else result:=FViditelny;
   end;

  procedure TVlastnostiSloupcu.SetNadpis(A:String);
   begin
    if Self<>Nil then FNadpis:=A;
   end;
  procedure TVlastnostiSloupcu.SetNazevProperty(A:String);
   begin
    if Self<>Nil then
     begin
      FNazevProperty:=A;
     end;
   end;
  procedure TVlastnostiSloupcu.SetIndexVGridu(A:integer);
   begin
    if Self<>Nil then FIndexVGridu:=A;
   end;
  procedure TVlastnostiSloupcu.SetIndexPropertyVElementu(A:integer);
   begin
    if Self<>Nil then FIndexPropertyVElementu:=A;
   end;
  procedure TVlastnostiSloupcu.SetSirka(A:Integer);
   begin
    if Self<>Nil then FSirka:=A;
   end;
  procedure TVlastnostiSloupcu.SetViditelny(A:Boolean);
   begin
    if Self<>Nil then FViditelny:=A;
   end;
//function Tpokcel.GetUka:string;
// begin
//  if self=nil then result:='je nil'
//              else result:='neni nil';
// end;

// 3.6 x 10^4951 .. 1.1 x 10^4932
{
procedure TLesniMnozina.setridPodlePropertyExteded(SProperty:String;vzestupne:Boolean);
var maxProp,iProp:longint;
    I,imax:integer;
    docasnyRadicPrvku:TOwnerEntity;
begin
 if count=0 then Exit;
 if not( Elements[0].HasPropertyByName(SProperty)) then
   begin
    showmessage('V prvcch mnoiny '+name+' nen properta "'+SProperty+'"' );
    exit;
   end;
 docasnyRadicPrvku:=TOwnerEntity.create;
 while count<>0 do
  begin
   maxProp:= -2147483647;
   for i:=0 to count-1 do
    begin
     Iprop:=Elements[i].GetPropertyLongIntByName(SProperty);
     if IProp>maxprop then
      begin
       imax:=i;
       maxprop:=Iprop;
      end;
    end;
   docasnyRadicPrvku.addelement(Elements[iMax]);
   RemoveElement(Elements[iMax]);
  end;
 if vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;
 docasnyRadicPrvku.free;
end;
}
procedure TLesniMnozina.setridPodlePropertyString(SProperty:String;vzestupne:Boolean);
// Logaritm
var maxProp,Iprop:String;
    I,iInd:integer;
    docasnyRadicPrvku:TLesniMnozina;
begin
 if count=0 then Exit;
 if not( Elements[0].HasPropertyByName(SProperty)) then
   begin
    showmessage('V prvcch mnoiny '+name+' nen properta "'+SProperty+'"' );
    exit;
   end;
 docasnyRadicPrvku := TLesniMnozina.create;
 docasnyRadicPrvku.FClass:=FClass;
 i:= count-1;
 while i>=0 do
  begin
   Iprop:=Elements[i].GetPropertyStringByName(SProperty);
   iInd:=docasnyRadicPrvku.GetNejblizsiPoradiIPodleSetridenePropertyString(SProperty,Iprop);
   if iInd=0 then
    begin
     if  Elements[i].GetPropertyStringByName(SProperty)<docasnyRadicPrvku.Elements[0].GetPropertyStringByName(SProperty) then
      begin
       docasnyRadicPrvku.InsertElement(0,Elements[i]);
      end
     else
      begin
       docasnyRadicPrvku.InsertElement(1,Elements[i]);
      end;
    end
   else
    begin
     docasnyRadicPrvku.InsertElement(iInd+1,Elements[i]);
    end;
   RemoveElement(Elements[i]);
   dec(i);
  end;
 if not vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;
 docasnyRadicPrvku.free;
end;

procedure TLesniMnozina.setridPodlePropertyLongInt(SProperty:String;vzestupne:Boolean);
// Logaritm
var maxProp,iProp:longint;
    I,iInd:integer;
    docasnyRadicPrvku:TLesniMnozina;
begin
 if count=0 then Exit;
 if not( Elements[0].HasPropertyByName(SProperty)) then
   begin
    showmessage('V prvcch mnoiny '+name+' nen properta "'+SProperty+'"' );
    exit;
   end;
 docasnyRadicPrvku:=TLesniMnozina.create;
 docasnyRadicPrvku.FClass:=FClass;
 i:= count-1;
 while i>=0 do
  begin
   Iprop:=Elements[i].GetPropertyLongIntByName(SProperty);
   iInd:=docasnyRadicPrvku.GetIndexNejblizsihoPrvkuPodleSetridenePropertyLongInt(SProperty,Iprop);
   if iInd=0 then
    begin
     if  Elements[i].GetPropertyLongIntByName(SProperty)<docasnyRadicPrvku.Elements[0].GetPropertyLongIntByName(SProperty) then
      begin
       docasnyRadicPrvku.InsertElement(0,Elements[i]);
      end
     else
      begin
       docasnyRadicPrvku.InsertElement(1,Elements[i]);
      end;
    end
   else
    begin
     docasnyRadicPrvku.InsertElement(iInd+1,Elements[i]);
    end;
   RemoveElement(Elements[i]);
   dec(i);
  end;

 if not vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;

 docasnyRadicPrvku.free;
end;


procedure TLesniMnozina.setridPodlePropertyLongIntPuvodni(SProperty:String;vzestupne:Boolean);
var maxProp,iProp:longint;
    I,imax:integer;
    docasnyRadicPrvku:TOwnerEntity;
begin
 if count=0 then Exit;
 if not( Elements[0].HasPropertyByName(SProperty)) then
   begin
    showmessage('V prvcch mnoiny '+name+' nen properta "'+SProperty+'"' );
    exit;
   end;
 docasnyRadicPrvku:=TOwnerEntity.create;
 while count<>0 do
  begin
   maxProp:= -2147483647;
   for i:=0 to count-1 do
    begin
     Iprop:=Elements[i].GetPropertyLongIntByName(SProperty);
     if IProp>maxprop then
      begin
       imax:=i;
       maxprop:=Iprop;
      end;
    end;
   docasnyRadicPrvku.addelement(Elements[iMax]);
   RemoveElement(Elements[iMax]);
   // showmessage('cai '+inttostr(MaxProp));
  end;
 if vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;
 docasnyRadicPrvku.free;
end;

procedure TLesniMnozina.setridPodlePropertyStringPuvodni(SProperty:String;vzestupne:Boolean);
var maxProp,Iprop:String;
    I,imax:integer;
    docasnyRadicPrvku:TOwnerEntity;
begin
 if count=0 then Exit;
 if not( Elements[0].HasPropertyByName(SProperty)) then
   begin
    showmessage('V prvcch mnoiny '+name+' nen properta "'+SProperty+'"' );
    exit;
   end;
 docasnyRadicPrvku:=TOwnerEntity.create;
 while count<>0 do
  begin
   maxProp:='   ';
   for i:=0 to count-1 do
    begin
     Iprop:=trim(WinToTrid(Elements[i].GetPropertyStringByName(SProperty)));
     if IProp>maxprop then
      begin
       imax:=i;
       maxprop:=Iprop;
      end;
    end;
   // showmessage('radim=*'+MaxProp+'* count='+inttostr(count));
   docasnyRadicPrvku.addelement(Elements[iMax]);
   RemoveElement(Elements[iMax]);
  end;
 if vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;
 docasnyRadicPrvku.free;
end;

function  TLesniMnozina.PrvekJeVMnozine(VElement:TElement):Boolean;
var i:Integer;
 begin
  result:=false;
  for i:=0 to count-1 do
   begin
    if elements[i]=VElement then result:=true;
   end;
 end;

function  TLesniMnozina.AktualniPrvekJeVMnozine:Boolean;
var i:Integer;
 begin
  result:=false;
  try
  for i:=0 to count-1 do
   begin
    if elements[i]=AktualniPrvek then result:=true;
   end;
  except
  end;
 end;
 procedure TLesniMnozina.IncAktualniPrvek;
 var i1:longint;
  begin
   if count=0 then Exit;
   i1:=IndexOf(aktualniPrvek);
   if i1<count-1 then
    begin
     inc(i1);
     AktualniPrvek:=elements[i1];
    end
  end;
 procedure TLesniMnozina.DecAktualniPrvek;
 var i1:longint;
  begin
   if count=0 then Exit;
   i1:=IndexOf(aktualniPrvek);
   if i1>0 then
    begin
     dec(i1);
     AktualniPrvek:=elements[i1];
    end
  end;
function  TLesniMnozina.jakoPodleCiselniku(
               poleKtereZname,hodnotaPoleKtereZname,poleKtereHledameVCiselniku:string):string;
var       i:Integer;
    ss1,ss2:string;
 begin
  if count=0 then
   begin
    result:='*0';
    exit;
   end;
  result:='*';
  for i:=0 to count-1 do
   begin
     ss1:=trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)));
     ss2:=trim(uppercase(hodnotaPoleKtereZname));
     if ss1=ss2 then
    // if trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))
    //       = trim(uppercase(hodnotaPoleKtereZname)) then
       begin
        result:=Elements[i].GetPropertyStringByName(poleKtereHledameVCiselniku);
       end;
   end;
 end;
function  TLesniMnozina.PrvekPodleHodnotyProperty(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;
var i:Integer;
 begin
  result:=nil;
  if AktualniPrvek<>nil then
   begin
    try
    if trim(uppercase(AktualniPrvek.GetPropertyStringByName(PoleKtereZname)))
            = trim(uppercase(hodnotaPoleKtereZname)) then
     begin
      result:=aktualniPrvek;
      exit;
     end;
    except
    end;
   end;
  try
   result:=nil;
   for i:=0 to count-1 do
    begin
     if trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))
           = trim(uppercase(hodnotaPoleKtereZname)) then
       begin
        result:=Elements[i];
       end;
    end;
  except
   showmessage('chyba PrvekPodleHodnotyProperty "'+PoleKtereZname+'"'+hodnotaPoleKtereZname+'"');
  end;
 end;

function  TLesniMnozina.PrvekPodleHodnotyPropertyKontrolneVypisuj(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;
var i:Integer;
 begin
  if AktualniPrvek<>nil then
   begin
    try
    if trim(uppercase(AktualniPrvek.GetPropertyStringByName(PoleKtereZname)))
            = trim(uppercase(hodnotaPoleKtereZname)) then
     begin
      result:=aktualniPrvek;
      exit;
     end;
    except
    end;
   end;
  try
   result:=nil;
   for i:=0 to count-1 do
    begin
     if trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))
           = trim(uppercase(hodnotaPoleKtereZname)) then
       begin
        result:=Elements[i];
        showmessage(trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))+'='+
           trim(uppercase(hodnotaPoleKtereZname)) );
       end
      else
       begin
        showmessage(trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))+'<>'+
           trim(uppercase(hodnotaPoleKtereZname)) );
       end;
    end;
  except
   showmessage('chyba PrvekPodleHodnotyProperty "'+PoleKtereZname+'"'+hodnotaPoleKtereZname+'"');
  end;
 end;

function  TLesniMnozina.PrvekPodleHodnotyPropertyOdZadu(
               poleKtereZname,hodnotaPoleKtereZname:string):TElement;
var i:Integer;
 begin
  result:=nil;
  for i:=count-1 downto 0 do
   begin
     if trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))
           = trim(uppercase(hodnotaPoleKtereZname)) then
       begin
        result:=Elements[i];
       end;
   end;
 end;

function  TLesniMnozina.PocetPrvkuPodleHodnotyProperty(
               poleKtereZname,hodnotaPoleKtereZname:string):integer;
var i,poc:Integer;
 begin
  poc:=0;
  for i:=0 to count-1 do
   begin
     if trim(uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))
           = trim(uppercase(hodnotaPoleKtereZname)) then
       begin
        inc(poc);
       end;
   end;
  result:=Poc;
 end;

function  TLesniMnozina.NajdiSubstrVProperte(
               poleKtereZname,HledSubstr:string;AktPrvek:TElement):TElement;
var i:Integer;
   OdCisla:integer;
 begin
  if AktPrvek=nil then
   begin
    OdCisla:=0;
   end
  else
   begin
    OdCisla:=IndexOf(AktPrvek)+1;
   end;
  result:=nil;
  i:=OdCisla;
  while  (result=nil)and(i<count) do
   begin
    if pos(uppercase(HledSubstr),uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname)))>0 then
     begin
      result:=Elements[i];
     end
    else
     begin
      inc(i);
     end;
   end;
 end;
function  TLesniMnozina.NajdiSubstrVPropertach(
               poleKtereZname1,HledSubstr1,poleKtereZname2,HledSubstr2:string;AktPrvek:TElement):TElement;
var i:Integer;
   OdCisla:integer;
 begin
  if AktPrvek=nil then
   begin
    OdCisla:=0;
   end
  else
   begin
    OdCisla:=IndexOf(AktPrvek)+1;
   end;
  result:=nil;
  i:=OdCisla;
  while  (result=nil)and(i<count) do
   begin
    if     (pos(uppercase(HledSubstr1),uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname1)))>0)
       and (pos(uppercase(HledSubstr2),uppercase(Elements[i].GetPropertyStringByName(PoleKtereZname2)))>0) then
     begin
      result:=Elements[i];
     end
    else
     begin
      inc(i);
     end;
   end;
 end;

function  TLesniMnozina.HodnotaPropertyExistuje(
               poleKtereZname,hodnotaPoleKtereZname:string):boolean;
 begin
  if PrvekPodleHodnotyProperty(poleKtereZname,hodnotaPoleKtereZname)=nil then
   begin
    result:=false;
   end
  else
   begin
    result:=true;
   end;
 end;
procedure TObecnyLesniprvek.nastavAktualniNaPrvni;
var i:integer;
 begin
  if Self is TLesniMnozina then
   begin
    if count>0 then
     TLesniMnozina(Self).aktualniPrvek:=elements[0];
   end;              
  for i:=0 to count-1 do
   begin
    if elements[i] is TObecnyLesniprvek then
     begin
      TObecnyLesniprvek(elements[i]).nastavAktualniNaPrvni;
     end;
   end;
 end;


function  TLesniMnozina.GetNejblizsiPoradiIPodleSetridenePropertyString(
                      SProperta,HlHodnota:string):Integer;
var i1,ip:integer;
 begin
  HlHodnota:=trim(WinToTrid(HlHodnota));
  if count=0 then
   begin
    result:=-1;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    // showmessage(elements[i1+ip].GetPropertyStringByName(SProperta)+'  '+inttostr(i1)+'  '+inttostr(ip));
    if trim(WinToTrid(elements[i1+ip].GetPropertyStringByName(SProperta)))<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  result:=i1;
 end;
function  TLesniMnozina.GetNejblizsiPrvekPodleSetridenePropertyString(
                      SProperta,HlHodnota:string):TObecnyLesniprvek;
var i1:integer;
 begin
  i1:=GetNejblizsiPoradiIPodleSetridenePropertyString(SProperta,HlHodnota);
  if i1=-1 then result:=nil
  else result:=TObecnyLesniprvek(elements[i1]);
 end;

procedure TLesniMnozina.VsechnyPrvkyPodlePropertyString(
                      SProperta,HlHodnota:string;RR:TLesniMnozina);
Var
 i:integer;
 begin
  for i:=0 to count-1 do
   begin
     if trim(uppercase(Elements[i].GetPropertyStringByName(SProperta)))
           = trim(uppercase(HLHodnota)) then
       begin
        RR.AddElement(Elements[i]);
       end;
   end;
 end;


procedure  TLesniMnozina.VsechnyPrvkyPodleSetridenePropertyString(
                      SProperta,HlHodnota:string;RR:TLesniMnozina);
var i1:integer;
    podminka:boolean;
 begin
  i1:=GetNejblizsiPoradiIPodleSetridenePropertyString(SProperta,HlHodnota);
  if i1=-1 then
   begin
    exit;
   end;

  while ((i1>0) and (trim(hlHodnota)=trim(elements[i1].GetPropertyStringByName(SProperta)))) do
   begin
    dec(i1);
   end;
  repeat
   if (trim(hlHodnota)=trim(elements[i1].GetPropertyStringByName(SProperta))) then
    begin
     rr.AddElement(elements[i1]);
    end;
   inc(i1);
   podminka:=false;
   if i1=count then
    begin
     podminka:=true
    end
   else
    begin
     if (trim(hlHodnota)<>trim(elements[i1].GetPropertyStringByName(SProperta))) then podminka:=true;
    end;
  until podminka;
 end;


function  TLesniMnozina.GetNejblizsiPrvekPodleSetridenePropertyLongInt(
                      SProperta:string;HlHodnota:LongInt):TObecnyLesniprvek;
var i1,ip:integer;
 begin
  if count=0 then
   begin
    result:=nil;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyLongIntByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  result:=TObecnyLesniprvek(elements[i1]);
 end;

function  TLesniMnozina.GetIndexNejblizsihoPrvkuPodleSetridenePropertyLongInt(
                      SProperta:string;HlHodnota:LongInt):Integer;
var i1,ip:integer;
 begin
  if count=0 then
   begin
    result:=-1;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyLongIntByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  result:=i1;
 end;

function  TLesniMnozina.GetIndexNejblizsihoPrvkuPodleSetridenePropertyString(
                      SProperta:string;HlHodnota:string):Integer;
var i1,ip:integer;
 begin
  if AktualniPrvek<>nil then
   begin
    try
     if AktualniPrvek.GetPropertyStringByName(SProperta)=HlHodnota then
      begin
       result:=PoradiAktualnihoPrvku;
       exit;
      end;
    except
    end;
   end;
  if count=0 then
   begin
    result:=-1;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyStringByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  result:=i1;
 end;

function  TLesniMnozina.GetNejblizsiPredchazejiciIndexHledaneHodnoty
                   (SProperta,HlHodnota:string;index:integer):integer;
 begin
  if  (index<0) then
   begin
    result:=index;
    exit;
   end;
  while((index>0)and(elements[index].GetPropertyStringByName(SProperta)<>HlHodnota)) do
   begin
    dec(index);
   end;
  result:=index;
  if (elements[index].GetPropertyStringByName(SProperta)<>HlHodnota) then
   begin
    while((index<count-1)and(elements[index].GetPropertyStringByName(SProperta)<>HlHodnota)) do
     begin
      inc(index);
     end;
   end;
  if (elements[index].GetPropertyStringByName(SProperta)=HlHodnota) then
   begin
    result:=index;
   end;
 end;
function  TLesniMnozina.ExistujePredchazejiciIndexHledaneHodnoty
                   (SProperta,HlHodnota:string;index:integer):boolean;
 begin
  result:=false;
  while index>0 do
   begin
    dec(index);
    if elements[index].GetPropertyStringByName(SProperta)=HlHodnota then result:=true
   end;

 end;

Procedure TLesniMnozina.PrvniIndexAPocetStejnychPrvkuPodleSetridenePropertyLongInt(
                      SProperta:string;HlHodnota:LongInt;var indexPrvniho,Pocet:integer);
var i1,ip:integer;
 begin
  if count=0 then
   begin
    indexPrvniho:=0;
    Pocet:=0;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyLongIntByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  if  elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota) do
     begin
      dec(i1)
     end;
    if not (elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota) then
      inc(i1);
    indexPrvniho:=i1;
    Pocet:=0;
    while (i1+pocet<count-1) and (elements[i1+pocet].GetPropertyLongIntByName(SProperta)=HlHodnota) do
     begin
      Inc(pocet);
     end;
    if (elements[i1+pocet].GetPropertyLongIntByName(SProperta)=HlHodnota) then
      inc(pocet);
    exit;
   end;
  if elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota  then
   begin
    while (i1<count-1) and (elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota) do
     begin
      Inc(i1);
     end;
    if (elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota) then
      inc(I1);
    indexPrvniho:=i1;
    pocet:=0;
    exit;
   end;

  if  elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota) do
     begin
      Dec(i1);
     end;
    if (elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota) then
      inc(I1);
    pocet:=0;
    exit;
   end;
 end;


{
var i1,ip:integer;
 begin
  if count=0 then
   begin
    indexPrvniho:=0;
    Pocet:=0;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyLongIntByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  if  elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota) do
     begin
      dec(i1)
     end;
    if not (elements[i1].GetPropertyLongIntByName(SProperta)=HlHodnota) then
      inc(i1);
    indexPrvniho:=i1;
    Pocet:=0;
    while (i1+pocet<count-1) and (elements[i1+pocet].GetPropertyLongIntByName(SProperta)=HlHodnota) do
     begin
      Inc(pocet);
     end;
    if (elements[i1+pocet].GetPropertyLongIntByName(SProperta)=HlHodnota) then
      inc(pocet);
    exit;
   end;
  if  elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota  then
   begin
    while (i1<count-1) and (elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota) do
     begin
      Inc(i1);
     end;
    if (elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota) then
      inc(I1);
    indexPrvniho:=i1;
    pocet:=0;
    exit;
   end;
  if  elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyLongIntByName(SProperta)<HlHodnota) do
     begin
      Dec(i1);
     end;
    if (elements[i1].GetPropertyLongIntByName(SProperta)>HlHodnota) then
      inc(I1);
    pocet:=0;
    exit;
   end;
 end;
}

Procedure TLesniMnozina.PrvniIndexAPocetStejnychPrvkuPodleSetridenePropertyString(
                      SProperta,HlHodnota:string;var indexPrvniho,Pocet:integer);
var i1,ip:integer;
 begin
  if count=0 then
   begin
    indexPrvniho:=0;
    Pocet:=0;
    exit;
   end;
  i1:=0;
  ip:=count;
  while ip>1 do
   begin
    ip:=(ip+1) div 2;
    if i1+ip>count-1 then i1:=count-1-ip;
    if elements[i1+ip].GetPropertyStringByName(SProperta)<=HlHodnota then
     begin
      i1:=i1+ip;
     end;
   end;
  if  elements[i1].GetPropertyStringByName(SProperta)=HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyStringByName(SProperta)=HlHodnota) do
     begin
      dec(i1)
     end;
    if not (elements[i1].GetPropertyStringByName(SProperta)=HlHodnota) then
      inc(i1);
    indexPrvniho:=i1;
    Pocet:=0;
    while (i1+pocet<count-1) and (elements[i1+pocet].GetPropertyStringByName(SProperta)=HlHodnota) do
     begin
      Inc(pocet);
     end;
    if (elements[i1+pocet].GetPropertyStringByName(SProperta)=HlHodnota) then
      inc(pocet);
    exit;
   end;
  if elements[i1].GetPropertyStringByName(SProperta)<HlHodnota  then
   begin
    while (i1<count-1) and (elements[i1].GetPropertyStringByName(SProperta)<HlHodnota) do
     begin
      Inc(i1);
     end;
    if (elements[i1].GetPropertyStringByName(SProperta)<HlHodnota) then
      inc(I1);
    indexPrvniho:=i1;
    pocet:=0;
    exit;
   end;

  if  elements[i1].GetPropertyStringByName(SProperta)>HlHodnota  then
   begin
    while (i1>0) and (elements[i1].GetPropertyStringByName(SProperta)>HlHodnota) do
     begin
      Dec(i1);
     end;
    if (elements[i1].GetPropertyStringByName(SProperta)<HlHodnota) then
      inc(I1);
    pocet:=0;
    exit;
   end;
 end;

procedure TLesniMnozina.SetAktualniPrvek(VAktualniPrvek:TElement);
 begin
  FJmenoStarehoPrvku:=JmenoAktualnihoPrvku;
  FAktualniPrvek:=VAktualniPrvek;
 end;

function  TLesniMnozina.GetPoradiAktualnihoPrvku:Integer;
 begin
   if aktualniPrvek=nil then result:=0
   else result:=IndexOf(aktualniPrvek);
 end;

constructor TLesniMnozina.Create;
 begin
  inherited create;
  FAktualniPrvek:=nil;
  FPrazdny:=nil;
  FAdresaOrbu:='';
  historie:='h';
 end;

Destructor TLesniMnozina.destroy;
 begin
  if FPrazdny<>nil then
   begin
    FPrazdny.free;
    FPrazdny:=nil;
   end;
  inherited destroy;
 end;


function TObecnyLesniPrvek.GetVlastnostiMN:TVlastnostiMN;
var s:string;
 begin
   if  FVlastnostiMN=nil then
    begin
     FVlastnostiMN:=TVlastnostiMN(FindElementName('TVlastnostiMN'));
     if FVlastnostiMN=nil then
      begin
       result:=nil;
      end;
     exit;
    end;
   try
    s:=FVlastnostiMN.name;
    result:=FVlastnostiMN;
   except
    FVlastnostiMN:=nil;
    result:=nil;
   end;
 end;
procedure zvetsRekurzivneNAME(Enti:TEntity);
var i:integer;
 begin
  for i:=0 to Enti.count-1 do
   begin
    Enti.elements[i].name:=upperCase(Enti.elements[i].name);
    // showmessage(Enti.elements[i].name);
    if  Enti.elements[i] is TEntity then
     begin
      zvetsRekurzivneNAME(TEntity(Enti.elements[i]));
     end;
   end;
 end;
function ZTypuZmenyString(VTypZmeny:TTypZmeny):String;
 begin
  case VTypZmeny of
   nezmenilse:result:='nezmenilse';
   bylNoveZaveden:result:='bylNoveZaveden';
   BudeSmazan1:result:='BudeSmazan';
  end;
 end;
function ZeStringuTypZmeny(strTypZmeny:String):TTypZmeny;
var
 nasel:boolean;
 begin
  nasel:=false;
  strTypZmeny:=lowercase(strTypZmeny);

  if strTypZmeny='nezmenilse'  then
   begin
    result:=nezmenilse;
    nasel:=true;
   end;
  if strTypZmeny='bylnovezaveden'  then
   begin
    result:=bylNoveZaveden;
    nasel:=true;
   end;
  if strTypZmeny='budesmazan'  then
   begin
    result:=BudeSmazan1;
    nasel:=true;
   end;
  if not nasel then
   begin
    showmessage('Neznm typZmeny ="'+strTypZmeny+'"');
   end;
 end;
 
function JazykZeStringu1(SJazyk:String):TJazyk;
var nasel:boolean;
 begin
  nasel:=false;
  SJazyk:=uppercase(SJazyk);
  if SJazyk='CESKY' then
   begin
    result:=Cesky;
    nasel:=true;
   end;
  if SJazyk='NEMECKY' then
   begin
    result:=Nemecky1;
    nasel:=true;
   end;
  if SJazyk='ANGLICKY' then
   begin
    result:=Anglicky1;
    nasel:=true;
   end;
  if not nasel then
   begin
    result:=Cesky;
    showmessage('String "'+SJazyk+'" nen nzvem jazyka.');
   end;
 end;
function ZeStrListuStrListElem(Seznam:TStringList):TStringListElement;
 var
  i:integer;
  LsE:TStringListElement;
 begin
  if  seznam=nil then
   begin
    result:=nil;
    exit;
   end;
  LsE:=TStringListElement.create;
  for i:=0 to Seznam.count-1 do
   begin
    Lse.AddString(Seznam.strings[i]);
    TStringElement(lse.elements[i]).name:=Seznam.strings[i];
   end;
  result:=LsE;
 end;
constructor  TObecnyLesniPrvek.create;
 begin
  inherited create;
  FTypDatLHP:=NeniLHP;
  FSelekt:=true;
  BylEditovan:=false;
 end;

function  TObecnyLesniPrvek.GetTypDatLHP:TTypDatLHP;
var i0:integer;
 begin
  if FTypDatLHP<>NeniLHP then
   begin
    result:=FTypDatLHP;
    exit;
   end;
  result:=NeniLHP;
  for i0:=0 to Ownerscount-1 do
   begin
    if Owners[i0] is TObecnyLesniPrvek then
     begin
      if TObecnyLesniPrvek(Owners[i0]).FFTypDatLHP<>NeniLHP then
       begin
        result:=TObecnyLesniPrvek(Owners[i0]).FFTypDatLHP;
        FTypDatLHP:=result;
        exit;
       end;
     end;
   end;
  for i0:=0 to Ownerscount-1 do
   begin
    if Owners[i0] is TObecnyLesniPrvek then
     begin
      if TObecnyLesniPrvek(Owners[i0]).TypDatLHP<>NeniLHP then
       begin
        result:=TObecnyLesniPrvek(Owners[i0]).TypDatLHP;
        FTypDatLHP:=result;
        exit;
       end;
     end;
   end;
 end;

function  TObecnyLesniPrvek.KopieElementu:TObecnyLesniPrvek;
var
 VKopieElementu:TObecnyLesniPrvek;
 I:integer;
 S1:string;
 begin
  VKopieElementu:=TObecnyLesniPrvek(CreateElementCopy(self));
  if VlastnostiMN<>NIl then
   begin
    VKopieElementu.VlastnostiMNCreate;
    for I:= GetPropIndex(self,'LastIndex')+1 to GetPropCount(self)-1 do
     begin
      s1:=GetPropName(Self, I);
      VKopieElementu.barva[s1]:=barva[s1];
     end;
   end;
  VKopieElementu.rid:=-1;
  VKopieElementu.vazba:=-1;
  VKopieElementu.puvodni_Oznaceni:='+-=+-=';
  result:=VKopieElementu;
 end;

function NactiZOrbu(odkudSoubDir:string;hlasitKdyzNeni:boolean):TOwnerEntity;
var  VLoad:TLoad;
     nnOdkudSoubDir :string;
     VSearch, VSearchNN:  TSearchRec;
     VyslFind: integer;
begin

 nnOdkudSoubDir:= vlozPredPosledniZnak (OdkudSoubDir,'.','nn');
//  showmessage(OdkudSoubDir);
 VyslFind:=FindFirst(nnOdkudSoubDir,faAnyFile,VSearchNN);
 if VyslFind=0 then
  begin
   VyslFind:=FindFirst(OdkudSoubDir,faAnyFile,VSearch);
   if VyslFind=0 then
    begin
     if VSearchNN.Time>VSearch.Time then
      begin
       OdkudSoubDir:=nnOdkudSoubDir;
      end
    else
      begin
       DeleteFile(nnOdkudSoubDir);
      end;
    end
   else
    begin
     OdkudSoubDir:=nnOdkudSoubDir;
    end;
  end;
// if fileExists(nnOdkudSoubDir) then
//  begin
//    OdkudSoubDir:=nnOdkudSoubDir;
//  end;

 if fileExists(odkudSoubDir) then
  begin
    VLoad:=TLoad.CreateAll(odkudSoubDir);
    try
     VLoad.doit;
     except
      showmessage('Soubor "'+odkudSoubDir+'" nejde nast jako Orb.');
      VLoad.Free;
      exit;
     end;
   if VLoad.OutPut is TOwnerEntity then
    begin
     if VLoad.OutPut.Name='BaUKL' then
      begin
       result:=TOwnerEntity(TOwnerEntity(VLoad.OutPut).elements[0]);
      end
     else
      begin
       result:=TOwnerEntity(VLoad.OutPut);
      end;
    end
   else
    begin
     showmessage('Soubor "'+odkudSoubDir+'" neobsahuje TOwnerEntity.');
    end;
   VLoad.Free;
  end
 else
  begin
   if hlasitKdyzNeni then showmessage('Soubor "'+odkudSoubDir+'" neexistuje.');
   result:=nil;
  end;
end;

procedure UlozDoOrbu(UlozBlok:TOwnerEntity;kamSoubDir:string;pocetZaloznichKopii:integer);
var
 VSave:TSave;
//  VXxxt:Txxxt;//TPrvekNaUlozeni;
 s,kamSoubDirA,kamSoubDirB:String;
 i:integer;
 begin
  application.ProcessMessages;
  {
  if rozdilVDatumech(15,4,2012)<0 then
   begin
    kamSoubDir:= vlozPredPosledniZnak(kamSoubDir,'.','nn');
   end;       }
  try
  s:='1';
  ForceDirectories(kPoslednimuznaku(kamSoubDir,'\'));
  s:='2';
  for i:=pocetZaloznichKopii-1 downto 0 do
   begin
    if i=0 then kamSoubDirA := kamSoubDir
           else kamSoubDirA := vlozPredPosledniZnak(kamSoubDir,'.',inttostr(i));
                             //vlozPredString(kamSoubDir,'.',inttostr(i));
    kamSoubDirB:=vlozPredPosledniZnak(kamSoubDir,'.',inttostr(i+1));
    if fileexists(kamSoubDirB) then
     begin
       DeleteFile(kamSoubDirB);
     end;
    if fileexists(kamSoubDirA) then
     begin
      RenameFile(kamSoubDirA,kamSoubDirB);
     end;
   end;
  VSave:=TSave.CreateAll(kamSoubDir);
  s:='3';
{  if rozdilVDatumech(15,4,2012)>0 then
   begin
    VXxxt:=TXxxt.Create;
    VXxxt:=TXXxt.Create;
    VXxxt.Name:='BaUKL';
    VXxxt.AddElement(elementsDel5.TOwnerEntity(UlozBlok));
    VSave.Input:=VXxxt;
   end
  else        }
   begin
    VSave.Input:=UlozBlok;
   end;
  s:='4';
  application.ProcessMessages;
  s:='5';
  VSave.doit;
  s:='6';
  application.ProcessMessages;
  s:='7';
  VSave.free;
  s:='8';
  except
   application.ProcessMessages;
   showmessage('Chyba pi ukldn do bloku "'+kamSoubDir+'"  .'+s);
  end;
 // kamSoubDir:= vlozPredPosledniZnak(kamSoubDir,'.','nn');
 // if fileexists(kamSoubDir) then DeleteFile(kamSoubDir);
{  if rozdilVDatumech(15,4,2012)>0 then
   begin
    VXxxt.Free;
   end;      }
  application.ProcessMessages;
 end;

Procedure TLesniMnozina.OdhlasSeZeZapisu;
var
 VUzivatel:String;
 begin
    if (FPouzeCteni=false) and (KontrolovatSdileni=true) then
     begin
      VUzivatel:=NactiZIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                   ,'Sdileni','Prave_uziva','nikdo');
      if (uppercase(VUzivatel)='nikdo')or(VUzivatel=jmenoPocitace) then
        begin
         zapisDoIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                   ,'Sdileni','Prave_uziva','nikdo');
        end;
     end;
 end;
Procedure TLesniMnozina.UlozDoOrbuPodleAdresy(pocetZaloznichKopii:integer);
var
 VOdpov:boolean;
 vUZI:string;
 begin
  if pouzeCteni then
   begin
    exit;
   end;
  if KontrolovatSdileni then
   begin
    vUZI:=nactiZIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                   ,'Sdileni','Prave_uziva','nikdo');
    if not((vUZI='nikdo')or(vUZI=jmenoPocitace)) then
     begin
      Application.CreateForm(TdotazF1,dotazF2);
      dotazF2.left:=10;
      dotazF2.Width:=620;
      dotazF2.Label1.Caption:='Soubor "'+FAdresaOrbu+'"';
      dotazF2.Label2.Caption:='je uivatelem "'+vUZI+'" ji oteven pro zpis.' ;
      dotazF2.Label3.Caption:='Pokud jej pepiete, nemus se zapsat nkter zmny. Chcete pesto zapsat?';
      dotazF2.showmodal;
      VOdpov:=dotazF2.odpoved;
      dotazF2.free;
      if VOdpov then
       begin
        UlozDoOrbu(Self,AdresaOrbu,pocetZaloznichKopii);
        zapisDoIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                    ,'Sdileni','Prave_uziva',jmenoPocitace);
       end;
     end
    else
     begin
      zapisDoIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                   ,'Sdileni','Prave_uziva',jmenoPocitace);
      UlozDoOrbu(Self,AdresaOrbu,pocetZaloznichKopii);
     end;
   end
  else
   begin
    UlozDoOrbu(Self,AdresaOrbu,pocetZaloznichKopii);
   end;
 end;

Procedure TLesniMnozina.SetPouzeCteni(vPouzeCteni:Boolean);
var
  VOdpov:boolean;
  vUZI,chy,AO:string;
 begin
  AO:='';
      application.ProcessMessages;
  try
  chy:='0';
  if VPouzeCteni then
   begin
  chy:='1';
    OdhlasSeZeZapisu;
  chy:='2';
    FPouzeCteni:=true;
  chy:='3';
   end
  else
   begin
  chy:='4';
    if KontrolovatSdileni then
     begin
  chy:='5a';
  AO:=FAdresaOrbu;
  chy:='5';
      vUZI:=nactiZIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                   ,'Sdileni','Prave_uziva','nikdo');
  chy:='6';
      application.ProcessMessages;
  chy:='7';
      if (vUZI='nikdo')or(vUzi=jmenoPocitace) then
       begin
  chy:='8';
        zapisDoIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                  ,'Sdileni','Prave_uziva',jmenoPocitace);
  chy:='9';
        application.ProcessMessages;
  chy:='10';
        FPouzeCteni:=false;
  chy:='11';
       end
      else
       begin
  chy:='12';
        Application.CreateForm(TdotazF1,dotazF2);
  chy:='13';
        dotazF2.left:=10;
  chy:='14';
        dotazF2.Width:=620;
  chy:='15';
        dotazF2.Label1.Caption:='Soubor "'+FAdresaOrbu+'"';
  chy:='16';
        dotazF2.Label2.Caption:='je uivatelem "'+vUZI+'" ji oteven pro zpis.' ;
  chy:='17';
        dotazF2.Label3.Caption:='Pokud jej pepiete, nemus se zapsat nkter zmny. Chcete pesto zapsat?';
  chy:='18';
         {
        dotazF2.Label1.Caption:='Soubor "'+FAdresaOrbu+'" je uivatelem "'+vUZI+'"';
        dotazF2.Label2.Caption:='ji oteven pro zpis. Pokud jej otevete tak, nemus se zapsat nkter zmny.' ;
        dotazF2.Label3.Caption:='Chcete jej pesto otevt pro zpis ?';
         }
        dotazF2.showmodal;
  chy:='19';
        VOdpov:=dotazF2.odpoved;
  chy:='20';
        dotazF2.free;
  chy:='21';
        if VOdpov then
         begin
  chy:='22';
          zapisDoIni(KPoslednimuZnaku(FAdresaOrbu,'.')+'.UZI'
                                  ,'Sdileni','Prave_uziva',jmenoPocitace);
  chy:='23';
          FPouzeCteni:=false;
  chy:='24';
         end
        else
         begin
  chy:='25';
          FPouzeCteni:=true;
  chy:='26';
         end;
       end;
     end
    else
     begin
  chy:='27';
      FPouzeCteni:=false;
  chy:='28';
     end;
   end;
  except
   LesniMnozinaSetPouzeCtenivyslo:=false;
   showmessage(' chyba v TLesniMnozina.SetPouzeCteni chy='+chy);
   showmessage('AO='+AO);
   showmessage('historie='+historie);
  end;
 end;

function  TLesniMnozina.SelektPocet:integer;
var i,ipocet:integer;
 begin
  ipocet:=0;
  for i:=0 to count-1 do
   begin
    if TObecnyLesniPrvek(elements[i]).Selekt then inc(iPocet);
   end;
  result:=iPocet;
 end;

function  TObecnyLesniPrvek.OwnerLesniMnozina:TLesniMnozina;
 begin
  result:=TLesniMnozina(OwnerTypu(TLesniMnozina));
 end;

Destructor TObecnyLesniPrvek.destroy;
 begin
  if FVlastnostiMN<>nil then
   begin
    FVlastnostiMN.free;
    FVlastnostiMN:=nil;
   end;
  inherited destroy;
 end;
Procedure TLesniMnozina.SmazVsechnyPrvkyVMnozine;
 begin
  while count<>0 do
   begin
    elements[count-1].free;
   end;
  aktualniprvek:=nil;
 end;
function  TObecnyLesniPrvek.GetBylNoveVytvoren:Boolean;
 begin
  if puvodni_Oznaceni='+-=+-=' then result:=true else result:=false;
 end;
function  TObecnyLesniPrvek.GetMaSmazany:Boolean;
 begin
  result:=false;
 end;
function  TObecnyLesniPrvek.GetMaSmazanyRekurz:Boolean;
 var i:integer;
 begin
  result:=false;
  if BylNoveVytvoren then
   begin
    result:=false;
    exit;
   end;
  if MaSmazany then
   begin
    result:=true;
    exit;
   end;
  for i:=0 to Count-1 do
   begin
    if elements[i] is TObecnyLesniPrvek then
     begin
      if TObecnyLesniPrvek(elements[i]).MaSmazanyRekurz then
       begin
        result:=true;
        exit;
       end;
     end;
   end;
 end;

function zBarvyInteger(Vbarva:TColor):integer;
 begin
  case VBarva of
    clInfoBk:result:=0;
    clWhite:result:=1;
    cl3DLight:result:=-1;
    clAqua:result:=5;
    ClYellow:result:=2;
    else
     begin
      result:=-1;
     end;
   end;
 end;

function zIntegeruBarva(Vbarva:integer):TColor;
 begin
  case VBarva of
    -1:result:=cl3DLight;
    5:result:=clAqua;
    1:result:=clWhite;
    0:result:=clInfoBk;
    2:result:=ClYellow;
   end;
 end;
procedure TObecnyLesniPrvek.NactiProperty(aElement: TStringListElement);
var i:integer;
    jmProp:string;
 begin
  for i:=0 to aElement.Count-1 do
   begin
    // showmessage(aElement.names[i]+':=:'+aElement.Strings[i]);
    jmProp:='';
    if HasPropertyByName(aElement.names[i]+'_XML') then
     begin
      jmProp:=aElement.names[i]+'_XML';
     end
    else
     begin
      if HasPropertyByName(aElement.names[i]) then
       begin
        jmProp:=aElement.names[i];
       end;
     end;
    if jmProp<>'' then
     begin
      try
       SetPropertyStringByName(jmProp,aElement.Strings[i]);
      except
       if HasPropertyByName('CeleOznaceni') then
        begin
         showmessage('Do vlastnosti "'+jmProp+'" prvku oznaen "'+getPropertyStringByName('CeleOznaceni')+'" nejde nast hodnota "'+aElement.Strings[i]+'".');
        end
       else
        begin
         showmessage('Do vlastnosti "'+jmProp+'" prvku jmnem "'+name+'" nejde nast hodnota "'+aElement.Strings[i]+'".');
        end;
      end;
     end;
   end;
 end;
  procedure TObecnyLesniPrvek.SetBylEditovan(VBylEditovan:boolean);
   begin
    if (FBylEditovan=false) and (VBylEditovan=true) then
     begin

     end;
    FBylEditovan:=VBylEditovan;
   end;

function  TLesniMnozina.GetPrazdny:TElement;
 begin
  if FPrazdny=nil then
   begin
    FPrazdny:=FClass.create;
   end;
  result:=Fprazdny;
 end;

procedure TLesniMnozina.nastavNeboVytvorAktualDleProperty(VProperta,HodnotaProperty:string);
var
 index1:integer;
 begin
  if aktualniPrvek<>nil then
   begin
    if aktualniPrvek.GetPropertyStringByName(VProperta) =HodnotaProperty then
     begin
      exit;
     end;
   end;
  index1:=GetIndexNejblizsihoPrvkuPodleSetridenePropertyString
                     (VProperta,HodnotaProperty);
  if index1=-1 then
   begin
    aktualniPrvek:=FClass.create;
    addelement(aktualniPrvek);
    exit;
   end;
  if aktualniPrvek.GetPropertyStringByName(VProperta)=HodnotaProperty then
   begin
    aktualniPrvek:=elements[index1];
   end
  else
   begin
    aktualniPrvek:=FClass.create;
    addelement(aktualniPrvek);
   end;
 end;
procedure TLesniMnozina.pripojLesniMnozinu(LesMN:TlesniMnozina);
var i:Integer;
 begin
  for i:=0 to LesMN.count-1 do
   begin
    AddElement(LesMN.Elements[i]);
   end; 
 end;


initialization
 registerOrbisClass(TVlastnosti);
 registerOrbisClass(TVlastnostiMN);
 registerOrbisClass(TVlastnostiSloupcu);
 registerOrbisClass(TVlastnostiSloupcuMN);
 registerOrbisClass(TObecnyLesniPrvek);
 registerOrbisClass(TLesniMnozina);
end.

