unit ERozhod;

interface

uses sysUtils,Dialogs,dbtables,DB,
     ELesObec,E_LesOdd,LesCisOr,mat1,
     E_Class,U_props,T_oper,TypInfo,
     elements,creacond,U_Podmin;
type

 TRadekRozhodnuti = class(TObecnyLesniPrvek)
  private
   FODD:integer;
   FDIL:string;
   FPOR:string;
   FPSK:string;
   FMAJ_KOD:string;
   FMAJ_DRUH:integer;
   FCisJedn:string;
   FTypRozh:integer;
   FDruhRozh:string;

   FVec:string;
   FZadatel:string;
   FDatum_Podani:string;
   FDatum_vydani:string;
   FDatum_Doruceni:string;
   FDatum_Odvolani:string;
   FDatum_Vyrizeni_Odvolani:string;
   FDatum_Pravni_moc:string;

   FPlatnost_OD:String;
   FPlatnost_DO:String;
   FPoznamka:String;
   function GetTypRozh_nazev:string;
   function GetOddDilPorPsk:string;
   function GetOddDilPorPskMinus:string;
   function GetJedinecnyTyp:string;
   function GetDruhRozh:string;
  public
   procedure kovnertujZRozhodnutiDoDokumentu;
  published
   property ODD:integer         read FODD write FODD;
   property DIL:string         read FDIL write FDIL;
   property POR:string         read FPOR write FPOR;
   property PSK:string         read FPSK write FPSK;
   property MAJ_KOD:string    read FMAJ_KOD write FMAJ_KOD;
   property MAJ_DRUH:integer   read FMAJ_DRUH write FMAJ_DRUH;
   property CisJedn:string     read FCisJedn write FCisJedn;
   property DruhRozh:string    read GetDruhRozh write FDruhRozh;
   property TypRozh:integer    read FTypRozh write FTypRozh;
   property TypRozh_nazev:string read GetTypRozh_nazev stored false;

   property Vec:string read FVec write FVec;
   property Zadatel:string read FZadatel write FZadatel;
   property Datum_Podani:string read FDatum_Podani write FDatum_Podani;
   property Datum_vydani:string read FDatum_vydani write FDatum_vydani;
   property Datum_Doruceni:string read FDatum_Doruceni write FDatum_Doruceni;
   property Datum_Odvolani:string read FDatum_Odvolani write FDatum_Odvolani;
   property Datum_Vyrizeni_Odvolani:string read FDatum_Vyrizeni_Odvolani write FDatum_Vyrizeni_Odvolani;
   property Datum_Pravni_moc:string read FDatum_Pravni_moc write FDatum_Pravni_moc;

   property Platnost_OD:String   read FPlatnost_OD write FPlatnost_OD;
   property Platnost_DO:String   read FPlatnost_DO write FPlatnost_DO;
   property Poznamka:String      read FPoznamka write FPoznamka;
   property OddDilPorPsk:string  read GetOddDilPorPsk stored false;
   property OddDilPorPskMinus:string  read GetOddDilPorPskMinus stored false;
   property JedinecnyTyp:string  read GetJedinecnyTyp stored false;

  end;

 TRadekRozhodnutiMN = class(TLesniMnozina)
  private
  public
   procedure kovnertujZRozhodnutiDoDokumentu;
   constructor Create; override;
  end;

implementation
function TRadekRozhodnuti.GetJedinecnyTyp:string;
 begin
  result:=ubm(DruhRozh+inttostr(TypRozh));
 end;

function TRadekRozhodnuti.GetDruhRozh:string;
 begin
  if FDruhRozh='' then result:='S' else result:=FDruhRozh;
 end;
procedure TRadekRozhodnuti.kovnertujZRozhodnutiDoDokumentu;
 begin
  If DruhRozh='S' then
   begin
    case TypRozh of
     1:begin
        DruhRozh:='R';
        TypRozh:=6;
       end;
     2:begin
        DruhRozh:='R';
        TypRozh:=17;
       end;
     3:begin
        DruhRozh:='R';
        TypRozh:=13;
       end;
     4:begin
        DruhRozh:='P';
        TypRozh:=9;
       end;
     5:begin
        DruhRozh:='P';
        TypRozh:=10;
       end;
     6:begin
        DruhRozh:='P';
        TypRozh:=13;
       end;
     7:begin
        DruhRozh:='O';
        TypRozh:=3;
       end;
    end;
   end;
 end;
function TRadekRozhodnuti.GetTypRozh_nazev:string;
 begin
    // CiselOrbisOwnEnt
  if ciselOrbisOwnEnt<>nil then
   begin
                      // CiselOrbisOwnEnt

    result:=TCiselOrbis(ciselOrbisOwnEnt).TypRozhodnutiMN.jakoPodleCiselniku('JedinecnyTyp',JedinecnyTyp,'POPIS');
    // result:=TCiselOrbis(ciselOrbisOwnEnt).TypRozhodnutiMN.jakoPodleCiselniku('KOD',inttostr(TypRozh),'POPIS');
   end
 else
   begin
    result:='nil';
   end;
 end;


constructor TRadekRozhodnutiMN.Create;
 begin
  inherited create;
  FClass:=TRadekRozhodnuti;
  FPredponaName:='R_ROZHOD';
 end;

function TRadekRozhodnuti.GetOddDilPorPsk:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,' ')+DIL+POR+PSK;
 end;

function TRadekRozhodnuti.GetOddDilPorPskMinus:string;
 begin
  result:=DoplnZePreduZnakem1(inttostr(ODD),4,'-')+DIL+POR+PSK;
 end;

procedure TRadekRozhodnutiMN.kovnertujZRozhodnutiDoDokumentu;
var i:integer;
 begin
  for i:=0 to count-1 do
   begin
    TRadekRozhodnuti(Elements[i]).kovnertujZRozhodnutiDoDokumentu;
   end;
 end;

initialization

 registerOrbisClass(TRadekRozhodnuti);
 registerOrbisClass(TRadekRozhodnutiMN);

end.
