unit ESeznCelk;

interface
uses ELesObec, mat1, Lesrecur,
     dbtables,SysUtils,stdctrls,dialogs,forms,FileCtrl,IniFiles,
     T_Recurs, T_Grp,    T_Select,
     e_Files,  elements,  G_elems, E_Class, T_saver, T_Loader,
     E_lesOdd, F_gauge, Graphics;
type

 TPodobnostPolozkyCelku =
     ( Shodna,
       LisiSeAdresar,
       LisiSeLHC_KOD_ID,
       ShodnyAdresarATypANeniOracle,
       lisiSeLHP_OD_DO,
       ShodnyLHC_KODATypaLHP_OD_DO,
       ShodnyLHC_NAZATypaLHP_OD_DO,
       LisiSeTypShodnyLHC_KOD_LHC_NAZ_LHP_OD_DO,
       LisiSeAdresarLHP_OD_DO,
       ShodnyLHC_KODATyp,
       ShodnyLHC_NAZATyp,
       LisiSeTypShodnyLHC_KOD_LHC_NAZ,
       ShodnyLHC_KOD,
       ShodnyLHC_NAZ,
       LisiSeUplne );
 TpolozkaSeznamuCelku = class;
 TObdelniky = class(TObecnyLesniPrvek)
 private
  FAdresarMapy1:String;
  FRecEnti:TRectEntity;
  function  GetRecEnti:TRectEntity;
 public
  constructor Create; override;
  function  OwnerpolozkaSeznamuCelku:TpolozkaSeznamuCelku;
 published
  property AdresarMapy1:String read FAdresarMapy1 write FAdresarMapy1;
  property RecEnti:TRectEntity read GetRecEnti write FRecEnti stored false;
 end;

 TObdelnikyMN = class(TLesniMnozina)
 private
 public
  constructor Create; override;
  function AdresarJeVObdelnikach(VAdresar:string):Boolean;
 published
 end;


TAdresarRastru = class(TObecnyLesniPrvek)
 private
  FadresarRastru:string;
  FBarvaRastru:string;
  FVrstvaRastru:string;
  function GetBarvaRasru:string;
 public
  constructor Create; override;
 published
  property adresarRastru:string read FadresarRastru write FadresarRastru;
  property BarvaRastru:string   read GetBarvaRasru   write FBarvaRastru;
  property VrstvaRastru:string   read FVrstvaRastru   write FVrstvaRastru;

 end;

 TAdresarRastruMN = class(TLesniMnozina)
 private
  FadresarRastru:string;
 public
  constructor Create; override;
 published
 end;

 TpolozkaSeznamuCelku = class(TObecnyLesniPrvek)
 private
  FLHC_KOD_Sc                 :longint;
  FLHC_NAZ_Sc                 :string;
  FLHP_OD_Sc                  :String{Datum};
  FLHP_DO_Sc                  :String{Datum};
  FadresarObecnychDat_Sc      :string;
  FAdresarMapy_SC             :string;
  FAdresarRastru_SC           :string;
  FAdresarVrstevnic_SC        :string;
  FTypDatLHP_St_SC            :string;
  FTypMapyLHP_St_SC           :string;
  FLHC_KOD_ID_Sc              :longint;
  FAdresarPomDat_SC           :string;
  FAdresarSpolecnychPomDat_SC :string;
  FNasobneRastry_SC :Boolean;
  FZobrazovatRastry_SC  :Boolean;
  FZobrazovatRastryNahore_SC  :Boolean;
  FZobrazovatVrstevnice_SC:Boolean;
  FNacitatMapuCelLHC_SC :Boolean;
  FNacitatVrstevnice_SC :Boolean;
  FSouvisleZobrazeni_SC :boolean;
  FVirtualScale_SC      :LongInt;
  FOsnovy_SC            :Boolean;
  FLHEvidence_SC        :boolean;
  FOdkornene_SC         :string;
  FViditelny            :Boolean;

  FVychDo40  :TAnoNeRozhodniSeSam;
  FRamcSmer  :TAnoNeRozhodniSeSam;
  FAdresaNeniSoucastiJmena  :TAnoNeRozhodniSeSam;
  FColor:TColor;
  FObdelnikyMN:TObdelnikyMN;
  FAdresarRastruMN:TAdresarRastruMN;
  FLHC_KOD_P0110_SC:LongInt;

  function  GetVychDo40Str  :string;
  procedure SetVychDo40Str  (s:string);

  function  GetRamcSmerStr  :string;
  procedure SetRamcSmerStr  (s:string);

  function  GetAdresaNeniSoucastiJmenaStr  :string;
  procedure SetAdresaNeniSoucastiJmenaStr  (s:string);

  function  GetColorStr_SC  :string;
  procedure SetColorStr_SC  (s:string);
  Function  GetLHC_KOD_nebo_P0110_KOD:LongInt;
  function  GetObdelnikyMN:TObdelnikyMN;
  function  GetAdresarRastruMN:TAdresarRastruMN;

 public
  // procedure nactiZTabulkyPolozku(TAble1:TTable);
  // procedure ulozDoTabulkyPolozku(TAble1:TTable);
  procedure UlozDoPomDatVcetneAdresare;
  procedure UlozDoPomDat;
  procedure ZalozAdresarPomDat;
  procedure NactizAdresarePomDat;
  property  Color_SC:TColor read FColor write FColor;
  property  ObdelnikyMN:TObdelnikyMN read GetObdelnikyMN write FObdelnikyMN;
  property  AdresarRastruMN:TAdresarRastruMN read GetAdresarRastruMN write FAdresarRastruMN;

 published
  property LHC_KOD_Sc       :longint read FLHC_KOD_Sc write FLHC_KOD_Sc;
  property LHC_NAZ_Sc       :string read FLHC_NAZ_Sc write FLHC_NAZ_Sc;
  property TypDatLHP_St_SC  :string read FTypDatLHP_St_SC write FTypDatLHP_St_SC;
  property TypMapyLHP_St_SC :string read FTypMapyLHP_St_SC write FTypMapyLHP_St_SC;
  property adresarObecnychDat_Sc :string read FadresarObecnychDat_Sc write FadresarObecnychDat_Sc;
  property AdresarMapy_SC   :string read FAdresarMapy_SC write FAdresarMapy_SC;
  property AdresarRastru_SC   :string read FAdresarRastru_SC write FAdresarRastru_SC;
  property AdresarVrstevnic_SC   :string read FAdresarVrstevnic_SC write FAdresarVrstevnic_SC;
  property AdresarPomDat_SC:string read FAdresarPomDat_SC write FAdresarPomDat_SC;
  property AdresarSpolecnychPomDat_SC:string read FAdresarSpolecnychPomDat_SC write FAdresarSpolecnychPomDat_SC;

  property LHP_OD_Sc        :String{Datum} read FLHP_OD_Sc write FLHP_OD_Sc;
  property LHP_DO_Sc        :String{Datum} read FLHP_DO_Sc write FLHP_DO_Sc;
  property LHC_KOD_ID_Sc    :longint read FLHC_KOD_ID_Sc write FLHC_KOD_ID_Sc;

  property ZobrazovatRastry_SC       :Boolean read FZobrazovatRastry_SC write FZobrazovatRastry_SC;
  property ZobrazovatRastryNahore_SC :Boolean read FZobrazovatRastryNahore_SC write FZobrazovatRastryNahore_SC;
  property ZobrazovatVrstevnice_SC   :Boolean read FZobrazovatVrstevnice_SC write FZobrazovatVrstevnice_SC;
  property NacitatMapuCelLHC_SC      :Boolean read FNacitatMapuCelLHC_SC write FNacitatMapuCelLHC_SC;
  property NacitatVrstevnice_SC      :Boolean read FNacitatVrstevnice_SC write FNacitatVrstevnice_SC;
  property SouvisleZobrazeni_SC      :Boolean read FSouvisleZobrazeni_SC write FSouvisleZobrazeni_SC;
  property VirtualScale_SC           :LongInt read FVirtualScale_SC write FVirtualScale_SC;

  property Viditelny        :Boolean read FViditelny write FViditelny;

  property VychDo40_SC   :TAnoNeRozhodniSeSam read FVychDo40 write FVychDo40 stored false;
  property RamcSmern_SC   :TAnoNeRozhodniSeSam read FRamcSmer write FRamcSmer stored false;
  property AdresaNeniSoucastiJmena_SC   :TAnoNeRozhodniSeSam read FAdresaNeniSoucastiJmena write FAdresaNeniSoucastiJmena stored false;

  property VychDo40Str_SC:string read GetVychDo40Str write SetVychDo40Str;
  property RamcSmerStr_SC:string read GetRamcSmerStr write SetRamcSmerStr;
  property AdresaNeniSoucastiJmenaStr_SC:string read GetAdresaNeniSoucastiJmenaStr write SetAdresaNeniSoucastiJmenaStr;
  property ColorStr_SC:string read GetColorStr_SC  write SetColorStr_SC;

  property Osnovy_SC  :Boolean read FOsnovy_SC write FOsnovy_SC;
  property LHC_KOD_P0110_SC:LongInt read FLHC_KOD_P0110_SC write FLHC_KOD_P0110_SC;
  property LHC_KOD_nebo_P0110_KOD_SC:LongInt read  GetLHC_KOD_nebo_P0110_KOD stored false;
  property Odkornene_SC1 :string  read FOdkornene_SC write FOdkornene_SC;
  property LHEvidence_SC  :Boolean read FLHEvidence_SC write FLHEvidence_SC;
  property NasobneRastry_SC :Boolean read FNasobneRastry_SC write FNasobneRastry_SC;
 end;

TpolozkaSeznamuCelkuMN = class(TLesniMnozina)
 private
  FProhledavaneDisky:TLesniStringListElement;
  FNacitaneFormaty:TLesniStringListElement;
  FadresarPomDatu:string;
  FkontrolovatSdileni:boolean;
  FTriditLHC:string;
  FAdresaMojeMapSQL:string;
  FMistoRozhodnutiDokumenty:boolean;
  function  GetProhledavaneDisky:TLesniStringListElement;
  function  GetNacitaneFormaty:TLesniStringListElement;
 public
  procedure AddElement(Element:TElement); override;
  procedure NactizAdresaruPomDat(INeviditelne:boolean);
  procedure nactiZPocitace;
  // procedure nactiZTabulky(TAble1:TTable);
  // procedure ulozDoTabulky(TAble1:TTable);
  procedure  UlozAdresarePomDat;
  function VyhovujiciPolozka(VLHC_KOD,VLHC_KOD_ID:Longint;
                             VAdresarObecnychDat,VLHP_OD:string):TpolozkaSeznamuCelku;
  function PodobnaPolozka(Pol1:TpolozkaSeznamuCelku;
                          var podobnost:TPodobnostPolozkyCelku):TpolozkaSeznamuCelku;
  function PrekryvajiciSeObdelniky(VObdelnik:TObdelniky;rozlisovatSouvisleZobrazeni:Boolean):TObdelnikyMN;
  constructor Create; override;

 published

  property ProhledavaneDisky:TLesniStringListElement read GetProhledavaneDisky stored false;
  property NacitaneFormaty:TLesniStringListElement read GetNacitaneFormaty stored false;
  property AdresarPomDatu:string read FadresarPomDatu write FadresarPomDatu stored false;
  property KontrolovatSdileni:boolean read FkontrolovatSdileni write FkontrolovatSdileni stored false;
  property MistoRozhodnutiDokumenty:boolean read FMistoRozhodnutiDokumenty write FMistoRozhodnutiDokumenty stored false;
  property TriditLHC:string read FTriditLHC write FTriditLHC stored false;
  property AdresaMojeMapSQL:string read FAdresaMojeMapSQL write FAdresaMojeMapSQL stored false;
 end;

function srovnanePolozkyCelku(MNZTabulky,MNZPocitace:TpolozkaSeznamuCelkuMN):TpolozkaSeznamuCelkuMN;
procedure obnovSeznamLHCZPomu(var PolozkaSeznamuCelkuMN:TPolozkaSeznamuCelkuMN);
procedure obnovSeznamLHCZPocitace(var PolozkaSeznamuCelkuMN:TPolozkaSeznamuCelkuMN);
function obdelniky_se_prekryvaji(Obdelnik1:TObdelniky;Obdelnik2:TObdelniky):boolean;

implementation
uses E_LesCel,Worlds;
function PodobnostPolozek(POL1,POL2:TpolozkaSeznamuCelku):TPodobnostPolozkyCelku;
 begin
  //predbezne vyhozeni
  if (Pol1.LHC_KOD_Sc<>Pol2.LHC_KOD_Sc) then
   begin
    if (Pol1.LHC_NAZ_Sc<>Pol2.LHC_NAZ_Sc) then
     begin
      if (Pol1.adresarObecnychDat_Sc<>Pol2.adresarObecnychDat_Sc) then
       begin
        result:=LisiSeUplne;
       end
      else
       begin
        if Pol1.TypDatLHP_St_SC='OraIDC' then
         begin
          result:=LisiSeUplne;
         end
        else
         begin
          if Pol1.TypDatLHP_St_SC=Pol2.TypDatLHP_St_SC then
           begin
            result:=ShodnyAdresarATypANeniOracle;
           end
          else
           begin
            result:=LisiSeUplne;
           end;
         end;
       end;
     end
    else //LHC_KOD<> ,LHC_NAZ=
     begin
      if     (Pol1.adresarObecnychDat_Sc=Pol2.adresarObecnychDat_Sc)
         and (Pol1.TypDatLHP_St_SC      =Pol2.TypDatLHP_St_SC)
         and (Pol1.TypDatLHP_St_SC<>'OraIDC')
      then
       begin
        result:=ShodnyAdresarATypANeniOracle;
       end
      else
       begin
        if (Pol1.TypDatLHP_St_SC      =Pol2.TypDatLHP_St_SC) then
         begin
          if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
             (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
           begin
            result:=ShodnyLHC_NAZATypaLHP_OD_DO;
           end
          else
           begin
            result:=ShodnyLHC_NAZATyp;
           end;
         end
        else
         begin
          result:=ShodnyLHC_NAZ;
         end;
       end;
     end;
   end
  else    // LHC_KOD =
   begin
    if (Pol1.LHC_NAZ_Sc<>Pol2.LHC_NAZ_Sc) then
     begin
      if     (Pol1.adresarObecnychDat_Sc=Pol2.adresarObecnychDat_Sc)
         and (Pol1.TypDatLHP_St_SC      =Pol2.TypDatLHP_St_SC)
         and (Pol1.TypDatLHP_St_SC<>'OraIDC')
      then
       begin
        result:=ShodnyAdresarATypANeniOracle;
       end
      else
       begin
        if (Pol1.TypDatLHP_St_SC      =Pol2.TypDatLHP_St_SC) then
         begin
          if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
             (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
           begin
            result:=ShodnyLHC_KODATypaLHP_OD_DO;
           end
          else
           begin
            result:=ShodnyLHC_KODATyp;
           end;
         end
        else
         begin
          result:=ShodnyLHC_KOD;
         end;
       end;
     end
    else  //LHC_KOD= ,LHC_NAZ=
     begin
      if Pol1.TypDatLHP_St_SC=Pol2.TypDatLHP_St_SC then
       begin
        if Pol1.adresarObecnychDat_Sc=Pol2.adresarObecnychDat_Sc then
         begin
          if (Pol1.LHC_KOD_ID_Sc=Pol2.LHC_KOD_ID_Sc) then
           begin
            if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
               (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
             begin
              Result:= Shodna;
             end
            else
             begin
              Result:= lisiSeLHP_OD_DO;
             end;
           end
          else
           begin
            if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
               (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
             begin
              Result:= LisiSeLHC_KOD_ID;
             end
            else
             begin
              if     (Pol1.adresarObecnychDat_Sc=Pol2.adresarObecnychDat_Sc)
                 and (Pol1.TypDatLHP_St_SC      =Pol2.TypDatLHP_St_SC)
                 and (Pol1.TypDatLHP_St_SC<>'OraIDC')
               then
                begin
                 Result:= ShodnyAdresarATypANeniOracle;
                end
               else
                begin
                 Result:= lisiSeLHP_OD_DO;
                end;
             end;
           end
         end
        else
         begin
          if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
             (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
           begin
            Result:=LisiSeAdresar;
           end
          else
           begin
            Result:=LisiSeAdresarLHP_OD_DO;
           end;
         end
       end
      else  //LHC_KOD= ,LHC_NAZ=,TypDatLHP<>
       begin
          if (Pol1.LHP_OD_Sc            =Pol2.LHP_OD_Sc)and
             (Pol1.LHP_DO_Sc            =Pol2.LHP_DO_Sc) then
           begin
            Result:=LisiSeTypShodnyLHC_KOD_LHC_NAZ_LHP_OD_DO;
           end
          else
           begin
            Result:=LisiSeTypShodnyLHC_KOD_LHC_NAZ;
           end;
       end;
     end;
   end;
 end;
function TpolozkaSeznamuCelkuMN.PodobnaPolozka(Pol1:TpolozkaSeznamuCelku;
                                     var podobnost:TPodobnostPolozkyCelku
         ):TpolozkaSeznamuCelku;
 var i:integer;
     podobnostV:TPodobnostPolozkyCelku;
 begin
  i:=0;
  podobnost:=LisiSeUplne;
  result:=nil;
  while (i<count)and(podobnost<>Shodna) do
   begin
    podobnostV:=PodobnostPolozek(TpolozkaSeznamuCelku(elements[i]),pol1);
    if podobnost>PodobnostV then
     begin
      podobnost:=PodobnostV;
      result:=TpolozkaSeznamuCelku(elements[i]);
     end;
    inc(i);
   end;
 end;

function srovnanePolozkyCelku(MNZTabulky,MNZPocitace:TpolozkaSeznamuCelkuMN):TpolozkaSeznamuCelkuMN;
var i:Integer;
    iPod,VPod : TPodobnostPolozkyCelku;
    PodPolozka:TpolozkaSeznamuCelku;
 begin
  result:=TpolozkaSeznamuCelkuMN.create;
  for iPod:=Shodna to LisiSeUplne do
   begin
    i:=0;
    while i< MNZPocitace.count do
     begin
      PodPolozka:=MNZTabulky.PodobnaPolozka(
                       TpolozkaSeznamuCelku(MNZPocitace.elements[i]),VPod);
      if VPod=IPod  then
       begin
        if VPod<>LisiSeUplne then
         begin
          TpolozkaSeznamuCelku(MNZPocitace.elements[i]).AdresarMapy_SC
              := PodPolozka.AdresarMapy_SC;
          TpolozkaSeznamuCelku(MNZPocitace.elements[i]).AdresarPomDat_SC
              := PodPolozka.AdresarPomDat_SC;
          PodPolozka.free;
         end;
        result.AddElement(MNZPocitace.elements[i]);
        MNZPocitace.RemoveElement(MNZPocitace.elements[i]);
       end
      else
       begin
        inc(i);
       end;
     end;
   end;
 end;

function TpolozkaSeznamuCelkuMN.VyhovujiciPolozka(VLHC_KOD,VLHC_KOD_ID:Longint;
                             VAdresarObecnychDat,VLHP_OD:string):TpolozkaSeznamuCelku;
var i:integer;
 begin
  result:=nil;
  for i:=0 to count-1 do
   begin
    with TpolozkaSeznamuCelku(elements[i]) do
     begin
      if
          (VLHC_KOD=LHC_KOD_sc)and
          (VLHC_KOD_ID=LHC_KOD_ID_sc)and
          (VAdresarObecnychDat=AdresarObecnychDat_sc)and
          (VLHP_OD=LHP_OD_sc)
         then
          begin
           result:=TpolozkaSeznamuCelku(self.elements[i]);
          end;
     end;
   end;
 end;
constructor TpolozkaSeznamuCelkuMN.Create;
 begin
  inherited create;
  FClass:=TpolozkaSeznamuCelku;
  FPredponaName:='POL_LHC';
 end;

{
procedure TpolozkaSeznamuCelku.ulozDoTabulkyPolozku(TAble1:TTable);
 begin
   if table1.findfield('KOD_LHP')<>nil  then
     Table1.fieldByName('KOD_LHP').asstring:=inttostr(LHC_KOD_Sc);
   if table1.findfield('NAZEV_LHP')<>nil  then
     Table1.fieldByName('NAZEV_LHP').asstring:=u0(LHC_NAZ_Sc);

   if table1.findfield('PLATNOST_LHP')<>nil  then
    begin
     Table1.fieldByName('PLATNOST_LHP').asstring:=LHP_OD_Sc+'-'+LHP_DO_Sc;
    end;

   if table1.findfield('UMISTENI_DAT')<>nil  then
     Table1.fieldByName('UMISTENI_DAT').asstring:=adresarObecnychDat_Sc;

   if table1.findfield('AdresarMapy')<>nil  then
     Table1.fieldByName('AdresarMapy').asstring:=AdresarMapy_SC;

   if table1.findfield('AdresarPomDat')<>nil  then
     Table1.fieldByName('AdresarPomDat').asstring:=AdresarPomDat_SC;

   if table1.findfield('TYP_LHP')<>nil  then
    begin
     Table1.fieldByName('TYP_LHP').asstring:=TypDatLHP_St_SC;
    end;
 end;
procedure TpolozkaSeznamuCelku.nactiZTabulkyPolozku(TAble1:TTable);
  var St:string;
   begin
   if table1.findfield('KOD_LHP')<>nil  then
     LHC_KOD_Sc:=strtoint0(Table1.fieldByName('KOD_LHP').asstring);

   if table1.findfield('NAZEV_LHP')<>nil  then
     LHC_NAZ_Sc:=Table1.fieldByName('NAZEV_LHP').asstring;

   if table1.findfield('PLATNOST_LHP')<>nil  then
    begin
     LHP_OD_Sc:=KPrvnimuZnaku(Table1.fieldByName('PLATNOST_LHP').asstring,'-');
    end;

   if table1.findfield('PLATNOST_LHP')<>nil  then
    begin
     LHP_DO_Sc:=OdPrvnihoZnaku(Table1.fieldByName('PLATNOST_LHP').asstring,'-');
    end;

   if table1.findfield('UMISTENI_DAT')<>nil  then
     adresarObecnychDat_Sc:=Table1.fieldByName('UMISTENI_DAT').asstring;

   if table1.findfield('AdresarMapy')<>nil  then
     AdresarMapy_SC:=Table1.fieldByName('AdresarMapy').asstring;

   if table1.findfield('AdresarPomDat')<>nil  then
     AdresarPomDat_SC:=Table1.fieldByName('AdresarPomDat').asstring;
   if table1.findfield('TYP_LHP')<>nil  then
    begin
     st:=Table1.fieldByName('TYP_LHP').asstring;
     if uppercase(st)='FST99' then TypDatLHP_St_SC:='IsHul99';
     if uppercase(st)='FST98' then TypDatLHP_St_SC:='IsHul98';
     if uppercase(st)='TAX97' then TypDatLHP_St_SC:='Tax97';
     if uppercase(st)='TAX98' then TypDatLHP_St_SC:='Tax98';
     if uppercase(st)='ISHUL99' then TypDatLHP_St_SC:='IsHul99';
     if uppercase(st)='ISHUL98' then TypDatLHP_St_SC:='IsHul98';
     if uppercase(st)='ORAIDC'  then TypDatLHP_St_SC:='OraIDC';
    end;
  end;

procedure TpolozkaSeznamuCelkuMN.nactiZTabulky(TAble1:TTable);
var i:integer;
    table1active:boolean;
 begin
  table1active:=table1.active;
  table1.active:=true;
  table1.first;
  i:=0;
  while not table1.eof do
   begin
    novyprvekVzdy:=inttostr(i);
    TpolozkaSeznamuCelku(AktualniPrvek).nactiZTabulkyPolozku(TAble1);
    table1.next;
   end;
  table1.active:=table1active;
 end;

procedure TpolozkaSeznamuCelkuMN.ulozDoTabulky(TAble1:TTable);
var i:integer;
 begin
  table1.Active:=false;
  table1.exclusive:=true;
  table1.emptytable;
  table1.exclusive:=false;
  table1.Active:=true;
  for i:=0 to count-1 do
   begin
    try
     table1.insert;
    except
    end;
    TpolozkaSeznamuCelku(elements[i]).ulozDoTabulkyPolozku(Table1);
    try
     table1.post;
    except
     with TpolozkaSeznamuCelku(elements[i]) do
      begin
       showmessage('dek "'+
                   inttostr(LHC_KOD_Sc)+' , ' +
        LHC_NAZ_Sc+' , ' +
        TypDatLHP_St_SC+' , ' +
        adresarObecnychDat_Sc+' , ' +
        LHP_OD_Sc+' , ' +
        LHP_DO_Sc+' , ' +
        inttostr(LHC_KOD_ID_Sc)+' , ' +
        '" nelze vloit do tabulky');
      end;
    end;
   end;
 end;        }
procedure TpolozkaSeznamuCelkuMN.nactiZPocitace;
var
  PolozkaSeznamuCelku : TPolozkaSeznamuCelku;
  LesniCelek:TLesniCelek;
  LC:TLocalComputerElement;
  i,ip:integer;
  S:TAllSelector;
  VGAuge:TF_gaugeForm;

 begin
   lesniCelek:=nil;
   LC := TLocalComputerElement.Create;
   for i:=0 to LC.count-1 do
    begin
     if ProhledavaneDisky.StringListElement.FindElementName(LC.elements[i].name[1])
       <> nil then
      begin
       application.CreateForm(TF_gaugeForm,VGauge);
       Vgauge.caption:='Natm LHP z disku '+LC.elements[i].name;
       VGauge.MaxValue:=1000;
       VGauge.left:=200;
       VGauge.top:=200;
       Vgauge.show;
       TLogicalDriveElement(LC.Elements[i]).active:=true;
       S := TAllSelector.Create;
       S.Condition :='(Name=''LHC.DB'') or (Name=''PP.FST'')';
       S.Input := LC.Elements[i];
       S.DoIt;
       VGauge.MaxValue:=TEntity(S.Output).count;
       for ip:=0 to TEntity(S.Output).count-1 do
        begin
         VGauge.Progress:=ip;
         if lesniCelek<>nil then
          begin
           lesniCelek.free;
           lesniCelek:=nil;
          end;
         LesniCelek:=TLesniCelek.create;
         LesniCelek.NajdiTypDatLHP(false,TFileElement(TEntity(S.Output).elements[ip]).FilePath,true,true,true);

         if NacitaneFormaty.StringListElement.FindElementName(LesniCelek.TypDatLHP_nazev)
             <> nil
           then
          begin
           LesniCelek.nactiRychlePolozkyLHC;
           self.novyPrvekVzdy:=inttostr(self.count);
           with TpolozkaSeznamuCelku(self.AktualniPrvek) do
            begin
             LHC_KOD_Sc           :=lesniCelek.lhc.LHC_KOD;
             LHC_KOD_ID_Sc        :=lesniCelek.lhc.LHC_KOD_ID;
             LHC_NAZ_Sc           :=trim(lesniCelek.lhc.LHC_NAZ);
             LHP_OD_Sc            :=trim(lesniCelek.lhc.LHP_OD);
             LHP_DO_Sc            :=trim(lesniCelek.lhc.LHP_DO);
             AdresarObecnychDat_Sc:=trim(lesniCelek.AdresarObecnychDatLHP);
             AdresarMapy_SC       :=trim(lesniCelek.AdresarMapy);
             TypDatLHP_St_SC      :=lesniCelek.TypDatLHP_nazev;
             viditelny:=true;
            end;
          end;
        end;
       S.Free;
       Vgauge.close;
       Vgauge.free;
      end;
    end;
 end;

procedure TPolozkaSeznamuCelkuMN.NactizAdresaruPomDat(INeviditelne:boolean);
var
  VSearch:  TSearchRec;
  VyslFindNext:integer;
 begin
  SmazVsechnyPrvkyVMnozine;

  if ubm(AdresarPomDatu)<>'' then
   begin
    VyslFindNext:=FindFirst(AdresarPomDatu+'\*.pom',faDirectory,VSearch);
   end
  else
   begin
    VyslFindNext:=FindFirst(KPoslednimuZnaku(Application.ExeName,'\')+'\*.pom',faDirectory,VSearch);
           // KPoslednimuZnaku(Application.ExeName,'\')+'\*.pom',
   end;
  while ( VyslFindNext = 0) do
   begin
    self.novyPrvekVzdy:=inttostr(self.count);
    with TpolozkaSeznamuCelku(self.AktualniPrvek) do
     begin
      if ubm(AdresarPomDatu)<>'' then
       begin
        AdresarPomDat_SC:=(AdresarPomDatu+'\'+VSearch.Name);
       end
      else
       begin
        AdresarPomDat_SC:=(KPoslednimuZnaku(Application.ExeName,'\')+'\'+VSearch.Name);
       end;
      NactizAdresarePomDat;
     end;
    if (not TpolozkaSeznamuCelku(self.AktualniPrvek).viditelny) then
     begin
      if iNeviditelne then
       begin
        TpolozkaSeznamuCelku(self.AktualniPrvek).viditelny:=true;
       end
      else
       begin
        self.AktualniPrvek.Free;
       end;
     end;
    VyslFindNext:=FindNext(VSearch);
   end;
  FindClose(VSearch);
 end;

procedure TPolozkaSeznamuCelku.NactizAdresarePomDat;
var
 initext:Tinifile;
 St,S1:String;
 VLoad:TLoad;
 i:integer;
 PAdresarRastru,PBarva,PVrstvaRastru,pNasobneRastry:String;
 VAdresarRastru:TAdresarRastru;
 IAdrRas:integer;
 begin
  initext:=Tinifile.create(AdresarPomDat_SC+'\identifi.ini');
  AdresarSpolecnychPomDat_SC:=initext.ReadString(
               'LHC_pomocnych_Souboru','AdresarSpolecnychPomDat',AdresarPomDat_SC);
  LHC_KOD_Sc:=strtoint0(initext.ReadString('LHC_pomocnych_Souboru','LHC_KOD','0'));
  LHC_NAZ_Sc:=initext.ReadString('LHC_pomocnych_Souboru','LHC_NAZ','');
  LHP_OD_Sc:=initext.ReadString('LHC_pomocnych_Souboru','LHP_OD','');
  LHP_DO_Sc:=initext.ReadString('LHC_pomocnych_Souboru','LHP_DO','');
  AdresarObecnychDat_Sc:=initext.ReadString('LHC_pomocnych_Souboru','AdresarObecnychDat','');
  AdresarMapy_SC:=initext.ReadString('LHC_pomocnych_Souboru','AdresarMapy','');
  pNasobneRastry:=initext.ReadString('LHC_pomocnych_Souboru','NasobneRastry','NE');
  if Uppercase(pnasobneRastry)='ANO' then
   begin
    NasobneRastry_SC:=true;
   end
  else
   begin
    NasobneRastry_SC:=false;
   end;

    PAdresarRastru:=initext.ReadString('LHC_pomocnych_Souboru','AdresarRastru','');
    AdresarRastru_SC:=PAdresarRastru;
    IAdrRas:=0;
    PAdresarRastru:=initext.ReadString('LHC_pomocnych_Souboru','AdresarRastru'+inttostr(IAdrRas),'');
    AdresarRastruMN:=TAdresarRastruMN.create;
    AddElement(AdresarRastruMN);
    while PAdresarRastru<>'' do
     begin
      VAdresarRastru:=TAdresarRastru.create;
      VAdresarRastru.AdresarRastru:=PAdresarRastru;
      VAdresarRastru.BarvaRastru:=initext.ReadString('LHC_pomocnych_Souboru','BarvaRastru'+inttostr(IAdrRas),'');
      VAdresarRastru.vrstvaRastru:=initext.ReadString('LHC_pomocnych_Souboru','VrstvaRastru'+inttostr(IAdrRas),'');
      AdresarRastruMN.AddElement(VAdresarRastru);
      inc(IAdrRas);
      PAdresarRastru:=initext.ReadString('LHC_pomocnych_Souboru','AdresarRastru'+inttostr(IAdrRas),'');
     end;

  AdresarVrstevnic_SC:=initext.ReadString('LHC_pomocnych_Souboru','AdresarVrstevnic','');
  TypDatLHP_St_Sc:=initext.ReadString('LHC_pomocnych_Souboru','TypDatLHP_St','');
  TypMapyLHP_St_Sc:=initext.ReadString('LHC_pomocnych_Souboru','TypMapyLHP_St','');
  if  (TypMapyLHP_St_Sc='')and(AdresarMapy_SC<>'') then
   begin
    TypMapyLHP_St_Sc:='Topol';
   end;
  LHC_KOD_ID_Sc:=strtoint0(initext.ReadString('LHC_pomocnych_Souboru','LHC_KOD_ID','0'));

  St:=initext.ReadString('LHC_pomocnych_Souboru','ZobrazovatRastry','ANO');
  if St='ANO' then ZobrazovatRastry_SC:=true else ZobrazovatRastry_SC:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','ZobrazovatRastryNahore','ANO');
  if St='ANO' then ZobrazovatRastryNahore_SC:=true else ZobrazovatRastryNahore_SC:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','ZobrazovatVrstevnice','ANO');
  if St='ANO' then ZobrazovatVrstevnice_SC:=true else ZobrazovatVrstevnice_SC:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','NacitatMapuCelLHC','NE');
  if St='ANO' then NacitatMapuCelLHC_SC:=true else NacitatMapuCelLHC_SC:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','NacitatVrstevnice','ANO');
  if St='ANO' then NacitatVrstevnice_SC:=true else NacitatVrstevnice_SC:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','SouvisleZobrazeni','NE');
  if St='ANO' then SouvisleZobrazeni_SC:=true else SouvisleZobrazeni_SC:=false;

  VirtualScale_SC:=strtoint0(initext.ReadString('LHC_pomocnych_Souboru','VirtualScale','5000'));
  LHC_KOD_P0110_SC:=strtoint0(initext.ReadString('LHC_pomocnych_Souboru','LHC_KOD_P0110','0'));

  S1:=initext.ReadString('LHC_pomocnych_Souboru','Zavazna_vychova_do_40','tisknout');
  VychDo40Str_SC:=S1;
  S1:=initext.ReadString('LHC_pomocnych_Souboru','Ramcove_Smernice','tisknout');
  RamcSmerStr_SC:=S1;
  S1:=initext.ReadString('LHC_pomocnych_Souboru','AdresaNeniSoucastiJmena','podle dat');
  AdresaNeniSoucastiJmenaStr_SC:=S1;

  S1:=initext.ReadString('LHC_pomocnych_Souboru','Barva_tisku_v_sep_HK','bl');
  ColorStr_SC:=S1;
  // pozor je taky v PHS.INI

  St:=initext.ReadString('LHC_pomocnych_Souboru','Viditelny','ANO');
  if St='ANO' then Viditelny:=true else Viditelny:=false;

  St:=initext.ReadString('LHC_pomocnych_Souboru','Pracovat_s_majetky_osnovy','ANO');
  if St='ANO' then osnovy_SC:=true else Osnovy_SC:=false;

  odkornene_SC1:=initext.ReadString('LHC_pomocnych_Souboru','Zobrazovat_Odkornene','VYBRAT');

  St:=initext.ReadString('LHC_pomocnych_Souboru','Vest_Lesni_hospodarskou_Evidenci','NE');
  if St='ANO' then LHEvidence_SC:=true else LHEvidence_SC:=false;

  initext.free;
  if fileExists(AdresarSpolecnychPomDat_SC+'\Obdelni.Orb') then
     begin
      VLoad:=TLoad.CreateAll(AdresarSpolecnychPomDat_SC+'\Obdelni.Orb');
      VLoad.doit;
      ObdelnikyMN:=TObdelnikyMN(VLoad.OutPut);
      addelement(ObdelnikyMN);
      VLoad.Free;
     end
   else
     begin
      ObdelnikyMN:=nil;
     end;

 end;

procedure TpolozkaSeznamuCelku.UlozDoPomDat;
 var
  initext:Tinifile;
  VSave:TSave;
  i,iAdrRast:integer;
  iss:string;
 begin
  try
     iss:=AdresarPomDat_SC+'\identifi.ini';
  initext:=Tinifile.create(AdresarPomDat_SC+'\identifi.ini');
  if AdresarSpolecnychPomDat_SC='' then
     AdresarSpolecnychPomDat_SC := AdresarPomDat_SC;
     iss:=iss+'  12b';
  initext.WriteString('LHC_pomocnych_Souboru','AdresarSpolecnychPomDat',AdresarSpolecnychPomDat_SC);
     iss:=iss+'  12ac';
  initext.WriteString('LHC_pomocnych_Souboru','LHC_KOD',inttostr(LHC_KOD_Sc));
     iss:=iss+'  12ad';
  initext.WriteString('LHC_pomocnych_Souboru','LHC_NAZ',LHC_NAZ_Sc);
     iss:=iss+'  12ae';
  initext.WriteString('LHC_pomocnych_Souboru','LHP_OD',LHP_OD_Sc);
     iss:=iss+'  12af';
  initext.WriteString('LHC_pomocnych_Souboru','LHP_DO',LHP_DO_Sc);
     iss:=iss+'  12ag';
  initext.WriteString('LHC_pomocnych_Souboru','AdresarObecnychDat',AdresarObecnychDat_Sc);
     iss:=iss+'  12ah';
  initext.WriteString('LHC_pomocnych_Souboru','AdresarMapy',AdresarMapy_SC);
     iss:=iss+'  12ai';
  initext.WriteString('LHC_pomocnych_Souboru','AdresarRastru',AdresarRastru_SC);
     iss:=iss+'  12a1';

  if not NasobneRastry_SC then
   begin
    initext.WriteString('LHC_pomocnych_Souboru','NasobneRastry','NE');
   end
  else
   begin
    initext.WriteString('LHC_pomocnych_Souboru','NasobneRastry','ANO');
    for iAdrRast:=0 to  AdresarRastruMN.count-1 do
     begin
      with TAdresarRastru(AdresarRastruMN.elements[iAdrRast]) do
       begin
        initext.WriteString('LHC_pomocnych_Souboru','AdresarRastru'+inttostr(IAdrRast),AdresarRastru);
        initext.WriteString('LHC_pomocnych_Souboru','BarvaRastru'+inttostr(IAdrRast),BarvaRastru);
        initext.WriteString('LHC_pomocnych_Souboru','VrstvaRastru'+inttostr(IAdrRast),VrstvaRastru);
       end;
     end;
    initext.WriteString('LHC_pomocnych_Souboru','AdresarRastru'+inttostr(AdresarRastruMN.count),'');
   end;

  initext.WriteString('LHC_pomocnych_Souboru','AdresarVrstevnic',AdresarVrstevnic_SC);
     iss:=iss+'  12a2';
  initext.WriteString('LHC_pomocnych_Souboru','TypDatLHP_St',TypDatLHP_St_Sc);
     iss:=iss+'  12a3';
  initext.WriteString('LHC_pomocnych_Souboru','TypMapyLHP_St',TypMapyLHP_St_Sc);
     iss:=iss+'  12a4';
  initext.WriteString('LHC_pomocnych_Souboru','LHC_KOD_ID',inttostr(LHC_KOD_ID_Sc));
     iss:=iss+'  12a5';

  if ZobrazovatRastry_SC then initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatRastry','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatRastry','NE');
     iss:=iss+'  12a6';

  if ZobrazovatRastryNahore_SC then initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatRastryNahore','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatRastryNahore','NE');

  if ZobrazovatVrstevnice_SC then initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatVrstevnice','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','ZobrazovatVrstevnice','NE');

  if NacitatMapuCelLHC_SC then initext.WriteString('LHC_pomocnych_Souboru','NacitatMapuCelLHC','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','NacitatMapuCelLHC','NE');

  if NacitatVrstevnice_SC then initext.WriteString('LHC_pomocnych_Souboru','NacitatVrstevnice','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','NacitatVrstevnice','NE');

  if SouvisleZobrazeni_SC then initext.WriteString('LHC_pomocnych_Souboru','SouvisleZobrazeni','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','SouvisleZobrazeni','NE');
     iss:=iss+'  12a7';

  initext.WriteString('LHC_pomocnych_Souboru','VirtualScale',inttostr(VirtualScale_SC));
  initext.WriteString('LHC_pomocnych_Souboru','LHC_KOD_P0110',inttostr(LHC_KOD_P0110_SC));

  initext.WriteString('LHC_pomocnych_Souboru','Zavazna_vychova_do_40',VychDo40Str_SC);
  initext.WriteString('LHC_pomocnych_Souboru','Ramcove_Smernice',RamcSmerStr_SC);
  initext.WriteString('LHC_pomocnych_Souboru','AdresaNeniSoucastiJmena',AdresaNeniSoucastiJmenaStr_SC);
  initext.WriteString('LHC_pomocnych_Souboru','Barva_tisku_v_sep_HK',ColorStr_SC);
     iss:=iss+'  12a8';

  if Osnovy_SC then initext.WriteString('LHC_pomocnych_Souboru','Pracovat_s_majetky_osnovy','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','Pracovat_s_majetky_osnovy','NE');

  if LHEvidence_SC then initext.WriteString('LHC_pomocnych_Souboru','Vest_Lesni_hospodarskou_Evidenci','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','Vest_Lesni_hospodarskou_Evidenci','NE');

  initext.WriteString('LHC_pomocnych_Souboru','Zobrazovat_Odkornene',odkornene_SC1);

  if Viditelny then initext.WriteString('LHC_pomocnych_Souboru','Viditelny','ANO')
     else initext.WriteString('LHC_pomocnych_Souboru','Viditelny','NE');
     iss:=iss+'  12a9';

  initext.free;
     iss:=iss+'  12a10';
  ForceDirectories(AdresarSpolecnychPomDat_SC);
     iss:=iss+'  12a11';
  if ObdelnikyMN<>nil then
   begin
    VSave:=TSave.CreateAll(AdresarSpolecnychPomDat_SC+'\Obdelni.Orb');
    VSave.Input:=ObdelnikyMN;
    VSave.doit;
    VSave.free;
   end;
     iss:=iss+'  12a12';
   except
    showmessage('chyba v UlozDoPomDat '+iss);
   end;
 end;

procedure TpolozkaSeznamuCelku.ZalozAdresarPomDat;
 var iPOM:integer;
  pomocDir:string;
 begin
  iPom:=1;
  pomocDir:=TpolozkaSeznamuCelkuMN(OwnerTypu(TpolozkaSeznamuCelkuMN)).adresarPomDatu+'\'+inttostr(LHC_KOD_Sc);
  // KPoslednimuZnaku(Application.ExeName,'\')+'\'+inttostr(LHC_KOD_Sc);
  while directoryExists(pomocDir+'_'+inttostr(iPOM)+'.pom') do
   begin
    inc(iPOM);
   end;
  pomocDir:=pomocDir+'_'+inttostr(iPOM)+'.pom';
  ForceDirectories(pomocDir);
  AdresarPomDat_SC := pomocDir;
 end;

procedure TpolozkaSeznamuCelku.UlozDoPomDatVcetneAdresare;
var iss:string;
 begin
  try
  iss:='"'+AdresarPomDat_SC+'"';
  if  trim(AdresarPomDat_SC)=''  then
   begin
    iss:=iss+' 11a';
    ZalozAdresarPomDat;
    iss:=iss+'  11b';
    UlozDoPomDat;
    iss:=iss+'  11c';
   end
  else
   begin
    UlozDoPomDat;
   end;
  except
    showmessage('UlozDoPomDatVcetneAdresare '+iss);
  end;
 end;
procedure TpolozkaSeznamuCelkuMN.UlozAdresarePomDat;
var i:integer;
 begin
  for i:=0 to count-1 do
   begin
    with TpolozkaSeznamuCelku(elements[i]) do
     begin
      UlozDoPomDatVcetneAdresare;
     end;
   end;
 end;

procedure obnovSeznamLHCZPomu(var PolozkaSeznamuCelkuMN:TPolozkaSeznamuCelkuMN);

var
 i:integer;
 VadresarPomDatu:widestring;
 begin
  VadresarPomDatu:=polozkaSeznamuCelkuMN.adresarPomDatu;
  if PolozkaSeznamuCelkuMN <> nil then
     PolozkaSeznamuCelkuMN.Free;
  PolozkaSeznamuCelkuMN:=TpolozkaSeznamuCelkuMN.create;
  World.ObjectModel.NextElement := PolozkaSeznamuCelkuMN;
  polozkaSeznamuCelkuMN.adresarPomDatu:=VadresarPomDatu;
  PolozkaSeznamuCelkuMN.NactizAdresaruPomDat(true);
  PolozkaSeznamuCelkuMN.setridPodlePropertyLongInt('LHC_KOD_Sc',true);
 end;

procedure obnovSeznamLHCZPocitace(var PolozkaSeznamuCelkuMN:TPolozkaSeznamuCelkuMN);

var
 PolozkaSeznamuCelkuMNZPocitace,PolozkaSeznamuCelkuMNzPom,
 PolozkaSeznamuCelkuMNVysledek,PolozkaSeznamuCelkuMN1:TpolozkaSeznamuCelkuMN;
 i:integer;
 begin
  PolozkaSeznamuCelkuMNZPocitace:=TpolozkaSeznamuCelkuMN.create;
  PolozkaSeznamuCelkuMNzPom:=TpolozkaSeznamuCelkuMN.create;
  PolozkaSeznamuCelkuMNzPom.NactizAdresaruPomDat(true);

  PolozkaSeznamuCelkuMNZPocitace.nactiZPocitace;
  PolozkaSeznamuCelkuMNVysledek:=srovnanePolozkyCelku(PolozkaSeznamuCelkuMNzPom,PolozkaSeznamuCelkuMNZPocitace);
  PolozkaSeznamuCelkuMN1:=srovnanePolozkyCelku(PolozkaSeznamuCelkuMN,PolozkaSeznamuCelkuMNVysledek);
  PolozkaSeznamuCelkuMN.free;
  PolozkaSeznamuCelkuMNZPocitace.free;
  PolozkaSeznamuCelkuMNzPom.free;
  PolozkaSeznamuCelkuMNVysledek.free;
  PolozkaSeznamuCelkuMN:=PolozkaSeznamuCelkuMN1;
  PolozkaSeznamuCelkuMN.setridPodlePropertyLongInt('LHC_KOD_Sc',true);
  PolozkaSeznamuCelkuMN.UlozAdresarePomDat;
 end;

function TpolozkaSeznamuCelkuMN.GetNacitaneFormaty:TLesniStringListElement;
 begin
  if FNacitaneFormaty=nil then
   begin
     NactiSeznamIniFile( FNacitaneFormaty,
                         KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini',
                         'NacitaneFormaty');
   end;
  result:=FNacitaneFormaty;
 end;


function TpolozkaSeznamuCelkuMN.GetProhledavaneDisky:TLesniStringListElement;
 begin
  if FProhledavaneDisky=nil then
   begin
     NactiSeznamIniFile( FProhledavaneDisky,
                         KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini',
                         'ProhledavaneDisky');
   end;
  result:=FProhledavaneDisky;
 end;

function TpolozkaSeznamuCelku.GetAdresaNeniSoucastiJmenaStr  :string;
 begin
  result:=StringZeAnoNeRozhodniSeSam (FAdresaNeniSoucastiJmena);
 end;

function TpolozkaSeznamuCelku.GetVychDo40Str  :string;
 begin
  result:=StringZeAnoNeRozhodniSeSam (FVychDo40);
 end;

function TpolozkaSeznamuCelku.GetRamcSmerStr  :string;
 begin
  result:=StringZeAnoNeRozhodniSeSam (FRamcSmer);
 end;
function  TpolozkaSeznamuCelku.GetColorStr_SC  :string;
 begin
  result:='neznam';
  case FColor of
   clYellow:
     begin
      result:='lut';
     end;
   clgreen:
     begin
      result:='zelen';
     end;
   clWhite:
     begin
      result:='bl';
     end;
   clSilver:
     begin
      result:='ed';
     end;
  end;
 end;

procedure TpolozkaSeznamuCelku.SetColorStr_SC  (s:string);
 begin
  FColor:=clWhite;
  if s='lut'  then FColor:=clYellow;
  if s='zelen' then FColor:=clgreen;
  if s='bl'   then FColor:=clWhite;
  if s='ed'   then FColor:=clSilver;
 end;

procedure TpolozkaSeznamuCelku.SetAdresaNeniSoucastiJmenaStr  (s:string);
 begin
  AdresaNeniSoucastiJmena_SC:=AnoNeRozhodniSeSamZeStringu(s);
 end;
procedure TpolozkaSeznamuCelku.SetVychDo40Str  (s:string);
 begin
  VychDo40_SC:=AnoNeRozhodniSeSamZeStringu(s);
 end;
procedure TpolozkaSeznamuCelku.SetRamcSmerStr  (s:string);
 begin
  RamcSmern_SC:=AnoNeRozhodniSeSamZeStringu(s);
 end;
 function  TpolozkaSeznamuCelku.GetObdelnikyMN:TObdelnikyMN;
   begin
    if FObdelnikyMN<>nil then
     begin
      result:=FObdelnikyMN;
     end
    else
     begin
      result:=TObdelnikyMN(FindElementName('TObdelnikyMN'));
     end;
   end;

 function  TpolozkaSeznamuCelku.GetAdresarRastruMN:TAdresarRastruMN;
   begin
    if FAdresarRastruMN<>nil then
     begin
      result:=FAdresarRastruMN;
     end
    else
     begin
      result:=TAdresarRastruMN(FindElementName('TAdresarRastruMN'));
      if result=nil then
       begin
        FAdresarRastruMN:=TAdresarRastruMN.create;
        AddElement(FAdresarRastruMN);
        result:=FAdresarRastruMN;
       end;
     end;
   end;

constructor TAdresarRastruMN.Create;
 begin
  inherited create;
  FClass:=TAdresarRastru;
  FPredponaName:='AdrRastr';
 end;

constructor TAdresarRastru.Create;
 begin
  inherited create;
 end;


constructor TObdelnikyMN.Create;
 begin
  inherited create;
  FClass:=TObdelniky;
  FPredponaName:='OBDEL';
 end;

constructor TObdelniky.Create;
 begin
  inherited create;
 end;
 function  TObdelniky.GetRecEnti:TRectEntity;
  begin
   if FRecEnti=nil then
    begin
     FRecEnti:=TRectEntity(self.FindElementClass(TRectEntity));
    end;
   if FRecEnti=nil then
    begin
     FRecEnti:=TRectEntity.create;
     addelement(FRecEnti);
    end;
   result:=FRecEnti;
  end;

function obdelniky_se_prekryvaji(Obdelnik1:TObdelniky;Obdelnik2:TObdelniky):boolean;
 var
 Minx1,miny1,maxx1,maxy1:double;
 begin
  if obdelnik1=nil then
   begin
    result:=false;
    exit;
   end;
  if obdelnik2=nil then
   begin
    result:=false;
    exit;
   end;
  with Obdelnik1.RecEnti do
   begin
    Minx1:=Minx;
    miny1:=miny;
    maxx1:=maxx;
    maxy1:=maxy;
   end;
  if (Minx1>1E29)and(Miny1>1E29)and(Maxx1<-1E29)and(Maxy1<-1E29)then
   begin
    result:=false;
    exit;
   end;
  with Obdelnik2.RecEnti do
   begin
    if (Minx>1E29)and(Miny>1E29)and(Maxx<-1E29)and(Maxy<-1E29)then
     begin
      result:=false;
      exit;
     end;
   end;
  result:=Obdelnik2.RecEnti.IsOverRegion(Minx1,miny1,maxx1,maxy1);
 end;

function TpolozkaSeznamuCelkuMN.PrekryvajiciSeObdelniky(VObdelnik:TObdelniky;rozlisovatSouvisleZobrazeni:Boolean):TObdelnikyMN;
var i,ip:integer;
    IObdelnik:TObdelniky;
 begin
  result:=TObdelnikyMN.create;
  for i:=0 to count-1 do
   begin
    if (not rozlisovatSouvisleZobrazeni)or TpolozkaSeznamuCelku(elements[i]).SouvisleZobrazeni_SC then
     begin
       // showmessage('CAU ma souvis '+TpolozkaSeznamuCelku(elements[i]).name+' '+inttostr(TpolozkaSeznamuCelku(elements[i]).LHC_KOD_Sc)
       //               +' '+TpolozkaSeznamuCelku(elements[i]).LHC_NAZ_Sc);
      if TpolozkaSeznamuCelku(elements[i]).ObdelnikyMN<>nil then
       begin
        // showmessage('CAU m '+inttostr(TpolozkaSeznamuCelku(elements[i]).ObdelnikyMN.count)+' obdelnik');
        for ip:=0 to TpolozkaSeznamuCelku(elements[i]).ObdelnikyMN.count-1 do
         begin
          IObdelnik:=TObdelniky(TpolozkaSeznamuCelku(elements[i]).ObdelnikyMN.elements[ip]);
          if obdelniky_se_prekryvaji(VObdelnik,IObdelnik) then
           begin
            result.addelement(IObdelnik);
            //  showmessage('CAU obdlnik se pekrv '+IObdelnik.AdresarMapy1);
           end
          else
           begin
            //  showmessage('CAU obdlnik se NEpekrv '+IObdelnik.AdresarMapy1);
           end;
         end;
       end
      else
       begin
        //  showmessage('CAU nem obdelnik');
       end;
     end;
   end;
 end;

function TObdelnikyMN.AdresarJeVObdelnikach(VAdresar:string):Boolean;
var i:integer;
 begin
  VAdresar:=uppercase(VAdresar);
  result:=false;
  for i:=0 to count-1 do
   begin
    if pos(uppercase(TObdelniky(Elements[i]).AdresarMapy1),VAdresar)>0 then
     begin
      result:=true;
     end;
   end;
 end;
function TpolozkaSeznamuCelku.GetLHC_KOD_nebo_P0110_KOD;
 begin
  if LHC_KOD_P0110_SC=0 then
   begin
    result:=LHC_KOD_Sc;
   end
  else
   begin
    result:=LHC_KOD_P0110_SC;
   end;
 end;
procedure TpolozkaSeznamuCelkuMN.AddElement(Element:TElement);
 begin
  inherited AddElement(Element);
  //  Showmessage('Do TpolozkaSeznamuCelkuMN pipojuju prvek "'+Element.Name+'".');
 end;
function  TObdelniky.OwnerpolozkaSeznamuCelku:TpolozkaSeznamuCelku;
begin
 result:=TpolozkaSeznamuCelku(OwnerTypu(TpolozkaSeznamuCelku));
end;

function TAdresarRastru.GetBarvaRasru:string;
 begin
  if  Length(FBarvaRastru)>0 then
   begin
    if FBarvaRastru[1]<>'$' then FBarvaRastru:='$'+FBarvaRastru;
   end;
  result:=FBarvaRastru;
 end;


initialization
 registerOrbisClass(TObdelniky);
 registerOrbisClass(TObdelnikyMN);
 registerOrbisClass(TpolozkaSeznamuCelkuMN);
 registerOrbisClass(TpolozkaSeznamuCelku);
 registerOrbisClass(TAdresarRastru);
 registerOrbisClass(TAdresarRastruMN);
end.
