unit I_lhcExp;

interface
TExportStandardCis_FST = class(TInterpret)
private
 FRadekCisS: String;
 FExpLHC_KOD:String;
 FExportovanePolozky:TStringListElement;
 function GetExportovanePolozky:TStringListElement;
protected
  function  QGoInside(Element: TElement): boolean; override;
public
  procedure Process(Element: TElement); override;
  property  ExportovanePolozky:TStringListElement
             read GetExportovanePolozky write FExportovanePolozky;
  property  RadekCisS : String read FRadekCisS  write FRadekCisS ;
  property  ExpLHC_KOD: String read FExpLHC_KOD write FExpLHC_KOD ;
end;

TExportStandardPP_FST = class(TInterpret)
private
   FOddeleniS: String;
   FDilecS: String;
   FPorostS: String;
   FPorost_PoznS :String;
   FPorostniSkupinaS:String;
   FPorostniSkupina_PoznS:String;
   FEtazS:String;
   FDrevinaS:String;
protected
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
public
   procedure Process(Element: TElement); override;
   property  OddeleniS: String read FOddeleniS write FOddeleniS;
   property  DilecS: String read FDilecS write FDilecS;
   property  PorostS: String read FPorostS write FPorostS;
   property  Porost_PoznS: String read FPorost_PoznS write FPorost_PoznS;
   property  PorostniSkupinaS: String read FPorostniSkupinaS
                                     write FPorostniSkupinaS;
   property  PorostniSkupina_PoznS: String read FPorostniSkupina_PoznS
                                     write FPorostniSkupina_PoznS;
   property  EtazS: String read FEtazS write FEtazS;
   property  DrevinaS: String read FDrevinaS write FDrevinaS;
end;

TExportStandardPSK_FST = class(TExportStandardPP_FST)
   private
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
   end;

TExportStandardBZL_FST = class(TExportStandardPP_FST)
   private
     FBezlesiS:string;
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property BezlesiS:string read FBezlesiS write FBezlesiS;
   end;

TExportStandardJP_FST = class(TExportStandardPP_FST)
   private
     FJineS:string;
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property JineS:string read FJineS write FJineS;
   end;

implementation
function  TExportStandardPP_FST.QGoInside(Element: TElement): boolean;
begin
   result := true;
end;

function  TExportStandardPP_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((element is TBezlesi)
               or(element is TJinyPozemek)
               or(element is TOstatni)
               or(element is TKategorieMN)
               or(element is TPoskozeniMN)
               or(element is TZalesneniMN));
 end;

 function  TExportStandardPSK_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((element is TBezlesi)
               or(element is TJinyPozemek)
               or(element is TOstatni)
               or(element is TKategorieMN)
               or(element is TEtaz)
               );
 end;

function  TExportStandardBZL_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((Element is TPorostniSkupina)
                or(element is TJinyPozemek)
                or(element is TOstatni)
                or(element is TKategorieMN)
                  );
 end;

function  TExportStandardJP_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((Element is TPorostniSkupina)
                or(element is TOstatni)
                or(element is TKategorieMN));
 end;

 procedure TExportStandardPP_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
      begin
       Device.WritelnText('@');
       Device.WritelnText('&');
       Device.WritelnText(inttoStr(
            PocetSpolecnychElement(SeznamExportStandard.StringListElement,
                                    SeznamStandardPP_FST.StringListElement)));
       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardPP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;

{       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
            begin
             Device.WritelnText(elements[i].name);
            end;
          end;
        end; }

       Device.WritelnText(inttostr(PocetDrevinAHolin));
      end;
    end
   else
    begin
     if Element is TOddeleni then
      begin
       oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
      end
     else
      begin
       if Element is TDilec then
        begin
         DilecS:=StandardStringDilec(TDilec(element));
        end
       else
        begin
         if Element is TPorost then
          begin
           porostS:=StandardStringPorost(TPorost(element));
           porost_poznS :=StandardStringPorostText(TPorost(element));
          end;
         if Element is TPorostniSkupina then
          begin
           porostniSkupinaS:=StandardStringPorostniSkupina(TPorostniSkupina(Element));
           PorostniSkupina_poznS:=StandardStringPorostniSkupinaText(TPorostniSkupina(Element));
          end;
         if Element is TEtaz then
          begin
           EtazS:=StandardStringEtaz(TEtaz(element));
           if TEtaz(element).DrevinaMN.pocetPrvku=0 then
            begin
             DrevinaS:=StandardStringDrevina
                   (TDrevina(TEtaz(Element).DrevinaMN.AktualniPrvekVzdy));
             TEtaz(Element).DrevinaMN.SmazEntityTridy(TDrevina);
             Device.WriteText(OddeleniS);
             Device.WriteText(DilecS);
             Device.WriteText(PorostS);
             Device.WriteText(Porost_PoznS);
             Device.WriteText(porostniSkupinaS);
             Device.WriteText(porostniSkupina_PoznS);
             Device.WriteText(EtazS);
             Device.WritelnText(copy(DrevinaS,1,length(DrevinaS)-1));
            end;
          end;
         if Element is TDrevina then
          begin
           DrevinaS:=StandardStringDrevina(TDrevina(Element));
           Device.WriteText(OddeleniS);
           Device.WriteText(DilecS);
           Device.WriteText(PorostS);
           Device.WriteText(Porost_PoznS);
           Device.WriteText(porostniSkupinaS);
           Device.WriteText(porostniSkupina_PoznS);
           Device.WriteText(EtazS);
           Device.WritelnText(copy(DrevinaS,1,length(DrevinaS)-1));
          end;
        end; {else element is tDilec}
      end; {else element is tOddeleni}
    end; {else element is tlesnicelek}
  end;

procedure TExportStandardPSK_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamExportStandard.StringListElement,
                                    SeznamStandardPP_FST.StringListElement)));
       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardPP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;


{         with SeznamStandardPP_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end; }
        Device.WritelnText(inttostr(PocetSkupin));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end;
   if Element is TPorostniSkupina then
    begin
     porostniSkupinaS:=StandardStringPorostniSkupina(TPorostniSkupina(Element));
     PorostniSkupina_poznS:=StandardStringPorostniSkupinaText(TPorostniSkupina(Element));
    end;
   if Element is TEtaz then
    begin
     EtazS:=StandardStringEtaz(TEtaz(element));
    end;
   if Element is TDrevina then
    begin
     DrevinaS:=StandardStringDrevina(TDrevina(Element));
     Device.WriteText(OddeleniS);
     Device.WriteText(DilecS);
     Device.WriteText(PorostS);
     Device.WriteText(Porost_PoznS);
     Device.WriteText(porostniSkupinaS);
     Device.WriteText(porostniSkupina_PoznS);
 {    Device.WriteText(EtazS);
      Device.WritelnText(DrevinaS); }
   end;
end;

 procedure TExportStandardBZL_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamExportStandard.StringListElement,
                                    SeznamStandardBZL_FST.StringListElement)));

       with SeznamStandardBZL_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardBZL_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;

{      with SeznamStandardBZL_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end; }
         Device.WritelnText(inttostr(PocetBezlesi));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TBezlesi then
    begin
     BezlesiS:=StandardStringBezlesi(TBezlesi(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     Device.WriteText   (Porost_PoznS);
     Device.WritelnText(copy(BezlesiS,1,length(BezlesiS)-1));
   end;
end;

 procedure TExportStandardJP_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
      begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamExportStandard.StringListElement,
                                    SeznamStandardJP_FST.StringListElement)));

       with SeznamStandardJP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardJP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;

{        with SeznamStandardJP_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end;   }
        Device.WritelnText(inttostr(PocetJinychPozemku));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TJinyPozemek then
    begin
     JineS:=StandardStringJinyPozemek(TJinyPozemek(Element));
     Device.WriteText   (OddeleniS);
     Device.WritelnText(copy(JineS,1,length(JineS)-1));
    end;
 end;
function  TExportStandardCis_FST.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
procedure TExportStandardCis_FST.Process(Element: TElement);
var i:integer;
 begin
  if element is TDatabaseClass then
   begin
    with TDatabaseClass(element) do
     begin
      if NAME='Majetky' then
       begin
        Device.WritelnText('@');
        Device.WritelnText('&');
       end
      else Device.WritelnText(self.NAME);
      with ExportovanePolozky do
       begin
        if ExpLHC_KOD<>'' then Device.WritelnText(inttostr(count+1))
                          else Device.WritelnText(inttostr(count));
        if ExpLHC_KOD<>'' then
            Device.WritelnText('LHC_KOD');
        for i:=0 to count-1 do
         begin
          if  not(elements[i] is TStringElement) then continue;
          if TDatabaseClass(Input).PropertyIndex[elements[i].name]<>-1 then
           begin
            Device.WritelnText(TStringElement(elements[i]).asstring);
           end;
         end;
       end; {with ExportovanePolozky}
      if NAME<>'Majetky' then Device.WritelnText('@');
      Device.WritelnText(inttostr(count));
     end;
   end;
  if element is TVirtualElement then
   begin
    with TVirtualElement(Element) do
     begin
      if ExpLHC_KOD<>'' then RadekCisS:=ExpLHC_KOD+'@'
      else RadekCisS:='';
      for i:=0 to ExportovanePolozky.count-1 do
       begin
        if  not(ExportovanePolozky.elements[i] is TStringElement) then continue;
        if TDatabaseClass(Input).PropertyIndex[ExportovanePolozky.elements[i].name]<>-1 then
         begin
          RadekCisS:=RadekCisS+
               ElementClass.DSData.dataSet.fieldByName(ExportovanePolozky.elements[i].name).asstring+'@';
         end;
       end;
      Device.WritelnText(copy(RadekCisS,1,length(RadekCisS)-1));
     end;
   end;  {if element is TVirtualElement}
 end;
function  TExportStandardCis_FST.GetExportovanePolozky:TStringListElement;
 begin
  if FExportovanePolozky=nil then
   begin
    FExportovanePolozky:=TStringListElement.create;
    addElement(FExportovanePolozky);
   end;
  result := FExportovanePolozky;
 end;

end.
