unit I_lhcstd;
interface
uses
   sysUtils, dialogs,forms,DB,DBTables,IniFiles,FileCtrl,
   T_Recurs, E_Type, U_String, E_dClass,
    //  KERNEL
  Elements,
  Tools,
  t_Device,
  i_Basic,
    //  DEVICE
  e_Proje,
    //  INTERPRET
  e_IScrpt,
    //  GUI
    //  F_STD,M_InterA,
  lesRecur,lesCisOr,LesCisel,ELesObec,
  mat1,Sp_VyhSo;

type
TVyberMajitele = class(TRecursor)
 private
  FTB_MajetkyPorosty:TTable;
  FTB_MajetkySeparaty:TTable;
 protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
 public
  procedure Process(Element: TElement); override;
  property Tb_MajetkyPorosty:TTable read FTB_MajetkyPorosty write FTB_MajetkyPorosty;
  property Tb_MajetkySeparaty:TTable read FTB_MajetkySeparaty write FTB_MajetkySeparaty;
 end;

TVyberMajiteleOr = class(TRecursor)
 private
  FNacitatPoSkupinach:boolean;
  FmajetkyMN:TmajetkyMN;
 protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
 public
  property  NacitatPoSkupinach:boolean read FNacitatPoSkupinach write FNacitatPoSkupinach;
  property  MajetkyMN:TmajetkyMN read FmajetkyMN write FmajetkyMN;
  procedure Process(Element: TElement); override;
 end;

 TPresunMajiteleZBezlesiDoPorostu = class(TRecursor)
 private
  FBylaProvedenaZmenaMajitele:boolean;
 protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
 public
  procedure Process(Element: TElement); override;
  property  BylaProvedenaZmenaMajitele:boolean
                  read FBylaProvedenaZmenaMajitele write FBylaProvedenaZmenaMajitele;
 end;


TExportStandardCis_FST = class(TInterpret)
private
 FRadekCisS: String;
 FExpLHC_KOD:String;
 FJmenoCiselniku:String;
 FExportovanePolozky:TStringListElement;
 function GetExportovanePolozky:TStringListElement;
protected
  function  QGoInside(Element: TElement): boolean; override;
public
  property JmenoCiselniku:String read FJmenoCiselniku write FJmenoCiselniku;
  procedure Process(Element: TElement); override;
  property  ExportovanePolozky:TStringListElement
             read GetExportovanePolozky write FExportovanePolozky;
  property  RadekCisS : String read FRadekCisS  write FRadekCisS ;
  property  ExpLHC_KOD: String read FExpLHC_KOD write FExpLHC_KOD ;
end;

TExportStandardPP_FST = class(TInterpret)
private
   FOddeleniS: String;
   FDilecS: String;
   FPorostS: String;
   FPorost_PoznS :String;
   FPorostniSkupinaS:String;
   FPorostniSkupina_PoznS:String;
   FEtazS:String;
   FDrevinaS:String;
protected
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
public
   procedure Process(Element: TElement); override;
   property  OddeleniS: String read FOddeleniS write FOddeleniS;
   property  DilecS: String read FDilecS write FDilecS;
   property  PorostS: String read FPorostS write FPorostS;
   property  Porost_PoznS: String read FPorost_PoznS write FPorost_PoznS;
   property  PorostniSkupinaS: String read FPorostniSkupinaS
                                     write FPorostniSkupinaS;
   property  PorostniSkupina_PoznS: String read FPorostniSkupina_PoznS
                                     write FPorostniSkupina_PoznS;
   property  EtazS: String read FEtazS write FEtazS;
   property  DrevinaS: String read FDrevinaS write FDrevinaS;
end;



TExportStandardPSK_FST = class(TExportStandardPP_FST)
   private
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
   end;

TExportStandardLHC_FST = class(TExportStandardPP_FST)
   private
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
   end;

TExportStandardCPB_FST = class(TExportStandardPP_FST)
   private
     FCastParcelyS:string;
     FBezlesiS    :string;
   protected
     function  QProcessAfter(Element: TElement): boolean;  override;
     function  QProcessBefore(Element: TElement): boolean; override;
     function  QGoInside(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property   CastParcelyS:string read FCastParcelyS write FCastParcelyS;
     property   BezlesiS:string read FBezlesiS write FBezlesiS;
   end;

TExportStandardCPJ_FST = class(TExportStandardPP_FST)
   private
     FCastParcelyS:string;
     FJinyPozemekS:string;
   protected
     function  QProcessAfter(Element: TElement): boolean;  override;
     function  QProcessBefore(Element: TElement): boolean; override;
     function  QGoInside(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property CastParcelyS:string read FCastParcelyS write FCastParcelyS;
     property JinyPozemekS:string read FJinyPozemekS write FJinyPozemekS;
   end;

TExportStandardCPP_FST = class(TExportStandardPP_FST)
   private
     FCastParcelyS:string;
   protected
     function  QProcessAfter(Element: TElement): boolean;  override;
     function  QProcessBefore(Element: TElement): boolean; override;
     function  QGoInside(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property CastParcelyS:string read FCastParcelyS write FCastParcelyS;
   end;


TExportStandardBZL_FST = class(TExportStandardPP_FST)
   private
     FBezlesiS:string;
   protected
     function  QProcessAfter(Element: TElement): boolean;  override;
     function  QProcessBefore(Element: TElement): boolean; override;
     function  QGoInside(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property BezlesiS:string read FBezlesiS write FBezlesiS;
   end;

TExportStandardJP_FST = class(TExportStandardPP_FST)
   private
     FJineS:string;
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property JineS:string read FJineS write FJineS;
   end;

TExportStandardOST_FST = class(TExportStandardPP_FST)
   private
     FOstS:string;
   protected
     function  QProcessBefore(Element: TElement): boolean; override;
   public
     procedure Process(Element: TElement); override;
     property OstS:string read FOstS write FOstS;
   end;

TPrenasecZeStandarduCiselnik = class(TOwnerEntity)
private
 FJmenoCiselniku:String;
 FOddelovacPropert:String;
 FPocetHodnotHlavicky:integer;
 FPocetDatovychRadku:longInt;
 FCisloNactenehoRadku:Longint;
 FNosicHlavicka:TStringListElement;
 FSoubStand:TextFile;
 FCtenyStr:String;
 FCtenyChar:Char;
 function GetNosicHlavicka:TStringListElement;
 function GetKonec:Boolean;
public
 constructor Create(ADirekSoub:String); virtual;
 property  SoubStand:TextFile read FSoubStand write FSoubStand;
 procedure NactiRadek;
published
 property JmenoCiselniku:String read FJmenoCiselniku write FJmenoCiselniku;
 property OddelovacPropert:String read FOddelovacPropert write FOddelovacPropert;
 property PocetHodnotHlavicky:integer read FPocetHodnotHlavicky write FPocetHodnotHlavicky;
 property PocetDatovychRadku:longInt read FPocetDatovychRadku write FPocetDatovychRadku;
 property CisloNactenehoRadku:LongInt read FCisloNactenehoRadku write FCisloNactenehoRadku;
 property NosicHlavicka:TStringListElement read GetNosicHlavicka write FNosicHlavicka;
 property CtenyStr:String read FCtenyStr write FCtenyStr;
 property CtenyChar:Char read FCtenyChar write FCtenyChar;
 property Konec:Boolean read GetKonec;
end;


TPrenasecZeStandarduData = class(TOwnerEntity)
private
 FkonecJenDleRadku:Boolean;
 FcistJenPoODD:Boolean;
 FOddelovacPropert:String;
 FOddelovacMeziNasobnymiHodnotami:String;
 FPocetHodnotHlavicky:integer;
 FPocetDatovychRadku:longInt;
 FCisloNactenehoRadku:Longint;
 FNosicHlavicka:TStringListElement;
 FCtenyStr:String;
 FCtenyChar:Char;
 FSeekRadku,FseekBuferu,FIBuf,FnactBuf:Longint;
 FBuf:array[1..40000] of char;
 function GetNosicHlavicka:TStringListElement;
 function GetCisloOddeleni:integer;
 function GetKonec:Boolean;
 function GetStringPodleHodnotyVListu(aIndex: integer):string;
public
 PoradiHodnotyVListu:array [0..300] of integer;
 FSoubStand1:fileofchar; // TextFile;
 constructor Create(ADirekSoub:String); virtual;
 property  StringPodleHodnotyVListu[aIndex: integer]: string read GetStringPodleHodnotyVListu;
 procedure NactiRadek;
 procedure nactiBuf;
 function nactiChar1:Char;
 procedure nactiFCtenyChar;
 function readLnZChar:string;

published
 property CisloOddeleni:integer read GetCisloOddeleni;
 property OddelovacPropert:String read FOddelovacPropert write FOddelovacPropert;
 property OddelovacMeziNasobnymiHodnotami:String read FOddelovacMeziNasobnymiHodnotami write FOddelovacMeziNasobnymiHodnotami;
 property PocetHodnotHlavicky:integer read FPocetHodnotHlavicky write FPocetHodnotHlavicky;
 property PocetDatovychRadku:longInt read FPocetDatovychRadku write FPocetDatovychRadku;
 property CisloNactenehoRadku:LongInt read FCisloNactenehoRadku write FCisloNactenehoRadku;
 property NosicHlavicka:TStringListElement read GetNosicHlavicka write FNosicHlavicka;
 property CtenyStr:String read FCtenyStr write FCtenyStr;
 // property CtenyChar:Char read FCtenyChar write FCtenyChar;
 property SeekRadku:Longint read FSeekRadku  write FSeekRadku;
 property cistJenPoODD:Boolean read FcistJenPoODD write FcistJenPoODD;
 property konecJenDleRadku:Boolean read FkonecJenDleRadku write FkonecJenDleRadku;
 property Konec:Boolean read GetKonec;
end;

TImportStandardPP_FST=class(TRecursor)
private
 FOddelovac:String;
 FLesniCelek:TOwnerEntity;
 FJmenoTextFile:String;
 FPUVOD_DAT_PP:string;
 FNastavuj:boolean;
 FNevytvaretNoveOddeleni:boolean;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
 property LesniCelek:TOwnerEntity read FLesniCelek write FLesniCelek;
published
 property PUVOD_DAT_PP:string read FPUVOD_DAT_PP write FPUVOD_DAT_PP;
 property Oddelovac:string read FOddelovac write FOddelovac;
 property JmenoTextFile:string read FJmenoTextFile write FJmenoTextFile;
 property Nastavuj:boolean read FNastavuj write FNastavuj;
 property NevytvaretNoveOddeleni:boolean read FNevytvaretNoveOddeleni write FNevytvaretNoveOddeleni;
end;
procedure VyberPodleMajitele(VMAJ_DRUH:longint; VMAJ_KOD:String; Oddeleni:TElement);
Function NajdiStandard:String;
implementation

uses
  E_LesOdd, e_LesCel, Dtb_les, T_Select;
{ procedure TUnivStareLHP.Open;
  begin
   if Table  <>NIL then Table.Open;
   if TextFil<>nil then reset(TextFil);
  end;
 procedure TUnivStareLHP.First;
  begin
   if Table  <>NIL then Table.first;
   if TextFil<>nil then
    begin
     closefile(TextFil);
     reset(textFil);
     readln(TextFil,FSRadek);
    end;
  end;
 procedure TUnivStareLHP.Open;
  begin
   if Table  <>NIL then Table.Open;
   if TextFil<>nil then reset(TextFil);
  end;  }
Function NajdiStandard:String;
var hl_Cesta,adr_ISH:String;
    initext:Tinifile;
 begin
  Application.CreateForm(TS_VyhlSoub1, S_VyhlSoub1);
  hl_Cesta:=KPoslednimuZnaku(Application.ExeName,'\')+'\vtx.ini';
  initext:=Tinifile.create(Hl_cesta);
  adr_ISH:=initext.ReadString('DATABASE','IS_HUL','C:\');
  if not DirectoryExists(adr_ISH) then adr_ISH:='C:\';
  S_VyhlSoub1.caption:='Vyhledej adres IS HL .';
  S_VyhlSoub1.fileListBox1.mask := '*.FST';
  S_VyhlSoub1.DirectoryListBox1.Directory:=Adr_ISH;
  S_VyhlSoub1.showmodal;
  if S_VyhlSoub1.Vybrano then
   begin
    result:=S_VyhlSoub1.DirectoryListBox1.Directory;
    initext.writeString('DATABASE','IS_HUL',result);
   end
  else
   begin
    result:='NicSeNevybralo';
   end;
  S_VYHLSOUB1.Free;
  initext.free;
 end;

 procedure TImportStandardPP_FST.Process(Element: TElement);
 var Element1:TElement;
     // VOdd:TOddeleni;
     aStr:string;
     ssOdd:string;
  begin
   Element1:=Element;
   { showmessage(element1.name); }
   { if Element1 is TStringElement then
      begin
       showmessage(element1.name+'   '+(TStringElement(Element1).text));
      end; }
   if (uppercase(element1.name)='LHC_KOD')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHC_KOD:=StrToInt0(u0(TStringElement(Element1).text));
       PUVOD_DAT:=PUVOD_DAT_PP;
      end;
    end;
   if (uppercase(element1.name)='LHC_NAZ')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHC_NAZ:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='LHP_OD')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_OD:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LHP_DO')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_DO:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='ETAT_TV')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       ETAT_TV:=StrToInt0(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='ETAT_TO')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       ETAT_TO:=StrToInt0(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='ETAT_TVYB')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       ETAT_TVYB:=StrToInt0(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='LHP_Z_OD')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_Z_OD:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LHP_Z_DO')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_Z_DO:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LHP_Z_TAX')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_Z_TAX:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LHP_TAX')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_TAX:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TEZ_PROC')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       TEZ_PROC:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='NOR_PAS')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       NOR_PAS:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='LHC_PN_PRO')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHC_PN_PRO:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='LHC_IND')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHC_IND:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='LHC_MAX')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHC_MAX:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;


   if (uppercase(element1.name)='LHP_LIC')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_LIC:=TStringElement(Element1).text;
      end;
    end;

   if (uppercase(element1.name)='LHP_Z_LIC')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       LHP_Z_LIC:=TStringElement(Element1).text;
      end;
    end;

   if (uppercase(element1.name)='MVYCH_DO40')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       MVYCH_DO40:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;

   if (uppercase(element1.name)='ODD')and(Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc do
      begin
       {if not(OddeleniMN.JmenoAktualnihoPrvku=TStringElement(Element1).text) then
         begin
          NactiOddeleni_DB_DleCisla(
            TStringElement(Element1).text,VOdd,TLesniCelek(LesniCelek).LOvr);
          if VOdd<>NIL then OddeleniMN.addElement(VOdd);
         end; }
       if not(NevytvaretNoveOddeleni) then
        begin
         ssOdd:=inttostr(strToInt(u0(TStringElement(Element1).text)));
         if not(OddeleniMN.JmenoAktualnihoPrvku=ssOdd) then
          begin
           OddeleniMN.NovyPrvek:=ssOdd;
           // showmessage('vytvarim nov prvek odd='+ssOdd);
          end;
        end;
       Oddeleni.ODD:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DIL')and(Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       // showmessage('DILEC "'+TStringElement(Element1).text+'" nastavuju.');
       DilecMN.NovyNeboAktualniPrvek:=TStringElement(Element1).text;
       Dilec.DIL:=TStringElement(Element1).text;
       // showmessage('DILEC "'+ Dilec.DIL+'" nastaven.'+dilec.CeleOznaceni+'='+inttostr(dilecmn.count));
      end;
    end;
   if (uppercase(element1.name)='JP')and(Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
       // NastavNeboVytvorPrvniPorost;
       // with dilec.Porost do
       // begin
         if POR='' then POR:='-';
         if OwnerDilec.DIL='' then OwnerDilec.DIL:='-';
         JinyPozemekMN.NovyPrvekVzdy:=TStringElement(Element1).text;
         JinyPOzemek.JP:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='JP_PUPFL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_PUPFL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='JP_P0')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_P0:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='JP_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='JP_V')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_V:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DRUH_POZ')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
         DRUH_POZ:=TStringElement(Element1).text;
        end;
      end;
    end;
   if (uppercase(element1.name)='JP_VYUZ')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_VYUZ:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='JP_DRUH')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
       JP_DRUH:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='POR')and(Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TDilec(DilecMN.AktualniPrvekVzdy) do
        begin
         // showmessage('Porost "'+TStringElement(Element1).text+'" nastavuju.');
         PorostMN.NovyNeboAktualniPrvek:=TStringElement(Element1).text;
         Porost.POR:=TStringElement(Element1).text;
         // showmessage('Porost "'+Porost.POR+'" nastaven. '+porost.CeleOznaceni);
        end;
      end;
    end;
   if (uppercase(element1.name)='SDR_POR')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       SDR_POR:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='MAJ_KOD')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
        // MAJ_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if     (JmenoTextFile='PP.FST')
          or(JmenoTextFile='PSK.FST')
          or(JmenoTextFile='BZL.FST')
          or((JmenoTextFile='JP.FST')
              and(TLesniCelek(LesniCelek).TypDatLHP=IsHul98))
           then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostVzdy do
        begin
         MAJ_KOD:=u0(TStringElement(Element1).text);
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
        // MAJ_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='MAJ_DRUH')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
     with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
      begin
      // MAJ_DRUH:=strToInt(u0(TStringElement(Element1).text));
      end;
     if     (JmenoTextFile='PP.FST')
          or(JmenoTextFile='PSK.FST')
          or(JmenoTextFile='BZL.FST')
          or((JmenoTextFile='JP.FST')
              and(TLesniCelek(LesniCelek).TypDatLHP=IsHul98))
         then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostVzdy do
        begin
         MAJ_DRUH:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
         // MAJ_DRUH:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='KATEGORIE')and( not Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
         Kategorie1MN.SetStringNasobnychPrvku(TStringElement(Element1).text,Oddelovac);
         Kategorie1MN.SetStringNasobnychHodnot('KATEGORIE',TStringElement(Element1).text,Oddelovac);
        end;
      end;
    end;
   if (uppercase(element1.name)='ORG_UROVEN')and( not Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
          Org_UrovenMN.SetStringNasobnychPrvku(TStringElement(Element1).text,Oddelovac);
          Org_UrovenMN.SetStringNasobnychHodnot('ORG_UROVEN',TStringElement(Element1).text,Oddelovac);
        end;
      end;
    end;
   if (uppercase(element1.name)='KAT_SPEC')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       KAT_SPEC:=strtoInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='PAS_OHR')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       PAS_OHR:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LES_OBL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       LES_OBL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='ZVL_STATUT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       ZVL_STATUT:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='OLH')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       OLH_98:=TStringElement(Element1).text;
      end;
    end;

   if (uppercase(element1.name)='POR_TEXT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostVzdy do
      begin
       if POR_TEXT.count=0 then
        begin
         POR_TEXT.add(Cz852ToWin(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='PSK')and( Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
         aStr:=opravenaSkupina(TStringElement(Element1).text);
         PorostniSkupinaMN.NovyNeboAktualniPrvek:=aStr;
         PorostniSkupina.PSK:=aStr;
        end;
      end;
    end;
   if (uppercase(element1.name)='PSK_P0')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PSK_P0:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='PSK_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PSK_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='PSK_V')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PSK_V:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='KVAL_P')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
         KVAL_P:=StrToInt(uc(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='PP.FST')or(JmenoTextFile='PSK.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
        begin
         KVAL_P:=strToInt(uc(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
         KVAL_P:=strToInt(uc(TStringElement(Element1).text));
        end;
      end;
    end;

   if (uppercase(element1.name)='KAT_PAR_KOD')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
         KAT_PAR_KOD:=StrToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='PP.FST')or(JmenoTextFile='PSK.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
        begin
         KAT_PAR_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
         KAT_PAR_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;


   if (uppercase(element1.name)='KU_KOD')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
         KU_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='PP.FST')or(JmenoTextFile='PSK.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
        begin
         KU_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
         KU_KOD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;

   if (uppercase(element1.name)='LES_URAD')and( not Nastavuj) then
    begin
     if JmenoTextFile='JP.FST' then
      begin
       with TLesniCelek(LesniCelek).lhc.JinyPozemekVzdy do
        begin
         LES_URAD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='PP.FST')or(JmenoTextFile='PSK.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
        begin
         LES_URAD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
     if (JmenoTextFile='BZL.FST') then
      begin
       with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
        begin
         LES_URAD:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='SLT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       SLT:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='LT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       LT:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TER_TYP')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       TER_TYP:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='PRIB_VZD')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PRIB_VZD:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='HOSP_ZP')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       HOSP_ZP:=StrToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DAN')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       DAN:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='PSK_TEXT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PSK_TEXT:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;

   if (uppercase(element1.name)='ETAZ_TEXT')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.PorostniSkupinaVzdy do
      begin
       PSK_TEXT:=PSK_TEXT+' ET: '+Cz852ToWin(TStringElement(Element1).text);
      end;
    end;

   if (uppercase(element1.name)='BZL')and( Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
         BezlesiMN.NovyPrvekVzdy:=TStringElement(Element1).text;
         Bezlesi.BZL:=strToInt(u0(TStringElement(Element1).text));
        end;
      end;
    end;
   if (uppercase(element1.name)='BZL_P0')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_P0:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='BZL_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='BZL_V')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_V:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='BZL_VYUZ')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_VYUZ:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='BZL_DRUH')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_DRUH:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='BZL_DRUH')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.BezlesiVzdy do
      begin
       BZL_DRUH:=Cz852ToWin(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='ETAZ')and (Nastavuj) then
    begin
     with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
      begin
       with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
        begin
         with TPorostniSkupina(PorostniSkupinaMN.AktualniPrvekVzdy) do
          begin
           EtazMN.NovyNeboAktualniPrvek:=TStringElement(Element1).text;
           Etaz.ETAZ:=TStringElement(Element1).text;
          end
        end;
      end;
    end;
   if (uppercase(element1.name)='ETAZ_PS')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       ETAZ_PS:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='ETAZ_PP')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       ETAZ_PP:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='HS')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       HS:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='OBMYTI')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       OBMYTI:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='OBN_DOBA')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       OBN_DOBA:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='POC_OBNOVY')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       POC_OBNOVY:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='MZD')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       MZDs:=ubm(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='VEK')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       VEK:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='ZAKM')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       ZAKM:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='M_Z_ZASOBY')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       M_Z_ZASOBY:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;

   if (uppercase(element1.name)='M_TEZ_PROC')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       M_TEZ_PROC:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;

   if (uppercase(element1.name)='ODVOZ_TEZ')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       ODVOZ_TEZ:=TStringElement(Element1).text;
      end;
    end;

   if (uppercase(element1.name)='HOSP_TV')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       HOSP_TV:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='PRO_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       PRO_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='PRO_NAL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       PRO_NAL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='PRO_POC')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       PRO_POC:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TV_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TV_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TV_NAL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TV_NAL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TV_POC')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TV_POC:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TO_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TO_P:=StrToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TO_NAL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TO_NAL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TO_DUVOD')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TO_DUVOD:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TO_ZPUSOB')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TO_ZPUSOB:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='TVYB_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TVYB_P:=strToExtended(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TVYB_NAL')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       TVYB_NAL:=TStringElement(Element1).text;
      end;
    end;

   if (uppercase(element1.name)='DR_ZKR')and( Nastavuj) then
    begin
     if TStringElement(Element1).text<>'' then
      begin
       with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
        begin
         with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
          begin
           with TEtaz(TPorostniSkupina(PorostniSkupinaMN.AktualniPrvekVzdy).EtazMN.AktualniPrvekVzdy) do
            begin
             {DrevinaMN.NovyNeboAktualniPrvek}
             DrevinaMN.NovyPrvekVzdy := TStringElement(Element1).text;
             Drevina.DR_ZKR          := TStringElement(Element1).text;
            end
          end;
        end;
      end
     else
      begin
       with TLesniCelek(LesniCelek).lhc.EtazVzdy do
        begin
         DrevinaMN.AktualniPrvek:=nil;
        end;
      end;
    end;

   if (uppercase(element1.name)='DR_PUVOD')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_PUVOD:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='ZAST')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       ZAST:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='VYSKA')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       VYSKA:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='TLOUSTKA')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       TLOUSTKA:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='BON_A')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       BON_A:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='BON_R')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       BON_R:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='PROC_SOUS')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       PROC_SOUS:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='GEN_KLAS')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       GEN_KLAS:=(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='VYB_STR')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       VYB_STR:=(TStringElement(Element1).text);
      end;
    end;
   if (uppercase(element1.name)='DR_ZAS_TAB')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_ZAS_TAB:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DR_ZAS_HA')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_ZAS_HA:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DR_ZAS_CEL')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_ZAS_CEL:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
  if (uppercase(element1.name)='IMISE')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       IMISE:=TStringElement(Element1).text;
      end;
    end;
  if (uppercase(element1.name)='DR_KVAL')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_KVAL:=TStringElement(Element1).text;
      end;
    end;
   if (uppercase(element1.name)='DR_TV')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_TV:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DR_TO')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_TO:=strToInt(uc(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='DR_TVYB')and( not Nastavuj) then
    begin
     if TLesniCelek(LesniCelek).lhc.EtazVzdy.drevina<>nil then
     with TLesniCelek(LesniCelek).lhc.DrevinaVzdy do
      begin
       DR_TVYB:=strToInt(u0(TStringElement(Element1).text));
      end;
    end;
   if (uppercase(element1.name)='ZAL_DR')and( not Nastavuj) then
    begin
     if TStringElement(Element1).text<>'' then
      begin
       with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
        begin
         with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
          begin
           with TEtaz(TPorostniSkupina(PorostniSkupinaMN.AktualniPrvekVzdy).EtazMN.AktualniPrvekVzdy) do
            begin
             ZalesneniMN.SetStringNasobnychPrvku(TStringElement(Element1).text,Oddelovac);
             ZalesneniMN.SetStringNasobnychHodnot('ZAL_DR',TStringElement(Element1).text,Oddelovac);
             if ZalesneniMN.pocetPrvku>0 then
              begin
               if trim(TZalesneni(ZalesneniMN.Elements[0]).ZAL_DRUH)='' then
                begin
                 ZalesneniMN.VyplnHromadneHodnotu('ZAL_DRUH',ZAL_DRUH);
                end
               else
                begin
                 ZalesneniMN.VyplnHromadneHodnotu('ZAL_DRUH',TZalesneni(ZalesneniMN.Elements[0]).ZAL_DRUH);
                end;
              end;
            end
          end;
        end;
      end;
    end;
   if (uppercase(element1.name)='ZAL_DRUH')and( not Nastavuj) then
    begin
     if TStringElement(Element1).text<>'' then
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       if ZalesneniMN.count>0 then
        begin
         ZalesneniMN.SetStringNasobnychHodnot('ZAL_DRUH',TStringElement(Element1).text,Oddelovac);
        end
       else
        begin
         ZAL_DRUH:=TStringElement(Element1).text;
        end;
      end;
    end;
   if (uppercase(element1.name)='ZAL_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       if strtoExtended(u0(TStringElement(Element1).text))>0.001 then
         begin
          ZalesneniMN.SetStringNasobnychHodnot('ZAL_P',TStringElement(Element1).text,Oddelovac);
         end;
       if (pos(Oddelovac,TStringElement(Element1).text)=0)
        and(TStringElement(Element1).text<>'')
        and(ZalesneniMN.PocetPrvku>1) then
         begin
          ZalesneniMN.PlochaZalesneni:=StrToExtended(u0(TStringElement(Element1).text));
         end;
      end;
    end;
   if (uppercase(element1.name)='ZAL_DR_P')and( not Nastavuj) then
    begin
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       if u0(TStringElement(Element1).text)<>'0' then
        begin
         ZalesneniMN.SetStringNasobnychHodnot('ZAL_DR_P',u0(TStringElement(Element1).text),Oddelovac);
         ZalesneniMN.PlochaZalesneni:=ZalesneniMN.PlochaZalesneni;
        end;
      end;
    end;
   if (uppercase(element1.name)='POSKOZ_D')and( not Nastavuj) then
    begin
     if TStringElement(Element1).text<>'' then
      begin
       with TOddeleni(TLesniCelek(LesniCelek).lhc.OddeleniMN.aktualniPrvekVzdy) do
        begin
         with TPorost(TDilec(DilecMN.AktualniPrvekVzdy).PorostMN.AktualniPrvekVzdy) do
          begin
           with TEtaz(TPorostniSkupina(PorostniSkupinaMN.AktualniPrvekVzdy).EtazMN.AktualniPrvekVzdy) do
            begin
             if DrevinaMN.drevina<>NIL then
              begin
               with TDrevina(DrevinaMN.AktualniPrvekVzdy)do
                begin
                 PoskozeniMN.SetStringNasobnychPrvku(TStringElement(Element1).text,Oddelovac);
                 PoskozeniMN.SetStringNasobnychHodnot('POSKOZ_D',TStringElement(Element1).text,Oddelovac);
                end;
              end;
            end;
          end;
        end;
      end;
    end;
   if (uppercase(element1.name)='POSKOZ_R')and( not Nastavuj) then
    begin
     if TStringElement(Element1).text<>'' then
     with TLesniCelek(LesniCelek).lhc.EtazVzdy do
      begin
       if DrevinaMN.drevina<>NIL then
        begin
         with DrevinaMN.drevina do
          begin
           try
            PoskozeniMN.SetStringNasobnychHodnot('POSKOZ_R10',TStringElement(Element1).text,Oddelovac);
           except
            showmessage('Chyba pi natn POSKOZ_R10.="'+TStringElement(Element1).text+'"');
           end;
          end;
        end;
      end;
    end;
  end;


function  TImportStandardPP_FST.QGoInside(Element: TElement): boolean;
begin
   result := true;
end;

function  TImportStandardPP_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := true;
 end;
function TPrenasecZeStandarduData.GetKonec:boolean;
 begin
   if konecJenDleRadku then
    begin
     result:=(CisloNactenehoRadku>PocetDatovychRadku);
    end
   else
    begin
     if (CisloNactenehoRadku>PocetDatovychRadku)
     or((FileSize(FSoubStand1)-(FseekBuferu+FIBuf))<0)
      then
       begin
        result:=True;
       end
      else
       begin
        result:=False;
       end;
    end;
 end;


function TPrenasecZeStandarduCiselnik.GetKonec:boolean;
 begin
  if CisloNactenehoRadku>PocetDatovychRadku then result:=True else result:=False;
 end;
procedure TPrenasecZeStandarduData.nactiBuf;
 begin
  FSeekBuferu:=FilePos(FSoubStand1);
  FiBuf:=0;
  blockread(FSoubStand1,FBuf,sizeof(Fbuf),FnactBuf);
 end;
function TPrenasecZeStandarduData.readLnZChar:string;
var hotovo:boolean;
    // ch:char;
 begin
  result:='';
  hotovo:=false;
  if konec then exit;
  repeat
   nactiFCtenyChar;
   // ch:=nactiChar;
   if ord(FCtenyChar)=13 then
     begin
      //read(FSoubStand,ch);
      //ch:=nactiChar;
      nactiFCtenyChar;
      if ord(FCtenyChar)=10 then hotovo:=true;
     end
   else
     begin
      result:=result+FCtenyChar;
     end;
   // if eof(FSoubStand) then hotovo:=true;
   if konec then hotovo:=true;
  until hotovo;
 end;
procedure TPrenasecZeStandarduData.nactiFCtenyChar;
 begin
  if Fibuf>=Fnactbuf then
   begin
    if Fnactbuf=sizeof(FBuf) then
     begin
      nactibuf;
     end;
    if Fibuf>=Fnactbuf then
     begin
      inc(Fibuf);
      FCtenyChar:=' ';
      exit;
     end;
   end;
  inc(Fibuf);
  FCtenyChar:=Fbuf[Fibuf];
 end;

function TPrenasecZeStandarduData.nactiChar1:Char;
 begin
  if Fibuf>=Fnactbuf then
   begin
    if Fnactbuf=sizeof(FBuf) then
     begin
      nactibuf;
     end;
    if Fibuf>=Fnactbuf then
     begin
      inc(Fibuf);
      result:=' ';
      exit;
     end;
   end;
  inc(Fibuf);
  result:=Fbuf[Fibuf];
 end;
procedure TPrenasecZeStandarduData.NactiRadek;
var iProp:integer;
 begin
  seekRadku:=FSeekBuferu+FIbuf;
  // FilePos(FSoubStand);
  CisloNactenehoRadku:=CisloNactenehoRadku+1;
  if konec then exit;
  for iProp:=0 to PocetHodnotHlavicky-1 do
   begin
    CtenyStr:='';
    repeat
     nactiFCtenyChar;
     if (FCtenyChar<>OddelovacPropert)and(ord(FctenyChar)<>13)and(ord(FctenyChar)<>10) then
      begin
       CtenyStr:=CtenyStr+FCtenyChar;
      end;
    until not((FCtenyChar<>OddelovacPropert)and(not((ord(FctenyChar)=13)and(iProp=PocetHodnotHlavicky-1)))and(length(CtenyStr)<2000));
    NosicHlavicka.strings[iProp]:=CtenyStr;
    if cistJenPoODD then
     begin
      if NosicHlavicka.Names[iProp]='ODD' then
       begin
        readLnZChar;
        exit;
       end;
     end;
    if (ord(FctenyChar)=13) then
     begin
       nactiFCtenyChar;
      //FCtenyChar:=nactiChar;
      // read(FSoubStand,FCtenyChar);
     end
   end;
  if (ord(FctenyChar)<>10) then
   begin
    // showmessage('Chybn dlka dku "'+CtenyStr+'"');
    // Application.terminate;
   end;
 end;
procedure TPrenasecZeStandarduCiselnik.NactiRadek;
var iProp:integer;
 begin
  CisloNactenehoRadku:=CisloNactenehoRadku+1;
  if konec then exit;
  for iProp:=0 to PocetHodnotHlavicky-1 do
   begin
    CtenyStr:='';
    repeat
     read(FSoubStand,FCtenyChar);
     if (CtenyChar<>OddelovacPropert)and(ord(ctenyChar)<>13) then
      begin
       CtenyStr:=CtenyStr+CtenyChar;
      end;
    until not((CtenyChar<>OddelovacPropert)and(ord(ctenyChar)<>13));
    { showmessage(''''+CtenyStr+'''');}
    NosicHlavicka.strings[iProp]:=CtenyStr;
    { showmessage(NosicHlavicka.Names[iProp]+'**'+NosicHlavicka.strings[iProp]); }
    if (ord(ctenyChar)=13) then
     begin
      read(FSoubStand,FCtenyChar);
     end
   end;
  if (ord(ctenyChar)<>10) then
   begin
    showmessage('Chybn dlka dku "'+CtenyStr+'"');
    // Application.terminate;
   end;
 end;
function TPrenasecZeStandarduData.GetNosicHlavicka:TStringListElement;
 begin
  if FNosicHlavicka=Nil then
   begin
    FNosicHlavicka:=TStringListElement.create;
    FNosicHlavicka.name:='NosicHlavicka';
    addElement(FNosicHlavicka);
   end;
  Result:=FNosicHlavicka;
 end;
function TPrenasecZeStandarduCiselnik.GetNosicHlavicka:TStringListElement;
 begin
  if FNosicHlavicka=Nil then
   begin
    FNosicHlavicka:=TStringListElement.create;
    FNosicHlavicka.name:='NosicHlavicka';
    addElement(FNosicHlavicka);
   end;
  Result:=FNosicHlavicka;
 end;
constructor TPrenasecZeStandarduData.Create(ADirekSoub:String);
var i:integer;
 begin
  inherited create;
  AssignFile(FSoubStand1,ADirekSoub);
  try
  fileMode:=0;
  reset(FSoubStand1);
  nactiBuf;
  FCtenyStr:=readLnZChar;
  // readlnZChar(FSoubStand,FCtenyStr);
  except
   FPocetHodnotHlavicky:=0;
   FPocetDatovychRadku:=-1;
   exit;
  end;
  OddelovacPropert:=CtenyStr[1];
  FCtenyStr:=readLnZChar;
  // readlnZChar(FSoubStand,FCtenyStr);
  OddelovacMeziNasobnymiHodnotami:=CtenyStr[1];
  FCtenyStr:=readLnZChar;
  //readlnZChar(FSoubStand,FCtenyStr);
  PocetHodnotHlavicky:=StrToInt0(CtenyStr);
  for i:=1 to PocetHodnotHlavicky do
   begin
    FCtenyStr:=readLnZChar;
    //  readlnZChar(FSoubStand,FCtenyStr);
    NosicHlavicka.AddNameString(UpperCase(CtenyStr),'');
   end;
  FCtenyStr:=readLnZChar;
  // readlnZChar(FSoubStand,FCtenyStr);
  PocetDatovychRadku:=StrToInt0(CtenyStr);
  with NosicHlavicka do
   begin
    PoradiHodnotyVListu[0]:=IndexOf(GetStringElementByName('LHC_KOD'));
    PoradiHodnotyVListu[1]:=IndexOf(GetStringElementByName('LHC_NAZ'));
    PoradiHodnotyVListu[2]:=IndexOf(GetStringElementByName('LHP_OD'));
    PoradiHodnotyVListu[3]:=IndexOf(GetStringElementByName('LHP_DO'));
    PoradiHodnotyVListu[4]:=IndexOf(GetStringElementByName('ETAT_TV'));
    PoradiHodnotyVListu[5]:=IndexOf(GetStringElementByName('ETAT_TO'));
    PoradiHodnotyVListu[6]:=IndexOf(GetStringElementByName('ETAT'));

    PoradiHodnotyVListu[100]:=IndexOf(GetStringElementByName('ETAT_TVYB'));
    PoradiHodnotyVListu[101]:=IndexOf(GetStringElementByName('LHP_Z_OD'));
    PoradiHodnotyVListu[102]:=IndexOf(GetStringElementByName('LHP_Z_DO'));
    PoradiHodnotyVListu[103]:=IndexOf(GetStringElementByName('LHP_Z_TAX'));
    PoradiHodnotyVListu[104]:=IndexOf(GetStringElementByName('LHP_TAX'));

    PoradiHodnotyVListu[105]:=IndexOf(GetStringElementByName('TEZ_PROC'));
    PoradiHodnotyVListu[106]:=IndexOf(GetStringElementByName('NOR_PAS'));
    PoradiHodnotyVListu[107]:=IndexOf(GetStringElementByName('LHC_PN_PRO'));
    PoradiHodnotyVListu[108]:=IndexOf(GetStringElementByName('LHC_IND'));
    PoradiHodnotyVListu[109]:=IndexOf(GetStringElementByName('LHC_MAX'));
    PoradiHodnotyVListu[112]:=IndexOf(GetStringElementByName('LHC_LIC'));
    PoradiHodnotyVListu[113]:=IndexOf(GetStringElementByName('LHP_Z_LIC'));
    PoradiHodnotyVListu[117]:=IndexOf(GetStringElementByName('MVYCH_DO40'));
    PoradiHodnotyVListu[7]  :=IndexOf(GetStringElementByName('ODD'));
    PoradiHodnotyVListu[8]  :=IndexOf(GetStringElementByName('DIL'));
    PoradiHodnotyVListu[9]  :=IndexOf(GetStringElementByName('POR'));
    PoradiHodnotyVListu[10]:=IndexOf(GetStringElementByName('SDR_POR'));
    PoradiHodnotyVListu[11]:=IndexOf(GetStringElementByName('MAJ_KOD'));
    PoradiHodnotyVListu[12]:=IndexOf(GetStringElementByName('MAJ_NAZ'));
    PoradiHodnotyVListu[13]:=IndexOf(GetStringElementByName('MAJ_DRUH'));
    PoradiHodnotyVListu[14]:=IndexOf(GetStringElementByName('ORG_UROVEN'));
    PoradiHodnotyVListu[15]:=IndexOf(GetStringElementByName('KATEGORIE'));
    PoradiHodnotyVListu[16]:=IndexOf(GetStringElementByName('KAT_SPEC'));
    PoradiHodnotyVListu[17]:=IndexOf(GetStringElementByName('PAS_OHR'));
    PoradiHodnotyVListu[18]:=IndexOf(GetStringElementByName('LES_OBL'));
    PoradiHodnotyVListu[19]:=IndexOf(GetStringElementByName('ZVL_STATUT'));
    PoradiHodnotyVListu[20]:=IndexOf(GetStringElementByName('OLH'));
    PoradiHodnotyVListu[116]:=IndexOf(GetStringElementByName('OLH_LIC'));
    PoradiHodnotyVListu[21]:=IndexOf(GetStringElementByName('POR_TEXT'));
    PoradiHodnotyVListu[22]:=IndexOf(GetStringElementByName('PSK'));
    PoradiHodnotyVListu[23]:=IndexOf(GetStringElementByName('PSK_P0'));
    PoradiHodnotyVListu[24]:=IndexOf(GetStringElementByName('PSK_V'));
    PoradiHodnotyVListu[25]:=IndexOf(GetStringElementByName('PSK_P'));
    PoradiHodnotyVListu[26]:=IndexOf(GetStringElementByName('KVAL_P'));
    PoradiHodnotyVListu[110]:=IndexOf(GetStringElementByName('KAT_PAR_KOD'));
    PoradiHodnotyVListu[27]:=IndexOf(GetStringElementByName('KU_KOD'));
    PoradiHodnotyVListu[28]:=IndexOf(GetStringElementByName('KU_NAZ'));
    PoradiHodnotyVListu[29]:=IndexOf(GetStringElementByName('LES_URAD'));
    PoradiHodnotyVListu[30]:=IndexOf(GetStringElementByName('SLT'));
    PoradiHodnotyVListu[31]:=IndexOf(GetStringElementByName('LT'));
    PoradiHodnotyVListu[32]:=IndexOf(GetStringElementByName('TER_TYP'));
    PoradiHodnotyVListu[33]:=IndexOf(GetStringElementByName('PRIB_VZD'));
    PoradiHodnotyVListu[34]:=IndexOf(GetStringElementByName('HOSP_ZP'));
    PoradiHodnotyVListu[35]:=IndexOf(GetStringElementByName('DAN'));
    PoradiHodnotyVListu[36]:=IndexOf(GetStringElementByName('PSK_TEXT'));
    PoradiHodnotyVListu[37]:=IndexOf(GetStringElementByName('ETAZ'));
    PoradiHodnotyVListu[38]:=IndexOf(GetStringElementByName('ETAZ_PS'));
    PoradiHodnotyVListu[39]:=IndexOf(GetStringElementByName('ETAZ_PP'));
    PoradiHodnotyVListu[40]:=IndexOf(GetStringElementByName('HS'));
    PoradiHodnotyVListu[41]:=IndexOf(GetStringElementByName('OBMYTI'));
    PoradiHodnotyVListu[42]:=IndexOf(GetStringElementByName('OBN_DOBA'));
    PoradiHodnotyVListu[43]:=IndexOf(GetStringElementByName('POC_OBNOVY'));
    PoradiHodnotyVListu[111]:=IndexOf(GetStringElementByName('PROC_HS'));
    PoradiHodnotyVListu[44]:=IndexOf(GetStringElementByName('MZD'));
    PoradiHodnotyVListu[45]:=IndexOf(GetStringElementByName('VEK'));
    PoradiHodnotyVListu[46]:=IndexOf(GetStringElementByName('ZAKM'));
    PoradiHodnotyVListu[47]:=IndexOf(GetStringElementByName('M_Z_ZASOBY'));
    PoradiHodnotyVListu[114]:=IndexOf(GetStringElementByName('M_TEZ_PROC'));
    PoradiHodnotyVListu[115]:=IndexOf(GetStringElementByName('ODVOZ_TEZ'));
    PoradiHodnotyVListu[48]:=IndexOf(GetStringElementByName('HOSP_TV'));
    PoradiHodnotyVListu[49]:=IndexOf(GetStringElementByName('PRO_P'));
    PoradiHodnotyVListu[50]:=IndexOf(GetStringElementByName('PRO_NAL'));
    PoradiHodnotyVListu[51]:=IndexOf(GetStringElementByName('PRO_POC'));
    PoradiHodnotyVListu[52]:=IndexOf(GetStringElementByName('TV_P'));
    PoradiHodnotyVListu[53]:=IndexOf(GetStringElementByName('TV_NAL'));
    PoradiHodnotyVListu[54]:=IndexOf(GetStringElementByName('TV_POC'));
    PoradiHodnotyVListu[55]:=IndexOf(GetStringElementByName('TO_P'));
    PoradiHodnotyVListu[56]:=IndexOf(GetStringElementByName('TO_NAL'));
    PoradiHodnotyVListu[57]:=IndexOf(GetStringElementByName('TO_DUVOD'));
    PoradiHodnotyVListu[97]:=IndexOf(GetStringElementByName('TO_ZPUSOB'));
    PoradiHodnotyVListu[98]:=IndexOf(GetStringElementByName('TVYB_P'));
    PoradiHodnotyVListu[99]:=IndexOf(GetStringElementByName('TVYB_NAL'));
    PoradiHodnotyVListu[58]:=IndexOf(GetStringElementByName('ZAL_DRUH'));
    PoradiHodnotyVListu[59]:=IndexOf(GetStringElementByName('ZAL_P'));
    PoradiHodnotyVListu[60]:=IndexOf(GetStringElementByName('ZAL_DR'));
    PoradiHodnotyVListu[61]:=IndexOf(GetStringElementByName('ZAL_DR_P'));
    PoradiHodnotyVListu[62]:=IndexOf(GetStringElementByName('DR_ZKR'));
    PoradiHodnotyVListu[63]:=IndexOf(GetStringElementByName('DR_KOD'));
    PoradiHodnotyVListu[64]:=IndexOf(GetStringElementByName('DR_PUVOD'));
    PoradiHodnotyVListu[65]:=IndexOf(GetStringElementByName('ZAST'));
    PoradiHodnotyVListu[66]:=IndexOf(GetStringElementByName('VYSKA'));
    PoradiHodnotyVListu[67]:=IndexOf(GetStringElementByName('TLOUSTKA'));
    PoradiHodnotyVListu[68]:=IndexOf(GetStringElementByName('BON_A'));
    PoradiHodnotyVListu[69]:=IndexOf(GetStringElementByName('BON_R'));
    PoradiHodnotyVListu[70]:=IndexOf(GetStringElementByName('GEN_KLAS'));
    PoradiHodnotyVListu[71]:=IndexOf(GetStringElementByName('VYB_STR'));
    PoradiHodnotyVListu[118]:=IndexOf(GetStringElementByName('DR_ZAS_TAB'));
    PoradiHodnotyVListu[72]:=IndexOf(GetStringElementByName('DR_ZAS_HA'));
    PoradiHodnotyVListu[73]:=IndexOf(GetStringElementByName('DR_ZAS_CEL'));
    PoradiHodnotyVListu[74]:=IndexOf(GetStringElementByName('DR_KVAL'));
    PoradiHodnotyVListu[75]:=IndexOf(GetStringElementByName('IMISE'));
    PoradiHodnotyVListu[76]:=IndexOf(GetStringElementByName('HMOT'));
    PoradiHodnotyVListu[77]:=IndexOf(GetStringElementByName('DR_TV'));
    PoradiHodnotyVListu[78]:=IndexOf(GetStringElementByName('DR_TO'));
    PoradiHodnotyVListu[96]:=IndexOf(GetStringElementByName('DR_TVYB'));
    PoradiHodnotyVListu[79]:=IndexOf(GetStringElementByName('POSKOZ_D'));
    PoradiHodnotyVListu[80]:=IndexOf(GetStringElementByName('POSKOZ_R'));
    PoradiHodnotyVListu[81]:=IndexOf(GetStringElementByName('PROC_SOUS'));
    PoradiHodnotyVListu[82]:=IndexOf(GetStringElementByName('BZL'));
    PoradiHodnotyVListu[83]:=IndexOf(GetStringElementByName('BZL_P0'));
    PoradiHodnotyVListu[84]:=IndexOf(GetStringElementByName('BZL_V'));
    PoradiHodnotyVListu[85]:=IndexOf(GetStringElementByName('BZL_P'));
    PoradiHodnotyVListu[86]:=IndexOf(GetStringElementByName('BZL_VYUZ'));
    PoradiHodnotyVListu[95]:=IndexOf(GetStringElementByName('BZL_DRUH'));
    PoradiHodnotyVListu[87]:=IndexOf(GetStringElementByName('JP'));
    PoradiHodnotyVListu[88]:=IndexOf(GetStringElementByName('JP_PUPFL'));
    PoradiHodnotyVListu[89]:=IndexOf(GetStringElementByName('JP_P0'));
    PoradiHodnotyVListu[90]:=IndexOf(GetStringElementByName('JP_V'));
    PoradiHodnotyVListu[91]:=IndexOf(GetStringElementByName('JP_P'));
    PoradiHodnotyVListu[92]:=IndexOf(GetStringElementByName('DRUH_POZ'));
    PoradiHodnotyVListu[93]:=IndexOf(GetStringElementByName('JP_VYUZ'));
    PoradiHodnotyVListu[94]:=IndexOf(GetStringElementByName('JP_DRUH'));

   end;
{   for i:=0 to 81 do
    begin
     if PoradiHodnotyVListu[i]=-1 then
       showmessage(inttostr(i)+'=='+inttostr(PoradiHodnotyVListu[i]))
     else
           showmessage(inttostr(i)
          +'=='+inttostr(PoradiHodnotyVListu[i])
          +'=='+NosicHlavicka.Names[PoradiHodnotyVListu[i]]);
    end;  }
  {
  GetStringElementByName(aName: string): TStringElement;
  OwnerEtaz.DrevinaMN.IndexOf(UklDrevina)
  PoradiHodnotyVListu:array [0..300] of integer;
  }

{  for i:=0 to PocetHodnotHlavicky-1 do
   begin
    showmessage('X'+NosicHlavicka.Strings[i]+'***'+NosicHlavicka.Names[i]+'x');
   end; }
 end;
constructor TPrenasecZeStandarduCiselnik.Create(ADirekSoub:String);
var i:integer;
 begin
  inherited create;
  AssignFile(FSoubStand,ADirekSoub);
  try
  reset(FSoubStand);
  readln(FSoubStand,FCtenyStr);
  except
   FPocetHodnotHlavicky:=0;
   FPocetDatovychRadku:=-1;
   exit;
  end;
  JmenoCiselniku:=CtenyStr;
  readln(FSoubStand,FCtenyStr);
  PocetHodnotHlavicky:=StrToInt(CtenyStr);
  for i:=1 to PocetHodnotHlavicky do
   begin
    readln(FSoubStand,FCtenyStr);
    NosicHlavicka.AddNameString(UpperCase(CtenyStr),'');
   end;
  readln(FSoubStand,FCtenyStr);
  oddelovacPropert:=CtenyStr[1];
  readln(FSoubStand,FCtenyStr);
  PocetDatovychRadku:=StrToInt(CtenyStr);
 end;

function StandardStringLHC(VLHC:TLHC):String;
 begin
  with VLHC do
   begin
    if ExportovatDoStandardu('LHC_KOD') then result:=inttoStr(LHC_KOD)+'@'
     else result:='';
    if ExportovatDoStandardu('LHC_NAZ') then result:=result+WinTo852Zavin(LHC_NAZ)+'@';
    if ExportovatDoStandardu('LHP_OD') then result:=result+LHP_OD+'@';
    if ExportovatDoStandardu('LHP_DO') then result:=result+LHP_DO+'@';
    if ExportovatDoStandardu('ETAT_TV') then result:=result+inttostr(ETAT_TV)+'@';
    if ExportovatDoStandardu('ETAT_TO') then result:=result+inttostr(ETAT_TO)+'@';
    if ExportovatDoStandardu('ETAT') then result:=result+inttostr(ETAT)+'@';
    if ExportovatDoStandardu('ETAT_TVYB') then result:=result+inttostr(ETAT_TVYB)+'@';
    if ExportovatDoStandardu('LHP_Z_OD') then result:=result+LHP_Z_OD+'@';
    if ExportovatDoStandardu('LHP_Z_DO') then result:=result+LHP_Z_DO+'@';
    if ExportovatDoStandardu('LHP_Z_TAX') then result:=result+WinTo852Zavin(LHP_Z_TAX)+'@';
    if ExportovatDoStandardu('LHP_TAX') then result:=result+WinTo852Zavin(LHP_TAX)+'@';
    if ExportovatDoStandardu('TEZ_PROC') then result:=result+inttostr(TEZ_PROC)+'@';
    if ExportovatDoStandardu('NOR_PAS') then result:=result+inttostr(NOR_PAS)+'@';
    if ExportovatDoStandardu('LHC_PN_PRO') then result:=result+inttostr(LHC_PN_PRO)+'@';
    if ExportovatDoStandardu('LHC_IND') then result:=result+inttostr(LHC_IND)+'@';
    if ExportovatDoStandardu('LHC_MAX') then result:=result+inttostr(LHC_MAX)+'@';
    if ExportovatDoStandardu('LHP_LIC') then result:=result+LHP_LIC+'@';
    if ExportovatDoStandardu('LHP_Z_LIC')   then result:=result+LHP_Z_LIC+'@';
    if ExportovatDoStandardu('MVYCH_DO40') then result := result + floatTOStrf1(MVYCH_DO40,ffFixed,8,2)+'@';
   end;
 end;
function StandardStringOddeleni(VOdd:TOddeleni):String;
 begin
  result:=StandardStringLHC(VOdd.OwnerLHC);
  if VOdd.ExportovatDoStandardu('ODD') then result :=result+ IntToStr(VOdd.ODD)+'@';
 end;
function StandardStringDilec(VDil:TDilec):String;
 begin
  if VDil.ExportovatDoStandardu('DIL') then result := VDil.DIL+'@'
     else Result:='';
 end;
function StandardStringPorost(VPor:TPorost):String;
 begin
     with VPor do
      begin
       if ExportovatDoStandardu('POR') then result :=POR+ '@' else result :='';
       if ExportovatDoStandardu('SDR_POR') then result :=result+SDR_POR+ '@';
       if ExportovatDoStandardu('MAJ_KOD') then result :=result+MAJ_KOD+ '@';
       if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852Zavin(MAJ_NAZ)+ '@';
       if ExportovatDoStandardu('MAJ_DRUH') then result :=result+inttostr(MAJ_DRUH)+ '@';
       if ExportovatDoStandardu('ORG_UROVEN') then
          begin
           result:=result+Org_UrovenMN.ZaSebouStr('ORG_UROVEN','&')+ '@';
          end;
       if ExportovatDoStandardu('KATEGORIE') then result :=result+kategorie1MN.ZaSebouStr('KATEGORIE','&')+'@';
       if ExportovatDoStandardu('KAT_SPEC') then result :=result+inttostr(KAT_SPEC)+ '@';
       if ExportovatDoStandardu('PAS_OHR') then result :=result+PAS_OHR + '@';
       if ExportovatDoStandardu('LES_OBL') then result :=result+uBM(LES_OBL) + '@';
       if ExportovatDoStandardu('ZVL_STATUT') then result :=result+ZVL_STATUT+ '@';
       if ExportovatDoStandardu('OLH_LIC')    then
         begin
          result :=result+OLH_LIC+ '@';
         end;
       if ExportovatDoStandardu('OLH')        then  result :=result+OLH_XML+ '@';
      end;
    end;
function StandardStringPorostText(VPor:TPorost):String;
 begin
  with VPor do
   begin
    if ExportovatDoStandardu('POR_TEXT') then result :=WinTo852Zavin(POR_TEXT_vse_BezZavin)
       else result :='';
   end;
 end;
function StandardStringBezlesi(VBzl:TBezlesi):String;
 begin
  with VBzl do
   begin
    if ExportovatDoStandardu('BZL') then result:=IntToStr(BZL)+ '@'
       else result:='';
{    neexportuje Se protoze by Byly stejn kolonky jako u porostu
     if ExportovatDoStandardu('MAJ_KOD')  then result :=result+IntToStr(MAJ_KOD)+ '@';
     if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852(MAJ_NAZ)+ '@';
     if ExportovatDoStandardu('MAJ_DRUH') then result :=result+IntToStr(MAJ_DRUH)+ '@'; }

    if ExportovatDoStandardu('KU_KOD')   then result := result+IntToStr(KU_KOD)+ '@';
    if ExportovatDoStandardu('KU_NAZ')   then result := result+WinTo852Zavin(KU_NAZ)+ '@';
    if ExportovatDoStandardu('LES_URAD') then result := result+IntToStr(LES_URAD)+ '@';
    if ExportovatDoStandardu('BZL_P0')   then result := result + floatTOStrf1(BZL_P0,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('BZL_V')    then result := result + floatTOStrf1(BZL_V,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('BZL_P')    then result := result + floatTOStrf1(BZL_P,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('KVAL_P')   then result := result + inttostr(KVAL_P)+'@';
    if ExportovatDoStandardu('KAT_PAR_KOD') then result := result + inttostr(KAT_PAR_KOD)+'@';
    if ExportovatDoStandardu('BZL_VYUZ') then result := result+WinTo852Zavin(BZL_VYUZ)+ '@';
    if ExportovatDoStandardu('BZL_DRUH') then result := result+WinTo852Zavin(BZL_DRUH)+'@';

   end;
 end;

function StandardStringCastParcely(VCastParcely:TCastParcely):String;
 begin
  with VCastParcely do
   begin
    if ExportovatDoStandardu('PAR_SKU_KN') then result:=WinTo852Zavin(PAR_SKU_KN)+ '@'
       else result:='';
    if ExportovatDoStandardu('PAR_CIS')    then result := result +WinTo852Zavin(PAR_CIS)+ '@';
    if ExportovatDoStandardu('PAR_POD')    then result := result +WinTo852Zavin(PAR_POD)+ '@';
    if ExportovatDoStandardu('PAR_DIL')    then result := result +WinTo852Zavin(PAR_DIL)+ '@';
    if ExportovatDoStandardu('CP_P0')      then result := result + inttostr(CP_P0)+'@';
    if ExportovatDoStandardu('CP_CAST')    then result := result +WinTo852Zavin(CP_CAST)+ '@';
    if ExportovatDoStandardu('PAR_P0')     then result := result + inttostr(PAR_P0)+'@';
    if ExportovatDoStandardu('PAR_V')      then result := result + inttostr(PAR_V)+'@';
    if ExportovatDoStandardu('DRUH_POZ')   then result := result +WinTo852Zavin(DRUH_POZ)+'@';
   end;
 end;


function StandardStringJinyPozemek_bez_DruhPoz(VJine:TJinyPozemek):String;
 begin
  with VJine do
   begin
    if ExportovatDoStandardu('JP') then result :=IntToStr(JP)+ '@'
       else result :='';
    if ExportovatDoStandardu('JP_PUPFL')  then result :=result+JP_PUPFL+ '@';
//    if ExportovatDoStandardu('MAJ_KOD')  then result :=result+IntToStr(MAJ_KOD)+ '@';
//    if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852Zavin(MAJ_NAZ)+ '@';
//    if ExportovatDoStandardu('MAJ_DRUH') then result :=result+IntToStr(MAJ_DRUH)+ '@';
    if ExportovatDoStandardu('KU_KOD')  then result :=result+IntToStr(KU_KOD)+ '@';
    if ExportovatDoStandardu('KU_NAZ')  then result :=result+WinTo852Zavin(KU_NAZ)+ '@';
    if ExportovatDoStandardu('LES_URAD')  then result :=result+IntToStr(LES_URAD)+ '@';
    if ExportovatDoStandardu('JP_P0') then result:=result + floatTOStrf1(JP_P0,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('JP_V') then result:=result + floatTOStrf1(JP_V,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('JP_P') then result:=result + floatTOStrf1(JP_P,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
    if ExportovatDoStandardu('KAT_PAR_KOD') then result := result + inttostr(KAT_PAR_KOD)+'@';
   end;
 end;

function StandardStringJinyPozemek(VJine:TJinyPozemek):String;
 begin
  result:=StandardStringJinyPozemek_bez_DruhPoz(VJine);
  with VJine do
   begin
    if ExportovatDoStandardu('DRUH_POZ')  then result :=result+DRUH_POZ+ '@';
    if ExportovatDoStandardu('JP_VYUZ')  then result :=result+WinTo852Zavin(JP_VYUZ)+ '@';
    if ExportovatDoStandardu('JP_DRUH')  then result :=result+WinTo852Zavin(JP_DRUH)+ '@';
   end
 end;
function StandardStringOstatni(VOstatni:TOstatni):String;
 begin
  with VOstatni do
   begin
    if ExportovatDoStandardu('OST') then result :=IntToStr(OST)+ '@'
       else result :='';
    //    if ExportovatDoStandardu('JP_PUPFL')  then result :=result+JP_PUPFL+ '@';
    //    if ExportovatDoStandardu('MAJ_KOD')  then result :=result+IntToStr(MAJ_KOD)+ '@';
    //    if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852Zavin(MAJ_NAZ)+ '@';
    //    if ExportovatDoStandardu('MAJ_DRUH') then result :=result+IntToStr(MAJ_DRUH)+ '@';
    if ExportovatDoStandardu('KU_KOD')  then result :=result+IntToStr(KU_KOD)+ '@';
    if ExportovatDoStandardu('KU_NAZ')  then result :=result+WinTo852Zavin(KU_NAZ)+ '@';
    if ExportovatDoStandardu('LES_URAD')  then result :=result+IntToStr(LES_URAD)+ '@';
    if ExportovatDoStandardu('OST_P0') then result:=result + floatTOStrf1(OST_P0,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('OST_V') then result:=result + floatTOStrf1(OST_V,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('OST_P') then result:=result + floatTOStrf1(OST_P,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
    if ExportovatDoStandardu('KAT_PAR_KOD') then result := result + inttostr(KAT_PAR_KOD)+'@';
    if ExportovatDoStandardu('DRUH_POZ')  then result :=result+DRUH_POZ+ '@';
    if ExportovatDoStandardu('OST_VYUZ')  then result :=result+WinTo852Zavin(OST_VYUZ)+ '@';
    //    if ExportovatDoStandardu('OST_DRUH')  then result :=result+WinTo852Zavin(OST_DRUH)+ '@';
   end;
 end;

function StandardStringPorostniSkupina(VSkup:TPorostniSkupina):String;
 begin
  with VSkup do
   begin
       if ExportovatDoStandardu('PSK') then result:=ubm(PSK)+'@' else result:='';
       if ExportovatDoStandardu('PSK_P0') then result:=result + floatTOStrf1(PSK_P0,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PSK_V') then result:=result + floatTOStrf1(PSK_V,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PSK_P') then result:=result + floatTOStrf1(PSK_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
       if ExportovatDoStandardu('KAT_PAR_KOD') then result := result + inttostr(KAT_PAR_KOD)+'@';
       if ExportovatDoStandardu('KU_KOD') then result:=result + inttostr(KU_KOD)+'@';
       if ExportovatDoStandardu('KU_NAZ')  then result :=result + WinTo852Zavin(KU_NAZ)+ '@';
       if ExportovatDoStandardu('LES_URAD') then result:=result + inttostr(LES_URAD)+'@';
       if ExportovatDoStandardu('SLT') then result:=result + SLT+'@';
       if ExportovatDoStandardu('LT') then result:=result + LT+'@';
       if ExportovatDoStandardu('TER_TYP') then result:=result  + TER_TYP+'@';
       if ExportovatDoStandardu('PRIB_VZD') then result:=result + inttostr(PRIB_VZD)+'@';
       if ExportovatDoStandardu('HOSP_ZP') then result:=result  + inttostr(HOSP_ZP)+'@';
       if ExportovatDoStandardu('DAN') then result:=result + DAN + '@';
      end;
    end;
function StandardStringPorostniSkupinaText(VSkup:TPorostniSkupina):String;
 begin
  with VSkup do
   begin
       if ExportovatDoStandardu('PSK_TEXT') then Result:=WinTo852Zavin(PSK_TEXT)
       else Result:='';
   end;
 end;
function StandardStringEtaz(VEtaz:TEtaz):String;
 begin
  with VEtaz do
   begin
       if ExportovatDoStandardu('ETAZ') then result:=ETAZ+'@' else result:='';
       if ExportovatDoStandardu('ETAZ_PS') then result:=result + floatTOStrf1(ETAZ_PS,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('ETAZ_PP') then result:=result + floatTOStrf1(ETAZ_PP,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('HS') then result:=result + IntToStr(HS)+'@';
       if ExportovatDoStandardu('OBMYTI') then result:=result + IntToStr(OBMYTI)+'@';
       if ExportovatDoStandardu('OBN_DOBA') then result:=result + IntToStr(OBN_DOBA)+'@';
       if ExportovatDoStandardu('POC_OBNOVY') then result:=result + IntToStr(POC_OBNOVY)+'@';
       if ExportovatDoStandardu('PROC_HS') then result:=result + IntToStr(PROC_HS)+'@';
       if ExportovatDoStandardu('MZD') then result:=result + MZDs +'@';
       if ExportovatDoStandardu('VEK') then result:=result + IntToStr(VEK)+'@';
       if ExportovatDoStandardu('ZAKM') then result:=result + IntToStr(ZAKM)+'@';
       if ExportovatDoStandardu('M_TEZ_PROC') then result:=result + IntToStr(M_TEZ_PROC)+'@';
       if ExportovatDoStandardu('ODVOZ_TEZ') then result:=result + ODVOZ_TEZ+'@';
       if ExportovatDoStandardu('M_Z_ZASOBY') then result:=result + IntToStr(M_Z_ZASOBY)+'@';
       if ExportovatDoStandardu('HOSP_TV') then result:=result + HOSP_TV +'@';
       if ExportovatDoStandardu('PRO_P') then result:=result + floatTOStrf1(PRO_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PRO_NAL') then result:=result + PRO_NAL+'@';
       if ExportovatDoStandardu('PRO_POC') then result:=result + IntToStr(PRO_POC)+'@';
       if ExportovatDoStandardu('TV_P') then result:=result + floatTOStrf1(TV_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('TV_NAL') then result:=result + TV_NAL+'@';
       if ExportovatDoStandardu('TV_POC') then result:=result + IntToStr(TV_POC)+'@';
       if ExportovatDoStandardu('TO_P') then result:=result + floatTOStrf1(TO_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('TO_NAL') then result:=result +TO_NAL+'@';
       if ExportovatDoStandardu('TO_DUVOD') then result:=result +TO_DUVOD+'@';
       if ExportovatDoStandardu('TO_ZPUSOB') then result:=result +TO_ZPUSOB+'@';
       if ExportovatDoStandardu('TVYB_P') then result:=result + floatTOStrf1(TVYB_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('TVYB_NAL') then result:=result + TVYB_NAL +'@';
       if zalesneniMN.PocetPrvku>0 then
        begin
         if ExportovatDoStandardu('ZAL_DRUH') then result:=result + zalesneniMN.Zalesneni.ZAL_DRUH+'@';
         if ExportovatDoStandardu('ZAL_P') then result:=result + floatTOStrf1(zalesneniMN.suma('ZAL_P'),ffFixed,6,2)+'@';
         if ExportovatDoStandardu('ZAL_DR') then result:=result + ZalesneniMN.ZaSebouStr('ZAL_DR','&')+'@';
         if ExportovatDoStandardu('ZAL_DR_P') then result:=result + ZalesneniMN.ZaSebouStr('ZAL_DR_P','&')+'@';
        end
       else
        begin
         if ExportovatDoStandardu('ZAL_DRUH') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_P') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_DR') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_DR_P') then result:=result +'@';
        end;
      end;
   end;
function StandardStringDrevina(VDrev:TDrevina):String;
 begin
   begin
     with VDrev  do
      begin
       if ExportovatDoStandardu('DR_ZKR') then result:=DR_ZKR+'@' else result:='';
       if ExportovatDoStandardu('DR_KOD') then result:=result + IntToStr(DR_KOD)+'@';
       if ExportovatDoStandardu('DR_PUVOD') then result:=result + DR_PUVOD+'@';
       if ExportovatDoStandardu('ZAST') then result:=result + IntToStr(ZAST)+'@';
       if ExportovatDoStandardu('VYSKA') then result:=result + IntToStr(VYSKA)+'@';
       if ExportovatDoStandardu('TLOUSTKA') then result:=result + IntToStr(TLOUSTKA)+'@';
       if ExportovatDoStandardu('BON_A') then result:=result + IntToStr(BON_A)+'@';
       if ExportovatDoStandardu('BON_R') then result:=result + IntToStr(BON_R)+'@';
       if ExportovatDoStandardu('GEN_KLAS') then result:=result + GEN_KLAS+'@';
       if ExportovatDoStandardu('VYB_STR') then result:=result + VYB_STR+'@';
       if ExportovatDoStandardu('DR_ZAS_TAB') then result:=result + IntToStr(DR_ZAS_TAB)+'@';
       if ExportovatDoStandardu('DR_ZAS_HA') then result:=result + IntToStr(DR_ZAS_HA)+'@';
       if ExportovatDoStandardu('DR_ZAS_CEL') then result:=result + IntToStr(DR_ZAS_CEL)+'@';
       if ExportovatDoStandardu('DR_KVAL') then result:=result + DR_KVAL+'@';
       if ExportovatDoStandardu('IMISE') then result:=result + IMISE +'@';
       if ExportovatDoStandardu('HMOT') then result:=result +  floatTOStrf1(HMOT,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('DR_TV') then result:=result + IntToStr(DR_TV)+'@';
       if ExportovatDoStandardu('DR_TO') then result:=result + IntToStr(DR_TO)+'@';
       if ExportovatDoStandardu('DR_TVYB') then result:=result + IntToStr(DR_TVYB)+'@';
       if poskozeniMN.PocetPrvku>0 then
        begin
         if ExportovatDoStandardu('POSKOZ_D') then result:=result + PoskozeniMN.ZaSebouStr('POSKOZ_D','&')+'@';
         if ExportovatDoStandardu('POSKOZ_R') then result:=result + PoskozeniMN.ZaSebouStr('POSKOZ_R10','&')+'@';
        end
       else
        begin
         if ExportovatDoStandardu('POSKOZ_D') then result:=result + '@';
         if ExportovatDoStandardu('POSKOZ_R') then result:=result + '@';
        end;
       if ExportovatDoStandardu('PROC_SOUS') then result:=result + IntToStr(PROC_SOUS)+'@';
      end;
    end;
 end;

(*
 function StandardStringOddeleni(VOdd:TOddeleni):String;
 begin
  with VOdd.OwnerLHC do
   begin
    if ExportovatDoStandardu('LHC_KOD') then result:=inttoStr(LHC_KOD)+'@'
     else result:='';
    if ExportovatDoStandardu('LHC_NAZ') then result:=result+WinTo852(LHC_NAZ)+'@';
    if ExportovatDoStandardu('LHP_OD') then result:=result+LHP_OD+'@';
    if ExportovatDoStandardu('LHP_DO') then result:=result+LHP_DO+'@';
   end;
  if VOdd.ExportovatDoStandardu('ODD') then result :=result+ IntToStr(VOdd.ODD)+'@';
 end;
function StandardStringDilec(VDil:TDilec):String;
 begin
  if VDil.ExportovatDoStandardu('DIL') then result := VDil.DIL+'@'
     else Result:='';
 end;
function StandardStringPorost(VPor:TPorost):String;
 begin
     with VPor do
      begin
       if ExportovatDoStandardu('POR') then result :=POR+ '@' else result :='';
       if ExportovatDoStandardu('SDR_POR') then result :=result+SDR_POR+ '@';
       if ExportovatDoStandardu('MAJ_KOD') then result :=result+inttostr(MAJ_KOD)+ '@';
       if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852(MAJ_NAZ)+ '@';
       if ExportovatDoStandardu('MAJ_DRUH') then result :=result+inttostr(MAJ_DRUH)+ '@';
       if ExportovatDoStandardu('ORG_UROVEN') then
          begin
           result:=result+Org_UrovenMN.ZaSebouStr('ORG_UROVEN','&')+ '@';
          end;
       if ExportovatDoStandardu('KATEGORIE') then result :=result+kategorieMN.ZaSebouStr('KATEGORIE','&')+'@';
       if ExportovatDoStandardu('KAT_SPEC') then result :=result+inttostr(KAT_SPEC)+ '@';
       if ExportovatDoStandardu('PAS_OHR') then result :=result+PAS_OHR + '@';
       if ExportovatDoStandardu('LES_OBL') then result :=result+uBM(LES_OBL) + '@';
       if ExportovatDoStandardu('ZVL_STATUT') then result :=result+inttostr(ZVL_STATUT)+ '@';
       if ExportovatDoStandardu('OLH') then result :=result+OLH+ '@';
      end;
    end;
function StandardStringPorostText(VPor:TPorost):String;
 begin
  with VPor do
   begin
    if ExportovatDoStandardu('POR_TEXT') then result :=WinTo852(POR_TEXT)+ '@'
       else result :='';
   end;
 end;
function StandardStringBezlesi(VBzl:TBezlesi):String;
 begin
  with VBzl do
   begin
    if ExportovatDoStandardu('BZL') then result :=IntToStr(BZL)+ '@'
       else result :='';
   { if ExportovatDoStandardu('MAJ_KOD')  then result :=result+IntToStr(MAJ_KOD)+ '@';
     if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+MAJ_NAZ+ '@';
     if ExportovatDoStandardu('MAJ_DRUH') then result :=result+IntToStr(MAJ_DRUH)+ '@'; }
    if ExportovatDoStandardu('KU_KOD')  then result :=result+IntToStr(KU_KOD)+ '@';
    if ExportovatDoStandardu('KU_NAZ')  then result :=result+WinTo852(KU_NAZ)+ '@';
    if ExportovatDoStandardu('LES_URAD')  then result :=result+IntToStr(LES_URAD)+ '@';
    if ExportovatDoStandardu('BZL_P0') then result:=result + floatTOStrf1(BZL_P0,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('BZL_V') then result:=result + floatTOStrf1(BZL_V,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('BZL_P') then result:=result + floatTOStrf1(BZL_P,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
    if ExportovatDoStandardu('BZL_VYUZ')  then result :=result+BZL_VYUZ+ '@';
   end;
 end;
function StandardStringJinyPozemek(VJine:TJinyPozemek):String;
 begin
  with VJine do
   begin
    if ExportovatDoStandardu('JP') then result :=IntToStr(JP)+ '@'
       else result :='';
    if ExportovatDoStandardu('JP_PUPFL')  then result :=result+JP_PUPFL+ '@';
    if ExportovatDoStandardu('MAJ_KOD')  then result :=result+IntToStr(MAJ_KOD)+ '@';
    if ExportovatDoStandardu('MAJ_NAZ')  then result :=result+WinTo852(MAJ_NAZ)+ '@';
    if ExportovatDoStandardu('MAJ_DRUH') then result :=result+IntToStr(MAJ_DRUH)+ '@';
    if ExportovatDoStandardu('KU_KOD')  then result :=result+IntToStr(KU_KOD)+ '@';
    if ExportovatDoStandardu('KU_NAZ')  then result :=result+WinTo852(KU_NAZ)+ '@';
    if ExportovatDoStandardu('LES_URAD')  then result :=result+IntToStr(LES_URAD)+ '@';
    if ExportovatDoStandardu('JP_P0') then result:=result + floatTOStrf1(JP_P0,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('JP_V') then result:=result + floatTOStrf1(JP_V,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('JP_P') then result:=result + floatTOStrf1(JP_P,ffFixed,6,2)+'@';
    if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
    if ExportovatDoStandardu('DRUH_POZ')  then result :=result+IntToStr(DRUH_POZ)+ '@';
    if ExportovatDoStandardu('JP_VYUZ')  then result :=result+JP_VYUZ+ '@';
   end;
 end;
function StandardStringPorostniSkupina(VSkup:TPorostniSkupina):String;
 begin
  with VSkup do
   begin
       if ExportovatDoStandardu('PSK') then result:=PSK+'@' else result:='';
       if ExportovatDoStandardu('PSK_P0') then result:=result + floatTOStrf1(PSK_P0,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PSK_V') then result:=result + floatTOStrf1(PSK_V,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PSK_P') then result:=result + floatTOStrf1(PSK_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('KVAL_P') then result:=result + inttostr(KVAL_P)+'@';
       if ExportovatDoStandardu('KU_KOD') then result:=result + inttostr(KU_KOD)+'@';
       if ExportovatDoStandardu('KU_NAZ')  then result :=result+WinTo852(KU_NAZ)+ '@';
       if ExportovatDoStandardu('LES_URAD') then result:=result + inttostr(LES_URAD)+'@';
       if ExportovatDoStandardu('SLT') then result:=result + SLT+'@';
       if ExportovatDoStandardu('LT') then result:=result + LT+'@';
       if ExportovatDoStandardu('TER_TYP') then result:=result + inttostr(TER_TYP)+'@';
       if ExportovatDoStandardu('PRIB_VZD') then result:=result + inttostr(PRIB_VZD)+'@';
       if ExportovatDoStandardu('HOSP_ZP') then result:=result + inttostr(HOSP_ZP)+'@';
       if ExportovatDoStandardu('DAN') then result:=result + DAN+'@';
      end;
    end;
function StandardStringPorostniSkupinaText(VSkup:TPorostniSkupina):String;
 begin
  with VSkup do
   begin
       if ExportovatDoStandardu('PSK_TEXT') then Result:=WinTo852(PSK_TEXT)+'@'
       else Result:='';
   end;
 end;
function StandardStringEtaz(VEtaz:TEtaz):String;
 begin
  with VEtaz do
   begin
       if ExportovatDoStandardu('ETAZ') then result:=ETAZ+'@' else result:='';
       if ExportovatDoStandardu('ETAZ_PS') then result:=result + floatTOStrf1(ETAZ_PS,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('ETAZ_PP') then result:=result + floatTOStrf1(ETAZ_PP,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('HS') then result:=result + IntToStr(HS)+'@';
       if ExportovatDoStandardu('OBMYTI') then result:=result + IntToStr(OBMYTI)+'@';
       if ExportovatDoStandardu('OBN_DOBA') then result:=result + IntToStr(OBN_DOBA)+'@';
       if ExportovatDoStandardu('POC_OBNOVY') then result:=result + IntToStr(POC_OBNOVY)+'@';
       if ExportovatDoStandardu('MZD') then result:=result + IntToStr(MZD)+'@';
       if ExportovatDoStandardu('VEK') then result:=result + IntToStr(VEK)+'@';
       if ExportovatDoStandardu('ZAKM') then result:=result + IntToStr(ZAKM)+'@';
       if ExportovatDoStandardu('M_Z_ZASOBY') then result:=result + IntToStr(M_Z_ZASOBY)+'@';
       if ExportovatDoStandardu('HOSP_TV') then result:=result + HOSP_TV +'@';
       if ExportovatDoStandardu('PRO_P') then result:=result + floatTOStrf1(PRO_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('PRO_NAL') then result:=result + IntToStr(PRO_NAL)+'@';
       if ExportovatDoStandardu('PRO_POC') then result:=result + IntToStr(PRO_POC)+'@';
       if ExportovatDoStandardu('TV_P') then result:=result + floatTOStrf1(TV_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('TV_NAL') then result:=result + IntToStr(TV_NAL)+'@';
       if ExportovatDoStandardu('TV_POC') then result:=result + IntToStr(TV_POC)+'@';
       if ExportovatDoStandardu('TO_P') then result:=result + floatTOStrf1(TO_P,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('TO_NAL') then result:=result + IntToStr(TO_NAL)+'@';
       if ExportovatDoStandardu('TO_DUVOD') then result:=result + IntToStr(TO_DUVOD)+'@';
       if zalesneniMN.PocetPrvku>0 then
        begin
         if ExportovatDoStandardu('ZAL_DRUH') then result:=result + IntToStr(zalesneniMN.Zalesneni.ZAL_DRUH)+'@';
         if ExportovatDoStandardu('ZAL_P') then result:=result + floatTOStrf1(zalesneniMN.suma('ZAL_P'),ffFixed,6,2)+'@';
         if ExportovatDoStandardu('ZAL_DR') then result:=result + ZalesneniMN.ZaSebouStr('ZAL_DR','&')+'@';
         if ExportovatDoStandardu('ZAL_DR_P') then result:=result + ZalesneniMN.ZaSebouStr('ZAL_DR_P','&')+'@';
        end
       else
        begin
         if ExportovatDoStandardu('ZAL_DRUH') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_P') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_DR') then result:=result +'@';
         if ExportovatDoStandardu('ZAL_DR_P') then result:=result +'@';
        end;
      end;
   end;
function StandardStringDrevina(VDrev:TDrevina):String;
 begin
   begin
     with VDrev  do
      begin
       if ExportovatDoStandardu('DR_ZKR') then result:=DR_ZKR+'@' else result:='';
       if ExportovatDoStandardu('DR_KOD') then result:=result + IntToStr(DR_KOD)+'@';
       if ExportovatDoStandardu('DR_PUVOD') then result:=result + DR_PUVOD+'@';
       if ExportovatDoStandardu('ZAST') then result:=result + IntToStr(ZAST)+'@';
       if ExportovatDoStandardu('VYSKA') then result:=result + IntToStr(VYSKA)+'@';
       if ExportovatDoStandardu('TLOUSTKA') then result:=result + IntToStr(TLOUSTKA)+'@';
       if ExportovatDoStandardu('BON_A') then result:=result + IntToStr(BON_A)+'@';
       if ExportovatDoStandardu('BON_R') then result:=result + IntToStr(BON_R)+'@';
       if ExportovatDoStandardu('GEN_KLAS') then result:=result + GEN_KLAS+'@';
       if ExportovatDoStandardu('VYB_STR') then result:=result + VYB_STR+'@';
       if ExportovatDoStandardu('DR_ZAS_HA') then result:=result + IntToStr(DR_ZAS_HA)+'@';
       if ExportovatDoStandardu('DR_ZAS_CEL') then result:=result + IntToStr(DR_ZAS_CEL)+'@';
       if ExportovatDoStandardu('DR_KVAL') then result:=result + DR_KVAL+'@';
       if ExportovatDoStandardu('IMISE') then result:=result + IMISE +'@';
       if ExportovatDoStandardu('HMOT') then result:=result +  floatTOStrf1(HMOT,ffFixed,6,2)+'@';
       if ExportovatDoStandardu('DR_TV') then result:=result + IntToStr(DR_TV)+'@';
       if ExportovatDoStandardu('DR_TO') then result:=result + IntToStr(DR_TO)+'@';
       if poskozeniMN.PocetPrvku>0 then
        begin
         if ExportovatDoStandardu('POSKOZ_D') then result:=result + PoskozeniMN.ZaSebouStr('POSKOZ_D','&')+'@';
         if ExportovatDoStandardu('POSKOZ_R') then result:=result + PoskozeniMN.ZaSebouStr('POSKOZ_R10','&')+'@';
        end
       else
        begin
         if ExportovatDoStandardu('POSKOZ_D') then result:=result + '@';
         if ExportovatDoStandardu('POSKOZ_R') then result:=result + '@';
        end;
       if ExportovatDoStandardu('PROC_SOUS') then result:=result + IntToStr(PROC_SOUS)+'@';
      end;
    end;
 end;        *)
function TPrenasecZeStandarduData.GetCisloOddeleni:integer;
 begin
  if konec then
   result:=32000
  else
   result:=strToIntDef(StringPodleHodnotyVListu[7],0);
   {strToInt(u0(TStringElement( NosicHlavicka.FindElementName('ODD')).text))}
 end;
function  TVyberMajitele.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TVyberMajitele.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TVyberMajiteleOr.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TVyberMajiteleOr.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;

procedure  TVyberMajiteleOr.Process(Element: TElement);
var odpovMajetek:TMajetky;
    ivp:integer;
 begin
   if Element is TPorost then
    begin
     with TPorost(Element) do
      begin
       odpovMajetek:=MajetkyMN.NajdiMAJ_DRUH_MAJ_KOD(intToStr(MAJ_DRUH),MAJ_KOD);
       if odpovMajetek=nil then
        begin
         MajetkyMN.NovyPrvekVzdy:=intToStr(MAJ_DRUH)+'-'+MAJ_KOD;
         odpovMajetek:=TMajetky(MajetkyMN.AktualniPrvek);
         odpovMajetek.MAJ_DRUH_C:=intToStr(MAJ_DRUH);
         odpovMajetek.MAJ_KOD_C:=MAJ_KOD;
         odpovMajetek.ODB_SPR_C:=OLH_XML;
         if Ciselnik.tb_Majetky<>nil then
            odpovMajetek.MAJ_NAZ_C:=DleCiselniku(Ciselnik.tb_Majetky,'MAJ_KOD',
                       MAJ_KOD,'MAJ_NAZ',false);
        end;
       if odpovMajetek.MajPoPorostechMN.NajdiMAJ_DRUH_MAJ_KOD_ODD_DIL_POR_JP_KU_KOD
         (MAJ_DRUH,MAJ_KOD,OwnerDilec.OwnerOddeleni.ODD,OwnerDilec.DIL,POR,-1,-1) = nil then
         begin
          if NacitatPoSkupinach then
           begin
            for ivp:=0 to PorostniSkupinaMN.count-1 do
             begin
              odpovMajetek.MajPoPorostechMN.NovyPrvekVzdy:=intToStr(OwnerDilec.OwnerOddeleni.ODD)+'-'+OwnerDilec.DIL+'-'+POR;
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).MAJ_DRUH:=MAJ_DRUH;
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).MAJ_KOD:=MAJ_KOD;
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).ODD:=OwnerDilec.OwnerOddeleni.ODD;
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).DIL:=OwnerDilec.DIL;
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).POR:='';
              TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).PSK:=trim(IporostniSkupina[ivp].PSK);
             end;
           end
          else
           begin
            odpovMajetek.MajPoPorostechMN.NovyPrvekVzdy:=intToStr(OwnerDilec.OwnerOddeleni.ODD)+'-'+OwnerDilec.DIL+'-'+POR;
            TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).MAJ_DRUH:=MAJ_DRUH;
            TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).MAJ_KOD:=MAJ_KOD;
            TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).ODD:=OwnerDilec.OwnerOddeleni.ODD;
            TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).DIL:=OwnerDilec.DIL;
            TMajPoPorostech(odpovMajetek.MajPoPorostechMN.AktualniPrvek).POR:=POR;
           end;
         end;
         //     (vMAJ_DRUH:Integer;vMAJ_KOD:Longint;vODD:Integer;vDIL,vPOR:string;VJP:integer;vKU_KOD:longInt):TMajPoPorostech;

      { if not TB_MajetkySeparaty.FindKey([MAJ_DRUH,MAJ_KOD]) then
        begin
         with TB_MajetkySeparaty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asinteger:=MAJ_KOD;
           post;
          end;
        end;
       if not TB_MajetkyPorosty.FindKey([        MAJ_DRUH
                                                ,MAJ_KOD
                        ,OwnerDilec.OwnerOddeleni.ODD
                                     ,OwnerDilec.DIL
                                                ,POR
                                                ,-1
                                                ,-1])
       then
        begin
         with TB_MajetkyPorosty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asinteger:=MAJ_KOD;
           FieldByName('ODD').asinteger:=OwnerDilec.OwnerOddeleni.ODD;
           FieldByName('DIL').asstring:=OwnerDilec.DIL;
           FieldByName('POR').asstring:=POR;
           FieldByName('JP').asinteger:=-1;
           FieldByName('KU_KOD').asinteger:=-1;
           post;
          end;
        end;   }
      end;
    end;
{  if Element is TJinyPozemek then
    begin
     with TJinyPozemek(element) do
      begin
       if not TB_MajetkySeparaty.FindKey([MAJ_DRUH,MAJ_KOD]) then
        begin
         with TB_MajetkySeparaty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asinteger:=MAJ_KOD;
           post;
          end;
        end;
       if not TB_MajetkyPorosty.FindKey([       MAJ_DRUH
                                               ,MAJ_KOD
           ,OwnerPorost.OwnerDilec.OwnerOddeleni.ODD
                                               ,Chr(126)
                                               ,Chr(126)
                                               ,JP
                                               ,KU_KOD])
       then
        begin
         with TB_MajetkyPorosty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asinteger:=MAJ_KOD;
           FieldByName('ODD').asinteger:=OwnerPorost.OwnerDilec.OwnerOddeleni.ODD;
           FieldByName('DIL').asstring:=Chr(126);
           FieldByName('POR').asstring:=Chr(126);
           FieldByName('JP').asinteger:=JP;
           FieldByName('KU_KOD').asinteger:=KU_KOD;
           post;
          end;
        end;
      end;
    end;    }
  end;

procedure  TVyberMajitele.Process(Element: TElement);
 begin
   if Element is TPorost then
    begin
     with TPorost(Element) do
      begin
       if not TB_MajetkySeparaty.FindKey([MAJ_DRUH,MAJ_KOD]) then
        begin
         with TB_MajetkySeparaty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asstring:=MAJ_KOD;
           post;
          end;
        end;
       if not TB_MajetkyPorosty.FindKey([        MAJ_DRUH
                                                ,MAJ_KOD
                        ,OwnerDilec.OwnerOddeleni.ODD
                                     ,OwnerDilec.DIL
                                                ,POR
                                                ,-1
                                                ,-1])
       then
        begin
         with TB_MajetkyPorosty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asString:=MAJ_KOD;
           FieldByName('ODD').asinteger:=OwnerDilec.OwnerOddeleni.ODD;
           FieldByName('DIL').asstring:=OwnerDilec.DIL;
           FieldByName('POR').asstring:=POR;
           FieldByName('JP').asinteger:=-1;
           FieldByName('KU_KOD').asinteger:=-1;
           post;
          end;
        end;
      end;
    end;
   if Element is TJinyPozemek then
    begin
     with TJinyPozemek(element) do
      begin
       if not TB_MajetkySeparaty.FindKey([MAJ_DRUH,MAJ_KOD]) then
        begin
         with TB_MajetkySeparaty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asstring:=MAJ_KOD;
           post;
          end;
        end;
       if not TB_MajetkyPorosty.FindKey([       MAJ_DRUH
                                               ,MAJ_KOD
           ,OwnerPorost.OwnerDilec.OwnerOddeleni.ODD
                                               ,Chr(126)
                                               ,Chr(126)
                                               ,JP
                                               ,KU_KOD])
       then
        begin
         with TB_MajetkyPorosty do
          begin
           insert;
           FieldByName('MAJ_DRUH').asinteger:=MAJ_DRUH;
           FieldByName('MAJ_KOD').asstring:=MAJ_KOD;
           FieldByName('ODD').asinteger:=OwnerPorost.OwnerDilec.OwnerOddeleni.ODD;
           FieldByName('DIL').asstring:=Chr(126);
           FieldByName('POR').asstring:=Chr(126);
           FieldByName('JP').asinteger:=JP;
           FieldByName('KU_KOD').asinteger:=KU_KOD;
           post;
          end;
        end;
      end;
    end;
  end;
procedure VyberPodleMajitele(VMAJ_DRUH:longint;VMAJ_KOD:string; Oddeleni:TElement);
var iDil,iPor:integer;
begin
 for idil:=TOddeleni(Oddeleni).DilecMN.count-1 downto 0 do
  begin
   with TOddeleni(Oddeleni).IDilec[iDil] do
    begin
     for Ipor:=PorostMN.count-1 downto 0 do
      begin
       if (ubm(IPorost[Ipor].MAJ_KOD)<>ubm(VMAJ_KOD))or(IPorost[Ipor].MAJ_DRUH<>VMAJ_DRUH) then
        begin
         IPorost[Ipor].free;
        end;
      end;
     if PorostMN.count=0 then free;
    end;
  end;
end;

procedure VyberPodleMajitele2(VMAJ_DRUH:longint;VMAJ_KOD:string; Oddeleni:TElement);
 var mazaciSeznam:TOwnerEntity;
     selector:TAllSelector;
     PresunMajiteleZBezlesiDoPorostu:TPresunMajiteleZBezlesiDoPorostu;
 begin

  selector:=TAllSelector.Create;
  selector.Condition:='not ((MAJ_KOD ='+VMAJ_KOD+') and (MAJ_DRUH = '+inttostr(VMAJ_DRUH)+'))';
  MazaciSeznam:=TOwnerEntity.create;
  {
  PresunMajiteleZBezlesiDoPorostu:= TPresunMajiteleZBezlesiDoPorostu.create;
  PresunMajiteleZBezlesiDoPorostu.InPut:=Oddeleni;
  PresunMajiteleZBezlesiDoPorostu.DoIt;
  PresunMajiteleZBezlesiDoPorostu.Free;
  }
  selector.InPut:=Oddeleni;
  selector.OutPut:=MazaciSeznam;
  selector.DoIt;
  selector.Free;
  with MazaciSeznam do
   begin
    while count>0 do
     begin
      if elements[count-1] is TPorost then
       begin
        with TPorost(elements[count-1]) do
         begin
          if OwnerDilec.PorostMN.count=1 then OwnerDilec.free;
         end;
        elements[count-1].free;
       end
      else
       begin
        RemoveElement(elements[count-1]);
       end;
     end;
   end;
  MazaciSeznam.free;
 end;

function  TExportStandardPP_FST.QGoInside(Element: TElement): boolean;
begin
   result := true;
end;

function  TExportStandardPP_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((element is TBezlesi)
               or(element is TJinyPozemek)
               or(element is TOstatni)
               or(element is TKategorie1MN)
               or(element is TPoskozeniMN)
               or(element is TZalesneniMN));
 end;

 function  TExportStandardLHC_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := (element is TLesniCelek);
 end;
 function  TExportStandardPSK_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((element is TBezlesi)
               or(element is TJinyPozemek)
               or(element is TOstatni)
               or(element is TKategorie1MN)
               or(element is TZvlStMN)
               or(element is TEtaz)
               );
 end;




 function  TExportStandardCPP_FST.QProcessBefore(Element: TElement): boolean;
 begin

  result :=    ((Element is TLesniCelek)
                or(Element is TOddeleni)
                or(element is TDilec)
                or(element is TPorost)
                or(element is TPorostniSkupina)
                or(element is TCastParcely)
                  );
 end;

function  TExportStandardCPJ_FST.QProcessBefore(Element: TElement): boolean;
 begin

  result :=    ((Element is TLesniCelek)
                or(Element is TOddeleni)
                or(element is TDilec)
                or(element is TPorost)
                or(element is TJinyPozemek)
                or(element is TCastParcely)
                  );
 end;

function  TExportStandardCPB_FST.QProcessBefore(Element: TElement): boolean;
 begin

  result :=    ((Element is TLesniCelek)
                or(Element is TOddeleni)
                or(element is TDilec)
                or(element is TPorost)
                or(element is TBezlesi)
                or(element is TCastParcely)
                  );
 end;

function  TExportStandardCPP_FST.QProcessAfter(Element: TElement): boolean;
 begin
  result:=false;
 end;
function  TExportStandardCPJ_FST.QProcessAfter(Element: TElement): boolean;
 begin
  result:=false;
 end;
function  TExportStandardCPB_FST.QProcessAfter(Element: TElement): boolean;
 begin
  result:=false;
 end;
function  TExportStandardCPP_FST.QGoInside(Element: TElement): boolean;
begin
  result := ((element is TLesniCelek)
            or(element is TDilecMN)
            or(element is TPorostMN)
            or(element is TPorostniSkupinaMN)
            or(element is TCastParcelyMN)
            or(Element is TOddeleni)
            or(element is TDilec)
            or(element is TPorost)
            or(element is TPorostniSkupina)
            or(element is TCastParcely)
                  );
end;
function  TExportStandardCPJ_FST.QGoInside(Element: TElement): boolean;
begin
  result := ((element is TLesniCelek)
            or(element is TDilecMN)
            or(element is TPorostMN)
            or(element is TJinyPozemekMN)
            or(element is TCastParcelyMN)
            or(Element is TOddeleni)
            or(element is TDilec)
            or(element is TPorost)
            or(element is TJinyPozemek)
            or(element is TCastParcely)
                  );
end;
function  TExportStandardCPB_FST.QGoInside(Element: TElement): boolean;
begin
  result := ((element is TLesniCelek)
            or(element is TDilecMN)
            or(element is TPorostMN)
            or(element is TBezlesiMN)
            or(element is TCastParcelyMN)
            or(Element is TOddeleni)
            or(element is TDilec)
            or(element is TPorost)
            or(element is TBezlesi)
            or(element is TCastParcely)
                  );
end;



function  TExportStandardBZL_FST.QProcessBefore(Element: TElement): boolean;
 begin

  result :=    ((Element is TLesniCelek)
                or(Element is TOddeleni)
                or(element is TDilec)
                or(element is TPorost)
                or(element is TBezlesi)
                  );
 end;
function  TExportStandardBZL_FST.QProcessAfter(Element: TElement): boolean;
 begin
  result:=false;
 end;
function  TExportStandardBZL_FST.QGoInside(Element: TElement): boolean;
begin
  result := ((element is TLesniCelek)
            or(element is TDilecMN)
            or(element is TPorostMN)
            or(element is TBezlesiMN)
            or(Element is TOddeleni)
            or(element is TDilec)
            or(element is TPorost)
            or(element is TBezlesi)
                  );
end;

function  TExportStandardJP_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((Element is TPorostniSkupina)
                or(element is TOstatni)
                or(element is TKategorie1MN)
                or(element is TZvlStMN)
                or(element is TBezlesi));
 end;

function  TExportStandardOST_FST.QProcessBefore(Element: TElement): boolean;
 begin
  result := not ((Element is TPorostniSkupina)
                or(element is TJinyPozemek)
                or(element is TKategorie1MN)
                or(element is TZvlStMN)
                or(element is TBezlesi));
 end;

 procedure TExportStandardPP_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
      begin
       Device.WritelnText('@');
       Device.WritelnText('&');
       Device.WritelnText(inttoStr(
            PocetSpolecnychElement(SeznamStandardPP_FST.StringListElement,
                                   SeznamExportStandard.StringListElement,
                                   false)));
       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardPP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;

{       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
            begin
             Device.WritelnText(elements[i].name);
            end;
          end;
        end; }

       Device.WritelnText(inttostr(PocetDrevinAHolin));
      end;
    end
   else
    begin
     if Element is TOddeleni then
      begin
       oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
      end
     else
      begin
       if Element is TDilec then
        begin
         DilecS:=StandardStringDilec(TDilec(element));
        end
       else
        begin
         if Element is TPorost then
          begin
           porostS:=StandardStringPorost(TPorost(element));
           porost_poznS :=StandardStringPorostText(TPorost(element));
          end;
         if Element is TPorostniSkupina then
          begin
           porostniSkupinaS:=StandardStringPorostniSkupina(TPorostniSkupina(Element));
           PorostniSkupina_poznS:=StandardStringPorostniSkupinaText(TPorostniSkupina(Element));
          end;
         if Element is TEtaz then
          begin
           TEtaz(element).DrevinaMN.Dopln1procentoDoRadkuBezZastoupeni;
           TEtaz(element).ZalesneniMN.Dopln1procentoDoRadkuBezZastoupeni;
           EtazS:=StandardStringEtaz(TEtaz(element));
           if TEtaz(element).DrevinaMN.pocetPrvku=0 then
            begin
             DrevinaS:=StandardStringDrevina
                   (TDrevina(TEtaz(Element).DrevinaMN.AktualniPrvekVzdy));
             TEtaz(Element).DrevinaMN.SmazEntityTridy(TDrevina);
             Device.WriteText(OddeleniS);
             Device.WriteText(DilecS);
             Device.WriteText(PorostS);
             if TEtaz(element).ExportovatDoStandardu('POR_TEXT') then
              begin
               Device.WriteText(Porost_PoznS);
               Device.WriteText('@');
              end;
             Device.WriteText(porostniSkupinaS);
             if TEtaz(element).ExportovatDoStandardu('PSK_TEXT') then
              begin
               Device.WriteText(porostniSkupina_PoznS);
               Device.WriteText('@');
              end;
             Device.WriteText(EtazS);
             Device.WritelnText(copy(DrevinaS,1,length(DrevinaS)-1));
            end;
          end;
         if Element is TDrevina then
          begin
           DrevinaS:=StandardStringDrevina(TDrevina(Element));
           Device.WriteText(OddeleniS);
           Device.WriteText(DilecS);
           Device.WriteText(PorostS);
           if TDrevina(Element).ExportovatDoStandardu('POR_TEXT') then
            begin
             Device.WriteText(Porost_PoznS);
             Device.WriteText   ('@');
            end;
           Device.WriteText(porostniSkupinaS);
           if TDrevina(Element).ExportovatDoStandardu('PSK_TEXT') then
            begin
             Device.WriteText(porostniSkupina_PoznS);
             Device.WriteText   ('@');
            end;
           Device.WriteText(EtazS);
           Device.WritelnText(copy(DrevinaS,1,length(DrevinaS)-1));
          end;
        end; {else element is tDilec}
      end; {else element is tOddeleni}
    end; {else element is tlesnicelek}
  end;

procedure TExportStandardLHC_FST.Process(Element: TElement);
 var i,i0:integer;
     LHCS:string;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardLHC_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));
       with SeznamStandardLHC_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardLHC_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
        Device.WritelnText('1');
        LHCS:=StandardStringLHC(LHC);
        Device.WritelnText(copy(LHCS,1,length(LHCS)-1));
      end;
    end;
  end;

procedure TExportStandardPSK_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardPP_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));
       with SeznamStandardPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardPP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;


{         with SeznamStandardPP_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end; }
        Device.WritelnText(inttostr(PocetSkupin));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end;
   if Element is TPorostniSkupina then
    begin
     porostniSkupinaS:=StandardStringPorostniSkupina(TPorostniSkupina(Element));
     PorostniSkupina_poznS:=StandardStringPorostniSkupinaText(TPorostniSkupina(Element));
    end;
   if Element is TEtaz then
    begin
     EtazS:=StandardStringEtaz(TEtaz(element));
    end;
   if Element is TDrevina then
    begin
     DrevinaS:=StandardStringDrevina(TDrevina(Element));
     Device.WriteText(OddeleniS);
     Device.WriteText(DilecS);
     Device.WriteText(PorostS);
     if TDrevina(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText(Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WriteText(porostniSkupinaS);
     if TDrevina(Element).ExportovatDoStandardu('PSK_TEXT') then
      begin
       Device.WritelnText(porostniSkupina_PoznS);
  {    Device.WriteText   ('@');  }
      end;
 {    Device.WriteText(EtazS);
      Device.WritelnText(DrevinaS); }
   end;
end;


procedure TExportStandardCPP_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardCPP_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));

       with SeznamStandardCPP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardCPP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
         Device.WritelnText(inttostr(PocetCastParcelyVPsk));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TPorostniSkupina then
    begin
     porostniSkupinaS:=StandardStringPorostniSkupina(TPorostniSkupina(element));
     porostniSkupina_poznS :=StandardStringPorostniSkupinaText(TPorostniSkupina(element));
    end
   else
   if Element is TCastParcely then
    begin
     CastParcelyS:=StandardStringCastParcely(TCastParcely(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TCastParcely(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WriteText     (porostniSkupinaS);
     if TCastParcely(Element).ExportovatDoStandardu('PSK_TEXT') then
      begin
       Device.WriteText   (PorostniSkupina_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WritelnText(copy(CastParcelyS,1,length(CastParcelyS)-1));
   end;
end;



procedure TExportStandardCPB_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardCPB_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));

       with SeznamStandardCPB_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardCPB_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
         Device.WritelnText(inttostr(PocetCastParcelyVBzl));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TBezlesi then
    begin
     BezlesiS:=StandardStringBezlesi(TBezlesi(element));
    end
   else
   if Element is TCastParcely then
    begin
     CastParcelyS:=StandardStringCastParcely(TCastParcely(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TCastParcely(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WriteText     (bezlesiS);
     Device.WritelnText(copy(CastParcelyS,1,length(CastParcelyS)-1));
   end;
end;


procedure TExportStandardCPJ_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardCPJ_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));

       with SeznamStandardCPJ_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardCPJ_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
         Device.WritelnText(inttostr(PocetCastParcelyVJp));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TJinyPozemek then
    begin
     JinyPozemekS:=StandardStringJinyPozemek_bez_DruhPoz(TJinyPozemek(element));
    end
   else
   if Element is TCastParcely then
    begin
     CastParcelyS:=StandardStringCastParcely(TCastParcely(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TCastParcely(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WriteText     (JinyPozemekS);
     Device.WritelnText(copy(CastParcelyS,1,length(CastParcelyS)-1));
   end;
end;



procedure TExportStandardBZL_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
    with TLesniCelek(element) do
        begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardBZL_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));

       with SeznamStandardBZL_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;

       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardBZL_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
{      with SeznamStandardBZL_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end; }
         Device.WritelnText(inttostr(PocetBezlesi));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end
   else
   if Element is TBezlesi then
    begin
     BezlesiS:=StandardStringBezlesi(TBezlesi(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TBezlesi(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WritelnText(copy(BezlesiS,1,length(BezlesiS)-1));
   end;
end;

procedure TExportStandardJP_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
      begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardJP_FST.StringListElement
                                    ,SeznamExportStandard.StringListElement
                                    ,false)));
       with SeznamStandardJP_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;
       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardJP_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;

{        with SeznamStandardJP_FST.StringListElement do
          begin
           for i:=0 to count-1 do
            begin
             if SeznamExportStandard.StringListElement.FindElementName(elements[i].name)<>nil then
              begin
               Device.WritelnText(elements[i].name);
              end;
            end;
          end;   }
        Device.WritelnText(inttostr(PocetJinychPozemku));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end;
   if Element is TJinyPozemek then
    begin
     JineS:=StandardStringJinyPozemek(TJinyPozemek(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TJinyPozemek(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WritelnText(copy(JineS,1,length(JineS)-1));
    end;
 end;

procedure TExportStandardOST_FST.Process(Element: TElement);
 var i,i0:integer;
  begin
   if element is TLesniCelek then
    begin
     with TLesniCelek(element) do
      begin
         Device.WritelnText('@');
         Device.WritelnText('&');
         Device.WritelnText(inttoStr(
             PocetSpolecnychElement(SeznamStandardOST_FST.StringListElement,
                                    SeznamExportStandard.StringListElement,
                                    false)));
       with SeznamStandardOST_FST.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamExportStandard.StringListElement.FindElementName(names[i])<>nil then
            begin
             Device.WritelnText(Names[i]);
            end;
          end;
        end;
       with SeznamExportStandard.StringListElement do
        begin
         for i:=0 to count-1 do
          begin
           if SeznamStandardOST_FST.StringListElement.FindElementName(names[i])<>nil then
            begin
             Strings[i]:='ANO';
            end
           else
            begin
             Strings[i]:='NE';
            end
          end;
        end;
        Device.WritelnText(inttostr(PocetOstatnich));
      end;
    end;
   if Element is TOddeleni then
    begin
     oddeleniS:=StandardStringOddeleni(TOddeleni(Element));
    end
   else
   if Element is TDilec then
    begin
     DilecS:=StandardStringDilec(TDilec(element));
    end
   else
   if Element is TPorost then
    begin
     porostS:=StandardStringPorost(TPorost(element));
     porost_poznS :=StandardStringPorostText(TPorost(element));
    end;
   if Element is TOstatni then
    begin
     ostS:=StandardStringOstatni(TOstatni(Element));
     Device.WriteText   (OddeleniS);
     Device.WriteText   (DilecS);
     Device.WriteText   (PorostS);
     if TJinyPozemek(Element).ExportovatDoStandardu('POR_TEXT') then
      begin
       Device.WriteText   (Porost_PoznS);
       Device.WriteText   ('@');
      end;
     Device.WritelnText(copy(OstS,1,length(OstS)-1));
    end;
 end;


function  TExportStandardCis_FST.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
procedure TExportStandardCis_FST.Process(Element: TElement);
var i:integer;
 begin
  if element is TDatabaseClass then
   begin
    with TDatabaseClass(element) do
     begin
      if NAME='Majetky' then
       begin
        Device.WritelnText('@');
        Device.WritelnText('&');
       end
      else Device.WritelnText(self.JmenoCiselniku);
      with ExportovanePolozky do
       begin
        if ExpLHC_KOD<>'' then Device.WritelnText(inttostr(count+1))
                          else Device.WritelnText(inttostr(count));
        if ExpLHC_KOD<>'' then
            Device.WritelnText('LHC_KOD');
        for i:=0 to count-1 do
         begin
          if  not(elements[i] is TStringElement) then
           begin
            continue;
           end;
          if (Input.HasPropertyByName(elements[i].name))
          or(TDatabaseClass(Input).PropertyIndex[elements[i].name]<>-1  )then
           begin
            Device.WritelnText(WinTo852Zavin(TStringElement(elements[i]).asstring));
           end;
         end;
       end; {with ExportovanePolozky}
      if NAME<>'Majetky' then Device.WritelnText('@');
      Device.WritelnText(inttostr(count));
     end;
   end;
  if element is TVirtualElement then
   begin
    with TVirtualElement(Element) do
     begin
      if ExpLHC_KOD<>'' then RadekCisS:=ExpLHC_KOD+'@'
      else RadekCisS:='';
      for i:=0 to ExportovanePolozky.count-1 do
       begin
        if  not(ExportovanePolozky.elements[i] is TStringElement) then continue;
        if (Input.HasPropertyByName(ExportovanePolozky.elements[i].name)) then
         begin
          RadekCisS:=RadekCisS+WinTo852(Input.GetPropertyStringByName(ExportovanePolozky.elements[i].name))+'@';
         end;
        if TDatabaseClass(Input).PropertyIndex[ExportovanePolozky.elements[i].name]<>-1 then
         begin
            if (ubm(self.JmenoCiselniku)='LES_OBL')and(ubm(ExportovanePolozky.elements[i].name)='KOD')
            then RadekCisS:=RadekCisS+
               ubm(WinTo852Zavin(ElementClass.DSData.dataSet.fieldByName(ExportovanePolozky.elements[i].name).asstring))+'@'
            else RadekCisS:=RadekCisS+
               WinTo852Zavin(ElementClass.DSData.dataSet.fieldByName(ExportovanePolozky.elements[i].name).asstring)+'@';
         end;
       end;
      Device.WritelnText(copy(RadekCisS,1,length(RadekCisS)-1));
     end;
   end;  {if element is TVirtualElement}
 end;
function  TExportStandardCis_FST.GetExportovanePolozky:TStringListElement;
 begin
  if FExportovanePolozky=nil then
   begin
    FExportovanePolozky:=TStringListElement.create;
    addElement(FExportovanePolozky);
   end;
  result := FExportovanePolozky;
 end;
function TPresunMajiteleZBezlesiDoPorostu.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TPresunMajiteleZBezlesiDoPorostu.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
procedure TPresunMajiteleZBezlesiDoPorostu.Process(Element: TElement);
var i:integer;
 begin
  if Element is TPorost then
   begin
    with TPorost(Element) do
     begin
      if (PorostniSkupinaMN.count=0)and(BezlesiMN.count>0) then
       begin
        if (TBezlesi(BezlesiMN.elements[0]).MAJ_KOD<>MAJ_KOD) or
              (TBezlesi(BezlesiMN.elements[0]).MAJ_DRUH<>MAJ_DRUH) then
         begin
          MAJ_KOD:=TBezlesi(BezlesiMN.elements[0]).MAJ_KOD;
          MAJ_DRUH:=TBezlesi(BezlesiMN.elements[0]).MAJ_DRUH;
          BylaProvedenaZmenaMajitele:=True;
         end;
       end;
      for i:=0 to BezlesiMN.count-1 do
       begin
        if      (MAJ_KOD <>TBezlesi(BezlesiMN.elements[i]).MAJ_KOD)
             or (MAJ_DRUH<>TBezlesi(BezlesiMN.elements[i]).MAJ_DRUH) then
         begin
          // showmessage('V bezles '+TBezlesi(BezlesiMN.elements[i]).celeOznaceni
            //     + ' je druh nebo kod majetku odlin od majetku v porostu.');
         end;
       end;
     end;
   end;
 end;
function TPrenasecZeStandarduData.GetStringPodleHodnotyVListu(aIndex: integer):string;
 begin
  if PoradiHodnotyVListu[AIndex]<0 then result:=''
  else result:=NosicHlavicka.Strings[PoradiHodnotyVListu[AIndex]];
 end;

end.
