unit Lesrecur;

interface
uses
   sysUtils, dialogs, Graphics, db,DBTables,
   T_Recurs,T_Grp,{T_Select,}
   Elements,E_Type,E_Class,
   {$IFDEF ORB40}
    E_Geometry,
   {$ELSE}
    E_Space,
   {$ENDIF}
   mat1;
   // Databaze,Times,RAS,REGISTER_TGIFIMAGE,LED,ORB40,TAX,SHP,HintShadow
type

TLesniStringListElement = class (TOwnerEntity)
 private
  FStringListElement:TStringListElement;
  FAktualniPolozka:String;
  function  GetAktualniJeVSeznamu:Boolean;
  function  GetAktualniJeVSeznamuAMaAno:Boolean;
  procedure SetStringListElement(VStringListElement:TStringListElement);
 public
  function  StringVybranych(NameDleNehozSeVybira,oddelovac:String):String;
 published
   property StringListElement:TStringListElement read FStringListElement write SetStringListElement;
   property AktualniPolozka:String     read FAktualniPolozka write FAktualniPolozka;
   property AktualniJeVSeznamu:boolean read GetAktualniJeVSeznamu stored False;
   property AktualniJeVSeznamuAMaAno:boolean read GetAktualniJeVSeznamuAMaAno stored False;
end;

TRecurursivniGroupper=class(TRecursor)
 private
  FGroupper: TGroupper;
 protected
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
 public
  property  Groupper:TGroupper read FGroupper write FGroupper;
  procedure Process(Element: TElement); override;
 end;

TPocetPrvku=class(TRecursor)
private
 FClass:TElementClass;
 FPocetElement:longInt;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
 property AClass:TElementClass read FClass write FClass;
published
 property pocetElement:longint read FpocetElement write FpocetElement;
end;

TPocetPrvkuVEntite=class(TRecursor)
private
 FClass:TElementClass;
 FEntiClass:TElementClass;
 FPocetElement:longInt;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
 property AClass:TElementClass read FClass write FClass;
 property AEntiClass:TElementClass read FEntiClass write FEntiClass;
published
 property pocetElement:longint read FpocetElement write FpocetElement;
end;

TVytvorSeznamPodleProperty=class(TRecursor)
private
 FPropertaStr:string;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
published
 property PropertaStr:string read FPropertaStr write FPropertaStr;
end;

TNastavHodnotuProperty=class(TRecursor)
private
 FPropertaStr:string;
 FHodnotaStr :string;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
published
 property PropertaStr:string read FPropertaStr write FPropertaStr;
 property HodnotaStr:string read FHodnotaStr write FHodnotaStr;
end;

TSumaPodleProperty=class(TRecursor)
private
 FPropertaStr:string;
 FSuma :Double;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
published
 property PropertaStr:string read FPropertaStr write FPropertaStr;
 property Suma :Double read FSuma write FSuma;
end;

TSumRetezecPodleProperty=class(TRecursor)
private
 FPropertaStr:string;
 FRetezec :String;
 FOddelovac:String;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
published
 property PropertaStr:string read FPropertaStr write FPropertaStr;
 property Retezec :string read FRetezec write FRetezec;
 property Oddelovac:String  read FOddelovac write FOddelovac;


end;


TSumVychovaDo40LET=class(TSumaPodleProperty)
public
 procedure Process(Element: TElement);  override;
end;
TPocetHolin=class(TPocetPrvku)
 public
 procedure Process(Element: TElement); override;
end;
TMazacTridy=class(TRecursor)
private
 FClass:TElementClass;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
 property AClass:TElementClass read FClass write FClass;
end;
TNeMazacTridy=class(TRecursor)
private
 FClass:TElementClass;
 FSeznamMazanych:TOwnerEntity;
protected
 function  QGoInside(Element: TElement): boolean; override;
 function  QProcessBefore(Element: TElement): boolean; override;
public
 procedure Process(Element: TElement); override;
 property  AClass:TElementClass read FClass write FClass;
 property  SeznamMazanych:TOwnerEntity read FSeznamMazanych;
 constructor Create; override;
end;
function  PocetSpolecnychElement(entita1,entita2:TNameEntity;hlasit:boolean):Longint;
function  PocetSouboruVAdresari(SAdresar:String):Integer;
procedure NaskladejTextDoRamecku(VCanvas:TCanvas;x1,y1,x2,y2:longint;SText:string);
procedure NactiZTabulkyHodnotyDoPrvkuPodleScriptu
              (VTable:TTable;VElement:TElement;VStringListElement:TStringListElement);
procedure UlozDoTabulkyHodnotyZPrvkuPodleScriptu
              (VTable:TDataSet;VElement:TElement;VStringListElement:TStringListElement);
function ZkontrolujTabulkuAPrvekPodleScriptu
              (VTable:TTable;VElement:TElement;VStringListElement:TStringListElement)
              :boolean;
function  SestavIndex(VTable:TTable;VStringListElement:TStringListElement;jmenoIndexu:string):boolean;

procedure NactiSeznamIniFile(Var VSeznamStandard:TLesniStringListElement;
                                 OdkudFile,odkudSection:String);

procedure SMazVsechnoKromne(var Enti:TEntity; VClass:TElementClass);
procedure pridejArea(Co,kam:tEntity);
function  VlastnikJmenem(VOwnEnt:TEntity;jmenoVlastnika:string):TEntity;

implementation

uses T_Type;

function  VlastnikJmenem(VOwnEnt:TEntity;jmenoVlastnika:string):TEntity;
var i0:integer;
 begin
  jmenoVlastnika:=uppercase(jmenoVlastnika);
  result:=nil;
  for i0:=0 to VOwnEnt.Ownerscount-1 do
   begin
    if upperCase(VOwnEnt.Owners[i0].name)=jmenoVlastnika then
     begin
      result:=VOwnEnt.Owners[i0];
      exit;
     end
    else
     begin
      result:=VlastnikJmenem(VOwnEnt.Owners[i0],jmenoVlastnika);
      if result<>nil then exit;
     end;
   end;
 end;


procedure NactiSeznamIniFile(Var VSeznamStandard:TLesniStringListElement;
                                 OdkudFile,odkudSection:String);
var IniF:TIniFileTool;
 begin
  VSeznamStandard:=TLesniStringListElement.create;
  IniF:=TIniFileTool.create;
  iniF.fileName:=OdkudFile;
  iniF.section:=odkudSection;
  VSeznamStandard.stringListElement:=iniF.ValuesElement;
  if VSeznamStandard.stringListElement=nil then
   begin
    Showmessage('Chyb soubor "'+OdkudFile
      +'" nebo v nm sekce "'+odkudSection+'".');
   end;
  inif.free;
 end;

function SestavIndex(VTable:TTable;VStringListElement:TStringListElement;jmenoIndexu:string):boolean;
var VJmenoKolonkyCislaMajitele,name1:string;
    I:integer;
 begin
  result:=false;
  VJmenoKolonkyCislaMajitele:='';
    for i:=0 to VStringListElement.count-1 do
     begin
      with TStringElement(VStringListElement.elements[i]) do
       begin
        name1:=OdPrvnihoStringu(lowercase(ubm(name)),'index:');
        if lowercase(ubm(name))<>Name1 then
         begin
          VJmenoKolonkyCislaMajitele:=VJmenoKolonkyCislaMajitele
            +Value+';';
         end; {index}
       end; {with tstringElement}
     end; {for i:=0}
  if VJmenoKolonkyCislaMajitele<>'' then VJmenoKolonkyCislaMajitele:=
    copy(VJmenoKolonkyCislaMajitele,1,length(VJmenoKolonkyCislaMajitele)-1);
  with VTable do
   begin
    close;
    try
     deleteIndex(JmenoIndexu);
    except
    end;
    try
     addindex(JmenoIndexu,VJmenoKolonkyCislaMajitele,[]);
    except
     showmessage('V tabulce '+tableName+' nelze vytvoit index "'
                 +VJmenoKolonkyCislaMajitele+'"');
     exit;
    end;
    indexName:=jmenoIndexu;
    try
     open;
    except
     showmessage('Tabulku '+tableName+' s indexem "'
                 +VJmenoKolonkyCislaMajitele+'" nelze otevt.');
     exit;
    end;
   end; {with VTable}
  result:=true;
 end;
procedure NactiZTabulkyHodnotyDoPrvkuPodleScriptu
              (VTable:TTable;VElement:TElement;VStringListElement:TStringListElement);
var i:integer;
  name1:String;
 begin
 { VTable.FindKey([GetPropertyStringByName(Name)]) }
  with VTable do
   begin
    EditKey;
    {FieldByName('LV').AsString := '107';}
    for i:=0 to VStringListElement.count-1 do
     begin
      with TStringElement(VStringListElement.elements[i]) do
       begin
        name1:=OdPrvnihoStringu(lowercase(ubm(name)),'index:');
        if lowercase(ubm(name))<>Name1 then
         begin
          if VElement.HasPropertyByName(name1) then
           begin
            FieldByName(value).asstring:=
              VElement.GetPropertyStringByName(Name1);
           end;
         end; {index}
       end; {with tstringElement}
     end; {for i:=0}
    if GotoKey then
     begin
      for i:=0 to VStringListElement.count-1 do
       begin
        with TStringElement(VStringListElement.elements[i]) do
         begin
          name1:=OdPrvnihoStringu(lowercase(ubm(name)),'index:');
          if VElement.HasPropertyByName(name1) then
           begin
            if VTable.FindField(Value)<>nil then
             begin
              VElement.SetPropertyStringByName(Name1,VTable.fieldByName(value).asstring);
             end;
           end;
         end;{TStringElement}
       end; {for i:=0 to}
     end; {if GotoKey then}
   end; {with VTable}
 end;
function ZkontrolujTabulkuAPrvekPodleScriptu
              (VTable:TTable;VElement:TElement;VStringListElement:TStringListElement)
              :boolean;
var i:integer;
  name1:String;
 begin
  result:=true;
 { VTable.FindKey([GetPropertyStringByName(Name)]) }
  with VTable do
   begin
    for i:=0 to VStringListElement.count-1 do
     begin
      with TStringElement(VStringListElement.elements[i]) do
       begin
        name1:=OdPrvnihoStringu(lowercase(ubm(name)),'index:');
        if not VElement.HasPropertyByName(name1) then
         begin
          showmessage('"'+uppercase(name1)+'" neni v natanm orbisovkm prvku.');
          result:=false;
         end
        else
         begin
          if FindField(Value)=nil then
           begin
            showmessage('"'+Value+'" nen v tabulce '+tableName);
            result:=false;
           end;
         end;
       end;{TStringElement}
     end; {for i:=0 to}
   end; {with VTable}
 end;
procedure UlozDoTabulkyHodnotyZPrvkuPodleScriptu
              (VTable:TDataSet;VElement:TElement;VStringListElement:TStringListElement);
var i:integer;
 begin
  for i:=0 to VStringListElement.count-1 do
   begin
    with TStringElement(VStringListElement.elements[i]) do
     begin
      if VElement.HasPropertyByName(Name) then
       begin
        if VTable.FindField(Value)<>nil then
         begin
          VTable.fieldByName(value).asstring:=VElement.GetPropertyStringByName(Name);
         end;
       end;
     end;
   end;
 end;
procedure NaskladejTextDoRamecku(VCanvas:TCanvas;x1,y1,x2,y2:longint;SText:string);
var SlPi,SlPif:string;
    PI,fSize:Integer;
    YRR:longint;
    nebylMenenFont:Boolean;
begin
 with VCanvas do
  begin
   fSize:=font.Size;
   repeat
    { zjisteni poctu radku - PI pocet radku, YRR sirka radku}
    slPI:=SText;
    PI:=1;
    while textwidth(slPI)>(X2-X1) do
     begin
      slpiF:=slpi;
      while textwidth(slPIf)>(X2-X1) do
       begin
        slpif:=KPoslednimuZnaku(slpif,' ');
       end;
      slPI:=copy(slpi,length(slpif)+1,length(slpi)-length(slpif));
      inc(pi);
     end;
    YRR:=(Y2-Y1) div PI;
    {nastaven psma v ppad e se to velkm psmem nevejde}
    if (YRR<textHeight(SText)) then
     begin
      Font.Size:=Font.Size-1;
      nebylMenenFont:=false;
     end
    else nebylMenenFont:=true;
   until nebylMenenFont;
   slPI:=SText;
   PI:=1;
   while textwidth(slPI)>(X2-X1) do
    begin
     slpiF:=slpi;
     while textwidth(slPIf)>(X2-X1) do
      begin
       slpif:=KPoslednimuZnaku(slpif,' ');
      end;
     TextOut(X1,Y1+round((PI-0.5)*Yrr)-textheight(slPIF) div 2,slPIF);
     slPI:=copy(slpi,length(slpif)+1,length(slpi)-length(slpif));
     inc(pi);
    end;
   TextOut(X1,Y1+round((PI-0.5)*Yrr)-textheight(slPIF) div 2,slPI);
   Font.Size:=FSize;
  end;
end;
function PocetSouboruVAdresari(SAdresar:String):Integer;
var Tsr: TSearchRec;
      V: Integer;
 begin
  result:=0;
  V:=findfirst(SAdresar,faAnyFile,tsr);
  while v=0 do
   begin
    result:=result+1;
    V:=findnext(Tsr);
   end;
 end;

function PocetSpolecnychElement(entita1,entita2:TNameEntity;hlasit:boolean):Longint;
var i:integer;
 begin
  result:=0;
  with Entita1 do
   begin
    for i:=0 to count-1 do
     begin
      if hlasit then ShowMessage('Cislo elementu '+inttoStr(i)+' '+elements[i].name);
      if Entita2.FindElementName(elements[i].name)<>nil then
       begin
        result:=result+1;
         if hlasit then showmessage('Element JE TAM '+inttoStr(result)+elements[i].name);
       end;
     end;
   end;
 end;

function TSumaPodleProperty.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function TSumaPodleProperty.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;

function TSumRetezecPodleProperty.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function TSumRetezecPodleProperty.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;


function TNastavHodnotuProperty.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function TNastavHodnotuProperty.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;

function TVytvorSeznamPodleProperty.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function TVytvorSeznamPodleProperty.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TPocetPrvku.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TPocetPrvku.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;

function  TPocetPrvkuVEntite.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TPocetPrvkuVEntite.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;

function  TMazacTridy.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TMazacTridy.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;

function  TNeMazacTridy.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
function  TNeMazacTridy.QGoInside(Element: TElement): boolean;
 begin
   if  Element=nil then
    begin
     result:=false;
     exit;
    end;
   if Element is AClass then result:=false
   else result := true;
 end;

procedure TSumaPodleProperty.Process(Element: TElement);
begin
 if Element.HasPropertyByName(propertaStr) then
  begin
{  showmessage(element.Name+' Suma='+ FloattoStr(suma)
              +' propStr='+Element.GetPropertyStringByName(PropertaStr)); }
   suma:=Suma+StrToFloat(Element.GetPropertyStringByName(PropertaStr));
  end;
end;


procedure TSumRetezecPodleProperty.Process(Element: TElement);
var
  ss:string;
begin
 if Element.HasPropertyByName(propertaStr) then
  begin
{  showmessage(element.Name+' Suma='+ FloattoStr(suma)
              +' propStr='+Element.GetPropertyStringByName(PropertaStr)); }
   if Retezec='' then
    begin
     Retezec := Element.GetPropertyStringByName(PropertaStr);
    end
   else
    begin
     ss:= Element.GetPropertyStringByName(PropertaStr);
     if pos(oddelovac + ss + oddelovac,oddelovac + Retezec + oddelovac)=0 then
      begin
       Retezec :=Retezec +oddelovac+ss;
      end;
    end;
  end;
end;

procedure TSumVychovaDo40LET.Process(Element: TElement);
begin
 if (Element.HasPropertyByName('VEK')) then
  begin
   if StrToInt(Element.GetPropertyStringByName('VEK'))<=40 then
    begin
     if (Element.HasPropertyByName('TV_P')) then
        suma:=Suma+StrToFloat(Element.GetPropertyStringByName('TV_P'));
     if (Element.HasPropertyByName('PRO_P')) then
        suma:=Suma+StrToFloat(Element.GetPropertyStringByName('PRO_P'));
    end;
  end;
end;

procedure TVytvorSeznamPodleProperty.Process(Element: TElement);
var iProp:longint;
begin
 if Element.HasPropertyByName(propertaStr) then
  begin
   Iprop:=Element.GetPropertyLongIntByName(PropertaStr);
   if not TIntegerListElement(output).ValueExists(IProp) then
    begin
     TIntegerListElement(output).AddInteger(IProp);
     TIntegerListElement(output).Elements
         [TIntegerListElement(output).count-1].name
       := element.getPropertyStringByName(propertaStr);
    end;
  end;
end;

procedure TNastavHodnotuProperty.Process(Element: TElement);
begin
 if Element.HasPropertyByName(propertaStr) then
  begin
   Element.SetPropertyStringByName(PropertaStr,HodnotaStr);
  end;
end;

procedure TPocetPrvku.Process(Element: TElement);
begin
  if Element is AClass then pocetElement:=pocetElement+1;
end;

procedure TPocetPrvkuVEntite.Process(Element: TElement);
var i,ie:integer;
begin
  if Element is AClass then
   begin
    for i:=0 to TEntity(Element).OwnersCount-1  do
     begin
      if TEntity(Element).owners[i] is AEntiClass then
       begin
        pocetElement:=pocetElement+1;
       end
      else
       begin
        for ie:=0 to TEntity(Element).owners[i].OwnersCount-1 do
         begin
          if TEntity(Element).owners[i].owners[ie] is AEntiClass then
           begin
            pocetElement:=pocetElement+1;
           end;
         end;
       end;
     end;
   end;
end;
procedure TPocetHolin.Process(Element: TElement);
begin
  if Element is AClass then
   begin
    if TOwnerEntity(Element).count=0 then
     begin
      pocetElement:=pocetElement+1;
     end;
   end;
end;
procedure TMazacTridy.Process(Element: TElement);
var i:integer;
begin
 If element is TEntity then
  begin
   with TEntity(Element)do
    begin
     for i:=count-1 downto 0 do
      begin
       if Elements[i] is AClass then
        begin
         Elements[i].Free;
        end;
      end;
    end;
  end;
end;
procedure TNeMazacTridy.Process(Element: TElement);
var i:integer;
begin
 If element is TEntity then
  begin
   with TEntity(Element)do
    begin
     for i:=count-1 downto 0 do
      begin
       if not (Elements[i] is AClass) then
        begin
         if Elements[i] is TEntity then
          begin
           if TEntity(Elements[i]).count=0 then
            begin
             Elements[i].Free;
            end;
          end;
        end;
      end;
    end;
   if TEntity(Element).count=0 then
    begin
     FSeznamMazanych.AddElement(Element);
    end;
   {
   nasel:=false;
   with TEntity(Element)do
    begin
     for i:=count-1 downto 0 do
      begin
   }

  end;
end;
function TRecurursivniGroupper.QGoInside(Element: TElement): boolean;
 begin
   result := true;
 end;
function TRecurursivniGroupper.QProcessBefore(Element: TElement): boolean;
 begin
   result := true;
 end;
procedure TRecurursivniGroupper.Process(Element: TElement);
 begin
  if element is TEntity then
   begin
    Groupper.input:=element;
    Groupper.doit;
   end;
 end;
function TLesniStringListElement.GetAktualniJeVSeznamu:Boolean;
 begin
  if StringListElement.FindElementName(AktualniPolozka)<>nil then
   begin
    result:=true
   end
  else result:=false;
 end;
function TLesniStringListElement.GetAktualniJeVSeznamuAMaAno:Boolean;
var i:integer;
 begin
  result:=false;
  aktualniPolozka:=UpperCase(AktualniPolozka);
  with StringListElement do
   begin
    for i:=0 to count-1 do
     begin
      if (UpperNames[i]=AktualniPolozka)and(Strings[i]='ANO') then
       begin
        result:=true;
        exit;
       end;
     end;
   end;
 end;
procedure TLesniStringListElement.SetStringListElement(VStringListElement:TStringListElement);
 begin
  FStringListElement:=VStringListElement;
  AddElement(VStringListElement);
 end;
function  TLesniStringListElement.StringVybranych(NameDleNehozSeVybira,oddelovac:String):String;
var I:Integer;
 begin
  NameDleNehozSeVybira:=trim(uppercase(NameDleNehozSeVybira));
  result:='';
  for I:=0 to  FStringListElement.count-1 do
   begin
    if trim(uppercase(FStringListElement.Names[i]))=NameDleNehozSeVybira then
     begin
      if result<>'' then result:=result+oddelovac;
      result:=result+FStringListElement.Strings[i];
     end;
   end;
 end;
constructor TNeMazacTridy.Create;
 begin
  inherited create;
  FSeznamMazanych:=TOwnerEntity.create;
 end;

procedure SMazVsechnoKromne(var Enti:TEntity; VClass:TElementClass);
var i:integer;
    Ent:TEntity;
 begin
  with Enti do
   begin
    i:=0;
    while i<count do
     begin
      if not(elements[i] is VClass) then
       begin
        if elements[i] is TEntity then
         begin
          Ent:=TEntity(elements[i]);
          SMazVsechnoKromne(Ent,VClass);
          if ent<>nil then inc(i);
         end;
       end
      else
       begin
        inc(i);
       end;
     end;
   end;
  if enti.count=0 then
   begin
    enti.free;
    enti:=nil;
   end
 end;
procedure pridejArea(Co,kam:tEntity);
var i:integer;
 begin
  if co is TPolyLineAreaElement then
   begin
    Kam.addelement(co);
   end
  else
   begin
    for i:=0 to co.count-1 do
     begin
      if co.Elements[i] is tEntity then
       begin
        pridejArea(TEntity(co.Elements[i]),kam);
       end;
     end;
   end;
 end;
initialization
 registerOrbisClass(TLesniStringListElement);
end.
