unit SpBzl200;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Elements, ELesObec,E_lesCel, E_lesOdd, uPrevod, U_Zobraz, dotaz, mat1,
  ExtCtrls, StdCtrls,spOchrPrir;

type
  TFBzl2000 = class(TForm)
    Panel1: TPanel;
    LOdd: TLabel;
    LDilec: TLabel;
    LPorost: TLabel;
    PBezlesi: TPanel;
    PJinePoz: TPanel;
    POstatni: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
     LesniCelek:TLesniCelek;
     stGrmBezlesi, stGrmJinyPozemek, stGrmOstatni:TStringGridMuj;
     stGrm1ODD,stGrm1DIL,stGrm1POR:TStringGridMujJednoPole;
     CobJP_DRUH,cobBZL_DRUH, cobOP_DRUH:TComboBoxCiselnikProGrid;
     procedure stGrmBezlesiSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
     procedure stGrmBezlesiEnter(Sender: TObject);
     procedure stGrmBezlesiKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmBezlesiExit(Sender: TObject);
     procedure stGrmBezlesiDblClick(Sender: TObject);
     procedure zobrFormOchrPrir(VLesniPlosnyPrvek:TLesniPlosnyPrvek;VlesniCelek:Tlesnicelek);

     procedure ZobrazCobBezlesi;

     procedure pridejBezlesi;
     procedure uberBezlesi;

     procedure stGrmJinyPozemekSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
     procedure stGrmJinyPozemekEnter(Sender: TObject);
     procedure stGrmJinyPozemekKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmJinyPozemekExit(Sender: TObject);
     procedure stGrmJinyPozemekDblClick(Sender: TObject);
     procedure ZobrazCobJinyPozemek;

     procedure pridejJinyPozemek;
     procedure uberJinyPozemek;

     procedure stGrmOstatniSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
     procedure stGrmOstatniEnter(Sender: TObject);
     procedure stGrmOstatniKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
     procedure stGrmOstatniExit(Sender: TObject);
     procedure stGrmOstatniDblClick(Sender: TObject);
     procedure ZobrazCobOstatni;

     procedure pridejOstatni;
     procedure uberOstatni;

     procedure PreZobraz;
     procedure RePaint; override;
  end;

var
  FBzl2000: TFBzl2000;

implementation

{$R *.DFM}
procedure TFBzl2000.PreZobraz;
 begin
  with LesniCelek.lhc do
   begin
    oddeleniVzdy.VlastnostiMNCreateKdyzNejsou;
    dilecVzdy.VlastnostiMNCreateKdyzNejsou;
    porostVzdy.VlastnostiMNCreateKdyzNejsou;
    // bezlesiVzdy.VlastnostiMNCreateKdyzNejsou;
    // JinyPozemekVzdy.VlastnostiMNCreateKdyzNejsou;
    // ostatniVzdy.VlastnostiMNCreateKdyzNejsou;
    with stGrm1ODD do
     begin
      ObLesPrvek:=oddeleniVzdyN;
      refresh;
     end;
    with stGrm1DIL do
     begin
      ObLesPrvek:=DilecVzdy;
      refresh;
     end;
    with stGrm1POR do
     begin
      ObLesPrvek:=porostVzdy;
      refresh;
     end;
    with stGrmBezlesi do
     begin
      ObLesMN:=PorostVzdy.BezlesiMN;
      // TVlastnostiSloupcu(VlastnostiSloupcuMN.PrvekDleJmena('BZL_MNG_REZIM')).viditelny:=false;
      mnozinuDoGriduAVlastnosti;
      if VerzeProPark1 then
       begin
       VlastnostiSloupcuMN.JmenoAktualnihoPrvku:='BZL_MNG_REZIM';
        with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
         begin
          if Nadpis='Mng.r.Nevid' then
           begin
            Nadpis:='Mng.r.';
            viditelny:=true;
            PripravZobrazeniGridu;
           end;
         end;
        mnozinuDoGriduAVlastnosti;
       end;
      PouzeCteni:=false;

     end;
    with stGrmJinyPozemek do
     begin
      ObLesMN:=PorostVzdy.JinyPozemekMN;
      // TVlastnostiSloupcu(VlastnostiSloupcuMN.PrvekDleJmena('JP_MNG_REZIM')).viditelny:=false;
      mnozinuDoGriduAVlastnosti;
      if VerzeProPark1 then
       begin
       VlastnostiSloupcuMN.JmenoAktualnihoPrvku:='JP_MNG_REZIM';
        with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
         begin
          if Nadpis='Mng.r.Nevid' then
           begin
            Nadpis:='Mng.r.';
            viditelny:=true;
            PripravZobrazeniGridu;
           end;
         end;
        mnozinuDoGriduAVlastnosti;
       end;
      PouzeCteni:=false;
     end;
    with stGrmOstatni do
     begin
      ObLesMN:=PorostVzdy.OstatniMN;
      mnozinuDoGriduAVlastnosti;
      PouzeCteni:=false;
     end;
   end;
 end;

procedure TFBzl2000.RePaint;
 begin
  inherited repaint;
  prezobraz;
 end;

procedure TFBzl2000.FormCreate(Sender: TObject);
var i:integer;
begin
  stGrm1ODD:=TStringGridMujJednoPole.Create(Self);
  with StGrm1ODD do
   begin
    Parent  := panel1;
    top     := 12;
    left    := 6;
    mheight := 19;
    mwidth  := 35;
    JmenoProperty:='ODD';
   end;
  LODD.left:=stGrm1ODD.left;
  stGrm1DIL:=TStringGridMujJednoPole.Create(Self);
  with StGrm1DIL do
   begin
    Parent  := self;
    top     := 12;
    left    := 58;
    mheight := 19;
    mwidth  := 19;
    JmenoProperty:='DIL';
   end;
  LDilec.left:=stGrm1DIL.left;

  stGrm1POR:=TStringGridMujJednoPole.Create(Self);
  with StGrm1POR do
   begin
    Parent := panel1;
    top    := 12;
    left   := 94;
    mheight := 19;
    mwidth  := 20;
    JmenoProperty:='POR';
   end;
  LPorost.left:=stGrm1POR.left;

  stGrmBezlesi:=TStringGridMuj.Create(Self);
  with StGrmBezlesi do
   begin

    name:='stGrmBezlesi';
    NastavStringGridMujNaTax200(stGrmBezlesi);
    Parent := PBezlesi;
    ZobrazeniGridu:=vybranePole;
    top    := 35;
    left   := 10;
    height := 133;
    width  := 354;
    align  := alClient;
    ObLesMN:=TBezlesiMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='Bezles';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='MAJ_KOD_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=55;
        Nadpis:='Majitel';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='MAJ_DRUH_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=30;
        Nadpis:='Dr.m.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='KU_KOD_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=70;
        Nadpis:='Katastr.zem';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='LES_URAD_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:='L..';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='BZL_P_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='Plocha';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='BZL_V_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='Vmra';
        poziceTisku:=naPravo;
       end;
      JmenoAktualnihoPrvku:='KVAL_P_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='Kv.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='BZL_VYUZ';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=150;
        Nadpis:='Zpsob vyuit';
        poziceTisku:=NaLevo;
       end;
      JmenoAktualnihoPrvku:='BZL_DRUH';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=30;
        Nadpis:='Dr.b.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='POT_VLAST_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=32;
        Nadpis:='Pot.Vl.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='SKUPPARC_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='Sk.parc.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='INV_CIS_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='Inv.s.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='CISLO_TEL_Bzl';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='sl.tel.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='LT_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='LT';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='PLT_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='PLT';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='SLT_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='SLT';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='LVS_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='LVS';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='BZL_MNG_REZIM';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=false;
        Sirka:=35;
        Nadpis:='Mng.r.Nevid';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='OCHR_PRIR_BZL';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=145;
        Nadpis:='Ochrana prody';
        poziceTisku:=uprostred;
       end;

     end;
    PripravZobrazeniGridu;
    onEnter:=stGrmBezlesiEnter;
    onKeyDown:=stGrmBezlesiKeyDown;
    onExit:=stGrmBezlesiExit;
    onDblClick:=stGrmBezlesiDblClick;
    onSelectCell:=stGrmBezlesiSelectCell;

   end;

  CobBZL_DRUH:=TComboBoxCiselnikProGrid.Create(Self);
  with CobBZL_DRUH do
    begin
     Parent := PBezlesi;;
     height := 19;
     ZpPrevodu:=dleJinehoSloupce;
     name   := 'CobBZL_DRUH';
     visible:=false;
     JmenoHlProperty:='BZL_DRUH';
     StrGrMuj:=StGrmBezlesi;
     NactiZTabulkyIJinySloupec
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\CIS_BEZL.DB','POPIS','KOD');
    end;




  stGrmJinyPozemek:=TStringGridMuj.Create(Self);
  with stGrmJinyPozemek do
   begin

    name:='stGrmJinyPozemek';
    NastavStringGridMujNaTax200(stGrmJinyPozemek);
    Parent := PJinePoz;
    ZobrazeniGridu:=vybranePole;
    top    := 35;
    left   := 10;
    height := 133;
    width  := 354;
    align  := alClient;
    ObLesMN:=TJinyPozemekMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='Jin';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='MAJ_KOD_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=48;
        Nadpis:='Majitel';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='MAJ_DRUH_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=27;
        Nadpis:='Dr.m.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='KU_KOD_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=68;
        Nadpis:='Katastr.zem';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='LES_URAD_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=34;
        Nadpis:='L..';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='JP_P_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:='Plocha';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='JP_V_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:='Vmra';
        poziceTisku:=naPravo;
       end;
      JmenoAktualnihoPrvku:='KVAL_P_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='Kv.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='JP_VYUZ';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=150;
        Nadpis:='Zpsob vyuit';
        poziceTisku:=NaLevo;
       end;
      JmenoAktualnihoPrvku:='JP_DRUH';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=26;
        Nadpis:='Dr.j.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='POT_VLAST_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=32;
        Nadpis:='Pot.Vl.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='SKUPPARC_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=38;
        Nadpis:='Sk.parc.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='DRUH_POZ_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=34;
        Nadpis:='Dr.poz.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='INV_CIS_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='Inv.s.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='CISLO_TEL_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='sl.tel.';
        poziceTisku:=uprostred;
       end;
    {
      JmenoAktualnihoPrvku:='LT_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='LT';
        poziceTisku:=uprostred;
       end; }

      JmenoAktualnihoPrvku:='LVS_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=35;
        Nadpis:='LVS';
        poziceTisku:=uprostred;
       end;


      JmenoAktualnihoPrvku:='JP_MNG_REZIM';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=false;
        Sirka:=35;
        Nadpis:='Mng.r.Nevid';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='OCHR_PRIR_JP';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=145;
        Nadpis:='Ochrana prody';
        poziceTisku:=uprostred;
       end;


     end;
    PripravZobrazeniGridu;
    onEnter:=stGrmJinyPozemekEnter;
    onKeyDown:=stGrmJinyPozemekKeyDown;
    onExit:=stGrmJinyPozemekExit;
    onDblClick:=stGrmJinyPozemekDblClick;
    onSelectCell:=stGrmJinyPozemekSelectCell;
   end;

  CobJP_DRUH:=TComboBoxCiselnikProGrid.Create(Self);
  with CobJP_DRUH do
    begin
     Parent := PJinePoz;
     height := 19;
     ZpPrevodu:=dleJinehoSloupce;
     name   := 'CobJP_DRUH';
     visible:=false;
     JmenoHlProperty:='JP_DRUH';
     StrGrMuj:=StGrmJinyPozemek;
     NactiZTabulkyIJinySloupec
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\CIS_JINE.DB','POPIS','KOD');
    end;


  stGrmOstatni:=TStringGridMuj.Create(Self);
  with stGrmOstatni do
   begin

    name:='stGrmOstatni';
    NastavStringGridMujNaTax200(stGrmOstatni);
    Parent := POstatni;
    ZobrazeniGridu:=vybranePole;
    top    := 35;
    left   := 10;
    height := 133;
    width  := 354;
    align  := alClient;
    ObLesMN:=TOstatniMN.create;
    NastavGrid;
    with VlastnostiSloupcuMN do
     begin
      for I:=0 to count-1 do
       begin
        with TVlastnostiSloupcu(elements[i]) do
         begin
          viditelny:=False;
         end;
       end;
     end;
    with VlastnostiSloupcuMN do
     begin
      JmenoAktualnihoPrvku:='OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=37;
        Nadpis:='Ostat.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='MAJ_KOD_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=48;
        Nadpis:='Majitel';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='MAJ_DRUH_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=27;
        Nadpis:='Dr.m.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='KU_KOD_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=68;
        Nadpis:='Katastr.zem';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='LES_URAD_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=34;
        Nadpis:='L..';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='OST_P_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:='Plocha';
        poziceTisku:=NaPravo;
       end;
      JmenoAktualnihoPrvku:='OST_V_st';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=40;
        Nadpis:='Vmra';
        poziceTisku:=naPravo;
       end;
      JmenoAktualnihoPrvku:='KVAL_P_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=17;
        Nadpis:='Kv.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='OST_VYUZ';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=150;
        Nadpis:='Zpsob vyuit';
        poziceTisku:=NaLevo;
       end;
      {
      JmenoAktualnihoPrvku:='JP_DRUH';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=26;
        Nadpis:='Dr.b.';
        poziceTisku:=uprostred;
       end;
      }
      JmenoAktualnihoPrvku:='OP_DRUH';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=26;
        Nadpis:='Dr.o.';
        poziceTisku:=uprostred;
       end;

      JmenoAktualnihoPrvku:='POT_VLAST_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=32;
        Nadpis:='Pot.Vl.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='SKUPPARC_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=38;
        Nadpis:='Sk.parc.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='DRUH_POZ_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=34;
        Nadpis:='Dr.poz.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='CISLO_TEL_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=45;
        Nadpis:='sl.tel.';
        poziceTisku:=uprostred;
       end;
      JmenoAktualnihoPrvku:='OCHR_PRIR_OST';
      with TVlastnostiSloupcu(VlastnostiSloupcuMN.AktualniPrvek) do
       begin
        viditelny:=true;
        Sirka:=145;
        Nadpis:='Ochrana prody';
        poziceTisku:=uprostred;
       end;

     end;
    PripravZobrazeniGridu;
    onEnter:=stGrmOstatniEnter;
    onKeyDown:=stGrmOstatniKeyDown;
    onExit:=stGrmOstatniExit;
    onDblClick:=stGrmOstatniDblClick;
    onSelectCell:=stGrmOstatniSelectCell;
   end;
  CobOP_DRUH:=TComboBoxCiselnikProGrid.Create(Self);
  with CobOP_DRUH do
    begin
     Parent := POstatni;
     height := 19;
     ZpPrevodu:=dleJinehoSloupce;
     name   := 'CobOP_DRUH';
     visible:=false;
     JmenoHlProperty:='OP_DRUH';
     StrGrMuj:=stGrmOstatni;
     NactiZTabulkyIJinySloupec
              (KPoslednimuZnaku(Application.ExeName,'\')
                                       +'\ciselnik\CIS_OST.DB','POPIS','KOD');
    end;
 end;

procedure TFBzl2000.FormShow(Sender: TObject);
begin
  PreZobraz;
end;

procedure TFBzl2000.stGrmBezlesiEnter(Sender: TObject);
begin
 with stGrmBezlesi do
  begin
   onEnter:=nil;
   if TBezlesiMN(ObLesMN).count=0 then
    begin
     pridejBezlesi;
     prezobraz;
    end
   else
    begin
     if stGrmBezlesi.col=stGrmBezlesi.ColDleProperty('OCHR_PRIR_BZL') then
      begin
       stGrmBezlesi.onSelectCell:=nil;
       zobrFormOchrPrir(TlesniPlosnyPrvek(stGrmBezlesi.objects[0,row]),lesniCelek);
       prezobraz;
       stGrmBezlesi.onSelectCell:=stGrmBezlesiSelectCell;
      end;
    end;
   onEnter:=stGrmBezlesiEnter;
  end;
end;
procedure TFBzl2000.stGrmBezlesiExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmBezlesi.onExit:=nil;
  stGrmBezlesi.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
   if stGrmBezlesi.col=stGrmBezlesi.ColDleProperty('OCHR_PRIR_BZL') then
     begin
       stGrmBezlesi.col:=1;
     end;

  with TBezlesiMN(stGrmBezlesi.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TBezlesi(elements[iC]).BZL=0 then
       begin
        TBezlesi(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmBezlesi.onExit:=stGrmBezlesiExit;
 end;
procedure TFBzl2000.zobrFormOchrPrir(VLesniPlosnyPrvek:TLesniPlosnyPrvek;VlesniCelek:Tlesnicelek);
begin
 if VLesniPlosnyPrvek<>nil then
  begin
   Application.CreateForm(TFOchrPrir,FOchrPrir);
   FOchrPrir.lesniCelek:=LesniCelek;
   FOchrPrir.LLesniPlosnyPrvek:=VLesniPlosnyPrvek;
   with FOchrPrir do
    begin
     showmodal;
     free;
    end;
   Application.ProcessMessages;
  end;
end;

procedure TFBzl2000.stGrmBezlesiSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
begin
 if acol=stGrmBezlesi.ColDleProperty('OCHR_PRIR_BZL') then
  begin
   stGrmBezlesi.ObLesMN.aktualniPrvek:=TElement(stGrmBezlesi.objects[0,arow]);
   stGrmBezlesi.onSelectCell:=nil;
   zobrFormOchrPrir(TLesniPlosnyPrvek(stGrmBezlesi.ObLesMN.aktualniPrvek),lesniCelek);
   prezobraz;
   stGrmBezlesi.onSelectCell:=stGrmBezlesiSelectCell;
  end;
end;

procedure TFBzl2000.stGrmJinyPozemekSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
begin
 if acol=stGrmJinyPozemek.ColDleProperty('OCHR_PRIR_JP') then
  begin
   stGrmJinyPozemek.ObLesMN.aktualniPrvek:=TElement(stGrmJinyPozemek.objects[0,arow]);
   stGrmJinyPozemek.onSelectCell:=nil;
   zobrFormOchrPrir(TLesniPlosnyPrvek(stGrmJinyPozemek.ObLesMN.aktualniPrvek),lesniCelek);
   prezobraz;
   stGrmJinyPozemek.onSelectCell:=stGrmJinyPozemekSelectCell;
  end;
end;

procedure TFBzl2000.stGrmOstatniSelectCell(Sender: TObject; ACol,ARow: Integer; var CanSelect: Boolean);
begin
 if acol=stGrmOstatni.ColDleProperty('OCHR_PRIR_OST') then
  begin
   stGrmOstatni.ObLesMN.aktualniPrvek:=TElement(stGrmOstatni.objects[0,arow]);
   stGrmOstatni.onSelectCell:=nil;
   zobrFormOchrPrir(TLesniPlosnyPrvek(stGrmOstatni.ObLesMN.aktualniPrvek),lesniCelek);
   prezobraz;
   stGrmOstatni.onSelectCell:=stGrmOstatniSelectCell;
  end;
end;

procedure TFBzl2000.stGrmBezlesiKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmBezlesi.onExit:=nil;
     stGrmBezlesi.DoExitPublic;
     Application.CreateForm(TdotazF1,dotazF2);
     dotazF2.caption:='Oven pkazu';
     dotazF2.label1.caption:='Mm opravdu smazat dek bezles ?';
     dotazF2.label2.caption:='';
     dotazF2.label3.caption:='';
     dotazF2.showModal;
     if dotazF2.odpoved=false then
      begin
       stGrmBezlesi.onExit:=stGrmBezlesiExit;
       dotazF2.free;
       exit;
      end;
     dotazF2.free;
     uberBezlesi;
     prezobraz;
     stGrmBezlesi.onExit:=stGrmBezlesiExit;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmBezlesi.row=stGrmBezlesi.rowcount-1 then
    begin
      stGrmBezlesi.onExit:=nil;
      stGrmBezlesi.DoExitPublic;
      pridejBezlesi;
      prezobraz;
      stGrmBezlesi.onExit:=stGrmBezlesiExit;
    end;
  end;
end;

procedure TFBzl2000.pridejBezlesi;
var IC:integer;
begin
 with LesniCelek.lhc do
  begin
   if porostKdyzJe<>nil then
    begin
     iC:=porostKdyzJe.BezlesiMN.count;
     porostKdyzJe.BezlesiMN.NovyNeboAktualniPrvek:='0';
     if iC<porostKdyzJe.BezlesiMN.count then
      begin
       BezlesiKdyzJe.BZL:=0;
       BezlesiKdyzJe.Vazba:=porostKdyzJe.Rid;
       // BezlesiKdyzJe.DoplnOchrPrirDleKategPor;
      end
     else
      begin
       showmessage('Bezlesi "0" existuje. Zobrazuji existujic bezlesi.');
      end;
    end
   else
    begin
     showmessage('Naped pidej porost.');
    end;
  end;
end;

procedure TFBzl2000.uberBezlesi;
begin
 with LesniCelek.lhc do
  begin
   if BezlesiKdyzJe<>nil then
    begin
     PorostKdyzJe.PresunDoSmazBezlesi(BezlesiKdyzJe);
     // BezlesiKdyzJe.free;
    end;
  end;
end;



procedure TFBzl2000.stGrmJinyPozemekEnter(Sender: TObject);
begin
 with stGrmJinyPozemek do
  begin
   onEnter:=nil;
   if TJinyPozemekMN(ObLesMN).count=0 then
    begin
     pridejJinyPozemek;
     prezobraz;
    end
   else
    begin
     if stGrmJinyPozemek.col=stGrmJinyPozemek.ColDleProperty('OCHR_PRIR_JP') then
      begin
       stGrmJinyPozemek.onSelectCell:=nil;
       zobrFormOchrPrir(TlesniPlosnyPrvek(stGrmJinyPozemek.objects[0,row]),lesniCelek);
       prezobraz;
       stGrmJinyPozemek.onSelectCell:=stGrmJinyPozemekSelectCell;
      end;
    end;

   onEnter:=stGrmJinyPozemekEnter;
  end;
end;
procedure TFBzl2000.stGrmJinyPozemekExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmJinyPozemek.onExit:=nil;
  stGrmJinyPozemek.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
  if stGrmJinyPozemek.col=stGrmJinyPozemek.ColDleProperty('OCHR_PRIR_JP') then
   begin
    stGrmJinyPozemek.col:=1;
   end;
  with TJinyPozemekMN(stGrmJinyPozemek.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TJinyPozemek(elements[iC]).JP=0 then
       begin
        TJinyPozemek(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmJinyPozemek.onExit:=stGrmJinyPozemekExit;
 end;

procedure TFBzl2000.stGrmJinyPozemekKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmJinyPozemek.onExit:=nil;
     stGrmJinyPozemek.DoExitPublic;
     Application.CreateForm(TdotazF1,dotazF2);
     dotazF2.caption:='Oven pkazu';
     dotazF2.label1.caption:='Mm opravdu smazat dek jinho pozemku ?';
     dotazF2.label2.caption:='';
     dotazF2.label3.caption:='';
     dotazF2.showModal;
     if dotazF2.odpoved=false then
      begin
       stGrmJinyPozemek.onExit:=stGrmJinyPozemekExit;
       dotazF2.free;
       exit;
      end;
     dotazF2.free;
     uberJinyPozemek;
     prezobraz;
     stGrmJinyPozemek.onExit:=stGrmJinyPozemekExit;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmJinyPozemek.row=stGrmJinyPozemek.rowcount-1 then
    begin
      stGrmJinyPozemek.onExit:=nil;
      stGrmJinyPozemek.DoExitPublic;
      pridejJinyPozemek;
      prezobraz;
      stGrmJinyPozemek.onExit:=stGrmJinyPozemekExit;
    end;
  end;
end;

procedure TFBzl2000.pridejJinyPozemek;
var IC:integer;
begin
 with LesniCelek.lhc do
  begin
   if porostKdyzJe<>nil then
    begin
     iC:=porostKdyzJe.JinyPozemekMN.count;
     porostKdyzJe.JinyPozemekMN.NovyNeboAktualniPrvek:='0';
     if iC<porostKdyzJe.JinyPozemekMN.count then
      begin
       JinyPozemekKdyzJe.JP:=0;
       JinyPozemekKdyzJe.Vazba:=porostKdyzJe.Rid;
       // JinyPozemekKdyzJe.DoplnOchrPrirDleKategPor;
      end
     else
      begin
       showmessage('Jin pozemek "0" existuje. Zobrazuji existujic jin pozemek.');
      end;
    end
   else
    begin
     showmessage('Naped pidej porost.');
    end;
  end;
end;

procedure TFBzl2000.uberJinyPozemek;
begin
 with LesniCelek.lhc do
  begin
   if JinyPozemekKdyzJe<>nil then
    begin
     // JinyPozemekKdyzJe.free;
     PorostKdyzJe.PresunDoSmazJinyPozemek(JinyPozemekKdyzJe);
    end;
  end;
end;


procedure TFBzl2000.stGrmOstatniEnter(Sender: TObject);
begin
 with stGrmOstatni do
  begin
   onEnter:=nil;
   if TOstatniMN(ObLesMN).count=0 then
    begin
     pridejOstatni;
     prezobraz;
    end
   else
    begin
     if stGrmOstatni.col=stGrmOstatni.ColDleProperty('OCHR_PRIR_OST') then
      begin
       stGrmOstatni.onSelectCell:=nil;
       zobrFormOchrPrir(TlesniPlosnyPrvek(stGrmOstatni.objects[0,row]),lesniCelek);
       prezobraz;
       stGrmOstatni.onSelectCell:=stGrmOstatniSelectCell;
      end;
    end;
   onEnter:=stGrmOstatniEnter;
  end;
end;

procedure TFBzl2000.stGrmOstatniExit(Sender: TObject);
var iC:integer;
    byloMeneno:boolean;
 begin
  stGrmOstatni.onExit:=nil;
  stGrmOstatni.DoExitPublic;
  iC:=0;
  byloMeneno:=false;
  if stGrmOstatni.col=stGrmOstatni.ColDleProperty('OCHR_PRIR_OST') then
    begin
      stGrmOstatni.col:=1;
    end;
  with TOstatniMN(stGrmOstatni.ObLesMN) do
   begin
    while iC<count do
     begin
      if  TOstatni(elements[iC]).OST=0 then
       begin
        TOstatni(elements[iC]).free;
        byloMeneno:=true;
       end
      else
       begin
        inc(ic);
       end;
     end;
   end;
  if byloMeneno then prezobraz;
  stGrmOstatni.onExit:=stGrmOstatniExit;
 end;

procedure TFBzl2000.stGrmOstatniKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (KEY=46) then
  begin
   if ssCtrl in shift then
    begin
     stGrmOstatni.onExit:=nil;
     stGrmOstatni.DoExitPublic;
     Application.CreateForm(TdotazF1,dotazF2);
     dotazF2.caption:='Oven pkazu';
     dotazF2.label1.caption:='Mm opravdu smazat dek ostatnho pozemku ?';
     dotazF2.label2.caption:='';
     dotazF2.label3.caption:='';
     dotazF2.showModal;
     if dotazF2.odpoved=false then
      begin
       stGrmOstatni.onExit:=stGrmOstatniExit;
       dotazF2.free;
       exit;
      end;
     dotazF2.free;

     uberOstatni;
     prezobraz;
    end;
  end;
 if (KEY=40) then
  begin
   if stGrmOstatni.row=stGrmOstatni.rowcount-1 then
    begin
      stGrmOstatni.onExit:=nil;
      stGrmOstatni.DoExitPublic;
      pridejOstatni;
      prezobraz;
      stGrmOstatni.onExit:=stGrmOstatniExit;
    end;
  end;
end;

procedure TFBzl2000.pridejOstatni;
var IC:integer;
begin
 with LesniCelek.lhc do
  begin
   if porostKdyzJe<>nil then
    begin
     iC:=porostKdyzJe.OstatniMN.count;
     porostKdyzJe.OstatniMN.NovyNeboAktualniPrvek:='0';
     if iC<porostKdyzJe.OstatniMN.count then
      begin
       OstatniKdyzJe.OST:=0;
       OstatniKdyzJe.Vazba:=porostKdyzJe.Rid;
       // OstatniKdyzJe.DoplnOchrPrirDleKategPor;
      end
     else
      begin
       showmessage('Ostatn pozemek "0" existuje. Zobrazuji existujic ostatn pozemek.');
      end;
    end
   else
    begin
     showmessage('Naped pidej porost.');
    end;
  end;
end;

procedure TFBzl2000.uberOstatni;
begin
 with LesniCelek.lhc do
  begin
   if OstatniKdyzJe<>nil then
    begin
     PorostKdyzJe.PresunDoSmazOstatni(OstatniKdyzJe);
     // OstatniKdyzJe.free;
    end;
  end;
end;

procedure TFBzl2000.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
  stGrmBezlesiExit(Nil);
  stGrmJinyPozemekExit(Nil);
  stGrmOstatniExit(Nil);
  Application.ProcessMessages;
 end;

procedure TFBzl2000.stGrmBezlesiDblClick(Sender: TObject);
 begin
  if stGrmBezlesi.col=stGrmBezlesi.ColDleProperty('BZL_DRUH') then
   begin
    stGrmBezlesi.onExit:=nil;
    Application.ProcessMessages;
    if not (LesniCelek.LHC.BezlesiVzdy.BZL_DRUHvPoradku) then
     begin
      LesniCelek.LHC.BezlesiVzdy.BZL_DRUH:='';
      stGrmBezlesi.prekresli;
     end;
    ZobrazCobBezlesi;

    Application.ProcessMessages;
    stGrmBezlesi.onExit:=stGrmBezlesiExit;
   end;
 end;
procedure TFBzl2000.ZobrazCobBezlesi;
var Acol,Arow:integer;
 begin
  with CobBZL_DRUH do
   begin
    if not visible then
     begin
      acol:=stgrmBezlesi.col;
      arow:=stgrmBezlesi.row;
      left   :=stGrmBezlesi.left+stGrmBezlesi.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=pBezlesi.width-left-5;
      Top    :=stGrmBezlesi.Top+stGrmBezlesi.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobBZL_DRUH;
   end;
 end;

procedure TFBzl2000.stGrmJinyPozemekDblClick(Sender: TObject);
 begin
  if stGrmJinyPozemek.col=stGrmJinyPozemek.ColDleProperty('JP_DRUH') then
   begin
    if not (LesniCelek.LHC.JinyPozemekVzdy.JP_DRUHvPoradku) then
     begin
      LesniCelek.LHC.JinyPozemekVzdy.JP_DRUH:='';
      stGrmJinyPozemek.prekresli;
     end;
    ZobrazCobJinyPozemek;
    Application.ProcessMessages;
    stGrmJinyPozemek.onExit:=stGrmJinyPozemekExit;
   end;
 end;

procedure TFBzl2000.ZobrazCobJinyPozemek;
var Acol,Arow:integer;
 begin
  with CobJP_DRUH do
   begin
    if not visible then
     begin
      acol:=stgrmJinyPozemek.col;
      arow:=stgrmJinyPozemek.row;
      left   :=stGrmJinyPozemek.left+stGrmJinyPozemek.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=pJinePoz.width-left-5;
      Top    :=stGrmJinyPozemek.Top+stGrmJinyPozemek.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobJP_DRUH;
   end;
 end;

procedure TFBzl2000.stGrmOstatniDblClick(Sender: TObject);
 begin
  if stGrmOstatni.col=stGrmOstatni.ColDleProperty('OP_DRUH') then
   begin
    if not (LesniCelek.LHC.OstatniVzdy.OP_DRUHvPoradku) then
     begin
      LesniCelek.LHC.OstatniVzdy.OP_DRUH:='';
      stGrmOstatni.prekresli;
     end;
    ZobrazCobOstatni;
    Application.ProcessMessages;
    stGrmOstatni.onExit:=stGrmOstatniExit;
   end;
 end;

procedure TFBzl2000.ZobrazCobOstatni;
var Acol,Arow:integer;
 begin
  with CobOP_DRUH do
   begin
    if not visible then
     begin
      acol:=stgrmOstatni.col;
      arow:=stgrmOstatni.row;
      left   :=stGrmOstatni.left+stGrmOstatni.colLeft[aCol+1]; // ColLeft[1]; //
      width  :=pOstatni.width-left-5;
      Top    :=stGrmOstatni.Top+stGrmOstatni.RowHeights[0];
      DroppedDown:=true;
      visible:=true;
     end;
    activeControl:=CobOP_DRUH;
   end;
 end;

end.
