unit U_ZobrComb;

interface

uses Grids,Windows,classes,stdctrls,graphics,Messages,
     Elements, forms,controls,
     ELesObec,E_LesCel,U_Zobraz, E_LesOdd,
     DBTables,DB;

type
TComboBoxMujOdd=class(TComboBox)
 protected
  FUkladatOddeleni:Boolean;
  FObLesniCelek:TLesniCelek;
  procedure SetObLesniCelek(A:TLesniCelek);
  procedure Change;  override;
  // procedure DropDown;  override;
 public
  procedure SeznamOddeleniDoItems;
  property  ObLesniCelek:TLesniCelek read FObLesniCelek write SetObLesniCelek;
  property  UkladatOddeleni:Boolean read FUkladatOddeleni write FUkladatOddeleni;
  procedure Repaint; override;
  constructor Create(AOwner: TComponent); override;
 end;

function DotazUlozOddeleni(ObLesniCelek:TLesniCelek):boolean;
procedure DotazUlozANactiOddeleni(VForm:TForm;ObLesniCelek:TLesniCelek;VText:String;UkladatOddeleni:boolean);

implementation
uses  U_Props,dialogs,sysutils,Dotaz;

procedure DotazUlozANactiOddeleni(VForm:TForm;ObLesniCelek:TLesniCelek;VText:String;UkladatOddeleni:boolean);
var
 VOdd,puvOdd:TOddeleni;
 konfliktVBarvach:boolean;
 puvNechavatJenJedenPrvek:Boolean;
 begin
  VForm.enabled:=false;
  PuvOdd:=ObLesniCelek.LHC.Oddeleni;
  application.ProcessMessages;
  puvNechavatJenJedenPrvek:=ObLesniCelek.LHC.OddeleniMN.NechavatJenJedenPrvek;
  ObLesniCelek.LHC.OddeleniMN.NechavatJenJedenPrvek:=false;
  application.ProcessMessages;
  vOdd:=ObLesniCelek.OddeleniDleCisla1(strtoInt(VText));
  application.ProcessMessages;
  ObLesniCelek.LHC.OddeleniMN.aktualniPrvek:=PuvOdd;
  application.ProcessMessages;
  VOdd.DoplnBarvy(konfliktVBarvach);
  application.ProcessMessages;
  if konfliktVBarvach then showmessage('Konflikt v barvch');
  if VOdd=nil then
   begin
      showmessage('Vybran oddlen neexistuje.');
      VForm.enabled:=true;
   end
  else
   begin
  application.ProcessMessages;
    if UkladatOddeleni then DotazUlozOddeleni(ObLesniCelek);
  application.ProcessMessages;
    ObLesniCelek.LHC.OddeleniMN.aktualniPrvek:=VOdd;
  application.ProcessMessages;
    ObLesniCelek.LHC.OddeleniMN.NechavatJenJedenPrvek:=puvNechavatJenJedenPrvek;
  application.ProcessMessages;
    PuvOdd.free;
  application.ProcessMessages;
{
    with TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek) do
     begin
      if BylEditovanNeboNoveVytvorenRekurz or MaSmazanyRekurz then
       begin
        Application.CreateForm(TdotazF1,dotazF2);
        dotazF2.caption:='Dotaz na uloen.';
        dotazF2.label1.caption:='V oddlen '+inttostr(ODD)+' byly provedeny zmny .';
        dotazF2.label2.caption:='Maj se zmny uloit ?';
        dotazF2.label3.caption:='';
        dotazF2.ActiveControl:=dotazF2.OKBtn;
        dotazF2.showModal;
        if dotazF2.odpoved=true then
         begin
          TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek).DoplnZpZdPodleBarev;
          if not(obLesniCelek.UlozZnovuOddeleni(TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek))) then
           begin
            showmessage('Nepodailo se uloit stvajc oddlen.');
            VForm.enabled:=true;
            exit;
           end;
         end;
        dotazF2.free;
       end; }
    // ObLesniCelek.LHC.OddeleniMN.AddElement(VOdd);
   end;
   VForm.enabled:=true;
  application.ProcessMessages;
   VForm.refresh;
  application.ProcessMessages;
 end;

procedure TComboBoxMujOdd.Change;
 begin
  TForm(owner).enabled:=false;
  inherited change;
  DotazUlozANactiOddeleni(TForm(owner),ObLesniCelek,text,UkladatOddeleni);
 end;
 constructor TComboBoxMujOdd.Create(AOwner: TComponent);
  begin
   inherited Create(AOwner);
   Style:=csDropDownList;
   UkladatOddeleni:=true;
  end;
procedure TComboBoxMujOdd.SetObLesniCelek(A:TLesniCelek);
 begin
  FObLesniCelek:=A;
  SeznamOddeleniDoItems;
 end;
procedure TComboBoxMujOdd.SeznamOddeleniDoItems;
 var i:integer;
 begin
  items.clear;
  if FObLesniCelek=nil then exit;
  for i:=0 to ObLesniCelek.SeznamOddeleni.count-1 do
   begin
    items.Add(ObLesniCelek.SeznamOddeleni.Strings[i]);
   end;
  ItemIndex:=0;
 end;
procedure  TComboBoxMujOdd.Repaint;
 begin
  if FObLesniCelek=nil then
   begin
    inherited repaint;
   end;
 end;
function DotazUlozOddeleni(ObLesniCelek:TLesniCelek):boolean;
var VOdpoved:boolean;
 begin
  if uRadButTlac then exit;
    with TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek) do
     begin
      if BylEditovanNeboNoveVytvorenRekurz or MaSmazanyRekurz then
       begin
        if ptatSeNaUkladani1 then
         begin
          Application.CreateForm(TdotazF1,dotazF2);
          dotazF2.caption:='Dotaz na uloen.';
          dotazF2.label1.caption:='V oddlen '+inttostr(ODD)+' byly provedeny zmny .';
          dotazF2.label2.caption:='Maj se zmny uloit ?';
          dotazF2.label3.caption:='';
          dotazF2.ActiveControl:=dotazF2.OKBtn;
          dotazF2.showModal;
          VOdpoved:=dotazF2.odpoved;
          dotazF2.free;
         end
        else
         begin
          VOdpoved:=true;
         end;
        if VOdpoved=true then
         begin
          TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek).DoplnZpZdPodleBarev;
          if not(obLesniCelek.UlozZnovuOddeleni(TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek))) then
           begin
            showmessage('Nepodailo se uloit stvajc oddlen.');
            result:=false;
            exit;
           end
          else
           begin
            result:=true;
           end;
         end
        else
         begin
          result:=false;
         end;
       end
      else
       begin
        result:=true;
       end;
     end;
 end;


end.
