unit U_Zobraz;

interface

uses Grids,Windows,classes,stdctrls,graphics,Messages,
     Elements, forms,controls,
     ELesObec,EHledAChyb,
     DBTables,DB;

const
 kr=7;

type
 TZobrazeniGridu=(nic,vybranePole,vybranyRadek,vybranySloupec);
 TZpPrevodu=(DoPomlcky,OdPomlcky,JedenSl,dleJinehoSloupce,DleJinehoSlCisla);
 TsetridCombo=( sDoPomlcky, sOdPomlcky, BezOhleduNaPomlcku);
 TStringGridMuj = class;
 TStringGridMujElement = class(TOwnerElement)
  private
    alesponJednaAkceProvedena1,alesponJednaAkceProvedena2:Boolean;
    FStrGrMuj: TStringGridMuj;
    procedure SetStrGrMuj(const Value: TStringGridMuj);
 public
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   property   StrGrMuj:  TStringGridMuj read FStrGrMuj write SetStrGrMuj;
 end;


 TStringGridMujJednoPole = class;
 TStringGridMujJednoPoleElement = class(TOwnerElement)
  private
    alesponJednaAkceProvedena1,alesponJednaAkceProvedena2:Boolean;
    FStrGrPol: TStringGridMujJednoPole;
    procedure SetStrGrPol(const Value: TStringGridMujJednoPole);
    function  GetAlesponJednaAkceProvedena:Boolean;
 public
   procedure  HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
   property   StrGrPol:  TStringGridMujJednoPole read FStrGrPol write SetStrGrPol;
   property   alesponJednaAkceProvedena: boolean read GetAlesponJednaAkceProvedena;
 end;

 TCheckBoxNactLED = class(TCheckBox)
  private
   FPozadovaneNacteniZLedu:SPozadovaneNacteniZLedu;
   FVysvetleni:String;
  protected
   procedure Click; override;
  public
   infoMemo:TMemo;
   constructor Create(AOwner: TComponent); override;
  published
   property PozadovaneNacteniZLedu: SPozadovaneNacteniZLedu read FPozadovaneNacteniZLedu write FPozadovaneNacteniZLedu;
   property Vysvetleni:String read FVysvetleni write FVysvetleni;
 end;

 TStringGridMujJednoPole = class(TStringGrid)
 private
   FPoziceTisku:TPoziceTisku;
   FObLesPrvek:TObecnyLesniPrvek;
   FJmenoProperty:String;
   FDoubleWidth:integer;
   FDoublePrec:integer;
   FmenitRowHeights:boolean;
   FPouzeCteni:boolean;
   FMElement: TStringGridMujJednoPoleElement;

   FPocetZnaku:integer;
   FDesMista:integer;
   FTypPolozky:char;

   function  GetObLesPrvek  :TObecnyLesniPrvek;
   function  getStringProperty:string;
   procedure setStringProperty(AStringProperty:string);
   function  getMheight:Integer;
   procedure setMheight(Aheight:Integer);
   function  getMwidth:Integer;
   procedure setMwidth(Awidth:Integer);
   Procedure SetPouzeCteni(VPouzeCteni:Boolean);
   function  GetPouzeCteni:boolean;
    procedure SetMElement(const Value: TStringGridMujJednoPoleElement);
 protected
   procedure DrawCell(ACol, ARow: Longint; ARect: TRect;
      AState: TGridDrawState); override;
   procedure DoExit;  override;
   procedure SetEditText(ACol, ARow: Longint; const Value: string); override;
   function  GetEditText(ACol, ARow: Longint): string;  override;
   procedure KeyDown(var Key: Word; Shift: TShiftState); override;
   procedure KeyPress(var Key: Char); override;
   property  MElement: TStringGridMujJednoPoleElement read FMElement write SetMElement;
 public
   meniloSe  :Boolean;
   DelatExit:boolean;
   procedure prekresli;
   procedure CellDoProperty;   virtual;
   procedure PropertuDoCell;
   procedure DoExitPublic;
   property  ObLesPrvek:TObecnyLesniPrvek read GetObLesPrvek write FObLesPrvek;
   property  MenitRowHeights:Boolean read FmenitRowHeights write FmenitRowHeights;
   procedure Repaint; override;
   constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
 published
   property PoziceTisku:TPoziceTisku read FPoziceTisku write FPoziceTisku;
   property DoubleWidth:integer read FDoubleWidth write FDoubleWidth;
   property DoublePrec:integer read FDoublePrec write FDoublePrec;
   property JmenoProperty:String read FJmenoProperty write FJmenoProperty;
   property StringProperty:String read getStringProperty write setStringProperty;
   property Mheight:Integer read  getMheight write setMheight;
   property Mwidth:Integer read  getMwidth write setMwidth;
   Property PouzeCteni:Boolean read GetPouzeCteni write SetPouzeCteni;

   property PocetZnaku:integer read FPocetZnaku write FPocetZnaku;
   property TypPolozky:char read FTypPolozky write FTypPolozky;  //I-integer, F-extended
   property DesMista:integer read FDesMista write FDesMista;
 end;

 {
 TStringGridMujJednoPoleODD = class(TStringGridMujJednoPole)
 private
  FObLesniCelek:TLesniCelek;
 public
  property  ObLesniCelek:TLesniCelek read FObLesniCelek write FObLesniCelek;
  procedure CellDoProperty;   override;
 published
 end;
 }


TStringGridMuj = class(TStringGrid)
 private
   FZobrazeniGridu:TZobrazeniGridu;
   FTitleFont: TFont;
   FtitleColor:TColor;
   FprvniRadaHeigth: integer;
   FObLesMN:TLesniMnozina;
   FVlastnostiSloupcuMN:TVlastnostiSloupcuMN;
   FmenitRowHeights:Boolean;
   FBylMenen:Boolean;
   FSelektivniZobrazeni:Boolean;
   FAktualniPrGridu:TElement;
   FDrzetRowVOknePoMnozineDoGridu:Boolean;
   FVybiraloSe:Boolean;
   FPredEntremBylaZmena:Boolean;
   FMElement: TStringGridMujElement;
   Procedure SetPouzeCteni(VPouzeCteni:Boolean);
   function  GetPouzeCteni:boolean;
   Procedure SetKontrolovatSdileni(VKontrolovatSdileni:Boolean);
   function  GetKontrolovatSdileni:Boolean;
   function  GetAktualniPrGridu:TElement;
   function  GetColLeft(VCol:integer):longInt;
   function  GetRowTop(VRow:integer):longInt;
   procedure SetLRow(VLRow:longInt);
   function  GetLRow:longInt;
   procedure SetMElement(const Value: TStringGridMujElement);
 protected
   procedure DrawCell(ACol, ARow: Longint; ARect: TRect;
             AState: TGridDrawState); override;
   procedure SetEditText(ACol, ARow: Longint; const Value: string); override;
   procedure DoExit;  override;
   procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
   procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
   procedure KeyDown(var Key: Word; Shift: TShiftState); override;
   procedure KeyPress(var Key: Char); override;
   function  SelectCell(ACol, ARow: Longint): Boolean;  override;

 public
   XMysDown, YMysDown:longint;
   AkcePoSelect:boolean;
   constructor Create(AOwner: TComponent); override;
   procedure Repaint; override;
   procedure prekresli;
   function   RowAktualnihoPrvku:integer;
   function    VybranyCell(ACol, ARow: Longint):boolean;
   function    ColDleProperty(VProperty:string):integer;
   procedure  DoExitPublic;
   procedure  PripravZobrazeniGridu;
   procedure  PripravZobrazeniGriduDlePomeruStran(PuvodniSirka,NovaSirka:integer);
   procedure  UpravGrid; Virtual;
   procedure  NastavGrid; Virtual;
   procedure  MnozinuZGridu;
   procedure  MnozinuDoGridu;
   procedure  MnozinuDoGriduAVlastnosti;
   procedure  CellDoPropert;
   procedure  SmazRadek;
   procedure  PridejRadek;
   procedure  ZkopirujRadek;
   procedure  aktRowDoViditelCasti;
   procedure  SetridPodleProperty(SProperty:String;vzestupne:Boolean);
   procedure  SetridPodlePropertyLongInt(SProperty:String; vzestupne:Boolean);
   property   ObLesMN:TLesniMnozina read FObLesMN write FObLesMN;
   property   AktualniPrGridu:TElement read GetAktualniPrGridu write FAktualniPrGridu;
   property   VlastnostiSloupcuMN:TVlastnostiSloupcuMN read FVlastnostiSloupcuMN;
   property   ZobrazeniGridu:TZobrazeniGridu read FZobrazeniGridu write FZobrazeniGridu;
   property   MenitRowHeights:Boolean read FmenitRowHeights write FmenitRowHeights;
   property   BylMenen:Boolean read FBylMenen write FBylMenen;
   property   SelektivniZobrazeni:Boolean  read FSelektivniZobrazeni write FSelektivniZobrazeni;
   Property   ColLeft[VCol:integer]:longInt read GetColLeft;
   Property   RowTop[VRow:integer]:longInt read GetRowTop;
   property   MElement: TStringGridMujElement read FMElement write SetMElement;
   destructor  Destroy; override;
 published
   property   VybiraloSe:Boolean         read FVybiraloSe           write FVybiraloSe;
   property   PrvniRadaHeigth:integer    read FPrvniRadaHeigth      write FPrvniRadaHeigth;
   property   TitleFont: TFont           read FTitleFont            write FTitleFont;
   property   TitleColor:TColor          read FTitleColor           write FTitleColor;
   Property   PouzeCteni:Boolean         read GetPouzeCteni         write SetPouzeCteni;
   Property   KontrolovatSdileni:Boolean read GetKontrolovatSdileni write SetKontrolovatSdileni;
   Property   DrzetRowVOknePoMnozineDoGridu:Boolean read FDrzetRowVOknePoMnozineDoGridu write FDrzetRowVOknePoMnozineDoGridu;
   Property   LRow:longint               read GetLRow write SetLRow;
   // Property   MujTopRow:Longint read FMujTopRow  write FMujTopRow;
   // Property   RowDrzetVTopRow:boolean read FRowDrzetVTopRow write FRowDrzetVTopRow;
 end;

 TComboBoxMuj=class(TComboBox)
 private
  FZpPrevodu:TZpPrevodu;
  procedure SetZpPrevodu (VZpPrevodu:TZpPrevodu);
  function  GetHledanyStr:String; virtual;
 protected
  procedure DropDown;  override;
 public
  VSkItemIndex,VSkItemIndex1,VSkItemIndex2,VItemIndex:integer;
  VVyslStr,VItem,VhlStr:string;

  FVyslStringS:TStringList;
  procedure setrid(dlePomlcky:TsetridCombo; Vzestupne:Boolean);
  procedure NactiZTabulky(TabulkaVcetneCesty,sloupecek:String);
  procedure NactiZTabulkyIJinySloupec(TabulkaVcetneCesty,sloupecek,JinySloupec:String);
  property  ZpPrevodu:TZpPrevodu read FZpPrevodu write SetZpPrevodu;
 published
  property  HledanyStr:string read GetHledanyStr;
 end;




TComboBoxCiselnikProGrid=class(TComboBoxMuj)
 private
  FStrGrMuj:TStringGridMuj;
  FJmenoHlProperty:String;
  function  GetHledanyStr:String; override;
 protected
  procedure KeyPress(var Key: Char); override;
  procedure Change;  override;
  procedure DoExit;  override;
 public
  property  StrGrMuj:TStringGridMuj read FStrGrMuj write FStrGrMuj;
 published
   property JmenoHlProperty:String read FJmenoHlProperty write FJmenoHlProperty;
 end;

TComboBoxCiselnikProTabulku=class(TComboBoxMuj)
 private
  FsloupecTabulkyProVkl:String;
  FsloupecTabulkyProCelyNaz:String;
  FsloupecTabulkyProZnacku:String;
  FZnacka:String;
 protected
  procedure Change;  override;
  procedure DoExit;  override;
 public
  tabulkaProVkl:TTable;
  // constructor Create(AOwner: TComponent); override;
 published
  property sloupecTabulkyProVkl:String  read FsloupecTabulkyProVkl write FsloupecTabulkyProVkl;
  property sloupecTabulkyProCelyNaz:String  read FsloupecTabulkyProCelyNaz write FsloupecTabulkyProCelyNaz;
  property sloupecTabulkyProZnacku:String  read FsloupecTabulkyProZnacku write FsloupecTabulkyProZnacku;
  property Znacka:String  read FZnacka write FZnacka;
 end;

 TComboBoxCiselnik=class(TComboBoxMuj)
 private
  FMinWidth:integer;
  FMaxWidth:integer;
  FMinLeft:integer;
  FMaxLeft:integer;
  FJednoPole:TStringGridMujJednoPole;
  procedure setJednoPole(AJednoPole:TStringGridMujJednoPole);
  function  GetHledanyStr:String; override;
 protected
  procedure DropDown;  override;
  procedure  Change;  override;
  procedure  DoExit;  override;
  procedure KeyPress(var Key: Char); override;
 public
  property JednoPole:TStringGridMujJednoPole read FJednoPole write SetJednoPole;
  procedure Repaint; override;
  constructor Create(AOwner: TComponent); override;
 published
  property MinWidth:integer read FMinWidth write FMinWidth;
  property MaxWidth:integer read FMaxWidth write FMaxWidth;
  property MaxLeft:integer  read FMaxLeft  write FMaxLeft;
 end;

TComboBoxMujName=class(TComboBox)
 protected
   FObLesMN:TLesniMnozina;
   procedure SetObLesMN(A:TLesniMnozina);
   procedure Change;  override;
   procedure DropDown;  override;
 public
   constructor Create(AOwner: TComponent); override;
   procedure Repaint; override;
   property ObLesMN:TLesniMnozina read FObLesMN write SetObLesMN;
 end;


{
procedure TextOUTPrelom2(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String);
}

function tiskniNeboVyzKousej(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String;naCisto:boolean;var vyjdetoNaSirku:Boolean):Boolean;

function TextOUTPrelom1(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String):boolean;
function TextOUTPrelom(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;
                        zmensovatPismo:boolean;
                        VPoziceTisku:TPoziceTisku;
                        TextStr:String):boolean;
procedure NastavStringGridMujNaTaxWiev(StrGrMuj:TStringGridMuj);
procedure NastavStringGridMujNaTax200(StrGrMuj:TStringGridMuj);
procedure NastavStringGridMujNaTaxPHS(StrGrMuj:TStringGridMuj);
function ZMemoDostringu(Memo:TMemo):String;
procedure ZeStringuDoMema(Memo:TMemo;S:String);
function  GetStredX(VCont:TControl):Integer;
procedure SetStredX(VCont:TControl;StredX:integer);
procedure SetTopPod(VCont,RidCont:TControl);
procedure MnozinuDoComba(Comb:TComboBox;ObMn:TLesniMnozina;NacitanaProperta:string);
procedure ZCombaDoMnoziny(Comb:TComboBox;ObMn:TLesniMnozina;NacitanaProperta:string);

// var  NahrObLesPrvek:TObecnyLesniPrvek;
var
    uRadButOdd: boolean;
    uRadButDil1: boolean;
    uRadButPor: boolean;
    uRadButPSK1: boolean;
    uRadButTlac: boolean;
    ptatSeNaUkladani1: boolean;
    posledniActivecontrol:string;
    MenitVOkynku:Boolean;
    implementation
uses U_Props,dialogs,sysutils,E_lesOdd,U_string,
     m_Orbis,Worlds, U_ZobrComb,
     E_lesCel,mat1,Tisky,Dotaz,ERozhod,uCasomir,EKursor;

function GetStredX(VCont:TControl):Integer;
 begin
  result:=VCont.left+(VCont.Width div 2);
 end;
procedure SetStredX(VCont:TControl;StredX:integer);
 begin
  VCont.left:=StredX-(VCont.Width div 2);
 end;
procedure SetTopPod(VCont,RidCont:TControl);
 begin
  VCont.Top:=RidCont.top+ridCont.Height;
 end;
function ZMemoDostringu(Memo:TMemo):String;
var i:integer;
 begin
  result:='';
  for i:=0 to Memo.lines.Count-1 do
   begin
    if result='' then result:=Memo.lines.Strings[i]
    else result:=result+'@$&'+Memo.lines.Strings[i];
   end;
 end;
procedure ZeStringuDoMema(Memo:TMemo;S:String);
var i,Pos1:integer;
 begin
  Memo.lines.Clear;
  repeat
   Pos1:=Pos('@$&',S);
   if pos1<>0 then
    begin
     Memo.lines.Add(copy(s,1,pos1-1));
     S:=copy(s,pos1+3,length(s)-pos1+2)
    end;
  until Pos1=0;
  Memo.lines.Add(s);
 end;

procedure NastavStringGridMujNaTaxWiev(StrGrMuj:TStringGridMuj);
 begin
  with StrGrMuj do
   begin
    defaultRowHeight:=17;
    PrvniRadaHeigth:=45;
    Ctl3D  :=False;
    borderStyle := BsSingle;
    DefaultDrawing:=false;
    editorMode:=false;
    ZobrazeniGridu:=nic;
    titleColor:=clBtnFace;
    TitleFONT.NAME:='MS Sans Serif';
    TitleFont.Size:=8;
    TitleFont.Style:=[fsBold];
    TitleFont.Color := clNavy;
    end;
 end;

procedure NastavStringGridMujNaTaxPHS(StrGrMuj:TStringGridMuj);
 begin
  with StrGrMuj do
   begin
    defaultRowHeight:=18;
    PrvniRadaHeigth:=45;
    Ctl3D  :=False;
    borderStyle := BsSingle;
    DefaultDrawing:=false;
    editorMode:=false;
    ZobrazeniGridu:=nic;
    titleColor:=clBtnFace;
    TitleFONT.NAME:='MS Sans Serif';
    TitleFont.Size:=8;
    TitleFont.Style:=[fsBold];
    TitleFont.Color := clNavy;
   end;
 end;

procedure NastavStringGridMujNaTax200(StrGrMuj:TStringGridMuj);
 begin
  with StrGrMuj do
   begin
    defaultRowHeight:=18;
    PrvniRadaHeigth:=12;
    Ctl3D  :=False;
    borderStyle := BsSingle;
    DefaultDrawing:=false;
    editorMode:=true;
    ZobrazeniGridu:=nic;
    titleColor:=clBtnFace;
    TitleFONT.NAME:='Small Fonts';
    TitleFont.Size:=7;
    TitleFont.Style:=[];
    TitleFont.Color := clBlack;
    fixedCols:=0;
   end;
 end;


{
procedure TextOUTPrelom2(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String);
var S1,S2:string;
    zalFontsize:integer;
    zalFontName:string;
 begin
  repeat
   RozdelDlePrvnihoStringu(textStr,'@$&', S1,S2);
   if Canvas.textwidth(S1)>(right-left+1) then
    begin
     zalFontsize:=Canvas.Font.size;
     zalFontName:=Canvas.Font.name;
     repeat
      Canvas.Font.size:=Canvas.font.Size-1;
      if Canvas.Font.size<8 then Canvas.Font.name:='Small Fonts';
     until not(Canvas.textwidth(S1)>(right-left+1))or(Canvas.Font.size<=7);
     Canvas.textOut(left,top,S1);
     Canvas.Font.size:=zalFontsize;
     Canvas.Font.name:=zalFontName;
    end
   else
    begin
     case Vpozicetisku of
      naLevo:Canvas.textOut(left,top,S1);
      naPravo:TextOutPK(canvas,right,top,S1);
      Uprostred:TextOutS(canvas,left,right,top,S1);
     end; // case
    end;
   Top:=Top+Canvas.TextHeight(S1);
   textStr:=S2;
  until textStr='';
 end;
}

function tiskniNeboVyzKousej(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String;naCisto:boolean;var vyjdetoNaSirku:Boolean):Boolean;
var S1,S2,S1R,S2R,S1RR,S2RR,s2pn:string;
    mujTop:integer;
begin
  repeat
   RozdelDlePrvnihoStringu (textStr, '@$&', S1, S2);
   if Canvas.textwidth(S1)>(right-left-1) then
    begin
     if Canvas.textwidth(S1)>(right-left-1) then
      begin
       MujTop:=top;
       repeat
        RozdelDlePrvnihoStringu(trim(S1),' ',S1R,S2R);
        S1RR:='';
        while not((Canvas.textwidth(S1R+S1RR)>(right-left-1))or(S2R=''))do
         begin
          S1R:=S1R+' '+S1RR;
          RozdelDlePrvnihoStringu(S2R,' ',S1RR,S2RR);
          S2R:=S2RR;
         end;
        if (Canvas.textwidth(S1R+S1RR)>(right-left-1)) then
         begin
          if naCisto then Canvas.textOut(left,MujTop,S1R);
          mujTop:=mujTop+Canvas.TextHeight(S1R);
          S1:=S1RR+' '+S2R;
         end
        else
         begin
          if naCisto then Canvas.textOut(left,MujTop,S1R+' '+S1RR);
          mujTop:=mujTop+Canvas.TextHeight(S1R+' '+S1RR);
          S1:=S2R;
         end;
       until (mujTop>bottom)or(S1='');
       top:=mujTop;
      end
     else
      begin
       if naCisto then Canvas.textOut(left,top,S1);
      end;
    end
   else
    begin
     case Vpozicetisku of
      naLevo:if naCisto then Canvas.textOut(left,top,S1);
      naPravo:if naCisto then TextOutPK(canvas,right,top,S1);
      Uprostred:if naCisto then TextOutS(canvas,left,right,top,S1);
     end; // case
    end;
   Top:=Top+Canvas.TextHeight(S1);
   s2pn:=textStr;
   textStr:=S2;
  until textStr='';
 if Canvas.textwidth(s2pn)>(right-left-1) then
   vyjdetoNaSirku:=false else vyjdetoNaSirku:=true;

 if top<bottom then
  begin
   result:=true
  end
 else
  begin
   result:=false;
  end;
end;
function TextOUTPrelom1(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;VPoziceTisku:TPoziceTisku;
                        TextStr:String):boolean;
 begin
  result:=TextOUTPrelom(Canvas,left,Right,top,Bottom,
                        true,
                        VPoziceTisku,TextStr);

 end;
function TextOUTPrelom(Canvas:TCanvas;
                        left,Right,top,Bottom:integer;
                        zmensovatPismo:boolean;
                        VPoziceTisku:TPoziceTisku;
                        TextStr:String):boolean;
var
    zalFontsize:integer;
    zalFontName:string;
    vyjdetoNaSirku:Boolean;
 begin
  zalFontsize:=Canvas.Font.size;
  zalFontName:=Canvas.Font.name;
  if zmensovatPismo then
   begin
    while (
         ((not tiskniNeboVyzKousej(Canvas,left,Right,top,Bottom,
                   VPoziceTisku,TextStr,false,vyjdetoNaSirku)))
         or (not vyjdetoNaSirku))
        and (not(Canvas.Font.size<=7)) do
     begin
      Canvas.Font.size:=Canvas.font.Size-1;
      // if Canvas.Font.size<8 then Canvas.Font.name:='Small Fonts';
     end;
   end;
  result:=tiskniNeboVyzKousej(Canvas,left,Right,top,Bottom,
                                VPoziceTisku,TextStr,true,vyjdetoNaSirku);
  Canvas.Font.size:=zalFontsize;
  Canvas.Font.name:=zalFontName;
 end;
 procedure  TStringGridMuj.setLRow(VLRow:longInt);
  begin
   AkcePoSelect:=false;
   Row:=VLRow;
   AkcePoSelect:=true;
  end;
 function  TStringGridMuj.GetLRow:longInt;
  begin
   result:=row;
  end;
 constructor TStringGridMuj.Create(AOwner: TComponent);
 begin
  inherited Create(AOwner);
  MElement := TStringGridMujElement.Create;
  AkcePoSelect:=true;
  PrvniRadaHeigth:=-1;
  FONT.NAME:='Arial CE';
  Font.Size:=10;
  Font.Style := [fsBold];
  Font.Color:=clBlack;
  FTitleFont:=TFont.Create;
       FTitleFONT.NAME:='Small Fonts';
       FTitleFont.Size:=7;
       FTitleFont.Style:=[];
       FTitleFont.Color:=clBlack;
  MenitRowHeights:=false;
  SelektivniZobrazeni:=false;
  DrzetRowVOknePoMnozineDoGridu:=false;
  FAktualniPrGridu:=nil;
  FPredEntremBylaZmena:=false;
 end;

constructor TCheckBoxNactLED.Create(AOwner: TComponent);
 begin
  inherited Create(AOwner);
  infoMemo:=nil;
 end;

constructor TStringGridMujJednoPole.Create(AOwner: TComponent);
 begin
  inherited Create(AOwner);
  MElement := TStringGridMujJednoPoleElement.Create;
  ScrollBars:=ssNone;
  BorderStyle:=bsNone;
  Rowcount:=1;
  ColCount:=1;
  poziceTisku:=naLevo;
  DoubleWidth:=-1;
  DoublePrec:=-1;
  FONT.NAME:='Arial CE';
  Font.Size:=10;
  Font.Style := [fsBold];
  Font.Color:=clBlack;
  FmenitRowHeights:=false;
  DelatExit:=true;
 end;
procedure TStringGridMujJednoPole.DrawCell
          (ACol, ARow: Longint; ARect: TRect;AState: TGridDrawState);
 var
     dobry:boolean;
 begin
  if ObLesPrvek=nil then
   begin
    // color:=clyellow;
    // cells[ACol,ARow]:='#';
    inherited DrawCell(ACol, ARow,ARect,[]);
    with canvas do
     begin
      Brush.Color:= clInfoBk; // clred;
      fillRect(ARect);
      Brush.style:=bsClear;
      Font.Assign(self.font);
      TextOUTPrelom1(Canvas,ARect.left+1,ARect.Right-1,ARect.top,ARect.Bottom,poziceTisku,cells[ACol,ARow]);
     end;
    // cells[ACol,ARow]:='@';
    exit;
   end;
  // inherited DrawCell(ACol, ARow,ARect,AState);
  with canvas do
   begin
    if (TForm(owner).activeControl=self) then
     begin
      Brush.Color:=ClNavy;
     end
    else
     begin
      Brush.Color:=ObLesPrvek.Barva[JmenoProperty];
     end;
    fillRect(ARect);
    Brush.style:=bsClear;
    Font.Assign(self.font);
    if (TForm(owner).activeControl=self)  then
      begin
       Font.Color:=ClYellow;
      end;
    TextOUTPrelom1(Canvas,ARect.left+1,ARect.Right-1,ARect.top,ARect.Bottom,poziceTisku,StringProperty);
    if ObLesPrvek.Chyba[JmenoProperty]>0 then
        begin
         FONT.NAME:='Small Fonts';
         Font.Size:=7;
         Font.Style :=[];
         Font.Color:=clBlack;
         Brush.color:= clred;
         Brush.style:=BsSolid;
         Polygon([
                Point(ARect.right,
                          ARect.top),
                Point(ARect.left+round(((ARect.right-ARect.left)/100)*80),
                          ARect.top +round(((ARect.bottom-ARect.Top)/100)*20)),
                Point(ARect.left+round(((ARect.right-ARect.left)/100)*80),
                          ARect.top +round(((ARect.bottom-ARect.Top)/100)*80)),
                Point(ARect.right,
                          ARect.Bottom)
                          ]);
         TextOUT(ARect.left+round(((ARect.right  - ARect.left)/100)*80),
                 ARect.top +round(((ARect.bottom - ARect.Top )/100)*20),
                 inttostr(ObLesPrvek.Chyba[JmenoProperty]));
        end;
   end;
 end;

procedure  TStringGridMuj.PripravZobrazeniGridu;
var i:integer;
 begin
  with FVlastnostiSloupcuMN do
   begin
    indexujSe;
    colCount:=pocetViditelnychPolozek;
    for i:=0 to count-1 do
     begin
      with TVlastnostiSloupcu(elements[i]) do
       begin
        if viditelny then
         begin
          Cells[indexVGridu,0]:=nadpis;
          ColWidths[indexVGridu]:=sirka;
          objects[indexVGridu,0]:=FVlastnostiSloupcuMN.elements[i];
         end;
       end;
     end;
   end;
 end;
procedure  TStringGridMuj.PripravZobrazeniGriduDlePomeruStran(PuvodniSirka,NovaSirka:integer);
var i:integer;
 begin
  with FVlastnostiSloupcuMN do
   begin
    indexujSe;
    colCount:=pocetViditelnychPolozek;
    for i:=0 to count-1 do
     begin
      with TVlastnostiSloupcu(elements[i]) do
       begin
        if viditelny then
         begin
          Cells[indexVGridu,0]:=nadpis;
          ColWidths[indexVGridu]:=round(sirka * NovaSirka/PuvodniSirka);
          objects[indexVGridu,0]:=FVlastnostiSloupcuMN.elements[i];
         end;
       end;
     end;
   end;
 end;

procedure TStringGridMuj.MnozinuDoGriduAVlastnosti;
var
 i:integer;
 begin
  if ObLesMN = nil then
   begin
    rowcount:=1;
    Exit;
   end;
  for i:=0 to ObLesMN.count-1 do
   begin
    with TObecnyLesniPrvek(ObLesMN.elements[i]) do
    VlastnostiMNCreateKdyzNejsou;
   end;
  MnozinuDoGridu;
  Application.ProcessMessages;
 end;

procedure TStringGridMuj.MnozinuZGridu;
var
 irr:Integer;
 begin
  for irr:=1 to RowCount-1 do
   begin
    objects[0,irr]:=nil;
   end;
  ObLesMN:=nil;
  rowcount:=1;
 end;

procedure TStringGridMuj.MnozinuDoGridu;
var i,iC,iR,irr:integer;
    S1:String;
    bylMenen1:boolean;
    VRowCount:longint;
 begin
 if SelektivniZobrazeni then
  begin
   // showmessage('cau davam MnozinuDoGridu '+name);
  end;
  if ObLesMN = nil then
   begin
    rowcount:=1;
    Exit;
   end;
  if not SelektivniZobrazeni then
   begin
    VRowCount:=ObLesMN.count+1;
   end
  else
   begin
    VRowCount:=ObLesMN.SelektPocet+1;
   end;
  if RowCount<>VRowCount then
     begin
      RowCount:=VRowCount;
     end;
  irr:=-1;
  for i:=0 to ObLesMN.count-1 do
   begin
    if not SelektivniZobrazeni then
     begin
      irr:=i;
     end
    else
     begin
      if not TObecnyLesniPrvek(ObLesMN.elements[i]).selekt then continue;
      inc(irr);
     end;
    if objects[0,irr+1]<>ObLesMN.elements[i] then
     begin
      objects[0,irr+1]:=ObLesMN.elements[i];
     end;
   end;
  if prvniRadaHeigth<>-1 then
   begin
    if RowHeights[0]<>prvniRadaHeigth then
     begin
      RowHeights[0]:=prvniRadaHeigth;
     end;
    if rowcount>1 then
     begin
      if FixedRows<>1 then
       begin
        FixedRows:=1;
       end;
     end;
   end;
  for ir:=1 to Rowcount-1 do
   begin
    bylMenen1:=false;
    for iC:=0 to ColCount-1 do
     begin
      s1:=GetPropString(TElement(objects[0,ir]),
                    TVlastnostiSloupcu(objects[ic,0]).IndexPropertyVElementu);
      if s1<>Cells[iC,iR] then
       begin
        Cells[iC,iR]:=s1;
        bylMenen1:=true;
       end;
     end;
    if bylMenen1 then
     begin
      if menitRowHeights then
       begin
        if RowHeights[ir]<>defaultRowHeight then
         begin
          RowHeights[ir]:=defaultRowHeight;
         end;
       end;
     end;
    if
       AktualniPrGridu=TElement(objects[0,ir]) then
     begin
      if row<>ir then
       begin
        LRow:=ir;
       end;
     end;
   end;
  DrzetRowVOknePoMnozineDoGridu:=true;
  Application.ProcessMessages;
 end;
{
procedure TStringGridMuj.MnozinuDoGriduPok;
var i,iC,iR:integer;
    S1:String;
    bylMenen1:boolean;
 begin
  if RowCount<(ObLesMN.count+1) then
   begin
    RowCount:=ObLesMN.count+1;
   end;
  for i:=0 to ObLesMN.count-1 do
   begin
    if objects[0,i+1]<>ObLesMN.elements[i] then
     begin
      objects[0,i+1]:=ObLesMN.elements[i];
     end;
   end;
  if RowCount>(ObLesMN.count+1) then
   begin
    if Row>ObLesMN.count then
     begin

      Row:=ObLesMN.count;
     end;
    RowCount:=ObLesMN.count+1;
   end;
  if prvniRadaHeigth<>-1 then
   begin
    if RowHeights[0]<>prvniRadaHeigth then
     begin
      RowHeights[0]:=prvniRadaHeigth;
     end;
    if rowcount>1 then
     begin
      if FixedRows<>1 then
       begin
        FixedRows:=1;
       end;
     end;
   end;
  for ir:=1 to Rowcount-1 do
   begin
    bylMenen1:=false;
    for iC:=0 to ColCount-1 do
     begin
      s1:=GetPropString(TElement(objects[0,ir]),
                    TVlastnostiSloupcu(objects[ic,0]).IndexPropertyVElementu);
      if s1<>Cells[iC,iR] then
       begin
        Cells[iC,iR]:=s1;
        bylMenen1:=true;
       end;
     end;
    if bylMenen1 then
     begin
      if menitRowHeights then
       begin
        if RowHeights[ir]<>defaultRowHeight then
         begin
          RowHeights[ir]:=defaultRowHeight;
         end;
       end;
     end;
    if ObLesMN.AktualniPrvek=TElement(objects[0,ir]) then
     begin
      if row<>ir then
       begin
        row:=ir;
       end;
     end;
   end;
 end;
}

function  TStringGridMujJednoPole.GetObLesPrvek  :TObecnyLesniPrvek;
 begin
  //if FObLesPrvek=nil then result:=NahrObLesPrvek
  //                   else result:=FObLesPrvek;
  result:=FObLesPrvek;
 end;

procedure TStringGridMujJednoPole.CellDoProperty;
 begin
  StringProperty:=Cells[0,0];
 end;
{
procedure TStringGridMujJednoPoleODD.CellDoProperty;
var i:integer;
 begin
  FObLesniCelek.SeznamOddeleni.Find(StringProperty,i);
  FObLesniCelek.SeznamOddeleni.Strings[i]:=
  inherited CellDoProperty;
  StringProperty:=Cells[0,0];
 end;
}
procedure TStringGridMujJednoPole.PropertuDoCell;
 begin
  meniloSe:=false;
  Cells[0,0]:=StringProperty;
  {
  if Cells[0,0]<>StringProperty then
   begin
    Cells[0,0]:=StringProperty;
   end;
  }
 end;
function  TStringGridMujJednoPole.getStringProperty:string;
var prInd:Integer;
    dd:Double;
    chb,chbNM:string;
 begin
  result:='#';
  if ObLesPrvek=nil then
   begin
    result:='';
    exit;
   end;
  try
  chbNM:='nnn';
  chb:='0';
  chbNM:=ObLesPrvek.name;
  chb:='1';
  prInd:=GetPropIndex(ObLesPrvek,JmenoProperty);
  chb:='2';
  if prInd<0 then result:='*'
  else
   begin
  chb:='3';
    if DoubleWidth=-1 then
     begin
  chb:='4';
      result:= GetPropString(ObLesPrvek,prInd);
  chb:='5';
     end
    else
     begin
  chb:='6';
      dd:=StrToExtended(GetPropString(ObLesPrvek,prInd));
  chb:='7';
      result:=DoubleToStr(dd, DoubleWidth, DoublePrec);
  chb:='8';
     end;
  chb:='9';
   end;
  except
   showmessage('Chyba ### v '+name+' jmp.pr."'+JmenoProperty+'". slo chyby:'+chb+' v prvku '+chbNM);
   result:='###';
   {
   showmessage('Chyba v TStringGridMujJednoPole.getStringProperty ');
   showmessage('name=' + name + '  JmenoProperty='+JmenoProperty);
   try
   showmessage('ObLesPrvek.name='+ObLesPrvek.name);
   except
     showmessage('ObLesPrvek je patn.');
   end;
   }
  end;
 end;

procedure TStringGridMujJednoPole.setStringProperty(AStringProperty:string);
 begin
  if ObLesPrvek=nil then
   begin
    exit;
   end;
  SetPropStringByName(ObLesPrvek,JmenoProperty,AStringProperty);
 end;

function  TStringGridMujJednoPole.getMheight:Integer;
 begin
  result:=height;
 end;

procedure TStringGridMujJednoPole.setMheight(Aheight:Integer);
 begin
  height:=Aheight;
  if borderStyle=BsSingle then DefaultRowHeight:=Aheight-4 else DefaultRowHeight:=Aheight-1;
 end;

function  TStringGridMujJednoPole.getMwidth:Integer;
 begin
  result:=width;
 end;
procedure TStringGridMujJednoPole.setMwidth(Awidth:Integer);
 begin
  width:=Awidth;
  if borderStyle=BsSingle then DefaultColwidth:=Awidth-4 else DefaultColwidth:=Awidth-1;
 end;
procedure TStringGridMuj.UpravGrid;
 begin
 end;
procedure TStringGridMuj.NastavGrid;
 begin
  // if FObLesMN=nil then Exit;
  if FVlastnostiSloupcuMN<>nil then Exit;
  FVlastnostiSloupcuMN:=TVlastnostiSloupcuMN.CreatePodle(FObLesMN.FClass);
  UpravGrid;
  PripravZobrazeniGridu;
 end;

function  TStringGridMuj.VybranyCell(ACol, ARow: Longint):boolean;
 begin
  result:=false;
  case ZobrazeniGridu of
     nic            : begin
                      end;
     vybranePole    : begin
                       if (ACol=Col)and (ARow=Row) then result:=true;
                      end;
     vybranyRadek   : begin
                       if (ARow=Row) then result:=true;
                      end;
     vybranySloupec : begin
                       if (ACol=Col) then result:=true;
                      end;
  end; {case}

 end;

procedure TStringGridMuj.DrawCell(ACol, ARow: Longint; ARect: TRect;
             AState: TGridDrawState);

var VChyba: integer;
    ARect1: TRect;
    s:string;
    dobry:Boolean;
begin
   {
   if ObLesMN=nil then
    begin
     //cells[ACol,ARow]:='F';
     // inherited DrawCell(ACol, ARow,ARect,AState);
    with canvas do
     begin
      Brush.Color:=clred;
      fillRect(ARect);
      Brush.style:=bsClear;
      Font.Assign(self.font);
      // cells[ACol,ARow]:=inttoStr(strtoint0(cells[ACol,ARow])+1);
      TextOUTPrelom1(Canvas,ARect.left+1,ARect.Right-1,ARect.top,ARect.Bottom,uprostred,cells[ACol,ARow]);
     end;
     exit;
    end;
   }
   with canvas do
    begin
      Arect1.Left:=Arect.Left; //+1;
      Arect1.Top:=Arect.Top;   //+1;
      Arect1.Right:=Arect.Right;
      Arect1.Bottom:=Arect.Bottom;
     if ARow=0 then
      begin
       Brush.Color:=titleColor;
       Font.Assign(self.TitleFont);
       fillRect(Arect1);
       TextOUTPrelom1(Canvas,ARect1.left,ARect1.Right,
                            ARect1.top,ARect1.Bottom,uprostred,
                            TVlastnostiSloupcu(objects[Acol,0]).nadpis);
      end;
     if (objects[0,aRow]<>nil) and (objects[Acol,0]<>nil)
        and (ARow<>0) then
      begin
       if (VybranyCell(ACol, ARow)) and  (TForm(owner).activeControl=self) then
        begin
         Brush.Color:=ClNavy;
        end
       else
        begin
         Brush.Color:=
          TObecnyLesniPrvek(objects[0,aRow]).barva[
           TVlastnostiSloupcu(objects[Acol,0]).NazevProperty];
        end;
       fillRect(Arect1);
       VChyba:=
         TObecnyLesniPrvek(objects[0,aRow]).Chyba[
          TVlastnostiSloupcu(objects[Acol,0]).NazevProperty];
       if Vchyba>0 then
        begin
         FONT.NAME:='Small Fonts';
         Font.Size:=7;
         Font.Style:=[];
         Font.Color:=clBlack;
         Brush.color:= clred;
         Brush.style:=BsSolid;
         Polygon([
                Point(ARect.right,
                          ARect.top),
                Point(ARect.left+round(((ARect.right-ARect.left)/100)*80),
                          ARect.top +round(((ARect.bottom-ARect.Top)/100)*20)),
                Point(ARect.left+round(((ARect.right-ARect.left)/100)*80),
                          ARect.top +round(((ARect.bottom-ARect.Top)/100)*80)),
                Point(ARect.right,
                          ARect.Bottom)
                          ]);
         TextOUT(ARect.left+round(((ARect.right-ARect.left)/100)*80),
                          ARect.top +round(((ARect.bottom-ARect.Top)/100)*20),
                 inttoStr(VChyba));
        end;
       Brush.style:=bsClear;
       { FONT.NAME:='Arial CE';
         Font.Size:=10;
         Font.Style := [fsBold];
         Font.Color:=clBlack;  }

       Font.Assign(self.font);
       if VybranyCell(ACol, ARow) and  (TForm(owner).activeControl=self)  then
        begin
         Font.Color:=ClYellow;
        end;
       repeat
        dobry:=TextOUTPrelom1(Canvas,
                     ARect1.left,ARect1.Right,ARect1.top,ARect1.bottom,
                     TVlastnostiSloupcu(objects[Acol,0]).poziceTisku,
                     Cells[ACol,aRow]);
        if not(menitRowHeights) then  dobry:=true;
        if not dobry then
         begin
          RowHeights[ARow]:=RowHeights[ARow]+2;
          ARect1.bottom:=ARect1.bottom+2;
         end;
       until dobry;
       Brush.color:=cl3DLight;
      end
     else
      begin
       if ARow<>0 then
        begin
         Brush.Color:=cl3DLight;
         fillRect(ARect1);
        end;
      end;
    end;
 end;

procedure TStringGridMuj.aktRowDoViditelCasti;
 begin
   if oblesMN=nil then exit;
   if (row>TopRow+VisibleRowCount-1) then
     begin
       topRow:=Row-(VisibleRowCount-1);
     end;
    if row<TopRow then
     begin
       topRow:=Row;
     end;
 end;

{
procedure TStringGridMuj.repaint;
 begin
  inherited repaint;
  if menitRowHeights then
   begin
    application.ProcessMessages;
    aktRowDoViditelCasti;
   end;
 end;
}
procedure TComboBoxMujName.SetObLesMN(A:TLesniMnozina);
var i:integer;
   S:string;
 begin
  FObLesMN:=A;
  items.clear;
  If FObLesMN<>nil then
   begin
    with FObLesMN do
     begin
      for i:=0 to count-1 do
       begin
        items.add(copy(Elements[i].name,length(PredponaName)+2,length(Elements[i].name)-(length(PredponaName)+1)));
       end;
      if AktualniPrvek<>nil then
       begin
        try
         S:=copy(AktualniPrvek.name,length(PredponaName)+2,length(AktualniPrvek.name)-(length(PredponaName)+1));
         ItemIndex:=items.IndexOf(S);
         text:=copy(AktualniPrvek.name,length(PredponaName)+2,length(AktualniPrvek.name)-(length(PredponaName)+1))
        except
         showmessage('bacha Bacha TComboBoxMujName.SetObLesMN.Name="'+Name+'"');
        end;
       end;
     end;
   end;
 end;
function  TComboBoxMuj.GetHledanyStr:String;
 begin
  result:='Blbina';
 end;
function  TComboBoxCiselnik.GetHledanyStr:String;
 begin
  result:=JednoPole.StringProperty;
 end;

procedure TComboBoxMuj.DropDown;
var i:integer;
 begin
  case ZpPrevodu of
   JedenSl:
    begin
     I:=0;
     ItemIndex:=0;
     for I:=0 to Items.Count-1 do
      begin
       if items[i]=HledanyStr then
        begin
         ItemIndex:=i;
         break;
        end;
      end;
    end;
   doPomlcky:
    begin
     I:=0;
     ItemIndex:=0;
     for I:=0 to Items.Count-1 do
      begin
       if trim(KPrvnimuZnaku(items[i],'-'))=HledanyStr then
        begin
         ItemIndex:=i;
         break;
        end;
      end;
    end;  // doPomlcky
   dleJinehoSloupce,dleJinehoSlCisla:
    begin
     I:=0;
     ItemIndex:=0;
     for I:=0 to FVyslStringS.Count-1 do
      begin
       Application.ProcessMessages;
       if FVyslStringS[i]=HledanyStr then
        begin
         // showmessage('ciu '+inttostr(i)+'   '+FVyslStringS[i]+'  '+HledanyStr+items[i]);
         VItemIndex:=i;
         VVyslStr:=FVyslStringS[i];
         VItem:=items[i];
         ItemIndex:=i;
         VSkItemIndex:=ItemIndex;
         break;
        end;
      end;
    end;  // dleJinehoSloupce
  end;    // case
  VSkItemIndex1:=ItemIndex;
  inherited DropDown;
  VSkItemIndex2:=ItemIndex;
 end;

procedure TComboBoxCiselnik.DropDown;
 begin
  FJednoPole.visible:=false;
  width:=MaxWidth;
  if maxLeft<>-1111 then
   begin
    FMinLeft:=left;
    left:=MaxLeft;
   end;
  inherited DropDown;
 end;

procedure TComboBoxCiselnik.Change;
var
 novyText:string;
 begin
  // showmessage('cau ted zacina change.');
  case ZpPrevodu of
   JedenSl:
    begin
     NovyText:=text;
    end;
   doPomlcky:
    begin
     NovyText:=trim(KPrvnimuZnaku(text,'-'))
    end;  // doPomlcky
   dleJinehoSloupce,dleJinehoSlCisla:
    begin
     if ItemIndex<0 then NovyText:=JednoPole.StringProperty
     else NovyText:=FVyslStringS[ItemIndex];
    end;  // dleJinehoSloupce
  end;    // case
  FJednoPole.visible:=true;
  if JednoPole.StringProperty<>NovyText then
   begin
    if JednoPole.OblesPrvek<>nil then
     begin
      JednoPole.StringProperty:=NovyText;
      JednoPole.OblesPrvek.Barva[JednoPole.JmenoProperty]:=clAqua;
      JednoPole.OblesPrvek.BylEditovan:=true;
      JednoPole.Cells[0,0]:=NovyText;
     end;
   end;
  width:=MinWidth;
  if maxLeft<>-1111 then
   begin
    left:=FMinLeft;
   end;
  inherited Change;
  TForm(owner).activeControl:=FJednoPole;
 end;

procedure TComboBoxMuj.SetZpPrevodu (VZpPrevodu:TZpPrevodu);
 begin
  FZpPrevodu:=VZpPrevodu;
  if (FZpPrevodu=dleJinehoSloupce) or (FZpPrevodu=dleJinehoSlCisla) then
   begin
    FVyslStringS:=TStringList.create;
   end;
 end;
procedure TComboBoxMuj.NactiZTabulkyIJinySloupec
                 (TabulkaVcetneCesty,sloupecek,JinySloupec:String);
var Tb:TTable;
    i:integer;
    S1,CC:string;
 begin
  if    (FZpPrevodu<>dleJinehoSloupce)
     and(FZpPrevodu<>dleJinehoSlCisla) then
   begin
    showmessage('V selnku "'+name+'" nen ZpPrevodu=dleJinehoSloupce. Nelze pout IJinySloupec.');
   end;
  try
   cc:='A1';
  Tb:=TTable.create(application.mainform);
   cc:='A2';
  Tb.TableName:=TabulkaVcetneCesty;
   cc:='A3';
  Tb.TableType:=ttDefault;
   cc:=TabulkaVcetneCesty+'A4';
  Tb.open;
   cc:='A5';
  items.clear;
   cc:='A6';
  FVyslStringS.clear;
   cc:='A7';
  while not Tb.eof do
   begin
   cc:='A8';
    s1:=Tb.fieldByName(sloupecek).asstring;
   cc:='A9';
    items.Add(s1);
   cc:='A10';
    if (FZpPrevodu=dleJinehoSloupce) then
     begin
   cc:='A11';
      s1:=Tb.fieldByName(JinySloupec).asstring;
   cc:='A12';
      FVyslStringS.Add(s1);
   cc:='A13';
     end;
    if (FZpPrevodu=dleJinehoSlCisla) then
     begin
   cc:='A14';
      s1:=inttostr(Tb.fieldByName(JinySloupec).asinteger);
   cc:='A15';
      FVyslStringS.Add(s1);
   cc:='A16';
     end;
   cc:='A17';
    tb.next;
   cc:='A18';
   end;
  except
   showmessage ('Cau pozor chyba NactiZTabulkyIJinySloupec toto slo potebuji='+CC);
   end;
  ItemIndex:=0;
  tb.Close;
  tb.free;
 end;

procedure TComboBoxMuj.NactiZTabulky
                 (TabulkaVcetneCesty,sloupecek:String);
var Tb:TTable;
    i:integer;
    S1:string;
 begin
  if (FZpPrevodu=dleJinehoSloupce)or(FZpPrevodu=dleJinehoSlCisla) then
   begin
    showmessage('V selnku "'+name+'" je ZpPrevodu=dleJinehoSloupce. Nelze pout NactiZTabulky.');
   end;
  Tb:=TTable.create(application.mainform);
  Tb.TableName:=TabulkaVcetneCesty;
  Tb.TableType:=ttDefault;
  Tb.open;
  items.clear;
  while not Tb.eof do
   begin
    s1:=Tb.fieldByName(sloupecek).asstring;
    items.Add(s1);
    tb.next;
   end;
  ItemIndex:=0;
  tb.Close;
  tb.free;
 end;

procedure TComboBoxCiselnik.DoExit;
var
  alesponJednaAkceProvedena:boolean;
 begin
  FJednoPole.visible:=true;
  width:=MinWidth;
  if maxLeft<>-1111 then
   begin
    left:=FMinLeft;
   end;
  provedAkcePoExitu(name,alesponJednaAkceProvedena);
  if alesponJednaAkceProvedena then
   begin
    TForm(owner).refresh;
   end;
  inherited DoExit;
 end;


procedure TComboBoxCiselnik.setJednoPole(AJednoPole:TStringGridMujJednoPole);
 begin
  FJednoPole:=AJednoPole;
  top    := FJednoPole.top-1;
  left   := FJednoPole.left;
  width:=FJednoPole.MWidth+15;
  MinWidth:=width;
  if maxLeft<>-1111 then
   begin
    left:=FMinLeft;
   end;
  height:=21; //nelze zadat jinak, vrati se to na 21
 end;

procedure TComboBoxMujName.Change;
 begin
  inherited change;
  if ObLesMN=nil then
   begin
    exit;
   end;
  if FObLesMN.jmenoAktualnihoPrvku<>text then
   begin
    FObLesMN.jmenoAktualnihoPrvku:=text;
   end;
  TControl(owner).refresh;
 end;
{
var
 VOdd:TOddeleni;
 konfliktVBarvach:boolean;
 begin
  TForm(owner).enabled:=false;
  inherited change;
  vOdd:=ObLesniCelek.OddeleniDleCisla[strtoInt(text)];
  VOdd.DoplnBarvy(konfliktVBarvach);
  if konfliktVBarvach then showmessage('Konflikt v barvch');
  if VOdd=nil then
   begin
      showmessage('Vybran oddlen neexistuje.');
      TForm(owner).enabled:=true;
   end
  else
   begin
    with TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek) do
     begin
      if BylEditovanNeboNoveVytvorenRekurz or MaSmazanyRekurz then
       begin
        Application.CreateForm(TdotazF1,dotazF2);
        dotazF2.caption:='Dotaz na uloen.';
        dotazF2.label1.caption:='V oddlen '+inttostr(ODD)+' byly provedeny zmny .';
        dotazF2.label2.caption:='Maj se zmny uloit ?';
        dotazF2.label3.caption:='';
        dotazF2.ActiveControl:=dotazF2.OKBtn;
        dotazF2.showModal;
        if dotazF2.odpoved=true then
         begin
          TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek).DoplnZpZdPodleBarev;
          if not(obLesniCelek.UlozZnovuOddeleni(TOddeleni(ObLesniCelek.LHC.OddeleniMN.aktualniPrvek))) then
           begin
            showmessage('Nepodailo se uloit stvajc oddlen.');
            TForm(owner).enabled:=true;
            exit;
           end;
         end;
        dotazF2.free;
       end;
      ObLesniCelek.LHC.OddeleniMN.AddElement(VOdd);
     end;
   end;
   TForm(owner).enabled:=true;
   TForm(owner).refresh;
 end;
}
 constructor TComboBoxMujName.Create(AOwner: TComponent);
  begin
   inherited Create(AOwner);
   Style:=csDropDownList;
  end;
{
procedure TComboBoxMujOdd.DropDown;
 begin
  SeznamOddeleniDoItems;
  inherited DropDown;
 end;
}

procedure TStringGridMuj.SmazRadek;
var
 ARow:integer;
 begin
  if ObLesMN=nil then
   begin
    exit;
   end;
  if RowCount=1 then
   begin
    exit;
   end;
  if row=0 then
   begin
    exit;
   end;
  objects[0,row].free;
  ARow:=row;
  mnozinuDoGridu;
  Row:=min(ARow,RowCount-1);
 end;

procedure  TStringGridMuj.PridejRadek;
var ARow:integer;
 begin
  if ObLesMN=nil then
   begin
    exit;
   end;
  ObLesMN.NovyPrvekVzdy:=inttostr(ObLesMN.count);
  ARow:=row;
  mnozinudoGridu;
  Row:=RowCount-1;
 end;

procedure  TStringGridMuj.ZkopirujRadek;
var ARow:integer;
 Kopie:TObecnyLesniPrvek;
 begin
  if ObLesMN=nil then exit;
  Kopie:=TObecnyLesniPrvek(objects[0,row]).KopieElementu;
  ObLesMN.AddElement(Kopie);
  ARow:=row;
  mnozinudoGridu;
  Row:=RowCount-1;
 end;
procedure  TStringGridMuj.SetridPodleProperty(SProperty:String;vzestupne:Boolean);
 begin
  if ObLesMN=nil then exit;
  ObLesMN.setridPodlePropertyString(SProperty,vzestupne);
  mnozinudoGridu;
 end;

 procedure  TStringGridMuj.SetridPodlePropertyLongInt(SProperty:String;vzestupne:Boolean);
 begin
  if ObLesMN=nil then exit;
  ObLesMN.setridPodlePropertyLongInt(SProperty,vzestupne);
  mnozinudoGridu;
 end;

procedure TStringGridMuj.SetEditText(ACol, ARow: Longint; const Value: string);
var
  sJmenoProp,s1:string;
  dd:Extended;
 begin
  if Cells[ACol, ARow]<>Value then
   begin
    sJmenoProp:=GetPropName(TElement(objects[0,Arow]),
                    TVlastnostiSloupcu(objects[aCol,0]).IndexPropertyVElementu);
    TObecnyLesniPrvek(objects[0,Arow]).Barva[sJmenoProp]:=clAqua;
    TObecnyLesniPrvek(objects[0,Arow]).BylEditovan:=true;
   end;
    if TVlastnostiSloupcu(objects[ACol,0]).pocetZnaku<>0 then
     begin
      if length(value)>TVlastnostiSloupcu(objects[ACol,0]).pocetZnaku then
       begin
        // showmessage('cau '+TVlastnostiSloupcu(objects[ACol,0]).Nadpis+'"'+value+'"'+inttostr(length(value))+'  '+inttostr(TVlastnostiSloupcu(objects[ACol,0]).pocetZnaku));
        pipni;
        exit;
       end;
     end;
    if Value<>'' then
     begin
      if TVlastnostiSloupcu(objects[ACol,0]).TypPolozky='I' then
       begin
        if not JenCisla(value) then
         begin
          pipni;
          exit;
         end;
       end;
     end;

    if Value<>'' then
     begin
      if TVlastnostiSloupcu(objects[ACol,0]).TypPolozky='A' then
       begin
        if not JenPismena(value) then
         begin
          pipni;
          exit;
         end;
       end;
     end;

    if Value<>'' then
     begin
      if TVlastnostiSloupcu(objects[ACol,0]).TypPolozky='F' then
       begin
        if not StringIsFloat(value) then
         begin
          pipni;
          exit;
         end;
        if TVlastnostiSloupcu(objects[ACol,0]).DesMista<>0 then
         begin
          s1:='';
          if pos('.',Value)>0 then s1:=OdPrvnihoZnaku(Value,'.');
          if pos(',',Value)>0 then s1:=OdPrvnihoZnaku(Value,',');
          if length(s1)>TVlastnostiSloupcu(objects[ACol,0]).desMista then
           begin
            pipni;
            exit;
           end;
         end;
       end;
     end;
  inherited  SetEditText(ACol, ARow,Value);
 end;
 
function TStringGridMujJednoPole.GetEditText(ACol, ARow: Longint): string;
 begin
  result:=  inherited  GetEditText(ACol, ARow);
 end;
procedure TStringGridMujJednoPole.SetEditText(ACol, ARow: Longint; const Value: string);
var S1:string;
 begin
  if Cells[ACol, ARow]<>Value then
   begin
    if OblesPrvek<> nil then
     begin
      OblesPrvek.Barva[JmenoProperty]:=clAqua;
      OblesPrvek.BylEditovan:=true;
     end;
    meniloSe:=true;
   end;
    if pocetZnaku<>0 then
     begin
      if length(trim(value))>pocetZnaku then
       begin
        pipni;
        exit;
       end;
     end;
    if Value<>'' then
     begin
      if TypPolozky='I' then
       begin
        if not JenCisla(value) then
         begin
          pipni;
          exit;
         end;
       end;
     end;

    if Value<>'' then
     begin
      if TypPolozky='A' then
       begin
        if not JenPismena(value) then
         begin
          pipni;
          exit;
         end;
       end;
     end;

    if Value<>'' then
     begin
      if TypPolozky='F' then
       begin
        if not StringIsFloat(value) then
         begin
          pipni;
          exit;
         end;
        if DesMista<>0 then
         begin
          s1:='';
          if pos('.',Value)>0 then s1:=OdPrvnihoZnaku(Value,'.');
          if pos(',',Value)>0 then s1:=OdPrvnihoZnaku(Value,',');
          if length(s1)>desMista then
           begin
            pipni;
            exit;
           end;
         end;
       end;
     end;
  inherited  SetEditText(ACol, ARow,VALUE);
 end;

procedure TStringGridMuj.KeyDown(var Key: Word; Shift: TShiftState);
 begin
  inherited  KeyDown(Key, Shift);
  vybiraloSe:=true;
 end;
procedure TStringGridMujJednoPole.KeyDown(var Key: Word; Shift: TShiftState);
 begin
  inherited  KeyDown(Key, Shift);
  if Key=27 then
   begin
    Cells[0,0]:=StringProperty;
   end;
 end;
procedure TStringGridMujJednoPole.KeyPress(var Key: Char);
var
 AktivPrvek,ss,UU:string;
 alesponJednaAkceProvedena1,alesponJednaAkceProvedena2,obnovobrazovkuIhned:Boolean;
 startPos,EndPos:longint;
 begin
  if OblesPrvek=nil then exit;
  ss:=GetEditText(Col,row);
  if (length(ss)>=PocetZnaku)and(pocetZnaku>0) then
   begin

    if ord(KEY)>=48 then
     begin
      SendMessage(InplaceEditor.handle, EM_GETSEL, Longint(@StartPos), Longint(@EndPos));
      if (length(ss)-(EndPos-startPos)>=PocetZnaku) then
       begin
        key:=chr(0);
        inherited KeyPress(Key);
        exit;
       end;
     end;
   end;
  if  typPolozky='I' then
   begin
    if ord(KEY)>=48 then
     begin
      if key>'9' then
       begin
        key:=chr(0);
        inherited KeyPress(Key);
        exit;
       end;
     end;
   end;
  if  typPolozky='F' then
   begin
    if ord(KEY)>=48 then
     begin
      if (key>'9')and(key<>'.')and(Key<>',') then
       begin
        key:=chr(0);
        inherited KeyPress(Key);
        exit;
       end;
     end;
   end;
  inherited KeyPress(Key);
  if key='$' then
   begin
    if barvaBraniMenit(OblesPrvek.Barva[JmenoProperty]) then
     begin
      OblesPrvek.Barva[JmenoProperty]:=clYellow;
     end
    else
     begin
      OblesPrvek.Barva[JmenoProperty]:=clAqua;
     end;
    OblesPrvek.BylEditovan:=true;
    meniloSe:=true;
    key:=chr(0);
   end;
  if ord(key)=0 then
   begin
    zapnicas;
    CellDoProperty;
    AktivPrvek:=ActiveControlPodleKurzoru(name,napred);
    // cc MElement.PostMsg(tm_StartProgress,MElement,nil,false);
    MElement.PostTextMsg(tm_StartProgress,'',MElement);
    provedAkcePoEntruIhned(name,alesponJednaAkceProvedena1,obnovobrazovkuIhned);
    //provedakcePoExitu(name,alesponJednaAkceProvedena2);
    // application.ProcessMessages;
   // cc
    if obnovobrazovkuIhned then
     begin
      TForm(owner).refresh;
     end;
    if alesponJednaAkceProvedena1 then
     begin
       MElement.PostTextMsg(tm_StartProgress,'refresh',MElement);
     end;

    if AktivPrvek='' then AktivPrvek:=ActiveControlPodleKurzoru(name,potom);
    if AktivPrvek='PohybKurzoru=nil' then
     begin
      AktivPrvek:='';
     end;
    DelatExit:=false;
    NastavAktivniPrvek(TForm(owner),AktivPrvek,false);
    DelatExit:=true;
    if TForm(owner).ActiveControl is TComboBox then
     begin
      Application.ProcessMessages;
      NastavAktivniPrvek(TForm(owner),AktivPrvek,true);
     end;
   end;
 end;

procedure TStringGridMuj.KeyPress(var Key: Char);
var
 AktivPrvek,ss,sJmenoProp,PuvActiveControl,SZal:string;
 alesponJednaAkceProvedena1,alesponJednaAkceProvedena2,meniloSe1,obnovObrazovkuIhned:Boolean;
 startPos,EndPos:longint;
 begin
  ss:=GetEditText(Col,row);
  with TVlastnostiSloupcu(objects[Col,0]) do
   begin
    if (length(ss)>=PocetZnaku)and(pocetZnaku>0) then
     begin
      SendMessage(InplaceEditor.handle, EM_GETSEL, Longint(@StartPos), Longint(@EndPos));
      if (length(ss)-(EndPos-startPos)>=PocetZnaku) then
       begin
        if ord(KEY)>=48 then
         begin
          key:=chr(0);
          inherited KeyPress(Key);
          exit;
         end;
        if  typPolozky='I' then
         begin
          if ord(KEY)>=48 then
           begin
            if key>'9' then
             begin
              key:=chr(0);
              inherited KeyPress(Key);
              exit;
             end;
           end;
         end;
        if  typPolozky='F' then
         begin
          if ord(KEY)>=48 then
           begin
            if (key>'9')and(key<>'.')and(Key<>',') then
             begin
              key:=chr(0);
              inherited KeyPress(Key);
              exit;
             end;
           end;
         end;
       end;
     end;
   end;
  if key='$' then
   begin
    sJmenoProp:=GetPropName(TElement(objects[0,Row]),
                    TVlastnostiSloupcu(objects[Col,0]).IndexPropertyVElementu);
    if barvaBraniMenit(TObecnyLesniPrvek(objects[0,Row]).Barva[sJmenoProp]) then
     begin
      TObecnyLesniPrvek(objects[0,Row]).Barva[sJmenoProp]:=clYellow;
     end
    else
     begin
      TObecnyLesniPrvek(objects[0,Row]).Barva[sJmenoProp]:=clAqua;
     end;
    TObecnyLesniPrvek(objects[0,Row]).BylEditovan:=true;
    Key:=chr(0);
   end;
  SZal:=cells[Col,Row];
  inherited KeyPress( Key );
  if ord(key)=0 then
   begin
    zapnicas;
    ss:=GetPropString(TElement(objects[0,Row]),TVlastnostiSloupcu(objects[Col,0]).IndexPropertyVElementu);
    if (cells[Col,Row]<>ss) then
     begin
      FPredEntremBylaZmena:=true;
     end;
    CellDoPropert;
    ObLesMN.AktualniPrvek:=TElement(objects[0,Row]);
    AktivPrvek:=ActiveControlPodleKurzoru(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,napred);
    ObLesMN.AktualniPrvek:=TElement(objects[0,Row]);
    PuvActiveControl:=name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty;
    MElement.PostTextMsg(tm_StartProgress,'PoEntruIExitu,'+PuvActiveControl,MElement);
    provedAkcePoEntruIhned(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,alesponJednaAkceProvedena1,obnovObrazovkuIhned);
    { cau,cau
    provedAkcePoExitu(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,alesponJednaAkceProvedena1);
    provedAkcePoEntru(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,alesponJednaAkceProvedena2);
    }
    if alesponJednaAkceProvedena1 then
     begin
      MnozinuDoGriduAVlastnosti;
      // TForm(owner).refresh;
     end;
    if AktivPrvek='' then AktivPrvek:=ActiveControlPodleKurzoru(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,potom);
    if AktivPrvek='PohybKurzoru=nil' then
     begin
      if col<ColCount-1 then
       begin
        AktivPrvek:=name+'#'+TVlastnostiSloupcu(objects[Col+1,0]).NazevProperty;
       end
      else
       begin
        AktivPrvek:='';
       end;
     end;
    NastavAktivniPrvek(TForm(owner),AktivPrvek,true);
   end;
 end;

procedure TComboBoxCiselnik.KeyPress(var Key: Char);
var
 AktivPrvek:string;
 alesponJednaAkceProvedena:Boolean;
 begin
  inherited KeyPress( Key );
  if ord(key)=13 then
   begin
    zapnicas;
    AktivPrvek:=ActiveControlPodleKurzoru(name,Napred);
    provedAkcePoEntru(name,alesponJednaAkceProvedena);
    if alesponJednaAkceProvedena then
     begin
      //cau TForm(owner).refresh;
     end;
    if AktivPrvek='' then AktivPrvek:=ActiveControlPodleKurzoru(name,potom);
    change;
    NastavAktivniPrvek(TForm(owner),AktivPrvek,true);
   end;
 end;

procedure TStringGridMuj.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
 begin
  XMysDown:=X;
  YMysDown:=Y;
  inherited  MouseDown(Button,Shift,X, Y);
  vybiraloSe:=true;
 end;
procedure TStringGridMuj.MouseMove(Shift: TShiftState; X, Y: Integer);
 begin
  if DrzetRowVOknePoMnozineDoGridu then
   begin
    aktRowDoViditelCasti;
    DrzetRowVOknePoMnozineDoGridu:=false;
   end;
  inherited MouseMove(Shift,X, Y);
 end;

procedure TStringGridMuj.DoExit;
var
 alesponJednaAkceProvedena1,alesponJednaAkceProvedena2:boolean;
 PuvActiveControl:string;
 begin
  inherited  doExit;
  posledniActivecontrol:=name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty;

  if ObLesMN=nil then exit;
   FObLesMN.aktualniPrvek:=TElement(objects[0,row]);
   if goEditing in options then
    begin
     CellDoPropert;
    end;
    PuvActiveControl:=name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty;
    MElement.PostTextMsg(tm_StartProgress,'PoExitu,'+PuvActiveControl,MElement);
    PuvActiveControl:=name;
    MElement.PostTextMsg(tm_StartProgress,'PoExitu,'+PuvActiveControl,MElement);

   {
   provedAkcePoExitu(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,alesponJednaAkceProvedena1);
   provedAkcePoExitu(name,alesponJednaAkceProvedena2);
   if (alesponJednaAkceProvedena1 or alesponJednaAkceProvedena2) then
    begin
     //cau TForm(owner).refresh;
    end;
   }
 end;

procedure TStringGridMujJednoPole.DoExit;
 var alesponJednaAkceProvedena:boolean;
 begin
  inherited  doExit;
 //  showmessage('cau');
  posledniActivecontrol:=name;
   if goEditing in options then
    begin
     CellDoProperty;
    end;
   if meniloSe and delatExit then
    begin
     meniloSe:=false;
     provedAkcePoExitu(name,alesponJednaAkceProvedena);
     if alesponJednaAkceProvedena then
      begin
       TForm(owner).refresh;
      end;
    end;
 end;
function TStringGridMuj.RowAktualnihoPrvku:integer;
var
 ir:integer;
 begin
  result:=0;
  for ir:=1 to Rowcount-1 do
   begin
    if ObLesMN.aktualniPrvek=TElement(objects[0,ir]) then result:=ir;
   end;
 end;
procedure TStringGridMuj.CellDoPropert;
var
 ir,ic:integer;
 s1:string;
 begin
  if ObLesMN=nil then
   begin
    exit;
   end;
  for ir:=1 to Rowcount-1 do
   begin
    for iC:=0 to ColCount-1 do
     begin
      s1:=Cells[iC,iR];
      {
      s2:=GetPropString(TElement(objects[0,ir]),
                    TVlastnostiSloupcu(objects[ic,0]).IndexPropertyVElementu);
      if s1<>s2 then  }
       begin
        SetPropString(TElement(objects[0,ir]),
                    TVlastnostiSloupcu(objects[ic,0]).IndexPropertyVElementu,s1);
       end;
     end;
   end;
 end;

procedure  TStringGridMuj.DoExitPublic;
 begin
  doexit;
 end;

procedure  TStringGridMujJednoPole.DoExitPublic;
 begin
  doexit;
 end;

function TStringGridMuj.ColDleProperty(VProperty:string):integer;
var
  i:integer;
begin
 result:=-1;
 with VlastnostiSloupcuMN do
  begin
   for i:=0 to count-1 do
    begin
     with TVlastnostiSloupcu(elements[i]) do
      begin
       if uppercase(NazevProperty)=uppercase(VProperty) then
        begin
         result:=IndexVGridu;
        end;
      end;
    end;
  end;
end;
Procedure TStringGridMuj.SetKontrolovatSdileni(VKontrolovatSdileni:Boolean);
 begin
  if FObLesMN=nil then
   begin
    exit;
   end;
  FObLesMN.KontrolovatSdileni:=VKontrolovatSdileni;
 end;
function TStringGridMuj.GetKontrolovatSdileni:Boolean;
 begin
  if FObLesMN=nil then
   begin
    result:=false;
   end
  else
   begin
    result:=FObLesMN.KontrolovatSdileni;
   end;
 end;

function  TStringGridMujJednoPole.GetPouzeCteni:boolean;
 begin
  result:=FPouzeCteni;
 end;

Procedure TStringGridMujJednoPole.SetPouzeCteni(VPouzeCteni:Boolean);
 begin

  if ObLesPrvek=nil then
   begin
    if goEditing in options then options:=options-[goEditing,goAlwaysShowEditor];
    PropertuDoCell;
    FPouzeCteni:=true;
    exit;
   end;

  if VPouzeCteni=true then
   begin
    options:=options-[goEditing,goAlwaysShowEditor];
    
   end
  else
   begin
    options:=options+[goEditing];//goAlwaysShowEditor];
    PropertuDoCell;
   end;
  FPouzeCteni:=VPouzeCteni;
 end;




Procedure TStringGridMuj.SetPouzeCteni(VPouzeCteni:Boolean);
var chy:string;
 begin
  try
   chy:='10';
   if ObLesMN=nil then
    begin
   chy:='11';
     if goEditing in options then options:=options-[goEditing,goAlwaysShowEditor];
   chy:='12';
     exit;
   chy:='13';
    end;
   if VPouzeCteni=true then
    begin
   chy:='14';
   if FObLesMN<>nil then
      begin
   chy:='16';
       FObLesMN.PouzeCteni:=true;
   chy:='17';
       application.processMessages;
   chy:='18';
      end
     else
      begin
   chy:='19';
       showmessage('pozor - v "'+name+'" je FObLesMN=nil');
   chy:='20';
      end;
     //options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goRangeSelect];
   chy:='21';
     options:=options-[goEditing]; //,goAlwaysShowEditor];
     if Col>1 then
      begin
       col:=Col-1;
       refresh;
      end;
   chy:='22';
    end
   else
    begin
   chy:='23';
     if FObLesMN<>nil then
      begin
   chy:='24';
       application.processMessages;
       FObLesMN.PouzeCteni:=false;
   chy:='25';
       application.processMessages;
   chy:='26';
       if not (FObLesMN.PouzeCteni) then
        begin
   chy:='27';
         options:=options+[goEditing];//,goAlwaysShowEditor];
   chy:='28';
         //options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goRangeSelect,goEditing];
        end;
      end
     else
      begin
   chy:='29';
       showmessage('pozor - v "'+name+' je FObLesMN=nil');
   chy:='30';
      end;
    end;
   chy:='31';
   except
    showmessage('Pozor v TStringGridMuj.SetPouzeCteni  '+chy);
   end;
 end;

function  TStringGridMuj.GetPouzeCteni:boolean;
 begin
  if FObLesMN<>nil then
   begin
    result:=FObLesMN.PouzeCteni;
   end
  else
   begin
    result:=true;
   end;
 end;
function TStringGridMuj.GetAktualniPrGridu:TElement;
 begin
  result:=nil;
  if FAktualniPrGridu<>nil then
   begin
    result:=FAktualniPrGridu;
   end
  else
   begin
    if FObLesMN<>nil then
     begin
      result:=FObLesMN.aktualniPrvek;
     end;
   end;
 end;
constructor TComboBoxCiselnik.Create(AOwner: TComponent);
 begin
  inherited Create(AOwner);
  maxLeft:=-1111;
 end;

procedure TComboBoxMujName.DropDown;
 begin
  SetObLesMN(FOblesMN);
  inherited DropDown;
 end;

function  TStringGridMuj.GetColLeft(VCol:integer):longInt;
var i:Integer;
   VLeft:longInt;
 begin
  VLeft:=1;
  for i:=0 to VCol-1 do
   begin
    VLeft:=VLeft+ColWidths[i]+1;
   end;
  result:=VLeft;
 end;
function  TStringGridMuj.GetRowTop(VRow:integer):longInt;
var i:Integer;
   VTop:longInt;
 begin
  VTop:=1;
  for i:=0 to VRow-1 do
   begin
    VTop:=VTop+RowHeights[i]+1;
    // showmessage('cau '+name+' i='+inttostr(i)+' VTop='+inttostr(VTop)+' VRow='+inttostr(VRow)+' ');
   end;
  result:=VTop;
 end;

function TStringGridMuj.SelectCell(ACol, ARow: Longint): Boolean;
 var
  alesponJednaAkceProvedena:boolean;
  ss,schyba:string;
  ssK:integer;
 begin
  {
   function  GetPropString      (Instance: TPersistent; Index: integer): string;
        SetPropString(TElement(objects[0,ir]),
                    TVlastnostiSloupcu(objects[ic,0]).IndexPropertyVElementu,s1);
  }
  SChyba:='';
  ssk:=0;
  try
  ssk:=1;
  SChyba:=' colcount='+inttostr(colCount)+' rowcount='+inttostr(rowCount)
         +' col='+inttostr(col)+' row='+inttostr(row);
  SChyba:=SChyba+' index='+intTostr(TVlastnostiSloupcu(objects[Col,0]).IndexPropertyVElementu);
  if (row<rowCount)and(col<ColCount) then
   begin
    ss:=GetPropString(TElement(objects[0,Row]),TVlastnostiSloupcu(objects[Col,0]).IndexPropertyVElementu);

    SChyba:='';
    ssk:=2;
    // showmessage('cau '+cells[Col,Row]+'  SS='+ss);
    if (cells[Col,Row]<>ss)or(FPredEntremBylaZmena=true) then
     begin
      ssk:=3;
      FPredEntremBylaZmena:=false;
      ssk:=4;
      if not AkcePoSelect then
       begin
        ssk:=5;
        result:= inherited SelectCell(ACol, ARow);
        ssk:=6;
        exit;
       end;
      if goEditing in options then
       begin
        ssk:=7;
        CellDoPropert;
        ssk:=8;
       end;
      ssk:=9;
      provedAkcePoExitu(name+'#'+TVlastnostiSloupcu(objects[Col,0]).NazevProperty,alesponJednaAkceProvedena);
      ssk:=10;
      if alesponJednaAkceProvedena then
       begin
        ssk:=11;
        //cau TForm(owner).refresh;
        ssk:=12;
       end;
     end;
   end;
  except
   showmessage(' V SelectCell '+name+' je chyba slo '+inttostr(ssk)+' hlka:'+SChyba);
  end;
  result:= inherited SelectCell(ACol, ARow);
 end;
procedure MnozinuDoComba(Comb:TComboBox;ObMn:TLesniMnozina;NacitanaProperta:string);
var i:integer;
 begin
  for i:=0 to ObMn.count-1 do
   begin
    Comb.items.add(GetPropStringByName(ObMN.Elements[i],NacitanaProperta));
   end;
 end;
procedure ZCombaDoMnoziny(Comb:TComboBox;ObMn:TLesniMnozina;NacitanaProperta:string);
var i:integer;
    Elem:TElement;
 begin
  ObMn.SmazVsechnyPrvkyVMnozine;
  for i:=0 to Comb.items.count-1 do
   begin
    Elem:=ObMn.FClass.create;
    if not SetPropStringByName(Elem,NacitanaProperta,Comb.items[i]) then
     begin
      showmessage('Chyba v ZCombaDoMnoziny.');
     end;
    ObMn.AddElement(Elem);
   end;
 end;

procedure  TStringGridMujJednoPole.Repaint;
 begin
  if FObLesPrvek=nil then
   begin
    inherited repaint;
   end;
 end;

procedure  TStringGridMuj.Repaint;
 begin
  if FObLesMN=nil then
   begin
    inherited repaint;
   end;
 end;

procedure  TComboBoxCiselnik.Repaint;
 begin
  inherited repaint;
 end;

procedure  TComboBoxMujName.Repaint;
 begin
  if FObLesMN=nil then
   begin
    inherited repaint;
   end;
 end;

{ TStringGridMujJednoPoleElement }

procedure TStringGridMujJednoPoleElement.HandleMessage(
  var aMessage: TOrbisMessage; var Handled: boolean);
var ss:string;
begin
   if aMessage.Message = tm_StartProgress then
   begin
      ss:= TOrbisTextMessage(aMessage).Text;
      provedAkcePoEntru(StrGrPol.name,alesponJednaAkceProvedena1);
      provedakcePoExitu(StrGrPol.name,alesponJednaAkceProvedena2);
      if alesponJednaAkceProvedena or (ss='refresh') then
       begin
        TForm(StrGrPol.owner).refresh;
       end;
   end;
end;

procedure TStringGridMujElement.HandleMessage(
  var aMessage: TOrbisMessage; var Handled: boolean);
var
   ss,PuvActiveControl,coDelat:string;
begin
   if aMessage.Message = tm_StartProgress then
   begin
    ss:= TOrbisTextMessage(aMessage).Text;
    RozdelDlePrvnihoStringu(ss,',',coDelat,PuvActiveControl);
    if (coDelat='PoExitu') or (coDelat='PoEntruIExitu') then
     begin
      provedAkcePoExitu(PuvActiveControl,alesponJednaAkceProvedena1);
     end;
    if (coDelat='PoEntru') or (coDelat='PoEntruIExitu') then
     begin
      provedAkcePoEntru(PuvActiveControl,alesponJednaAkceProvedena2);
     end;
    if alesponJednaAkceProvedena1 or alesponJednaAkceProvedena2 then
     begin
       TForm(StrGrMuj.owner).refresh;
     end;
   end;
end;

procedure TStringGridMujJednoPoleElement.SetStrGrPol(
  const Value: TStringGridMujJednoPole);
begin
   FStrGrPol := Value;
end;

procedure TStringGridMuj.SetMElement(
  const Value: TStringGridMujElement);
begin
  FMElement := Value;
  FMElement.StrGrMuj :=self;
end;

destructor TStringGridMuj.Destroy;
begin
   MElement.Free;
   inherited;
end;


procedure TStringGridMujElement.SetStrGrMuj(
  const Value: TStringGridMuj);
begin
   FStrGrMuj := Value;
end;

procedure TStringGridMujJednoPole.SetMElement(
  const Value: TStringGridMujJednoPoleElement);
begin
  FMElement := Value;
  FMElement.StrGrPol :=self;
end;

destructor TStringGridMujJednoPole.Destroy;
begin
   MElement.Free;
   inherited;
end;

function  TStringGridMujJednoPoleElement.GetAlesponJednaAkceProvedena:Boolean;
 begin
  result:=(alesponJednaAkceProvedena1 or alesponJednaAkceProvedena2);
 end;

function  TComboBoxCiselnikProGrid.GetHledanyStr:String;
var
 Vcol:integer;
 begin
  vCol:=FStrGrMuj.ColDleProperty(FJmenoHlProperty);
  result:=FStrGrMuj.Cells[vCol,FStrGrMuj.row];
 end;
procedure TComboBoxCiselnikProGrid.Change;
var
 Vcol,Vrow:integer;
 VVtext:string;
 begin
  vCol:=FStrGrMuj.ColDleProperty(FJmenoHlProperty);
  vRow:=FStrGrMuj.row;
// puvodne bylo    FStrGrMuj.Cells[vCol,vRow]:=FVyslStringS[ItemIndex];
//nahrazeno zacatek
  case ZpPrevodu of
   JedenSl:
    begin
     VVText:=text;
    end;
   doPomlcky:
    begin
     VVText:=trim(KPrvnimuZnaku(text,'-'))
    end;  // doPomlcky
   dleJinehoSloupce,dleJinehoSlCisla:
    begin
     if ItemIndex<0 then VVText:=FStrGrMuj.Cells[vCol,vRow] // JednoPole.StringProperty
     else VVText:=FVyslStringS[ItemIndex];
    end;  // dleJinehoSloupce
  end;    // case
  FStrGrMuj.Cells[vCol,vRow]:=VVText;
//nahrazeno konec

    TObecnyLesniPrvek(FStrGrMuj.objects[0,vRow]).Barva[FJmenoHlProperty]:=clAqua;
    TObecnyLesniPrvek(FStrGrMuj.objects[0,vRow]).BylEditovan:=true;
    FStrGrMuj.CellDoPropert;
  inherited Change;
  TForm(owner).activeControl:=FStrGrMuj;
 end;

procedure TComboBoxCiselnikProTabulku.Change;
var
 VVtext:string;
begin
   case ZpPrevodu of
   JedenSl:
    begin
     VVText:=text;
    end;
   doPomlcky:
    begin
     VVText:=trim(KPrvnimuZnaku(text,'-'))
    end;  // doPomlcky
   dleJinehoSloupce,dleJinehoSlCisla:
    begin
     {if ItemIndex<0 then VVText:=FStrGrMuj.Cells[vCol,vRow] // JednoPole.StringProperty
     else} VVText:=FVyslStringS[ItemIndex];
    end;  // dleJinehoSloupce
  end;    // case

  MenitVOkynku:=false;
  tabulkaProVkl.Edit;
  tabulkaProVkl.FieldByName(sloupecTabulkyProVkl).asString:=VVText;
  tabulkaProVkl.FieldByName(sloupecTabulkyProCelyNaz).asString:=Text;
  if sloupecTabulkyProZnacku<>'' then tabulkaProVkl.FieldByName(sloupecTabulkyProZnacku).asString:=Znacka;
  tabulkaProVkl.post;
  MenitVOkynku:=true;

 //showmessage('Cau zapisujuasas "'+VVText+'"' );
end;

procedure TComboBoxCiselnikProGrid.DoExit;
 begin
  inherited DoExit;
  visible:=false;
 end;

procedure TComboBoxCiselnikProTabulku.DoExit;
 begin
  inherited DoExit;
 // visible:=false;
 end;


procedure TComboBoxCiselnikProGrid.KeyPress(var Key: Char);
 begin
  inherited KeyPress( Key );
  if (ord(key)=0) or (ord(key)=13) then
   begin
    TForm(owner).activeControl:=FStrGrMuj;
   end;
 end;
procedure TStringGridMujJednoPole.prekresli;
 begin
  if visible=true then
   begin
    PropertuDoCell;
    refresh;
    { visible:=false;
      visible:=true; }
   end;
 end;
procedure TStringGridMuj.prekresli;
 begin
  if visible=true then
   begin
    mnozinuDoGriduAVlastnosti;
    refresh;
   end;
  { visible:=false;
    visible:=true; }
 end;

procedure TComboBoxMuj.setrid(dlePomlcky:TsetridCombo; vzestupne:Boolean);
var maxProp,Iprop,SProp:String;
    I,iInd:integer;
    docasnyRadicPrvku:TLesniMnozina;
    VlPrv:TPrvekNaTrideni;
begin
 if Items.Count=0 then Exit;
 docasnyRadicPrvku := TLesniMnozina.create;
 docasnyRadicPrvku.FClass:=TPrvekNaTrideni;
 SProp:='StrTrid';
 i:= Items.count-1;
 while i>=0 do
  begin
   case dlePomlcky of
    sOdPomlcky:
    begin
     iprop:=OdPrvnihoZnaku(items[i],'-');
    end;
    BezOhleduNaPomlcku:
    begin
     Iprop:=items[i];
    end;
    sDoPomlcky:
    begin
     Iprop:=DoplnZePreduZnakem1( ubm(KPrvnimuZnaku(items[i],'-')),10,'-');
    end;
   end; //
   iInd:=docasnyRadicPrvku.GetNejblizsiPoradiIPodleSetridenePropertyString(SProp,Iprop);
   if iInd=0 then
    begin
     if  iProp<docasnyRadicPrvku.Elements[0].GetPropertyStringByName(SProp) then
      begin
       VlPrv:=TPrvekNaTrideni.Create;
       VlPrv.PuvIndex:=i;
       VlPrv.PuvStr:=items[i];
       VlPrv.StrTrid:=iprop;
       docasnyRadicPrvku.InsertElement(0,VlPrv);
      end
     else
      begin
       VlPrv:=TPrvekNaTrideni.Create;
       VlPrv.PuvIndex:=i;
       VlPrv.PuvStr:=items[i];
       VlPrv.StrTrid:=iprop;
       docasnyRadicPrvku.InsertElement(1,VlPrv);
      end;
    end
   else
    begin
       VlPrv:=TPrvekNaTrideni.Create;
       VlPrv.PuvIndex:=i;
       VlPrv.PuvStr:=items[i];
       VlPrv.StrTrid:=iprop;
       docasnyRadicPrvku.InsertElement(iInd+1,VlPrv);
    end;
   items.Delete(i);
   // RemoveElement(Elements[i]);
   dec(i);
  end;
 if not vzestupne then
  begin
   for I:= docasnyRadicPrvku.count-1 downto 0 do
    begin
     items.Append(TPrvekNaTrideni(docasnyRadicPrvku.Elements[i]).PuvStr);
     // addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end
 else
  begin
   for I:=0 to docasnyRadicPrvku.count-1 do
    begin
     items.Append(TPrvekNaTrideni(docasnyRadicPrvku.Elements[i]).PuvStr);
     // addelement(docasnyRadicPrvku.Elements[i]);
    end;
  end;
 docasnyRadicPrvku.SmazVsechnyPrvkyVMnozine;
 docasnyRadicPrvku.free;
end;

procedure TCheckBoxNactLED.Click;
 begin
  inherited Click;
  if infomemo<>nil then
   begin
    infoMemo.Lines.Clear;
    infoMemo.Lines.Add(Caption +' - '+Vysvetleni);
   end;
 end;

initialization
  MenitVOkynku:=true;
  posledniActivecontrol:='';
  ptatSeNaUkladani1:=false;
 // NahrObLesPrvek := TObecnyLesniPrvek.create;
end.
